/* THIS FILE IS AUTOGENERATED FROM RTCEncodedVideoFrame.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_RTCENCODEDVIDEOFRAMEBINDING_H_
#define DOM_RTCENCODEDVIDEOFRAMEBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
class RTCEncodedVideoFrame;
struct RTCEncodedVideoFrameMetadataAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class RTCEncodedVideoFrameType : uint8_t {
  Empty,
  Key,
  Delta,
  EndGuard_
};

namespace RTCEncodedVideoFrameTypeValues {
extern const EnumEntry strings[4];

static constexpr size_t Count = 3;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(RTCEncodedVideoFrameType::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(RTCEncodedVideoFrameType stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace RTCEncodedVideoFrameTypeValues

bool
ToJSValue(JSContext* aCx, RTCEncodedVideoFrameType aArgument, JS::MutableHandle<JS::Value> aValue);


struct RTCEncodedVideoFrameMetadata : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<uint32_t>> mContributingSources;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<uint64_t>> mDependencies;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint64_t> mFrameId;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint16_t> mHeight;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint8_t> mPayloadType;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mSpatialIndex;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mSynchronizationSource;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mTemporalIndex;
  MOZ_INIT_OUTSIDE_CTOR Optional<int64_t> mTimestamp;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint16_t> mWidth;

  RTCEncodedVideoFrameMetadata();

  explicit inline RTCEncodedVideoFrameMetadata(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  RTCEncodedVideoFrameMetadata(RTCEncodedVideoFrameMetadata&& aOther) = default;

  explicit inline RTCEncodedVideoFrameMetadata(const RTCEncodedVideoFrameMetadata& aOther)
  {
    *this = aOther;
  }

  bool
  Init(const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  RTCEncodedVideoFrameMetadata&
  operator=(const RTCEncodedVideoFrameMetadata& aOther);

private:
  static bool
  InitIds(JSContext* cx, RTCEncodedVideoFrameMetadataAtoms* atomsCache);
};

namespace binding_detail {
struct FastRTCEncodedVideoFrameMetadata : public RTCEncodedVideoFrameMetadata
{
  inline FastRTCEncodedVideoFrameMetadata()
    : RTCEncodedVideoFrameMetadata(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace RTCEncodedVideoFrame_Binding {

  typedef mozilla::dom::RTCEncodedVideoFrame NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::RTCEncodedVideoFrame* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::RTCEncodedVideoFrame,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::RTCEncodedVideoFrame,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace RTCEncodedVideoFrame_Binding



} // namespace mozilla::dom

#endif // DOM_RTCENCODEDVIDEOFRAMEBINDING_H_
