// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Metrics_h
#define mozilla_Metrics_h

#include "mozilla/glean/bindings/MetricTypes.h"
#include "mozilla/Maybe.h"
#include "nsTArray.h"
#include "nsPrintfCString.h"

#include <tuple>

namespace mozilla::glean {
struct NoExtraKeys;
enum class DynamicLabel: uint16_t { };

namespace background_update {
  /**
   * generated from background_update.reasons_to_not_update
   */
  /**
   * Records which error was causing the background updater to fail. This list
     * supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
   */
  constexpr impl::StringListMetric reasons_to_not_update(1);

  /**
   * generated from background_update.time_last_update_scheduled
   */
  /**
   * Last time the background update was triggered.
   */
  constexpr impl::DatetimeMetric time_last_update_scheduled(2);

  /**
   * generated from background_update.automatic_restart_attempted
   */
  /**
   * True if the background update task successfully attempted an automatic restart.
   */
  constexpr impl::BooleanMetric automatic_restart_attempted(3);

  /**
   * generated from background_update.automatic_restart_success
   */
  /**
   * True if the background update task successfully restarted after an automatic
     * restart.
   */
  constexpr impl::BooleanMetric automatic_restart_success(4);

  /**
   * generated from background_update.client_id
   */
  /**
   * The legacy Telemetry client ID of this installation's default profile.
     * The default profile is as determined by the Profile Service, namely
     * `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
     * Firefox installation and only one profile, so the default profile is their
     * regular browsing profile.
     * It is possible for a Firefox installation to not have a default profile, but in
     * such cases the background update task will abort before sending any telemetry;
     * therefore, the legacy Telemetry client ID should always be present.
   */
  constexpr impl::UuidMetric client_id(5);

  /**
   * generated from background_update.exit_code_exception
   */
  /**
   * True if the exit code/status of the background update task is 3, which means an
     * exception was thrown.
   */
  constexpr impl::BooleanMetric exit_code_exception(6);

  /**
   * generated from background_update.exit_code_success
   */
  /**
   * True if the exit code/status of the background update task is 0, which means
     * success.
   */
  constexpr impl::BooleanMetric exit_code_success(7);

  /**
   * generated from background_update.final_state
   */
  /**
   * String description of the final state the update state machine reached.
   */
  constexpr impl::StringMetric final_state(8);

  /**
   * generated from background_update.reasons
   */
  /**
   * List of reasons that the background update task did not run.
   */
  constexpr impl::StringListMetric reasons(9);

  /**
   * generated from background_update.states
   */
  /**
   * Ordered list of string descriptions of the states that the update state machine
     * reached.
   */
  constexpr impl::StringListMetric states(10);

  /**
   * generated from background_update.targeting_env_current_date
   */
  /**
   * The `environment.currentDate` of the default profile's serialized targeting
     * snapshot.
   */
  constexpr impl::DatetimeMetric targeting_env_current_date(11);

  /**
   * generated from background_update.targeting_env_firefox_version
   */
  /**
   * The `environment.firefoxVersion` of the default profile's serialized targeting
     * snapshot.  At the time of writing, this version is an integer representing the
     * Firefox major version, e.g., `109`.
   */
  constexpr impl::QuantityMetric targeting_env_firefox_version(12);

  /**
   * generated from background_update.targeting_env_profile_age
   */
  /**
   * The `environment.profileAgeCreated` of the default profile's serialized
     * targeting snapshot.
   */
  constexpr impl::DatetimeMetric targeting_env_profile_age(13);

  /**
   * generated from background_update.targeting_exception
   */
  /**
   * True if the default profile had a targeting snapshot serialized to disk, but an
     * exception was thrown reading it.
   */
  constexpr impl::BooleanMetric targeting_exception(14);

  /**
   * generated from background_update.targeting_exists
   */
  /**
   * True if the default profile had a targeting snapshot serialized to disk, and
     * there was no exception thrown reading it.
   */
  constexpr impl::BooleanMetric targeting_exists(15);

  /**
   * generated from background_update.targeting_version
   */
  /**
   * If the default profile had a targeting snapshot serialized to disk, the
     * `version` of the snapshot.
     * This version number does not have a physical unit: it's only useful to compare
     * between versions.
   */
  constexpr impl::QuantityMetric targeting_version(16);

}
namespace browser_launched_to_handle {
  /**
   * generated from browser.launched_to_handle.system_notification
   */
    struct SystemNotificationExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> name;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when Firefox launches to complete a native notification popped by a
     * system (chrome privileged) alert.  Windows-only at the time of writing.
   */
  constexpr impl::EventMetric<SystemNotificationExtra> system_notification(17);

}
namespace browser_migration {
  /**
   * generated from browser.migration.matched_extensions
   */
  /**
   * Records a list of the Chrome extension IDs that were successfully matched to
     * Firefox equivalents from the list downloaded from AMO.
   */
  constexpr impl::StringListMetric matched_extensions(18);

  /**
   * generated from browser.migration.unmatched_extensions
   */
  /**
   * Records a list of the Chrome extension IDs that were unsuccessfully matched to
     * Firefox equivalents from the list downloaded from AMO.
   */
  constexpr impl::StringListMetric unmatched_extensions(19);

}
namespace messaging_system {
  /**
   * generated from messaging_system.action
   */
  /**
   * What type of action resulted in the event. One of "IMPRESSION" or "DISMISS".
   */
  constexpr impl::StringMetric action(20);

  /**
   * generated from messaging_system.addon_version
   */
  /**
   * Used to hold the system addon's version, now is almost certainly an echo of the
     * app's build id.
   */
  constexpr impl::StringMetric addon_version(21);

  /**
   * generated from messaging_system.browser_session_id
   */
  /**
   * The Legacy Telemetry browser "session id". Identifies a specific period from
     * application start to shutdown. See [the "main" ping docs](https://firefox-
     * source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for
     * details.
   */
  constexpr impl::UuidMetric browser_session_id(22);

  /**
   * generated from messaging_system.bucket_id
   */
  /**
   * A name shared between multiple messages that may individually be too targetted.
     * e.g. a message that gets shown on specific websites or a message asking about
     * personal information.
   */
  constexpr impl::StringMetric bucket_id(23);

  /**
   * generated from messaging_system.cfr_action
   */
  /**
   * The Contextual Feature Recommender's action.
   */
  constexpr impl::TextMetric cfr_action(24);

  /**
   * generated from messaging_system.client_id
   */
  /**
   * The client_id according to Telemetry.
     * Might not always have a value due to policy around specific types of
     * ping being sent. Value may be the canary client id
     * `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
     * in pings near when the data upload pref is disabled (if Telemetry gets
     * to go first), or between when a client_id has been removed and when it
     * has been regenerated.
     * Present only in some circumstances (see
     * [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
   */
  constexpr impl::UuidMetric client_id(25);

  /**
   * generated from messaging_system.event
   */
  /**
   * The type of event. Any user defined string (e.g. “IMPRESSION”, “CLICK_BUTTON”,
     * "INDEXEDDB_OPEN_FAILED", “SESSION_END”)
   */
  constexpr impl::StringMetric event(26);

  /**
   * generated from messaging_system.event_context
   */
  /**
   * The stringified JSON of `event_context`.
   */
  constexpr impl::TextMetric event_context(27);

  /**
   * generated from messaging_system.event_context_parse_error
   */
  /**
   * How often we failed to parse event_context as JSON.
   */
  constexpr impl::CounterMetric event_context_parse_error(28);

  /**
   * generated from messaging_system.event_page
   */
  /**
   * The event_context's `page`. Almost always "about:welcome".
   */
  constexpr impl::StringMetric event_page(29);

  /**
   * generated from messaging_system.event_reason
   */
  /**
   * The event_context's `reason`. Likely something like
     * "welcome-window-closed" or "app-shut-down",.
   */
  constexpr impl::StringMetric event_reason(30);

  /**
   * generated from messaging_system.event_source
   */
  /**
   * The event_context's `source`. Likely something like "primary_button".
   */
  constexpr impl::StringMetric event_source(31);

  /**
   * generated from messaging_system.glean_ping_for_ping_failures
   */
  /**
   * How often something went awry within
     * `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
   */
  constexpr impl::CounterMetric glean_ping_for_ping_failures(32);

  /**
   * generated from messaging_system.impression_id
   */
  /**
   * The unique impression identifier for a specific client.
   */
  constexpr impl::UuidMetric impression_id(33);

  /**
   * generated from messaging_system.invalid_nested_data
   */
  /**
   * We received a ping with non-scalar data on a field of this name.
     * If this is existing pre-PingCentre-replacement data, you may need to
     * augment the logic in
     * `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
     * If this is for new, post-PingCentre-replacement data, you should
     * probably prefer a flat structure.
     * If you're unsure, please ask in
     * [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> invalid_nested_data(34);

  /**
   * generated from messaging_system.locale
   */
  /**
   * The locale as supplied to the messaging system by
     * `Services.locale.appLocaleAsBCP47`.
   */
  constexpr impl::StringMetric locale(35);

  /**
   * generated from messaging_system.message_id
   */
  /**
   * A string identifier of the message in Activity Stream Router.
   */
  constexpr impl::TextMetric message_id(36);

  /**
   * generated from messaging_system.page
   */
  /**
   * One of [”about:newtab”, “about:home”, “about:welcome”, “unknown” (which either
     * means not-applicable or is a bug)].
   */
  constexpr impl::StringMetric page(37);

  /**
   * generated from messaging_system.ping_type
   */
  /**
   * Type of event the ping is capturing. e.g. "cfr", "whats-new-panel",
     * "onboarding"
   */
  constexpr impl::StringMetric ping_type(38);

  /**
   * generated from messaging_system.source
   */
  /**
   * The source of the interaction described by the other metrics. e.g.
     * "frecent_links", "newtab", "CFR"
   */
  constexpr impl::StringMetric source(39);

  /**
   * generated from messaging_system.unknown_key_count
   */
  /**
   * The sum of all unknown keys counted.
     * Useful for testing.
     * Can be removed after bug 1600008 is resolved.
   */
  constexpr impl::CounterMetric unknown_key_count(40);

  /**
   * generated from messaging_system.unknown_keys
   */
  /**
   * Ping keys supplied to the messaging system for which
     * we did not have a corresponding metric mapped to how often they attempted
     * to be recorded.
     * You may have forgotten to define an appropriate metric in
     * `browser/components/newtab/metrics.yaml`.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown_keys(41);

}
namespace messaging_system_attribution {
  /**
   * generated from messaging_system.attribution.campaign
   */
  /**
   * Attribution's campaign, possibly derived from the utm parameter of the
     * same name.
   */
  constexpr impl::StringMetric campaign(42);

  /**
   * generated from messaging_system.attribution.content
   */
  /**
   * Attribution's content, possibly derived from the utm parameter of the
     * same name.
   */
  constexpr impl::StringMetric content(43);

  /**
   * generated from messaging_system.attribution.dlsource
   */
  /**
   * Mozilla-specific download "source" name. Could be something like
     * "mozillaci" to identify that the installer came from
     * `{archive|ftp}.mozilla.org`.
   */
  constexpr impl::StringMetric dlsource(44);

  /**
   * generated from messaging_system.attribution.dltoken
   */
  /**
   * String representation of the dltoken identifying the particular
     * installer used to install this Firefox.
     * Likely a UUID, if present.
   */
  constexpr impl::StringMetric dltoken(45);

  /**
   * generated from messaging_system.attribution.experiment
   */
  /**
   * Attribution's experiment key.
   */
  constexpr impl::StringMetric experiment(46);

  /**
   * generated from messaging_system.attribution.medium
   */
  /**
   * Attribution's medium, possibly derived from the utm parameter of the same
     * name.
   */
  constexpr impl::StringMetric medium(47);

  /**
   * generated from messaging_system.attribution.msstoresignedin
   */
  /**
   * Either the string "true" or the string "false" to indicate whether the
     * attributed install came from the Microsoft store and, if so, whether the
     * user was signed in at the time.
   */
  constexpr impl::StringMetric msstoresignedin(48);

  /**
   * generated from messaging_system.attribution.source
   */
  /**
   * Attribution's source, possibly derived from the utm parameter of the same
     * name.
   */
  constexpr impl::StringMetric source(49);

  /**
   * generated from messaging_system.attribution.ua
   */
  /**
   * Attribution's ua key.
   */
  constexpr impl::StringMetric ua(50);

  /**
   * generated from messaging_system.attribution.unknown_keys
   */
  /**
   * Attribution keys supplied to the messaging system for which
     * we did not have a corresponding metric, and the count of how
     * often that happened.
     * Either add this key to a list of known attribution keys in
     * `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
     * `browser/components/newtab/metrics.yaml` to collect.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> unknown_keys(51);

  /**
   * generated from messaging_system.attribution.variation
   */
  /**
   * Attribution's variation key.
   */
  constexpr impl::StringMetric variation(52);

}
namespace newtab {
  /**
   * generated from newtab.blocked_sponsors
   */
  /**
   * The advertiser names that have been dismissed by the user.
   */
  constexpr impl::StringListMetric blocked_sponsors(53);

  /**
   * generated from newtab.closed
   */
    struct ClosedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when newtab UI is closed by * navigation * closing the tab
     * Doesn't mean that the newtab was ever visible to a user.
   */
  constexpr impl::EventMetric<ClosedExtra> closed(54);

  /**
   * generated from newtab.homepage_category
   */
  /**
   * The current setting of the home page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `home_url_category`. Sampled once after newtab init.
   */
  constexpr impl::StringMetric homepage_category(55);

  /**
   * generated from newtab.locale
   */
  /**
   * The application's locale as of when newtab's TelemetryFeed was init. Comes from
     * `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
   */
  constexpr impl::StringMetric locale(56);

  /**
   * generated from newtab.newtab_category
   */
  /**
   * The current setting of the newtab page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `newtab_url_category`. Sampled once after newtab init.
   */
  constexpr impl::StringMetric newtab_category(57);

  /**
   * generated from newtab.opened
   */
    struct OpenedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when newtab UI is opened via `about:newtab` or `about:home` or
     * `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
     * [detect-user-session-start.js](https://searchfox.org/mozilla-
     * central/source/browser/components/newtab/content-src/lib/detect-user-session-
     * start.js)).
   */
  constexpr impl::EventMetric<OpenedExtra> opened(58);

  /**
   * generated from newtab.sov_allocation
   */
  /**
   * The partner group assignment for sov
   */
  constexpr impl::StringListMetric sov_allocation(59);

}
namespace newtab_handoff_preference {
  /**
   * generated from newtab.handoff_preference.enabled
   */
  /**
   * Records whether the browser.newtabpage.activity-
     * stream.improvesearch.handoffToAwesomebar preference is enabled or disabled
   */
  constexpr impl::BooleanMetric enabled(60);

}
namespace newtab_search {
  /**
   * generated from newtab.search.enabled
   */
  /**
   * Whether the search input is enabled on the newtab. Corresponds to the value of
     * the `browser.newtabpage.activity-stream.showSearch` pref.
   */
  constexpr impl::BooleanMetric enabled(61);

  /**
   * generated from newtab.search.issued
   */
    struct IssuedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * When Firefox was asked to issue a search from a Search Access Point (SAP) on a
     * newtab page. Doesn't record searches in Private Browsing Mode unless
     * `browser.engagement.search_counts.pbm` is set to `true`.
   */
  constexpr impl::EventMetric<IssuedExtra> issued(62);

}
namespace pocket {
  /**
   * generated from pocket.click
   */
    struct ClickExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<ClickExtra> click(63);

  /**
   * generated from pocket.enabled
   */
  /**
   * Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
     * section. Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.section.topstories` pref.
   */
  constexpr impl::BooleanMetric enabled(64);

  /**
   * generated from pocket.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket tile is visible to the user.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(65);

  /**
   * generated from pocket.is_signed_in
   */
  /**
   * Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
     * so its value is resampled at newtab's component init and whenever there is a
     * Discovery Stream user event.
   */
  constexpr impl::BooleanMetric is_signed_in(66);

  /**
   * generated from pocket.save
   */
    struct SaveExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<nsCString> recommendationId;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (recommendationId) {
          extraKeys.AppendElement()->AssignASCII("recommendation_id");
          extraValues.EmplaceBack(recommendationId.value());
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user decides to save a pocket tile. Does not mean it ends up
     * successfully saved. Just that the user clicked on "Save to Pocket" in the
     * little pocket tile menu.
   */
  constexpr impl::EventMetric<SaveExtra> save(67);

  /**
   * generated from pocket.shim
   */
  /**
   * Opaque partner identifier for a given ad impression or engagement action,
     * unique per market and region.
     * Pocket
     * [proxies requests to ad partners](https://github.com/Pocket/proxy-server/)
     * and provides them solely with market, region, and action to generate these
     * shims. Thus, though the contents of this field are obscure, they cannot
     * identify clients.
     * At time of writing this information is a comma-separated trio.
     * The first item is an index into the proxy server's list of acceptable http
     * endpoints for contacting the ad service. The second item is a
     * several-hundred-byte base64-encoded JSON-encoded struct with fields for,
     * amongst other things, market and region. The third is unknown, but appears
     * to be a signature or checksum.
     * This shim should not be sent with the client_id.
   */
  constexpr impl::TextMetric shim(68);

  /**
   * generated from pocket.sponsored_stories_enabled
   */
  /**
   * Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
     * value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
     * `true` even if pocket.enabled is `false`.
   */
  constexpr impl::BooleanMetric sponsored_stories_enabled(69);

  /**
   * generated from pocket.topic_click
   */
    struct TopicClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> topic;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
     * on middle-click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<TopicClickExtra> topic_click(70);

}
namespace top_sites {
  /**
   * generated from top_sites.advertiser
   */
  /**
   * The name of the advertiser providing the sponsored TopSite.
   */
  constexpr impl::StringMetric advertiser(71);

  /**
   * generated from top_sites.context_id
   */
  /**
   * An identifier to identify users for Contextual Services user interaction pings.
   */
  constexpr impl::UuidMetric context_id(72);

  /**
   * generated from top_sites.ping_type
   */
  /**
   * The ping's type. In other situations might be designated by an event's name or
     * an interaction field. E.g. "topsites-impression", "topsites-click".
   */
  constexpr impl::StringMetric ping_type(73);

  /**
   * generated from top_sites.position
   */
  /**
   * The position (1-based) of the topsites item being interatcted with.
   */
  constexpr impl::QuantityMetric position(74);

  /**
   * generated from top_sites.reporting_url
   */
  /**
   * The url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(75);

  /**
   * generated from top_sites.source
   */
  /**
   * The source of the interaction. Always set to "newtab".
   */
  constexpr impl::StringMetric source(76);

  /**
   * generated from top_sites.tile_id
   */
  /**
   * String-encoded number for the tile's sponsored tile id.
   */
  constexpr impl::StringMetric tile_id(77);

}
namespace topsites {
  /**
   * generated from topsites.click
   */
    struct ClickExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
   */
  constexpr impl::EventMetric<ClickExtra> click(78);

  /**
   * generated from topsites.dismiss
   */
    struct DismissExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the "Dismiss" menu item in the three-dots menu of a topsite is
     * clicked. Corresponds to the receipt of a dispatched `BLOCK_URL` action by
     * `TelemetryFeed`. Applies to both sponsored and non-sponsored topsites.
     * `advertiser_name` is only provided for sponsored topsites.
   */
  constexpr impl::EventMetric<DismissExtra> dismiss(79);

  /**
   * generated from topsites.enabled
   */
  /**
   * Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
     * Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.topsites` pref.
   */
  constexpr impl::BooleanMetric enabled(80);

  /**
   * generated from topsites.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when topsite tiles are loaded.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(81);

  /**
   * generated from topsites.pref_changed
   */
    struct PrefChangedExtra {
      mozilla::Maybe<bool> newValue;
      mozilla::Maybe<nsCString> prefName;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newValue) {
          extraKeys.AppendElement()->AssignASCII("new_value");
          extraValues.AppendElement()->AssignASCII(newValue.value() ? "true" : "false");
        }
        if (prefName) {
          extraKeys.AppendElement()->AssignASCII("pref_name");
          extraValues.EmplaceBack(prefName.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when specific topsites prefs have changed.
     * The list of possible prefs is presently:
     *  * browser.newtabpage.activity-stream.feeds.topsites
     *  * browser.newtabpage.activity-stream.showSponsoredTopSites
   */
  constexpr impl::EventMetric<PrefChangedExtra> pref_changed(82);

  /**
   * generated from topsites.rows
   */
  /**
   * The number of topsite tile rows configured to be shown on the newtab page.
     * Corresponds to the value of the `browser.newtabpage.activity-
     * stream.topSitesRows` pref. This is not the number of rows actually seen by the
     * user: if the browser window is partially off-screen, or isn't wide enough to
     * accommodate eight tiles per row, the actual number of rows may be different.
   */
  constexpr impl::QuantityMetric rows(83);

  /**
   * generated from topsites.show_privacy_click
   */
    struct ShowPrivacyClickExtra {
      mozilla::Maybe<nsCString> advertiserName;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;
      mozilla::Maybe<uint32_t> tileId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (advertiserName) {
          extraKeys.AppendElement()->AssignASCII("advertiser_name");
          extraValues.EmplaceBack(advertiserName.value());
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        if (tileId) {
          extraKeys.AppendElement()->AssignASCII("tile_id");
          extraValues.EmplaceBack(nsPrintfCString("%d", tileId.value()));
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the "Our Sponsors and Your Privacy" menu item in the three- dots
     * menu of a sponsored topsite is clicked. Corresponds to the receipt of a
     * dispatched `ABOUT_SPONSORED_TOP_SITES` action by `TelemetryFeed`.
   */
  constexpr impl::EventMetric<ShowPrivacyClickExtra> show_privacy_click(84);

  /**
   * generated from topsites.sponsored_enabled
   */
  /**
   * Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
     * Shortcuts" section. Corresponds to the value of the
     * `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
     * even if topsites.enabled is `false`.
   */
  constexpr impl::BooleanMetric sponsored_enabled(85);

}
namespace pocket_button {
  /**
   * generated from pocket.button.event_action
   */
  /**
   * The action that was taken, like "click" or... actually, it might only ever be
     * "click".
   */
  constexpr impl::StringMetric event_action(86);

  /**
   * generated from pocket.button.event_position
   */
  /**
   * 0-based index of the item on which the action was performed. Not always
     * provided.
   */
  constexpr impl::QuantityMetric event_position(87);

  /**
   * generated from pocket.button.event_source
   */
  /**
   * The source of the taken action, like "save_button", "home_button",
     * "on_save_recs", or the like.
   */
  constexpr impl::StringMetric event_source(88);

  /**
   * generated from pocket.button.impression_id
   */
  /**
   * A UUID representing this profile. This isn't client_id, nor can it be used to
     * link to a client_id. This also means it should never be sent in a ping with a
     * client_id.
   */
  constexpr impl::UuidMetric impression_id(89);

  /**
   * generated from pocket.button.model
   */
  /**
   * A string that identifies the ML model (if any) used to generate on-save
     * recommendations. Like "doc2vec-incremental-best-article-pubspread".
   */
  constexpr impl::StringMetric model(90);

  /**
   * generated from pocket.button.pocket_logged_in_status
   */
  /**
   * Whether there was a logged-in Pocket account in the Pocket-Firefox integration
     * at the point in time this action occurred.
   */
  constexpr impl::BooleanMetric pocket_logged_in_status(91);

  /**
   * generated from pocket.button.profile_creation_date
   */
  /**
   * The days since Jan 1, 1970 that the oldest file in the profile dir was
     * modified. Or created. Or just the day and time of the first thing to ask for
     * the profile age called in. Or something earlier or later than that.
     * You may not want to use this.
   */
  constexpr impl::QuantityMetric profile_creation_date(92);

}
namespace privacy_ui_fpp_click {
  /**
   * generated from privacy.ui.fpp.click.checkbox
   */
    struct CheckboxExtra {
      mozilla::Maybe<bool> checked;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (checked) {
          extraKeys.AppendElement()->AssignASCII("checked");
          extraValues.AppendElement()->AssignASCII(checked.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on fingerprinting protection checkbox in the
     * ETP Custom subpanel.
   */
  constexpr impl::EventMetric<CheckboxExtra> checkbox(93);

  /**
   * generated from privacy.ui.fpp.click.menu
   */
    struct MenuExtra {
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * User interaction by click events on fingerprinting protection menulist in the
     * ETP Custom subpanel.
   */
  constexpr impl::EventMetric<MenuExtra> menu(94);

}
namespace private_browsing_reset_pbm {
  /**
   * generated from private_browsing.reset_pbm.confirm_panel
   */
    struct ConfirmPanelExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Confirm panel show / hide event.
   */
  constexpr impl::EventMetric<ConfirmPanelExtra> confirm_panel(95);

  /**
   * generated from private_browsing.reset_pbm.reset_action
   */
    struct ResetActionExtra {
      mozilla::Maybe<bool> didConfirm;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (didConfirm) {
          extraKeys.AppendElement()->AssignASCII("did_confirm");
          extraValues.AppendElement()->AssignASCII(didConfirm.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Dispatched whenever PBM is restarted / reset via the resetPBM feature.
   */
  constexpr impl::EventMetric<ResetActionExtra> reset_action(96);

}
namespace protocolhandler_mailto {
  /**
   * generated from protocolhandler.mailto.handler_prompt_shown
   */
  enum class HandlerPromptShownLabel: uint16_t {
      eOsDefault = 0,
      eFxDefault = 1,
      e__Other__,
    };
  /**
   * A website was visited, which called registerProtocolHandler for mailto://
   */
  constexpr impl::Labeled<impl::CounterMetric, HandlerPromptShownLabel> handler_prompt_shown(97);

  /**
   * generated from protocolhandler.mailto.prompt_clicked
   */
  enum class PromptClickedLabel: uint16_t {
      eSetOsDefault = 0,
      eDismissOsDefault = 1,
      eSetLocalDefault = 2,
      eDismissLocalDefault = 3,
      e__Other__,
    };
  /**
   * User clicked on a button to approve setting the current site as default web
     * mail site. The sum of all counters is the total amount of user interactions and
     * dismissing the same dialog often could be a sign of a bug.
   */
  constexpr impl::Labeled<impl::CounterMetric, PromptClickedLabel> prompt_clicked(98);

  /**
   * generated from protocolhandler.mailto.visit
   */
    struct VisitExtra {
      mozilla::Maybe<bool> triggeredExternally;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (triggeredExternally) {
          extraKeys.AppendElement()->AssignASCII("triggered_externally");
          extraValues.AppendElement()->AssignASCII(triggeredExternally.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * a URI of type mailto was visited. Furthermore we want to know if from within
     * the browser.
   */
  constexpr impl::EventMetric<VisitExtra> visit(99);

}
namespace newtab_search_ad {
  /**
   * generated from newtab.search.ad.click
   */
    struct ClickExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
     * was loaded by a seach that began on a newtab page.
   */
  constexpr impl::EventMetric<ClickExtra> click(100);

  /**
   * generated from newtab.search.ad.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a newtab visit resulted in a search that loaded a Search Engine
     * Result Page (SERP) that contains an ad link. And the SERP is visible.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(101);

}
namespace search_with {
  /**
   * generated from search_with.context_id
   */
  /**
   * An identifier for Contextual Services user interaction pings. This is used
     * internally for counting unique users as well as for anti-fraud. It is shared
     * with other Contextual Services. It is not shared externally.
   */
  constexpr impl::UuidMetric context_id(102);

  /**
   * generated from search_with.reporting_url
   */
  /**
   * The external url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(103);

}
namespace serp {
  /**
   * generated from serp.abandonment
   */
    struct AbandonmentExtra {
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when there is no engagement with the SERP before the tab is closed,
     * the window is closed, the app is closed, or the tab is navigated away from.
   */
  constexpr impl::EventMetric<AbandonmentExtra> abandonment(104);

  /**
   * generated from serp.ad_impression
   */
    struct AdImpressionExtra {
      mozilla::Maybe<uint32_t> adsHidden;
      mozilla::Maybe<uint32_t> adsLoaded;
      mozilla::Maybe<uint32_t> adsVisible;
      mozilla::Maybe<nsCString> component;
      mozilla::Maybe<nsCString> impressionId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (adsHidden) {
          extraKeys.AppendElement()->AssignASCII("ads_hidden");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsHidden.value()));
        }
        if (adsLoaded) {
          extraKeys.AppendElement()->AssignASCII("ads_loaded");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsLoaded.value()));
        }
        if (adsVisible) {
          extraKeys.AppendElement()->AssignASCII("ads_visible");
          extraValues.EmplaceBack(nsPrintfCString("%d", adsVisible.value()));
        }
        if (component) {
          extraKeys.AppendElement()->AssignASCII("component");
          extraValues.EmplaceBack(component.value());
        }
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user loads a SERP and ads are detected.
   */
  constexpr impl::EventMetric<AdImpressionExtra> ad_impression(105);

  /**
   * generated from serp.categorization_duration
   */
  /**
   * The time it takes to categorize elements on a SERP.
   */
  constexpr impl::TimingDistributionMetric categorization_duration(106);

  /**
   * generated from serp.engagement
   */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<nsCString> target;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (target) {
          extraKeys.AppendElement()->AssignASCII("target");
          extraValues.EmplaceBack(target.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded user actions on a SERP.
   */
  constexpr impl::EventMetric<EngagementExtra> engagement(107);

  /**
   * generated from serp.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<bool> isPrivate;
      mozilla::Maybe<bool> isShoppingPage;
      mozilla::Maybe<nsCString> partnerCode;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<bool> shoppingTabDisplayed;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<bool> tagged;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (isPrivate) {
          extraKeys.AppendElement()->AssignASCII("is_private");
          extraValues.AppendElement()->AssignASCII(isPrivate.value() ? "true" : "false");
        }
        if (isShoppingPage) {
          extraKeys.AppendElement()->AssignASCII("is_shopping_page");
          extraValues.AppendElement()->AssignASCII(isShoppingPage.value() ? "true" : "false");
        }
        if (partnerCode) {
          extraKeys.AppendElement()->AssignASCII("partner_code");
          extraValues.EmplaceBack(partnerCode.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (shoppingTabDisplayed) {
          extraKeys.AppendElement()->AssignASCII("shopping_tab_displayed");
          extraValues.AppendElement()->AssignASCII(shoppingTabDisplayed.value() ? "true" : "false");
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (tagged) {
          extraKeys.AppendElement()->AssignASCII("tagged");
          extraValues.AppendElement()->AssignASCII(tagged.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a search engine results page (SERP) is shown to a user.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(108);

}
namespace shopping {
  /**
   * generated from shopping.address_bar_feature_callout_displayed
   */
    struct AddressBarFeatureCalloutDisplayedExtra {
      mozilla::Maybe<nsCString> configuration;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (configuration) {
          extraKeys.AppendElement()->AssignASCII("configuration");
          extraValues.EmplaceBack(configuration.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user was shown the feature callout for the Shopping component.
   */
  constexpr impl::EventMetric<AddressBarFeatureCalloutDisplayedExtra> address_bar_feature_callout_displayed(109);

  /**
   * generated from shopping.address_bar_icon_clicked
   */
    struct AddressBarIconClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping product Address Bar Icon was clicked by the user.
   */
  constexpr impl::EventMetric<AddressBarIconClickedExtra> address_bar_icon_clicked(110);

  /**
   * generated from shopping.address_bar_icon_displayed
   */
  /**
   * The Shopping product Address Bar Icon was displayed to the user.
   */
  constexpr impl::EventMetric<NoExtraKeys> address_bar_icon_displayed(111);

  /**
   * generated from shopping.ads_exposure
   */
  /**
   * On a supported product page, the review checker showed analysis, and
     * the ads exposure pref was enabled, or review checker ads were enabled,
     * and when we tried to fetch an ad from the ad server, an ad was available.
     * Does not indicate whether the ad was actually shown.
   */
  constexpr impl::EventMetric<NoExtraKeys> ads_exposure(112);

  /**
   * generated from shopping.product_page_visits
   */
  /**
   * Counts number of visits to a supported retailer product page
     * while enrolled in either the control or treatment branches
     * of the shopping experiment.
   */
  constexpr impl::CounterMetric product_page_visits(113);

  /**
   * generated from shopping.surface_ads_clicked
   */
  /**
   * An ad shown in the sidebar was clicked.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_ads_clicked(114);

  /**
   * generated from shopping.surface_ads_impression
   */
  /**
   * An ad was shown and visible in the sidebar for 1.5 seconds.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_ads_impression(115);

  /**
   * generated from shopping.surface_ads_setting_toggled
   */
    struct SurfaceAdsSettingToggledExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked the settings toggle to enable or disable ads in the
     * sidebar settings component.
   */
  constexpr impl::EventMetric<SurfaceAdsSettingToggledExtra> surface_ads_setting_toggled(116);

  /**
   * generated from shopping.surface_analyze_reviews_none_available_clicked
   */
  /**
   * The user clicked to analyze reviews in the case the reliability rating
     * was not available for display in the shopping side bar. This metric
     * does not contain any information about the product the user is viewing.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_analyze_reviews_none_available_clicked(117);

  /**
   * generated from shopping.surface_closed
   */
    struct SurfaceClosedExtra {
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user opened the settings menu of the shopping component.
   */
  constexpr impl::EventMetric<SurfaceClosedExtra> surface_closed(118);

  /**
   * generated from shopping.surface_displayed
   */
    struct SurfaceDisplayedExtra {
      mozilla::Maybe<nsCString> sideBarState;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (sideBarState) {
          extraKeys.AppendElement()->AssignASCII("side_bar_state");
          extraValues.EmplaceBack(sideBarState.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping product Sidebar was displayed.
   */
  constexpr impl::EventMetric<SurfaceDisplayedExtra> surface_displayed(119);

  /**
   * generated from shopping.surface_learn_more_clicked
   */
  /**
   * The user clicked the 'Learn More' link in the Shopping onboarding
     * experience.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_learn_more_clicked(120);

  /**
   * generated from shopping.surface_no_ads_available
   */
  /**
   * On a supported product page, the review checker showed analysis, and
     * review checker ads were enabled, but when we tried to fetch an ad from
     * the ad server, no ad was available.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_no_ads_available(121);

  /**
   * generated from shopping.surface_no_review_reliability_available
   */
  /**
   * Review reliability was not available for display in the shopping side
     * bar. This metric does not contain any information about the product
     * the user is viewing.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_no_review_reliability_available(122);

  /**
   * generated from shopping.surface_not_now_clicked
   */
  /**
   * The user clicked 'Not Now' to dismiss the dialog.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_not_now_clicked(123);

  /**
   * generated from shopping.surface_onboarding_displayed
   */
    struct SurfaceOnboardingDisplayedExtra {
      mozilla::Maybe<nsCString> configuration;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (configuration) {
          extraKeys.AppendElement()->AssignASCII("configuration");
          extraValues.EmplaceBack(configuration.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The Shopping Side bar displayed the onboarding experience.
   */
  constexpr impl::EventMetric<SurfaceOnboardingDisplayedExtra> surface_onboarding_displayed(124);

  /**
   * generated from shopping.surface_opt_in_clicked
   */
  /**
   * The user clicked the "Yes, try it" element to use the Shopping product's
     * functionality.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_opt_in_clicked(125);

  /**
   * generated from shopping.surface_opt_out_button_clicked
   */
  /**
   * The user clicked the button in the settings panel to turn off the shopping
     * experience.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_opt_out_button_clicked(126);

  /**
   * generated from shopping.surface_powered_by_fakespot_link_clicked
   */
  /**
   * The user clicked the "Fakespot by Mozilla" link in the shopping side
     * bar.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_powered_by_fakespot_link_clicked(127);

  /**
   * generated from shopping.surface_reactivated_button_clicked
   */
  /**
   * The user clicked the reactivated product button.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_reactivated_button_clicked(128);

  /**
   * generated from shopping.surface_reanalyze_clicked
   */
  /**
   * The user clicked to REanalyze reviews in the shopping side bar. This
     * metric does not contain any information about the product the user is
     * viewing or any displayed trusted deals.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_reanalyze_clicked(129);

  /**
   * generated from shopping.surface_settings_expand_clicked
   */
    struct SurfaceSettingsExpandClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user opened the settings menu of the shopping component.
   */
  constexpr impl::EventMetric<SurfaceSettingsExpandClickedExtra> surface_settings_expand_clicked(130);

  /**
   * generated from shopping.surface_show_more_reviews_button_clicked
   */
    struct SurfaceShowMoreReviewsButtonClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked to expand the recent reviews to see more.
   */
  constexpr impl::EventMetric<SurfaceShowMoreReviewsButtonClickedExtra> surface_show_more_reviews_button_clicked(131);

  /**
   * generated from shopping.surface_show_privacy_policy_clicked
   */
  /**
   * The user clicked to view the Privacy Policy.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_privacy_policy_clicked(132);

  /**
   * generated from shopping.surface_show_quality_explainer_clicked
   */
    struct SurfaceShowQualityExplainerClickedExtra {
      mozilla::Maybe<nsCString> action;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The user clicked to see the explanation of Review Quality in the
     * shopping component.
   */
  constexpr impl::EventMetric<SurfaceShowQualityExplainerClickedExtra> surface_show_quality_explainer_clicked(133);

  /**
   * generated from shopping.surface_show_quality_explainer_url_clicked
   */
  /**
   * The user clicked to see the explanation of Review Quality in the
     * shopping component.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_quality_explainer_url_clicked(134);

  /**
   * generated from shopping.surface_show_terms_clicked
   */
  /**
   * The user clicked to view the Terms of Service.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_show_terms_clicked(135);

  /**
   * generated from shopping.surface_stale_analysis_shown
   */
  /**
   * The user was shown the dialogue box indicating that analysis of a product
     * was stale. No information about the product is included.
   */
  constexpr impl::EventMetric<NoExtraKeys> surface_stale_analysis_shown(136);

}
namespace shopping_settings {
  /**
   * generated from shopping.settings.component_opted_out
   */
  /**
   * Indicates if the user has opted out of using the shopping component.
     * Set during shopping component init and updated when changed in browser.
   */
  constexpr impl::BooleanMetric component_opted_out(137);

  /**
   * generated from shopping.settings.disabled_ads
   */
  /**
   * Indicates if the user has manually disabled ads. Set during shopping
     * component init and updated when changed in browser.
   */
  constexpr impl::BooleanMetric disabled_ads(138);

  /**
   * generated from shopping.settings.has_onboarded
   */
  /**
   * Indicates if the user has completed the Shopping product Onboarding
     * experience. Set during shopping component init and updated when changed
     * in browser.
   */
  constexpr impl::BooleanMetric has_onboarded(139);

  /**
   * generated from shopping.settings.nimbus_disabled_shopping
   */
  /**
   * Indicates if Nimbus has disabled the use the shopping component.
   */
  constexpr impl::BooleanMetric nimbus_disabled_shopping(140);

}
namespace quick_suggest {
  /**
   * generated from quick_suggest.advertiser
   */
  /**
   * The name of the advertiser providing the sponsored TopSite.
   */
  constexpr impl::StringMetric advertiser(141);

  /**
   * generated from quick_suggest.block_id
   */
  /**
   * A unique identifier for the suggestion (a.k.a. a keywords block).
   */
  constexpr impl::StringMetric block_id(142);

  /**
   * generated from quick_suggest.context_id
   */
  /**
   * An identifier to identify users for Contextual Services user interaction pings.
   */
  constexpr impl::UuidMetric context_id(143);

  /**
   * generated from quick_suggest.iab_category
   */
  /**
   * The suggestion's category. Either "22 - Shopping" or "5 - Educational".
   */
  constexpr impl::StringMetric iab_category(144);

  /**
   * generated from quick_suggest.improve_suggest_experience
   */
  /**
   * Whether the "Improve Suggest Experience" checkbox is checked.
   */
  constexpr impl::BooleanMetric improve_suggest_experience(145);

  /**
   * generated from quick_suggest.is_clicked
   */
  /**
   * Whether this quicksuggest-impression ping was for an item that was clicked.
   */
  constexpr impl::BooleanMetric is_clicked(146);

  /**
   * generated from quick_suggest.match_type
   */
  /**
   * Whether this was a best/top match or not. Either "best-match" or "firefox-
     * suggest".
   */
  constexpr impl::StringMetric match_type(147);

  /**
   * generated from quick_suggest.ping_type
   */
  /**
   * The ping's type. In other situations might be designated by an event's name or
     * an interaction field. E.g. "quicksuggest-impression", "quicksuggest-block",
     * "quicksuggest-click".
   */
  constexpr impl::StringMetric ping_type(148);

  /**
   * generated from quick_suggest.position
   */
  /**
   * The position (1-based) of the QuickSuggest item being interatcted with.
   */
  constexpr impl::QuantityMetric position(149);

  /**
   * generated from quick_suggest.reporting_url
   */
  /**
   * The url to report this interaction to.
   */
  constexpr impl::UrlMetric reporting_url(150);

  /**
   * generated from quick_suggest.request_id
   */
  /**
   * A request identifier for each API request to [Merino](https://mozilla-
     * services.github.io/merino/). Only present for suggestions provided by Merino.
   */
  constexpr impl::StringMetric request_id(151);

  /**
   * generated from quick_suggest.source
   */
  /**
   * The source of the interaction. E.g. "urlbar".
   */
  constexpr impl::StringMetric source(152);

  /**
   * generated from quick_suggest.suggested_index
   */
  /**
   * A stringified integer value that is the intended index of the suggestion being
     * interacted with. If `suggested_index_relative_to_group` is true, the index is
     * relative to the "Firefox Suggest" group; otherwise the index is relative to the
     * entire list of suggestions. Non-negative values (starting at 0) are relative to
     * the start/top of the group/list; negative values are relative to the end/bottom
     * of the group/list.
   */
  constexpr impl::StringMetric suggested_index(153);

  /**
   * generated from quick_suggest.suggested_index_relative_to_group
   */
  /**
   * Whether `suggested_index` is relative to the "Firefox Suggest" group. If false,
     * it is relative to the entire list of suggestions.
   */
  constexpr impl::BooleanMetric suggested_index_relative_to_group(154);

}
namespace urlbar {
  /**
   * generated from urlbar.abandonment
   */
    struct AbandonmentExtra {
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchEngineDefaultId;
      mozilla::Maybe<nsCString> searchMode;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchEngineDefaultId) {
          extraKeys.AppendElement()->AssignASCII("search_engine_default_id");
          extraValues.EmplaceBack(searchEngineDefaultId.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user abandons a search (blurring the urlbar).
   */
  constexpr impl::EventMetric<AbandonmentExtra> abandonment(155);

  /**
   * generated from urlbar.engagement
   */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> engagementType;
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchEngineDefaultId;
      mozilla::Maybe<nsCString> searchMode;
      mozilla::Maybe<uint32_t> selectedPosition;
      mozilla::Maybe<nsCString> selectedResult;
      mozilla::Maybe<nsCString> selectedResultSubtype;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (engagementType) {
          extraKeys.AppendElement()->AssignASCII("engagement_type");
          extraValues.EmplaceBack(engagementType.value());
        }
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchEngineDefaultId) {
          extraKeys.AppendElement()->AssignASCII("search_engine_default_id");
          extraValues.EmplaceBack(searchEngineDefaultId.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        if (selectedPosition) {
          extraKeys.AppendElement()->AssignASCII("selected_position");
          extraValues.EmplaceBack(nsPrintfCString("%d", selectedPosition.value()));
        }
        if (selectedResult) {
          extraKeys.AppendElement()->AssignASCII("selected_result");
          extraValues.EmplaceBack(selectedResult.value());
        }
        if (selectedResultSubtype) {
          extraKeys.AppendElement()->AssignASCII("selected_result_subtype");
          extraValues.EmplaceBack(selectedResultSubtype.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the user executes an action on a result.
   */
  constexpr impl::EventMetric<EngagementExtra> engagement(156);

  /**
   * generated from urlbar.exposure
   */
    struct ExposureExtra {
      mozilla::Maybe<nsCString> results;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when client is exposed to urlbar experiment results.
   */
  constexpr impl::EventMetric<ExposureExtra> exposure(157);

  /**
   * generated from urlbar.impression
   */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchEngineDefaultId;
      mozilla::Maybe<nsCString> searchMode;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchEngineDefaultId) {
          extraKeys.AppendElement()->AssignASCII("search_engine_default_id");
          extraValues.EmplaceBack(searchEngineDefaultId.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when urlbar results are shown to the user.
   */
  constexpr impl::EventMetric<ImpressionExtra> impression(158);

  /**
   * generated from urlbar.pref_max_results
   */
  /**
   * Maximum results to show in the Address Bar. Corresponds to the value of the
     * `browser.urlbar.maxRichResults` pref.
   */
  constexpr impl::QuantityMetric pref_max_results(159);

  /**
   * generated from urlbar.pref_suggest_data_collection
   */
  /**
   * Whether the user has opted in to data collection for Firefox Suggest, i.e.,
     * online suggestions served from Merino. Corresponds to the value of the
     * `browser.urlbar.quicksuggest.dataCollection.enabled` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_data_collection(160);

  /**
   * generated from urlbar.pref_suggest_nonsponsored
   */
  /**
   * Whether non-sponsored quick suggest results are shown in the urlbar.
     * Corresponds to the value of the
     * `browser.urlbar.suggest.quicksuggest.nonsponsored` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_nonsponsored(161);

  /**
   * generated from urlbar.pref_suggest_sponsored
   */
  /**
   * Whether sponsored quick suggest results are shown in the urlbar. Corresponds to
     * the value of the `browser.urlbar.suggest.quicksuggest.sponsored` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_sponsored(162);

  /**
   * generated from urlbar.pref_suggest_topsites
   */
  /**
   * Whether topsite results are enabled in the urlbar. Corresponds to the value of
     * the `browser.urlbar.suggest.topsites` pref.
   */
  constexpr impl::BooleanMetric pref_suggest_topsites(163);

  /**
   * generated from urlbar.quick_suggest_contextual_opt_in
   */
    struct QuickSuggestContextualOptInExtra {
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<bool> sayHello;
      mozilla::Maybe<bool> topPosition;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (sayHello) {
          extraKeys.AppendElement()->AssignASCII("say_hello");
          extraValues.AppendElement()->AssignASCII(sayHello.value() ? "true" : "false");
        }
        if (topPosition) {
          extraKeys.AppendElement()->AssignASCII("top_position");
          extraValues.AppendElement()->AssignASCII(topPosition.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the contextual opt-in UI is shown or interacted with.
   */
  constexpr impl::EventMetric<QuickSuggestContextualOptInExtra> quick_suggest_contextual_opt_in(164);

}
namespace browser_engagement {
  /**
   * generated from browser.engagement.active_ticks
   */
  /**
   * The number of five-second intervals ('ticks') the user was considered
     * 'active'.
     * 
     * 'active' means keyboard or mouse interaction with the application.
     * It doesn't take into account whether or not the window has focus or is in
     * the foreground, only if it is receiving these interaction events.
     * 
     * Migrated from Telemetry's `browser.engagement.active_ticks`.
   */
  constexpr impl::CounterMetric active_ticks(165);

  /**
   * generated from browser.engagement.profile_count
   */
  /**
   * Windows only count of the browser profiles on the current system. This
     * counts profiles that have been used across all Windows user accounts on
     * machine since this probe was added. The value persists across installs.
     * A value of 0 is reported if there is an error determining the correct
     * count. Unset on other platforms.
   */
  constexpr impl::QuantityMetric profile_count(166);

  /**
   * generated from browser.engagement.uri_count
   */
  /**
   * The number of total non-unique http(s) URIs visited, including page
     * reloads, after the session has been restored. URIs on minimized or
     * background tabs may also be counted. Private browsing uris are included.
     * 
     * Migrated from Telemetry's
     * `browser.engagement.total_uri_count_normal_and_private_mode`.
   */
  constexpr impl::CounterMetric uri_count(167);

}
namespace ping_centre {
  /**
   * generated from ping.centre.send_failures
   */
  /**
   * The number of PingCentre send failures.
   */
  constexpr impl::CounterMetric send_failures(168);

  /**
   * generated from ping.centre.send_failures_by_namespace
   */
  enum class SendFailuresByNamespaceLabel: uint16_t {
      eActivityStream = 0,
      eMessagingSystem = 1,
      eContextualServices = 2,
      e__Other__,
    };
  /**
   * The number of PingCentre send failures,
     * broken down by structured ingestion namespace.
   */
  constexpr impl::Labeled<impl::CounterMetric, SendFailuresByNamespaceLabel> send_failures_by_namespace(169);

  /**
   * generated from ping.centre.send_successes_by_namespace
   */
  enum class SendSuccessesByNamespaceLabel: uint16_t {
      eActivityStream = 0,
      eMessagingSystem = 1,
      eContextualServices = 2,
      e__Other__,
    };
  /**
   * The number of PingCentre send successes,
     * broken down by structured ingestion namespace.
   */
  constexpr impl::Labeled<impl::CounterMetric, SendSuccessesByNamespaceLabel> send_successes_by_namespace(170);

}
namespace use_counter {
  /**
   * generated from use.counter.content_documents_destroyed
   */
  /**
   * A count of how many content documents were destroyed. Used to turn document use
     * counters' counts into rates. Excludes documents for which we do not count use
     * counters (See `Document::ShouldIncludeInTelemetry`).
   */
  constexpr impl::CounterMetric content_documents_destroyed(171);

  /**
   * generated from use.counter.dedicated_workers_destroyed
   */
  /**
   * A count of how many `Dedicated`-kind workers were destroyed. Used to turn
     * dedicated worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric dedicated_workers_destroyed(172);

  /**
   * generated from use.counter.service_workers_destroyed
   */
  /**
   * A count of how many `Service`-kind workers were destroyed. Used to turn service
     * worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric service_workers_destroyed(173);

  /**
   * generated from use.counter.shared_workers_destroyed
   */
  /**
   * A count of how many `Shared`-kind workers were destroyed. Used to turn shared
     * worker use counters' counts into rates. Excludes chrome workers.
   */
  constexpr impl::CounterMetric shared_workers_destroyed(174);

  /**
   * generated from use.counter.top_level_content_documents_destroyed
   */
  /**
   * A count of how many "pages" were destroyed. Used to turn page use counters'
     * counts into rates. Excludes pages that contain only documents for which we do
     * not count use counters (See `Document::ShouldIncludeInTelemetry`).
   */
  constexpr impl::CounterMetric top_level_content_documents_destroyed(175);

}
namespace use_counter_css_doc {
  /**
   * generated from use.counter.css.doc.alignment_baseline
   */
  /**
   * Whether a document used the (unknown, counted) CSS property alignment-baseline.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric alignment_baseline(176);

  /**
   * generated from use.counter.css.doc.background_repeat_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property background-
     * repeat-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_x(177);

  /**
   * generated from use.counter.css.doc.background_repeat_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property background-
     * repeat-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_y(178);

  /**
   * generated from use.counter.css.doc.baseline_shift
   */
  /**
   * Whether a document used the (unknown, counted) CSS property baseline-shift.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric baseline_shift(179);

  /**
   * generated from use.counter.css.doc.buffered_rendering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property buffered-rendering.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric buffered_rendering(180);

  /**
   * generated from use.counter.css.doc.color_rendering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property color-rendering.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric color_rendering(181);

  /**
   * generated from use.counter.css.doc.css_accent_color
   */
  /**
   * Whether a document used the CSS property accent-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_accent_color(182);

  /**
   * generated from use.counter.css.doc.css_align_content
   */
  /**
   * Whether a document used the CSS property align-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_content(183);

  /**
   * generated from use.counter.css.doc.css_align_items
   */
  /**
   * Whether a document used the CSS property align-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_items(184);

  /**
   * generated from use.counter.css.doc.css_align_self
   */
  /**
   * Whether a document used the CSS property align-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_self(185);

  /**
   * generated from use.counter.css.doc.css_align_tracks
   */
  /**
   * Whether a document used the CSS property align-tracks. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_tracks(186);

  /**
   * generated from use.counter.css.doc.css_all
   */
  /**
   * Whether a document used the CSS property all. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_all(187);

  /**
   * generated from use.counter.css.doc.css_animation
   */
  /**
   * Whether a document used the CSS property animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation(188);

  /**
   * generated from use.counter.css.doc.css_animation_composition
   */
  /**
   * Whether a document used the CSS property animation-composition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_composition(189);

  /**
   * generated from use.counter.css.doc.css_animation_delay
   */
  /**
   * Whether a document used the CSS property animation-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_delay(190);

  /**
   * generated from use.counter.css.doc.css_animation_direction
   */
  /**
   * Whether a document used the CSS property animation-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_direction(191);

  /**
   * generated from use.counter.css.doc.css_animation_duration
   */
  /**
   * Whether a document used the CSS property animation-duration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_duration(192);

  /**
   * generated from use.counter.css.doc.css_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property animation-fill-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_fill_mode(193);

  /**
   * generated from use.counter.css.doc.css_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property animation-iteration-count. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_iteration_count(194);

  /**
   * generated from use.counter.css.doc.css_animation_name
   */
  /**
   * Whether a document used the CSS property animation-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_name(195);

  /**
   * generated from use.counter.css.doc.css_animation_play_state
   */
  /**
   * Whether a document used the CSS property animation-play-state. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_play_state(196);

  /**
   * generated from use.counter.css.doc.css_animation_timeline
   */
  /**
   * Whether a document used the CSS property animation-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timeline(197);

  /**
   * generated from use.counter.css.doc.css_animation_timing_function
   */
  /**
   * Whether a document used the CSS property animation-timing-function. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timing_function(198);

  /**
   * generated from use.counter.css.doc.css_appearance
   */
  /**
   * Whether a document used the CSS property appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_appearance(199);

  /**
   * generated from use.counter.css.doc.css_aspect_ratio
   */
  /**
   * Whether a document used the CSS property aspect-ratio. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_aspect_ratio(200);

  /**
   * generated from use.counter.css.doc.css_backdrop_filter
   */
  /**
   * Whether a document used the CSS property backdrop-filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backdrop_filter(201);

  /**
   * generated from use.counter.css.doc.css_backface_visibility
   */
  /**
   * Whether a document used the CSS property backface-visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backface_visibility(202);

  /**
   * generated from use.counter.css.doc.css_background
   */
  /**
   * Whether a document used the CSS property background. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background(203);

  /**
   * generated from use.counter.css.doc.css_background_attachment
   */
  /**
   * Whether a document used the CSS property background-attachment. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_attachment(204);

  /**
   * generated from use.counter.css.doc.css_background_blend_mode
   */
  /**
   * Whether a document used the CSS property background-blend-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_blend_mode(205);

  /**
   * generated from use.counter.css.doc.css_background_clip
   */
  /**
   * Whether a document used the CSS property background-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_clip(206);

  /**
   * generated from use.counter.css.doc.css_background_color
   */
  /**
   * Whether a document used the CSS property background-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_color(207);

  /**
   * generated from use.counter.css.doc.css_background_image
   */
  /**
   * Whether a document used the CSS property background-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_image(208);

  /**
   * generated from use.counter.css.doc.css_background_origin
   */
  /**
   * Whether a document used the CSS property background-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_origin(209);

  /**
   * generated from use.counter.css.doc.css_background_position
   */
  /**
   * Whether a document used the CSS property background-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position(210);

  /**
   * generated from use.counter.css.doc.css_background_position_x
   */
  /**
   * Whether a document used the CSS property background-position-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_x(211);

  /**
   * generated from use.counter.css.doc.css_background_position_y
   */
  /**
   * Whether a document used the CSS property background-position-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_y(212);

  /**
   * generated from use.counter.css.doc.css_background_repeat
   */
  /**
   * Whether a document used the CSS property background-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_repeat(213);

  /**
   * generated from use.counter.css.doc.css_background_size
   */
  /**
   * Whether a document used the CSS property background-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_size(214);

  /**
   * generated from use.counter.css.doc.css_baseline_source
   */
  /**
   * Whether a document used the CSS property baseline-source. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_baseline_source(215);

  /**
   * generated from use.counter.css.doc.css_block_size
   */
  /**
   * Whether a document used the CSS property block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_block_size(216);

  /**
   * generated from use.counter.css.doc.css_border
   */
  /**
   * Whether a document used the CSS property border. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border(217);

  /**
   * generated from use.counter.css.doc.css_border_block
   */
  /**
   * Whether a document used the CSS property border-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block(218);

  /**
   * generated from use.counter.css.doc.css_border_block_color
   */
  /**
   * Whether a document used the CSS property border-block-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_color(219);

  /**
   * generated from use.counter.css.doc.css_border_block_end
   */
  /**
   * Whether a document used the CSS property border-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end(220);

  /**
   * generated from use.counter.css.doc.css_border_block_end_color
   */
  /**
   * Whether a document used the CSS property border-block-end-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_color(221);

  /**
   * generated from use.counter.css.doc.css_border_block_end_style
   */
  /**
   * Whether a document used the CSS property border-block-end-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_style(222);

  /**
   * generated from use.counter.css.doc.css_border_block_end_width
   */
  /**
   * Whether a document used the CSS property border-block-end-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_width(223);

  /**
   * generated from use.counter.css.doc.css_border_block_start
   */
  /**
   * Whether a document used the CSS property border-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start(224);

  /**
   * generated from use.counter.css.doc.css_border_block_start_color
   */
  /**
   * Whether a document used the CSS property border-block-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_color(225);

  /**
   * generated from use.counter.css.doc.css_border_block_start_style
   */
  /**
   * Whether a document used the CSS property border-block-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_style(226);

  /**
   * generated from use.counter.css.doc.css_border_block_start_width
   */
  /**
   * Whether a document used the CSS property border-block-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_width(227);

  /**
   * generated from use.counter.css.doc.css_border_block_style
   */
  /**
   * Whether a document used the CSS property border-block-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_style(228);

  /**
   * generated from use.counter.css.doc.css_border_block_width
   */
  /**
   * Whether a document used the CSS property border-block-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_width(229);

  /**
   * generated from use.counter.css.doc.css_border_bottom
   */
  /**
   * Whether a document used the CSS property border-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom(230);

  /**
   * generated from use.counter.css.doc.css_border_bottom_color
   */
  /**
   * Whether a document used the CSS property border-bottom-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_color(231);

  /**
   * generated from use.counter.css.doc.css_border_bottom_left_radius
   */
  /**
   * Whether a document used the CSS property border-bottom-left-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_left_radius(232);

  /**
   * generated from use.counter.css.doc.css_border_bottom_right_radius
   */
  /**
   * Whether a document used the CSS property border-bottom-right-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_right_radius(233);

  /**
   * generated from use.counter.css.doc.css_border_bottom_style
   */
  /**
   * Whether a document used the CSS property border-bottom-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_style(234);

  /**
   * generated from use.counter.css.doc.css_border_bottom_width
   */
  /**
   * Whether a document used the CSS property border-bottom-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_width(235);

  /**
   * generated from use.counter.css.doc.css_border_collapse
   */
  /**
   * Whether a document used the CSS property border-collapse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_collapse(236);

  /**
   * generated from use.counter.css.doc.css_border_color
   */
  /**
   * Whether a document used the CSS property border-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_color(237);

  /**
   * generated from use.counter.css.doc.css_border_end_end_radius
   */
  /**
   * Whether a document used the CSS property border-end-end-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_end_radius(238);

  /**
   * generated from use.counter.css.doc.css_border_end_start_radius
   */
  /**
   * Whether a document used the CSS property border-end-start-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_start_radius(239);

  /**
   * generated from use.counter.css.doc.css_border_image
   */
  /**
   * Whether a document used the CSS property border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image(240);

  /**
   * generated from use.counter.css.doc.css_border_image_outset
   */
  /**
   * Whether a document used the CSS property border-image-outset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_outset(241);

  /**
   * generated from use.counter.css.doc.css_border_image_repeat
   */
  /**
   * Whether a document used the CSS property border-image-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_repeat(242);

  /**
   * generated from use.counter.css.doc.css_border_image_slice
   */
  /**
   * Whether a document used the CSS property border-image-slice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_slice(243);

  /**
   * generated from use.counter.css.doc.css_border_image_source
   */
  /**
   * Whether a document used the CSS property border-image-source. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_source(244);

  /**
   * generated from use.counter.css.doc.css_border_image_width
   */
  /**
   * Whether a document used the CSS property border-image-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_width(245);

  /**
   * generated from use.counter.css.doc.css_border_inline
   */
  /**
   * Whether a document used the CSS property border-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline(246);

  /**
   * generated from use.counter.css.doc.css_border_inline_color
   */
  /**
   * Whether a document used the CSS property border-inline-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_color(247);

  /**
   * generated from use.counter.css.doc.css_border_inline_end
   */
  /**
   * Whether a document used the CSS property border-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end(248);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_color
   */
  /**
   * Whether a document used the CSS property border-inline-end-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_color(249);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_style
   */
  /**
   * Whether a document used the CSS property border-inline-end-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_style(250);

  /**
   * generated from use.counter.css.doc.css_border_inline_end_width
   */
  /**
   * Whether a document used the CSS property border-inline-end-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_width(251);

  /**
   * generated from use.counter.css.doc.css_border_inline_start
   */
  /**
   * Whether a document used the CSS property border-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start(252);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_color
   */
  /**
   * Whether a document used the CSS property border-inline-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_color(253);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_style
   */
  /**
   * Whether a document used the CSS property border-inline-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_style(254);

  /**
   * generated from use.counter.css.doc.css_border_inline_start_width
   */
  /**
   * Whether a document used the CSS property border-inline-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_width(255);

  /**
   * generated from use.counter.css.doc.css_border_inline_style
   */
  /**
   * Whether a document used the CSS property border-inline-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_style(256);

  /**
   * generated from use.counter.css.doc.css_border_inline_width
   */
  /**
   * Whether a document used the CSS property border-inline-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_width(257);

  /**
   * generated from use.counter.css.doc.css_border_left
   */
  /**
   * Whether a document used the CSS property border-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left(258);

  /**
   * generated from use.counter.css.doc.css_border_left_color
   */
  /**
   * Whether a document used the CSS property border-left-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_color(259);

  /**
   * generated from use.counter.css.doc.css_border_left_style
   */
  /**
   * Whether a document used the CSS property border-left-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_style(260);

  /**
   * generated from use.counter.css.doc.css_border_left_width
   */
  /**
   * Whether a document used the CSS property border-left-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_width(261);

  /**
   * generated from use.counter.css.doc.css_border_radius
   */
  /**
   * Whether a document used the CSS property border-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_radius(262);

  /**
   * generated from use.counter.css.doc.css_border_right
   */
  /**
   * Whether a document used the CSS property border-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right(263);

  /**
   * generated from use.counter.css.doc.css_border_right_color
   */
  /**
   * Whether a document used the CSS property border-right-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_color(264);

  /**
   * generated from use.counter.css.doc.css_border_right_style
   */
  /**
   * Whether a document used the CSS property border-right-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_style(265);

  /**
   * generated from use.counter.css.doc.css_border_right_width
   */
  /**
   * Whether a document used the CSS property border-right-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_width(266);

  /**
   * generated from use.counter.css.doc.css_border_spacing
   */
  /**
   * Whether a document used the CSS property border-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_spacing(267);

  /**
   * generated from use.counter.css.doc.css_border_start_end_radius
   */
  /**
   * Whether a document used the CSS property border-start-end-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_end_radius(268);

  /**
   * generated from use.counter.css.doc.css_border_start_start_radius
   */
  /**
   * Whether a document used the CSS property border-start-start-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_start_radius(269);

  /**
   * generated from use.counter.css.doc.css_border_style
   */
  /**
   * Whether a document used the CSS property border-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_style(270);

  /**
   * generated from use.counter.css.doc.css_border_top
   */
  /**
   * Whether a document used the CSS property border-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top(271);

  /**
   * generated from use.counter.css.doc.css_border_top_color
   */
  /**
   * Whether a document used the CSS property border-top-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_color(272);

  /**
   * generated from use.counter.css.doc.css_border_top_left_radius
   */
  /**
   * Whether a document used the CSS property border-top-left-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_left_radius(273);

  /**
   * generated from use.counter.css.doc.css_border_top_right_radius
   */
  /**
   * Whether a document used the CSS property border-top-right-radius. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_right_radius(274);

  /**
   * generated from use.counter.css.doc.css_border_top_style
   */
  /**
   * Whether a document used the CSS property border-top-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_style(275);

  /**
   * generated from use.counter.css.doc.css_border_top_width
   */
  /**
   * Whether a document used the CSS property border-top-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_width(276);

  /**
   * generated from use.counter.css.doc.css_border_width
   */
  /**
   * Whether a document used the CSS property border-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_width(277);

  /**
   * generated from use.counter.css.doc.css_bottom
   */
  /**
   * Whether a document used the CSS property bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_bottom(278);

  /**
   * generated from use.counter.css.doc.css_box_decoration_break
   */
  /**
   * Whether a document used the CSS property box-decoration-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_decoration_break(279);

  /**
   * generated from use.counter.css.doc.css_box_shadow
   */
  /**
   * Whether a document used the CSS property box-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_shadow(280);

  /**
   * generated from use.counter.css.doc.css_box_sizing
   */
  /**
   * Whether a document used the CSS property box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_sizing(281);

  /**
   * generated from use.counter.css.doc.css_break_after
   */
  /**
   * Whether a document used the CSS property break-after. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_after(282);

  /**
   * generated from use.counter.css.doc.css_break_before
   */
  /**
   * Whether a document used the CSS property break-before. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_before(283);

  /**
   * generated from use.counter.css.doc.css_break_inside
   */
  /**
   * Whether a document used the CSS property break-inside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_inside(284);

  /**
   * generated from use.counter.css.doc.css_caption_side
   */
  /**
   * Whether a document used the CSS property caption-side. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caption_side(285);

  /**
   * generated from use.counter.css.doc.css_caret_color
   */
  /**
   * Whether a document used the CSS property caret-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caret_color(286);

  /**
   * generated from use.counter.css.doc.css_clear
   */
  /**
   * Whether a document used the CSS property clear. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clear(287);

  /**
   * generated from use.counter.css.doc.css_clip
   */
  /**
   * Whether a document used the CSS property clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip(288);

  /**
   * generated from use.counter.css.doc.css_clip_path
   */
  /**
   * Whether a document used the CSS property clip-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_path(289);

  /**
   * generated from use.counter.css.doc.css_clip_rule
   */
  /**
   * Whether a document used the CSS property clip-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_rule(290);

  /**
   * generated from use.counter.css.doc.css_color
   */
  /**
   * Whether a document used the CSS property color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color(291);

  /**
   * generated from use.counter.css.doc.css_color_adjust
   */
  /**
   * Whether a document used the CSS property color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_adjust(292);

  /**
   * generated from use.counter.css.doc.css_color_interpolation
   */
  /**
   * Whether a document used the CSS property color-interpolation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation(293);

  /**
   * generated from use.counter.css.doc.css_color_interpolation_filters
   */
  /**
   * Whether a document used the CSS property color-interpolation-filters. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation_filters(294);

  /**
   * generated from use.counter.css.doc.css_color_scheme
   */
  /**
   * Whether a document used the CSS property color-scheme. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_scheme(295);

  /**
   * generated from use.counter.css.doc.css_column_count
   */
  /**
   * Whether a document used the CSS property column-count. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_count(296);

  /**
   * generated from use.counter.css.doc.css_column_fill
   */
  /**
   * Whether a document used the CSS property column-fill. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_fill(297);

  /**
   * generated from use.counter.css.doc.css_column_gap
   */
  /**
   * Whether a document used the CSS property column-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_gap(298);

  /**
   * generated from use.counter.css.doc.css_column_rule
   */
  /**
   * Whether a document used the CSS property column-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule(299);

  /**
   * generated from use.counter.css.doc.css_column_rule_color
   */
  /**
   * Whether a document used the CSS property column-rule-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_color(300);

  /**
   * generated from use.counter.css.doc.css_column_rule_style
   */
  /**
   * Whether a document used the CSS property column-rule-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_style(301);

  /**
   * generated from use.counter.css.doc.css_column_rule_width
   */
  /**
   * Whether a document used the CSS property column-rule-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_width(302);

  /**
   * generated from use.counter.css.doc.css_column_span
   */
  /**
   * Whether a document used the CSS property column-span. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_span(303);

  /**
   * generated from use.counter.css.doc.css_column_width
   */
  /**
   * Whether a document used the CSS property column-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_width(304);

  /**
   * generated from use.counter.css.doc.css_columns
   */
  /**
   * Whether a document used the CSS property columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_columns(305);

  /**
   * generated from use.counter.css.doc.css_contain
   */
  /**
   * Whether a document used the CSS property contain. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain(306);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_block_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-block-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_block_size(307);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_height
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-height. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_height(308);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_inline_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-inline-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_inline_size(309);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_size
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_size(310);

  /**
   * generated from use.counter.css.doc.css_contain_intrinsic_width
   */
  /**
   * Whether a document used the CSS property contain-intrinsic-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_width(311);

  /**
   * generated from use.counter.css.doc.css_container
   */
  /**
   * Whether a document used the CSS property container. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container(312);

  /**
   * generated from use.counter.css.doc.css_container_name
   */
  /**
   * Whether a document used the CSS property container-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_name(313);

  /**
   * generated from use.counter.css.doc.css_container_type
   */
  /**
   * Whether a document used the CSS property container-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_type(314);

  /**
   * generated from use.counter.css.doc.css_content
   */
  /**
   * Whether a document used the CSS property content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content(315);

  /**
   * generated from use.counter.css.doc.css_content_visibility
   */
  /**
   * Whether a document used the CSS property content-visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content_visibility(316);

  /**
   * generated from use.counter.css.doc.css_counter_increment
   */
  /**
   * Whether a document used the CSS property counter-increment. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_increment(317);

  /**
   * generated from use.counter.css.doc.css_counter_reset
   */
  /**
   * Whether a document used the CSS property counter-reset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_reset(318);

  /**
   * generated from use.counter.css.doc.css_counter_set
   */
  /**
   * Whether a document used the CSS property counter-set. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_set(319);

  /**
   * generated from use.counter.css.doc.css_cursor
   */
  /**
   * Whether a document used the CSS property cursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cursor(320);

  /**
   * generated from use.counter.css.doc.css_cx
   */
  /**
   * Whether a document used the CSS property cx. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cx(321);

  /**
   * generated from use.counter.css.doc.css_cy
   */
  /**
   * Whether a document used the CSS property cy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cy(322);

  /**
   * generated from use.counter.css.doc.css_d
   */
  /**
   * Whether a document used the CSS property d. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_d(323);

  /**
   * generated from use.counter.css.doc.css_direction
   */
  /**
   * Whether a document used the CSS property direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_direction(324);

  /**
   * generated from use.counter.css.doc.css_display
   */
  /**
   * Whether a document used the CSS property display. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_display(325);

  /**
   * generated from use.counter.css.doc.css_dominant_baseline
   */
  /**
   * Whether a document used the CSS property dominant-baseline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_dominant_baseline(326);

  /**
   * generated from use.counter.css.doc.css_empty_cells
   */
  /**
   * Whether a document used the CSS property empty-cells. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_empty_cells(327);

  /**
   * generated from use.counter.css.doc.css_fill
   */
  /**
   * Whether a document used the CSS property fill. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill(328);

  /**
   * generated from use.counter.css.doc.css_fill_opacity
   */
  /**
   * Whether a document used the CSS property fill-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_opacity(329);

  /**
   * generated from use.counter.css.doc.css_fill_rule
   */
  /**
   * Whether a document used the CSS property fill-rule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_rule(330);

  /**
   * generated from use.counter.css.doc.css_filter
   */
  /**
   * Whether a document used the CSS property filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_filter(331);

  /**
   * generated from use.counter.css.doc.css_flex
   */
  /**
   * Whether a document used the CSS property flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex(332);

  /**
   * generated from use.counter.css.doc.css_flex_basis
   */
  /**
   * Whether a document used the CSS property flex-basis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_basis(333);

  /**
   * generated from use.counter.css.doc.css_flex_direction
   */
  /**
   * Whether a document used the CSS property flex-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_direction(334);

  /**
   * generated from use.counter.css.doc.css_flex_flow
   */
  /**
   * Whether a document used the CSS property flex-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_flow(335);

  /**
   * generated from use.counter.css.doc.css_flex_grow
   */
  /**
   * Whether a document used the CSS property flex-grow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_grow(336);

  /**
   * generated from use.counter.css.doc.css_flex_shrink
   */
  /**
   * Whether a document used the CSS property flex-shrink. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_shrink(337);

  /**
   * generated from use.counter.css.doc.css_flex_wrap
   */
  /**
   * Whether a document used the CSS property flex-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_wrap(338);

  /**
   * generated from use.counter.css.doc.css_float
   */
  /**
   * Whether a document used the CSS property float. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_float(339);

  /**
   * generated from use.counter.css.doc.css_flood_color
   */
  /**
   * Whether a document used the CSS property flood-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_color(340);

  /**
   * generated from use.counter.css.doc.css_flood_opacity
   */
  /**
   * Whether a document used the CSS property flood-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_opacity(341);

  /**
   * generated from use.counter.css.doc.css_font
   */
  /**
   * Whether a document used the CSS property font. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font(342);

  /**
   * generated from use.counter.css.doc.css_font_family
   */
  /**
   * Whether a document used the CSS property font-family. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_family(343);

  /**
   * generated from use.counter.css.doc.css_font_feature_settings
   */
  /**
   * Whether a document used the CSS property font-feature-settings. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_feature_settings(344);

  /**
   * generated from use.counter.css.doc.css_font_kerning
   */
  /**
   * Whether a document used the CSS property font-kerning. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_kerning(345);

  /**
   * generated from use.counter.css.doc.css_font_language_override
   */
  /**
   * Whether a document used the CSS property font-language-override. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_language_override(346);

  /**
   * generated from use.counter.css.doc.css_font_optical_sizing
   */
  /**
   * Whether a document used the CSS property font-optical-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_optical_sizing(347);

  /**
   * generated from use.counter.css.doc.css_font_palette
   */
  /**
   * Whether a document used the CSS property font-palette. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_palette(348);

  /**
   * generated from use.counter.css.doc.css_font_size
   */
  /**
   * Whether a document used the CSS property font-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size(349);

  /**
   * generated from use.counter.css.doc.css_font_size_adjust
   */
  /**
   * Whether a document used the CSS property font-size-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size_adjust(350);

  /**
   * generated from use.counter.css.doc.css_font_stretch
   */
  /**
   * Whether a document used the CSS property font-stretch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_stretch(351);

  /**
   * generated from use.counter.css.doc.css_font_style
   */
  /**
   * Whether a document used the CSS property font-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_style(352);

  /**
   * generated from use.counter.css.doc.css_font_synthesis
   */
  /**
   * Whether a document used the CSS property font-synthesis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis(353);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_position
   */
  /**
   * Whether a document used the CSS property font-synthesis-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_position(354);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_small_caps
   */
  /**
   * Whether a document used the CSS property font-synthesis-small-caps. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_small_caps(355);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_style
   */
  /**
   * Whether a document used the CSS property font-synthesis-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_style(356);

  /**
   * generated from use.counter.css.doc.css_font_synthesis_weight
   */
  /**
   * Whether a document used the CSS property font-synthesis-weight. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_weight(357);

  /**
   * generated from use.counter.css.doc.css_font_variant
   */
  /**
   * Whether a document used the CSS property font-variant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant(358);

  /**
   * generated from use.counter.css.doc.css_font_variant_alternates
   */
  /**
   * Whether a document used the CSS property font-variant-alternates. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_alternates(359);

  /**
   * generated from use.counter.css.doc.css_font_variant_caps
   */
  /**
   * Whether a document used the CSS property font-variant-caps. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_caps(360);

  /**
   * generated from use.counter.css.doc.css_font_variant_east_asian
   */
  /**
   * Whether a document used the CSS property font-variant-east-asian. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_east_asian(361);

  /**
   * generated from use.counter.css.doc.css_font_variant_emoji
   */
  /**
   * Whether a document used the CSS property font-variant-emoji. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_emoji(362);

  /**
   * generated from use.counter.css.doc.css_font_variant_ligatures
   */
  /**
   * Whether a document used the CSS property font-variant-ligatures. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_ligatures(363);

  /**
   * generated from use.counter.css.doc.css_font_variant_numeric
   */
  /**
   * Whether a document used the CSS property font-variant-numeric. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_numeric(364);

  /**
   * generated from use.counter.css.doc.css_font_variant_position
   */
  /**
   * Whether a document used the CSS property font-variant-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_position(365);

  /**
   * generated from use.counter.css.doc.css_font_variation_settings
   */
  /**
   * Whether a document used the CSS property font-variation-settings. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variation_settings(366);

  /**
   * generated from use.counter.css.doc.css_font_weight
   */
  /**
   * Whether a document used the CSS property font-weight. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_weight(367);

  /**
   * generated from use.counter.css.doc.css_forced_color_adjust
   */
  /**
   * Whether a document used the CSS property forced-color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_forced_color_adjust(368);

  /**
   * generated from use.counter.css.doc.css_gap
   */
  /**
   * Whether a document used the CSS property gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_gap(369);

  /**
   * generated from use.counter.css.doc.css_grid
   */
  /**
   * Whether a document used the CSS property grid. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid(370);

  /**
   * generated from use.counter.css.doc.css_grid_area
   */
  /**
   * Whether a document used the CSS property grid-area. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_area(371);

  /**
   * generated from use.counter.css.doc.css_grid_auto_columns
   */
  /**
   * Whether a document used the CSS property grid-auto-columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_columns(372);

  /**
   * generated from use.counter.css.doc.css_grid_auto_flow
   */
  /**
   * Whether a document used the CSS property grid-auto-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_flow(373);

  /**
   * generated from use.counter.css.doc.css_grid_auto_rows
   */
  /**
   * Whether a document used the CSS property grid-auto-rows. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_rows(374);

  /**
   * generated from use.counter.css.doc.css_grid_column
   */
  /**
   * Whether a document used the CSS property grid-column. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column(375);

  /**
   * generated from use.counter.css.doc.css_grid_column_end
   */
  /**
   * Whether a document used the CSS property grid-column-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_end(376);

  /**
   * generated from use.counter.css.doc.css_grid_column_gap
   */
  /**
   * Whether a document used the CSS property grid-column-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_gap(377);

  /**
   * generated from use.counter.css.doc.css_grid_column_start
   */
  /**
   * Whether a document used the CSS property grid-column-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_start(378);

  /**
   * generated from use.counter.css.doc.css_grid_gap
   */
  /**
   * Whether a document used the CSS property grid-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_gap(379);

  /**
   * generated from use.counter.css.doc.css_grid_row
   */
  /**
   * Whether a document used the CSS property grid-row. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row(380);

  /**
   * generated from use.counter.css.doc.css_grid_row_end
   */
  /**
   * Whether a document used the CSS property grid-row-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_end(381);

  /**
   * generated from use.counter.css.doc.css_grid_row_gap
   */
  /**
   * Whether a document used the CSS property grid-row-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_gap(382);

  /**
   * generated from use.counter.css.doc.css_grid_row_start
   */
  /**
   * Whether a document used the CSS property grid-row-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_start(383);

  /**
   * generated from use.counter.css.doc.css_grid_template
   */
  /**
   * Whether a document used the CSS property grid-template. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template(384);

  /**
   * generated from use.counter.css.doc.css_grid_template_areas
   */
  /**
   * Whether a document used the CSS property grid-template-areas. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_areas(385);

  /**
   * generated from use.counter.css.doc.css_grid_template_columns
   */
  /**
   * Whether a document used the CSS property grid-template-columns. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_columns(386);

  /**
   * generated from use.counter.css.doc.css_grid_template_rows
   */
  /**
   * Whether a document used the CSS property grid-template-rows. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_rows(387);

  /**
   * generated from use.counter.css.doc.css_height
   */
  /**
   * Whether a document used the CSS property height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_height(388);

  /**
   * generated from use.counter.css.doc.css_hyphenate_character
   */
  /**
   * Whether a document used the CSS property hyphenate-character. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphenate_character(389);

  /**
   * generated from use.counter.css.doc.css_hyphens
   */
  /**
   * Whether a document used the CSS property hyphens. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphens(390);

  /**
   * generated from use.counter.css.doc.css_image_orientation
   */
  /**
   * Whether a document used the CSS property image-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_orientation(391);

  /**
   * generated from use.counter.css.doc.css_image_rendering
   */
  /**
   * Whether a document used the CSS property image-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_rendering(392);

  /**
   * generated from use.counter.css.doc.css_ime_mode
   */
  /**
   * Whether a document used the CSS property ime-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ime_mode(393);

  /**
   * generated from use.counter.css.doc.css_initial_letter
   */
  /**
   * Whether a document used the CSS property initial-letter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_initial_letter(394);

  /**
   * generated from use.counter.css.doc.css_inline_size
   */
  /**
   * Whether a document used the CSS property inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inline_size(395);

  /**
   * generated from use.counter.css.doc.css_inset
   */
  /**
   * Whether a document used the CSS property inset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset(396);

  /**
   * generated from use.counter.css.doc.css_inset_block
   */
  /**
   * Whether a document used the CSS property inset-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block(397);

  /**
   * generated from use.counter.css.doc.css_inset_block_end
   */
  /**
   * Whether a document used the CSS property inset-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_end(398);

  /**
   * generated from use.counter.css.doc.css_inset_block_start
   */
  /**
   * Whether a document used the CSS property inset-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_start(399);

  /**
   * generated from use.counter.css.doc.css_inset_inline
   */
  /**
   * Whether a document used the CSS property inset-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline(400);

  /**
   * generated from use.counter.css.doc.css_inset_inline_end
   */
  /**
   * Whether a document used the CSS property inset-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_end(401);

  /**
   * generated from use.counter.css.doc.css_inset_inline_start
   */
  /**
   * Whether a document used the CSS property inset-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_start(402);

  /**
   * generated from use.counter.css.doc.css_isolation
   */
  /**
   * Whether a document used the CSS property isolation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_isolation(403);

  /**
   * generated from use.counter.css.doc.css_justify_content
   */
  /**
   * Whether a document used the CSS property justify-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_content(404);

  /**
   * generated from use.counter.css.doc.css_justify_items
   */
  /**
   * Whether a document used the CSS property justify-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_items(405);

  /**
   * generated from use.counter.css.doc.css_justify_self
   */
  /**
   * Whether a document used the CSS property justify-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_self(406);

  /**
   * generated from use.counter.css.doc.css_justify_tracks
   */
  /**
   * Whether a document used the CSS property justify-tracks. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_tracks(407);

  /**
   * generated from use.counter.css.doc.css_left
   */
  /**
   * Whether a document used the CSS property left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_left(408);

  /**
   * generated from use.counter.css.doc.css_letter_spacing
   */
  /**
   * Whether a document used the CSS property letter-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_letter_spacing(409);

  /**
   * generated from use.counter.css.doc.css_lighting_color
   */
  /**
   * Whether a document used the CSS property lighting-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_lighting_color(410);

  /**
   * generated from use.counter.css.doc.css_line_break
   */
  /**
   * Whether a document used the CSS property line-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_break(411);

  /**
   * generated from use.counter.css.doc.css_line_height
   */
  /**
   * Whether a document used the CSS property line-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_height(412);

  /**
   * generated from use.counter.css.doc.css_list_style
   */
  /**
   * Whether a document used the CSS property list-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style(413);

  /**
   * generated from use.counter.css.doc.css_list_style_image
   */
  /**
   * Whether a document used the CSS property list-style-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_image(414);

  /**
   * generated from use.counter.css.doc.css_list_style_position
   */
  /**
   * Whether a document used the CSS property list-style-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_position(415);

  /**
   * generated from use.counter.css.doc.css_list_style_type
   */
  /**
   * Whether a document used the CSS property list-style-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_type(416);

  /**
   * generated from use.counter.css.doc.css_margin
   */
  /**
   * Whether a document used the CSS property margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin(417);

  /**
   * generated from use.counter.css.doc.css_margin_block
   */
  /**
   * Whether a document used the CSS property margin-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block(418);

  /**
   * generated from use.counter.css.doc.css_margin_block_end
   */
  /**
   * Whether a document used the CSS property margin-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_end(419);

  /**
   * generated from use.counter.css.doc.css_margin_block_start
   */
  /**
   * Whether a document used the CSS property margin-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_start(420);

  /**
   * generated from use.counter.css.doc.css_margin_bottom
   */
  /**
   * Whether a document used the CSS property margin-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_bottom(421);

  /**
   * generated from use.counter.css.doc.css_margin_inline
   */
  /**
   * Whether a document used the CSS property margin-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline(422);

  /**
   * generated from use.counter.css.doc.css_margin_inline_end
   */
  /**
   * Whether a document used the CSS property margin-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_end(423);

  /**
   * generated from use.counter.css.doc.css_margin_inline_start
   */
  /**
   * Whether a document used the CSS property margin-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_start(424);

  /**
   * generated from use.counter.css.doc.css_margin_left
   */
  /**
   * Whether a document used the CSS property margin-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_left(425);

  /**
   * generated from use.counter.css.doc.css_margin_right
   */
  /**
   * Whether a document used the CSS property margin-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_right(426);

  /**
   * generated from use.counter.css.doc.css_margin_top
   */
  /**
   * Whether a document used the CSS property margin-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_top(427);

  /**
   * generated from use.counter.css.doc.css_marker
   */
  /**
   * Whether a document used the CSS property marker. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker(428);

  /**
   * generated from use.counter.css.doc.css_marker_end
   */
  /**
   * Whether a document used the CSS property marker-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_end(429);

  /**
   * generated from use.counter.css.doc.css_marker_mid
   */
  /**
   * Whether a document used the CSS property marker-mid. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_mid(430);

  /**
   * generated from use.counter.css.doc.css_marker_start
   */
  /**
   * Whether a document used the CSS property marker-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_start(431);

  /**
   * generated from use.counter.css.doc.css_mask
   */
  /**
   * Whether a document used the CSS property mask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask(432);

  /**
   * generated from use.counter.css.doc.css_mask_clip
   */
  /**
   * Whether a document used the CSS property mask-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_clip(433);

  /**
   * generated from use.counter.css.doc.css_mask_composite
   */
  /**
   * Whether a document used the CSS property mask-composite. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_composite(434);

  /**
   * generated from use.counter.css.doc.css_mask_image
   */
  /**
   * Whether a document used the CSS property mask-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_image(435);

  /**
   * generated from use.counter.css.doc.css_mask_mode
   */
  /**
   * Whether a document used the CSS property mask-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_mode(436);

  /**
   * generated from use.counter.css.doc.css_mask_origin
   */
  /**
   * Whether a document used the CSS property mask-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_origin(437);

  /**
   * generated from use.counter.css.doc.css_mask_position
   */
  /**
   * Whether a document used the CSS property mask-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position(438);

  /**
   * generated from use.counter.css.doc.css_mask_position_x
   */
  /**
   * Whether a document used the CSS property mask-position-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_x(439);

  /**
   * generated from use.counter.css.doc.css_mask_position_y
   */
  /**
   * Whether a document used the CSS property mask-position-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_y(440);

  /**
   * generated from use.counter.css.doc.css_mask_repeat
   */
  /**
   * Whether a document used the CSS property mask-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_repeat(441);

  /**
   * generated from use.counter.css.doc.css_mask_size
   */
  /**
   * Whether a document used the CSS property mask-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_size(442);

  /**
   * generated from use.counter.css.doc.css_mask_type
   */
  /**
   * Whether a document used the CSS property mask-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_type(443);

  /**
   * generated from use.counter.css.doc.css_masonry_auto_flow
   */
  /**
   * Whether a document used the CSS property masonry-auto-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_masonry_auto_flow(444);

  /**
   * generated from use.counter.css.doc.css_math_depth
   */
  /**
   * Whether a document used the CSS property math-depth. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_depth(445);

  /**
   * generated from use.counter.css.doc.css_math_style
   */
  /**
   * Whether a document used the CSS property math-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_style(446);

  /**
   * generated from use.counter.css.doc.css_max_block_size
   */
  /**
   * Whether a document used the CSS property max-block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_block_size(447);

  /**
   * generated from use.counter.css.doc.css_max_height
   */
  /**
   * Whether a document used the CSS property max-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_height(448);

  /**
   * generated from use.counter.css.doc.css_max_inline_size
   */
  /**
   * Whether a document used the CSS property max-inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_inline_size(449);

  /**
   * generated from use.counter.css.doc.css_max_width
   */
  /**
   * Whether a document used the CSS property max-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_width(450);

  /**
   * generated from use.counter.css.doc.css_min_block_size
   */
  /**
   * Whether a document used the CSS property min-block-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_block_size(451);

  /**
   * generated from use.counter.css.doc.css_min_height
   */
  /**
   * Whether a document used the CSS property min-height. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_height(452);

  /**
   * generated from use.counter.css.doc.css_min_inline_size
   */
  /**
   * Whether a document used the CSS property min-inline-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_inline_size(453);

  /**
   * generated from use.counter.css.doc.css_min_width
   */
  /**
   * Whether a document used the CSS property min-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_width(454);

  /**
   * generated from use.counter.css.doc.css_mix_blend_mode
   */
  /**
   * Whether a document used the CSS property mix-blend-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mix_blend_mode(455);

  /**
   * generated from use.counter.css.doc.css_moz_animation
   */
  /**
   * Whether a document used the CSS property -moz-animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation(456);

  /**
   * generated from use.counter.css.doc.css_moz_animation_delay
   */
  /**
   * Whether a document used the CSS property -moz-animation-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_delay(457);

  /**
   * generated from use.counter.css.doc.css_moz_animation_direction
   */
  /**
   * Whether a document used the CSS property -moz-animation-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_direction(458);

  /**
   * generated from use.counter.css.doc.css_moz_animation_duration
   */
  /**
   * Whether a document used the CSS property -moz-animation-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_duration(459);

  /**
   * generated from use.counter.css.doc.css_moz_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property -moz-animation-fill-mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_fill_mode(460);

  /**
   * generated from use.counter.css.doc.css_moz_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property -moz-animation-iteration-count.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_iteration_count(461);

  /**
   * generated from use.counter.css.doc.css_moz_animation_name
   */
  /**
   * Whether a document used the CSS property -moz-animation-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_name(462);

  /**
   * generated from use.counter.css.doc.css_moz_animation_play_state
   */
  /**
   * Whether a document used the CSS property -moz-animation-play-state. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_play_state(463);

  /**
   * generated from use.counter.css.doc.css_moz_animation_timing_function
   */
  /**
   * Whether a document used the CSS property -moz-animation-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_timing_function(464);

  /**
   * generated from use.counter.css.doc.css_moz_appearance
   */
  /**
   * Whether a document used the CSS property -moz-appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_appearance(465);

  /**
   * generated from use.counter.css.doc.css_moz_backface_visibility
   */
  /**
   * Whether a document used the CSS property -moz-backface-visibility. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_backface_visibility(466);

  /**
   * generated from use.counter.css.doc.css_moz_border_end
   */
  /**
   * Whether a document used the CSS property -moz-border-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end(467);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_color
   */
  /**
   * Whether a document used the CSS property -moz-border-end-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_color(468);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_style
   */
  /**
   * Whether a document used the CSS property -moz-border-end-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_style(469);

  /**
   * generated from use.counter.css.doc.css_moz_border_end_width
   */
  /**
   * Whether a document used the CSS property -moz-border-end-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_width(470);

  /**
   * generated from use.counter.css.doc.css_moz_border_image
   */
  /**
   * Whether a document used the CSS property -moz-border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_image(471);

  /**
   * generated from use.counter.css.doc.css_moz_border_start
   */
  /**
   * Whether a document used the CSS property -moz-border-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start(472);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_color
   */
  /**
   * Whether a document used the CSS property -moz-border-start-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_color(473);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_style
   */
  /**
   * Whether a document used the CSS property -moz-border-start-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_style(474);

  /**
   * generated from use.counter.css.doc.css_moz_border_start_width
   */
  /**
   * Whether a document used the CSS property -moz-border-start-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_width(475);

  /**
   * generated from use.counter.css.doc.css_moz_box_align
   */
  /**
   * Whether a document used the CSS property -moz-box-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_align(476);

  /**
   * generated from use.counter.css.doc.css_moz_box_collapse
   */
  /**
   * Whether a document used the CSS property -moz-box-collapse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_collapse(477);

  /**
   * generated from use.counter.css.doc.css_moz_box_direction
   */
  /**
   * Whether a document used the CSS property -moz-box-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_direction(478);

  /**
   * generated from use.counter.css.doc.css_moz_box_flex
   */
  /**
   * Whether a document used the CSS property -moz-box-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_flex(479);

  /**
   * generated from use.counter.css.doc.css_moz_box_ordinal_group
   */
  /**
   * Whether a document used the CSS property -moz-box-ordinal-group. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_ordinal_group(480);

  /**
   * generated from use.counter.css.doc.css_moz_box_orient
   */
  /**
   * Whether a document used the CSS property -moz-box-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_orient(481);

  /**
   * generated from use.counter.css.doc.css_moz_box_pack
   */
  /**
   * Whether a document used the CSS property -moz-box-pack. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_pack(482);

  /**
   * generated from use.counter.css.doc.css_moz_box_sizing
   */
  /**
   * Whether a document used the CSS property -moz-box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_sizing(483);

  /**
   * generated from use.counter.css.doc.css_moz_context_properties
   */
  /**
   * Whether a document used the CSS property -moz-context-properties. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_context_properties(484);

  /**
   * generated from use.counter.css.doc.css_moz_control_character_visibility
   */
  /**
   * Whether a document used the CSS property -moz-control-character-visibility.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_control_character_visibility(485);

  /**
   * generated from use.counter.css.doc.css_moz_default_appearance
   */
  /**
   * Whether a document used the CSS property -moz-default-appearance. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_default_appearance(486);

  /**
   * generated from use.counter.css.doc.css_moz_float_edge
   */
  /**
   * Whether a document used the CSS property -moz-float-edge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_float_edge(487);

  /**
   * generated from use.counter.css.doc.css_moz_font_feature_settings
   */
  /**
   * Whether a document used the CSS property -moz-font-feature-settings. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_font_feature_settings(488);

  /**
   * generated from use.counter.css.doc.css_moz_font_language_override
   */
  /**
   * Whether a document used the CSS property -moz-font-language-override. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_font_language_override(489);

  /**
   * generated from use.counter.css.doc.css_moz_force_broken_image_icon
   */
  /**
   * Whether a document used the CSS property -moz-force-broken-image-icon. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_force_broken_image_icon(490);

  /**
   * generated from use.counter.css.doc.css_moz_hyphens
   */
  /**
   * Whether a document used the CSS property -moz-hyphens. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_hyphens(491);

  /**
   * generated from use.counter.css.doc.css_moz_inert
   */
  /**
   * Whether a document used the CSS property -moz-inert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_inert(492);

  /**
   * generated from use.counter.css.doc.css_moz_margin_end
   */
  /**
   * Whether a document used the CSS property -moz-margin-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_end(493);

  /**
   * generated from use.counter.css.doc.css_moz_margin_start
   */
  /**
   * Whether a document used the CSS property -moz-margin-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_start(494);

  /**
   * generated from use.counter.css.doc.css_moz_math_variant
   */
  /**
   * Whether a document used the CSS property -moz-math-variant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_math_variant(495);

  /**
   * generated from use.counter.css.doc.css_moz_min_font_size_ratio
   */
  /**
   * Whether a document used the CSS property -moz-min-font-size-ratio. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_min_font_size_ratio(496);

  /**
   * generated from use.counter.css.doc.css_moz_orient
   */
  /**
   * Whether a document used the CSS property -moz-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_orient(497);

  /**
   * generated from use.counter.css.doc.css_moz_osx_font_smoothing
   */
  /**
   * Whether a document used the CSS property -moz-osx-font-smoothing. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_osx_font_smoothing(498);

  /**
   * generated from use.counter.css.doc.css_moz_padding_end
   */
  /**
   * Whether a document used the CSS property -moz-padding-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_end(499);

  /**
   * generated from use.counter.css.doc.css_moz_padding_start
   */
  /**
   * Whether a document used the CSS property -moz-padding-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_start(500);

  /**
   * generated from use.counter.css.doc.css_moz_perspective
   */
  /**
   * Whether a document used the CSS property -moz-perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective(501);

  /**
   * generated from use.counter.css.doc.css_moz_perspective_origin
   */
  /**
   * Whether a document used the CSS property -moz-perspective-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective_origin(502);

  /**
   * generated from use.counter.css.doc.css_moz_subtree_hidden_only_visually
   */
  /**
   * Whether a document used the CSS property -moz-subtree-hidden-only-visually.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_subtree_hidden_only_visually(503);

  /**
   * generated from use.counter.css.doc.css_moz_tab_size
   */
  /**
   * Whether a document used the CSS property -moz-tab-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_tab_size(504);

  /**
   * generated from use.counter.css.doc.css_moz_text_size_adjust
   */
  /**
   * Whether a document used the CSS property -moz-text-size-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_text_size_adjust(505);

  /**
   * generated from use.counter.css.doc.css_moz_theme
   */
  /**
   * Whether a document used the CSS property -moz-theme. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_theme(506);

  /**
   * generated from use.counter.css.doc.css_moz_top_layer
   */
  /**
   * Whether a document used the CSS property -moz-top-layer. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_top_layer(507);

  /**
   * generated from use.counter.css.doc.css_moz_transform
   */
  /**
   * Whether a document used the CSS property -moz-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform(508);

  /**
   * generated from use.counter.css.doc.css_moz_transform_origin
   */
  /**
   * Whether a document used the CSS property -moz-transform-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_origin(509);

  /**
   * generated from use.counter.css.doc.css_moz_transform_style
   */
  /**
   * Whether a document used the CSS property -moz-transform-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_style(510);

  /**
   * generated from use.counter.css.doc.css_moz_transition
   */
  /**
   * Whether a document used the CSS property -moz-transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition(511);

  /**
   * generated from use.counter.css.doc.css_moz_transition_delay
   */
  /**
   * Whether a document used the CSS property -moz-transition-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_delay(512);

  /**
   * generated from use.counter.css.doc.css_moz_transition_duration
   */
  /**
   * Whether a document used the CSS property -moz-transition-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_duration(513);

  /**
   * generated from use.counter.css.doc.css_moz_transition_property
   */
  /**
   * Whether a document used the CSS property -moz-transition-property. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_property(514);

  /**
   * generated from use.counter.css.doc.css_moz_transition_timing_function
   */
  /**
   * Whether a document used the CSS property -moz-transition-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_transition_timing_function(515);

  /**
   * generated from use.counter.css.doc.css_moz_user_focus
   */
  /**
   * Whether a document used the CSS property -moz-user-focus. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_focus(516);

  /**
   * generated from use.counter.css.doc.css_moz_user_input
   */
  /**
   * Whether a document used the CSS property -moz-user-input. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_input(517);

  /**
   * generated from use.counter.css.doc.css_moz_user_modify
   */
  /**
   * Whether a document used the CSS property -moz-user-modify. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_modify(518);

  /**
   * generated from use.counter.css.doc.css_moz_user_select
   */
  /**
   * Whether a document used the CSS property -moz-user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_select(519);

  /**
   * generated from use.counter.css.doc.css_moz_window_dragging
   */
  /**
   * Whether a document used the CSS property -moz-window-dragging. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_dragging(520);

  /**
   * generated from use.counter.css.doc.css_moz_window_input_region_margin
   */
  /**
   * Whether a document used the CSS property -moz-window-input-region-margin.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_window_input_region_margin(521);

  /**
   * generated from use.counter.css.doc.css_moz_window_opacity
   */
  /**
   * Whether a document used the CSS property -moz-window-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_opacity(522);

  /**
   * generated from use.counter.css.doc.css_moz_window_shadow
   */
  /**
   * Whether a document used the CSS property -moz-window-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_shadow(523);

  /**
   * generated from use.counter.css.doc.css_moz_window_transform
   */
  /**
   * Whether a document used the CSS property -moz-window-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform(524);

  /**
   * generated from use.counter.css.doc.css_moz_window_transform_origin
   */
  /**
   * Whether a document used the CSS property -moz-window-transform-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform_origin(525);

  /**
   * generated from use.counter.css.doc.css_object_fit
   */
  /**
   * Whether a document used the CSS property object-fit. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_fit(526);

  /**
   * generated from use.counter.css.doc.css_object_position
   */
  /**
   * Whether a document used the CSS property object-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_position(527);

  /**
   * generated from use.counter.css.doc.css_offset
   */
  /**
   * Whether a document used the CSS property offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset(528);

  /**
   * generated from use.counter.css.doc.css_offset_anchor
   */
  /**
   * Whether a document used the CSS property offset-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_anchor(529);

  /**
   * generated from use.counter.css.doc.css_offset_distance
   */
  /**
   * Whether a document used the CSS property offset-distance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_distance(530);

  /**
   * generated from use.counter.css.doc.css_offset_path
   */
  /**
   * Whether a document used the CSS property offset-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_path(531);

  /**
   * generated from use.counter.css.doc.css_offset_position
   */
  /**
   * Whether a document used the CSS property offset-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_position(532);

  /**
   * generated from use.counter.css.doc.css_offset_rotate
   */
  /**
   * Whether a document used the CSS property offset-rotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_rotate(533);

  /**
   * generated from use.counter.css.doc.css_opacity
   */
  /**
   * Whether a document used the CSS property opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_opacity(534);

  /**
   * generated from use.counter.css.doc.css_order
   */
  /**
   * Whether a document used the CSS property order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_order(535);

  /**
   * generated from use.counter.css.doc.css_outline
   */
  /**
   * Whether a document used the CSS property outline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline(536);

  /**
   * generated from use.counter.css.doc.css_outline_color
   */
  /**
   * Whether a document used the CSS property outline-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_color(537);

  /**
   * generated from use.counter.css.doc.css_outline_offset
   */
  /**
   * Whether a document used the CSS property outline-offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_offset(538);

  /**
   * generated from use.counter.css.doc.css_outline_style
   */
  /**
   * Whether a document used the CSS property outline-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_style(539);

  /**
   * generated from use.counter.css.doc.css_outline_width
   */
  /**
   * Whether a document used the CSS property outline-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_width(540);

  /**
   * generated from use.counter.css.doc.css_overflow
   */
  /**
   * Whether a document used the CSS property overflow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow(541);

  /**
   * generated from use.counter.css.doc.css_overflow_anchor
   */
  /**
   * Whether a document used the CSS property overflow-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_anchor(542);

  /**
   * generated from use.counter.css.doc.css_overflow_block
   */
  /**
   * Whether a document used the CSS property overflow-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_block(543);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box
   */
  /**
   * Whether a document used the CSS property overflow-clip-box. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box(544);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box_block
   */
  /**
   * Whether a document used the CSS property overflow-clip-box-block. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_block(545);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_box_inline
   */
  /**
   * Whether a document used the CSS property overflow-clip-box-inline. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_inline(546);

  /**
   * generated from use.counter.css.doc.css_overflow_clip_margin
   */
  /**
   * Whether a document used the CSS property overflow-clip-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_margin(547);

  /**
   * generated from use.counter.css.doc.css_overflow_inline
   */
  /**
   * Whether a document used the CSS property overflow-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_inline(548);

  /**
   * generated from use.counter.css.doc.css_overflow_wrap
   */
  /**
   * Whether a document used the CSS property overflow-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_wrap(549);

  /**
   * generated from use.counter.css.doc.css_overflow_x
   */
  /**
   * Whether a document used the CSS property overflow-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_x(550);

  /**
   * generated from use.counter.css.doc.css_overflow_y
   */
  /**
   * Whether a document used the CSS property overflow-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_y(551);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior
   */
  /**
   * Whether a document used the CSS property overscroll-behavior. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior(552);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_block
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-block. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_block(553);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_inline
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-inline. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_inline(554);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_x
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_x(555);

  /**
   * generated from use.counter.css.doc.css_overscroll_behavior_y
   */
  /**
   * Whether a document used the CSS property overscroll-behavior-y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_y(556);

  /**
   * generated from use.counter.css.doc.css_padding
   */
  /**
   * Whether a document used the CSS property padding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding(557);

  /**
   * generated from use.counter.css.doc.css_padding_block
   */
  /**
   * Whether a document used the CSS property padding-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block(558);

  /**
   * generated from use.counter.css.doc.css_padding_block_end
   */
  /**
   * Whether a document used the CSS property padding-block-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_end(559);

  /**
   * generated from use.counter.css.doc.css_padding_block_start
   */
  /**
   * Whether a document used the CSS property padding-block-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_start(560);

  /**
   * generated from use.counter.css.doc.css_padding_bottom
   */
  /**
   * Whether a document used the CSS property padding-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_bottom(561);

  /**
   * generated from use.counter.css.doc.css_padding_inline
   */
  /**
   * Whether a document used the CSS property padding-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline(562);

  /**
   * generated from use.counter.css.doc.css_padding_inline_end
   */
  /**
   * Whether a document used the CSS property padding-inline-end. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_end(563);

  /**
   * generated from use.counter.css.doc.css_padding_inline_start
   */
  /**
   * Whether a document used the CSS property padding-inline-start. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_start(564);

  /**
   * generated from use.counter.css.doc.css_padding_left
   */
  /**
   * Whether a document used the CSS property padding-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_left(565);

  /**
   * generated from use.counter.css.doc.css_padding_right
   */
  /**
   * Whether a document used the CSS property padding-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_right(566);

  /**
   * generated from use.counter.css.doc.css_padding_top
   */
  /**
   * Whether a document used the CSS property padding-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_top(567);

  /**
   * generated from use.counter.css.doc.css_page
   */
  /**
   * Whether a document used the CSS property page. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page(568);

  /**
   * generated from use.counter.css.doc.css_page_break_after
   */
  /**
   * Whether a document used the CSS property page-break-after. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_after(569);

  /**
   * generated from use.counter.css.doc.css_page_break_before
   */
  /**
   * Whether a document used the CSS property page-break-before. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_before(570);

  /**
   * generated from use.counter.css.doc.css_page_break_inside
   */
  /**
   * Whether a document used the CSS property page-break-inside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_inside(571);

  /**
   * generated from use.counter.css.doc.css_page_orientation
   */
  /**
   * Whether a document used the CSS property page-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_orientation(572);

  /**
   * generated from use.counter.css.doc.css_paint_order
   */
  /**
   * Whether a document used the CSS property paint-order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_paint_order(573);

  /**
   * generated from use.counter.css.doc.css_perspective
   */
  /**
   * Whether a document used the CSS property perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective(574);

  /**
   * generated from use.counter.css.doc.css_perspective_origin
   */
  /**
   * Whether a document used the CSS property perspective-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective_origin(575);

  /**
   * generated from use.counter.css.doc.css_place_content
   */
  /**
   * Whether a document used the CSS property place-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_content(576);

  /**
   * generated from use.counter.css.doc.css_place_items
   */
  /**
   * Whether a document used the CSS property place-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_items(577);

  /**
   * generated from use.counter.css.doc.css_place_self
   */
  /**
   * Whether a document used the CSS property place-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_self(578);

  /**
   * generated from use.counter.css.doc.css_pointer_events
   */
  /**
   * Whether a document used the CSS property pointer-events. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_pointer_events(579);

  /**
   * generated from use.counter.css.doc.css_position
   */
  /**
   * Whether a document used the CSS property position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position(580);

  /**
   * generated from use.counter.css.doc.css_print_color_adjust
   */
  /**
   * Whether a document used the CSS property print-color-adjust. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_print_color_adjust(581);

  /**
   * generated from use.counter.css.doc.css_quotes
   */
  /**
   * Whether a document used the CSS property quotes. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_quotes(582);

  /**
   * generated from use.counter.css.doc.css_r
   */
  /**
   * Whether a document used the CSS property r. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_r(583);

  /**
   * generated from use.counter.css.doc.css_resize
   */
  /**
   * Whether a document used the CSS property resize. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_resize(584);

  /**
   * generated from use.counter.css.doc.css_right
   */
  /**
   * Whether a document used the CSS property right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_right(585);

  /**
   * generated from use.counter.css.doc.css_rotate
   */
  /**
   * Whether a document used the CSS property rotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rotate(586);

  /**
   * generated from use.counter.css.doc.css_row_gap
   */
  /**
   * Whether a document used the CSS property row-gap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_row_gap(587);

  /**
   * generated from use.counter.css.doc.css_ruby_align
   */
  /**
   * Whether a document used the CSS property ruby-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_align(588);

  /**
   * generated from use.counter.css.doc.css_ruby_position
   */
  /**
   * Whether a document used the CSS property ruby-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_position(589);

  /**
   * generated from use.counter.css.doc.css_rx
   */
  /**
   * Whether a document used the CSS property rx. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rx(590);

  /**
   * generated from use.counter.css.doc.css_ry
   */
  /**
   * Whether a document used the CSS property ry. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ry(591);

  /**
   * generated from use.counter.css.doc.css_scale
   */
  /**
   * Whether a document used the CSS property scale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scale(592);

  /**
   * generated from use.counter.css.doc.css_scroll_behavior
   */
  /**
   * Whether a document used the CSS property scroll-behavior. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_behavior(593);

  /**
   * generated from use.counter.css.doc.css_scroll_margin
   */
  /**
   * Whether a document used the CSS property scroll-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin(594);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block
   */
  /**
   * Whether a document used the CSS property scroll-margin-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block(595);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block_end
   */
  /**
   * Whether a document used the CSS property scroll-margin-block-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_end(596);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_block_start
   */
  /**
   * Whether a document used the CSS property scroll-margin-block-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_start(597);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_bottom
   */
  /**
   * Whether a document used the CSS property scroll-margin-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_bottom(598);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline(599);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline_end
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_end(600);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_inline_start
   */
  /**
   * Whether a document used the CSS property scroll-margin-inline-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_start(601);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_left
   */
  /**
   * Whether a document used the CSS property scroll-margin-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_left(602);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_right
   */
  /**
   * Whether a document used the CSS property scroll-margin-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_right(603);

  /**
   * generated from use.counter.css.doc.css_scroll_margin_top
   */
  /**
   * Whether a document used the CSS property scroll-margin-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_top(604);

  /**
   * generated from use.counter.css.doc.css_scroll_padding
   */
  /**
   * Whether a document used the CSS property scroll-padding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding(605);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block
   */
  /**
   * Whether a document used the CSS property scroll-padding-block. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block(606);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block_end
   */
  /**
   * Whether a document used the CSS property scroll-padding-block-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_end(607);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_block_start
   */
  /**
   * Whether a document used the CSS property scroll-padding-block-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_start(608);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_bottom
   */
  /**
   * Whether a document used the CSS property scroll-padding-bottom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_bottom(609);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline(610);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline_end
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline-end. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_end(611);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_inline_start
   */
  /**
   * Whether a document used the CSS property scroll-padding-inline-start. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_start(612);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_left
   */
  /**
   * Whether a document used the CSS property scroll-padding-left. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_left(613);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_right
   */
  /**
   * Whether a document used the CSS property scroll-padding-right. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_right(614);

  /**
   * generated from use.counter.css.doc.css_scroll_padding_top
   */
  /**
   * Whether a document used the CSS property scroll-padding-top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_top(615);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_align
   */
  /**
   * Whether a document used the CSS property scroll-snap-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_align(616);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_stop
   */
  /**
   * Whether a document used the CSS property scroll-snap-stop. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_stop(617);

  /**
   * generated from use.counter.css.doc.css_scroll_snap_type
   */
  /**
   * Whether a document used the CSS property scroll-snap-type. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_type(618);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline
   */
  /**
   * Whether a document used the CSS property scroll-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline(619);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline_axis
   */
  /**
   * Whether a document used the CSS property scroll-timeline-axis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_axis(620);

  /**
   * generated from use.counter.css.doc.css_scroll_timeline_name
   */
  /**
   * Whether a document used the CSS property scroll-timeline-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_name(621);

  /**
   * generated from use.counter.css.doc.css_scrollbar_color
   */
  /**
   * Whether a document used the CSS property scrollbar-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_color(622);

  /**
   * generated from use.counter.css.doc.css_scrollbar_gutter
   */
  /**
   * Whether a document used the CSS property scrollbar-gutter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_gutter(623);

  /**
   * generated from use.counter.css.doc.css_scrollbar_width
   */
  /**
   * Whether a document used the CSS property scrollbar-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_width(624);

  /**
   * generated from use.counter.css.doc.css_shape_image_threshold
   */
  /**
   * Whether a document used the CSS property shape-image-threshold. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_image_threshold(625);

  /**
   * generated from use.counter.css.doc.css_shape_margin
   */
  /**
   * Whether a document used the CSS property shape-margin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_margin(626);

  /**
   * generated from use.counter.css.doc.css_shape_outside
   */
  /**
   * Whether a document used the CSS property shape-outside. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_outside(627);

  /**
   * generated from use.counter.css.doc.css_shape_rendering
   */
  /**
   * Whether a document used the CSS property shape-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_rendering(628);

  /**
   * generated from use.counter.css.doc.css_size
   */
  /**
   * Whether a document used the CSS property size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_size(629);

  /**
   * generated from use.counter.css.doc.css_stop_color
   */
  /**
   * Whether a document used the CSS property stop-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_color(630);

  /**
   * generated from use.counter.css.doc.css_stop_opacity
   */
  /**
   * Whether a document used the CSS property stop-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_opacity(631);

  /**
   * generated from use.counter.css.doc.css_stroke
   */
  /**
   * Whether a document used the CSS property stroke. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke(632);

  /**
   * generated from use.counter.css.doc.css_stroke_dasharray
   */
  /**
   * Whether a document used the CSS property stroke-dasharray. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dasharray(633);

  /**
   * generated from use.counter.css.doc.css_stroke_dashoffset
   */
  /**
   * Whether a document used the CSS property stroke-dashoffset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dashoffset(634);

  /**
   * generated from use.counter.css.doc.css_stroke_linecap
   */
  /**
   * Whether a document used the CSS property stroke-linecap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linecap(635);

  /**
   * generated from use.counter.css.doc.css_stroke_linejoin
   */
  /**
   * Whether a document used the CSS property stroke-linejoin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linejoin(636);

  /**
   * generated from use.counter.css.doc.css_stroke_miterlimit
   */
  /**
   * Whether a document used the CSS property stroke-miterlimit. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_miterlimit(637);

  /**
   * generated from use.counter.css.doc.css_stroke_opacity
   */
  /**
   * Whether a document used the CSS property stroke-opacity. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_opacity(638);

  /**
   * generated from use.counter.css.doc.css_stroke_width
   */
  /**
   * Whether a document used the CSS property stroke-width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_width(639);

  /**
   * generated from use.counter.css.doc.css_tab_size
   */
  /**
   * Whether a document used the CSS property tab-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_tab_size(640);

  /**
   * generated from use.counter.css.doc.css_table_layout
   */
  /**
   * Whether a document used the CSS property table-layout. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_table_layout(641);

  /**
   * generated from use.counter.css.doc.css_text_align
   */
  /**
   * Whether a document used the CSS property text-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align(642);

  /**
   * generated from use.counter.css.doc.css_text_align_last
   */
  /**
   * Whether a document used the CSS property text-align-last. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align_last(643);

  /**
   * generated from use.counter.css.doc.css_text_anchor
   */
  /**
   * Whether a document used the CSS property text-anchor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_anchor(644);

  /**
   * generated from use.counter.css.doc.css_text_combine_upright
   */
  /**
   * Whether a document used the CSS property text-combine-upright. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_combine_upright(645);

  /**
   * generated from use.counter.css.doc.css_text_decoration
   */
  /**
   * Whether a document used the CSS property text-decoration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration(646);

  /**
   * generated from use.counter.css.doc.css_text_decoration_color
   */
  /**
   * Whether a document used the CSS property text-decoration-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_color(647);

  /**
   * generated from use.counter.css.doc.css_text_decoration_line
   */
  /**
   * Whether a document used the CSS property text-decoration-line. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_line(648);

  /**
   * generated from use.counter.css.doc.css_text_decoration_skip_ink
   */
  /**
   * Whether a document used the CSS property text-decoration-skip-ink. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_skip_ink(649);

  /**
   * generated from use.counter.css.doc.css_text_decoration_style
   */
  /**
   * Whether a document used the CSS property text-decoration-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_style(650);

  /**
   * generated from use.counter.css.doc.css_text_decoration_thickness
   */
  /**
   * Whether a document used the CSS property text-decoration-thickness. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_thickness(651);

  /**
   * generated from use.counter.css.doc.css_text_emphasis
   */
  /**
   * Whether a document used the CSS property text-emphasis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis(652);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_color
   */
  /**
   * Whether a document used the CSS property text-emphasis-color. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_color(653);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_position
   */
  /**
   * Whether a document used the CSS property text-emphasis-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_position(654);

  /**
   * generated from use.counter.css.doc.css_text_emphasis_style
   */
  /**
   * Whether a document used the CSS property text-emphasis-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_style(655);

  /**
   * generated from use.counter.css.doc.css_text_indent
   */
  /**
   * Whether a document used the CSS property text-indent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_indent(656);

  /**
   * generated from use.counter.css.doc.css_text_justify
   */
  /**
   * Whether a document used the CSS property text-justify. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_justify(657);

  /**
   * generated from use.counter.css.doc.css_text_orientation
   */
  /**
   * Whether a document used the CSS property text-orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_orientation(658);

  /**
   * generated from use.counter.css.doc.css_text_overflow
   */
  /**
   * Whether a document used the CSS property text-overflow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_overflow(659);

  /**
   * generated from use.counter.css.doc.css_text_rendering
   */
  /**
   * Whether a document used the CSS property text-rendering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_rendering(660);

  /**
   * generated from use.counter.css.doc.css_text_shadow
   */
  /**
   * Whether a document used the CSS property text-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_shadow(661);

  /**
   * generated from use.counter.css.doc.css_text_transform
   */
  /**
   * Whether a document used the CSS property text-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_transform(662);

  /**
   * generated from use.counter.css.doc.css_text_underline_offset
   */
  /**
   * Whether a document used the CSS property text-underline-offset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_offset(663);

  /**
   * generated from use.counter.css.doc.css_text_underline_position
   */
  /**
   * Whether a document used the CSS property text-underline-position. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_position(664);

  /**
   * generated from use.counter.css.doc.css_text_wrap
   */
  /**
   * Whether a document used the CSS property text-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap(665);

  /**
   * generated from use.counter.css.doc.css_top
   */
  /**
   * Whether a document used the CSS property top. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_top(666);

  /**
   * generated from use.counter.css.doc.css_touch_action
   */
  /**
   * Whether a document used the CSS property touch-action. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_touch_action(667);

  /**
   * generated from use.counter.css.doc.css_transform
   */
  /**
   * Whether a document used the CSS property transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform(668);

  /**
   * generated from use.counter.css.doc.css_transform_box
   */
  /**
   * Whether a document used the CSS property transform-box. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_box(669);

  /**
   * generated from use.counter.css.doc.css_transform_origin
   */
  /**
   * Whether a document used the CSS property transform-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_origin(670);

  /**
   * generated from use.counter.css.doc.css_transform_style
   */
  /**
   * Whether a document used the CSS property transform-style. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_style(671);

  /**
   * generated from use.counter.css.doc.css_transition
   */
  /**
   * Whether a document used the CSS property transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition(672);

  /**
   * generated from use.counter.css.doc.css_transition_delay
   */
  /**
   * Whether a document used the CSS property transition-delay. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_delay(673);

  /**
   * generated from use.counter.css.doc.css_transition_duration
   */
  /**
   * Whether a document used the CSS property transition-duration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_duration(674);

  /**
   * generated from use.counter.css.doc.css_transition_property
   */
  /**
   * Whether a document used the CSS property transition-property. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_property(675);

  /**
   * generated from use.counter.css.doc.css_transition_timing_function
   */
  /**
   * Whether a document used the CSS property transition-timing-function. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_timing_function(676);

  /**
   * generated from use.counter.css.doc.css_translate
   */
  /**
   * Whether a document used the CSS property translate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_translate(677);

  /**
   * generated from use.counter.css.doc.css_unicode_bidi
   */
  /**
   * Whether a document used the CSS property unicode-bidi. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_unicode_bidi(678);

  /**
   * generated from use.counter.css.doc.css_user_select
   */
  /**
   * Whether a document used the CSS property user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_user_select(679);

  /**
   * generated from use.counter.css.doc.css_vector_effect
   */
  /**
   * Whether a document used the CSS property vector-effect. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vector_effect(680);

  /**
   * generated from use.counter.css.doc.css_vertical_align
   */
  /**
   * Whether a document used the CSS property vertical-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vertical_align(681);

  /**
   * generated from use.counter.css.doc.css_view_timeline
   */
  /**
   * Whether a document used the CSS property view-timeline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline(682);

  /**
   * generated from use.counter.css.doc.css_view_timeline_axis
   */
  /**
   * Whether a document used the CSS property view-timeline-axis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_axis(683);

  /**
   * generated from use.counter.css.doc.css_view_timeline_inset
   */
  /**
   * Whether a document used the CSS property view-timeline-inset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_inset(684);

  /**
   * generated from use.counter.css.doc.css_view_timeline_name
   */
  /**
   * Whether a document used the CSS property view-timeline-name. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_name(685);

  /**
   * generated from use.counter.css.doc.css_visibility
   */
  /**
   * Whether a document used the CSS property visibility. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_visibility(686);

  /**
   * generated from use.counter.css.doc.css_webkit_align_content
   */
  /**
   * Whether a document used the CSS property -webkit-align-content. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_content(687);

  /**
   * generated from use.counter.css.doc.css_webkit_align_items
   */
  /**
   * Whether a document used the CSS property -webkit-align-items. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_items(688);

  /**
   * generated from use.counter.css.doc.css_webkit_align_self
   */
  /**
   * Whether a document used the CSS property -webkit-align-self. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_self(689);

  /**
   * generated from use.counter.css.doc.css_webkit_animation
   */
  /**
   * Whether a document used the CSS property -webkit-animation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation(690);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_delay
   */
  /**
   * Whether a document used the CSS property -webkit-animation-delay. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_delay(691);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_direction
   */
  /**
   * Whether a document used the CSS property -webkit-animation-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_direction(692);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_duration
   */
  /**
   * Whether a document used the CSS property -webkit-animation-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_duration(693);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_fill_mode
   */
  /**
   * Whether a document used the CSS property -webkit-animation-fill-mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_fill_mode(694);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_iteration_count
   */
  /**
   * Whether a document used the CSS property -webkit-animation-iteration-count.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_iteration_count(695);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_name
   */
  /**
   * Whether a document used the CSS property -webkit-animation-name. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_name(696);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_play_state
   */
  /**
   * Whether a document used the CSS property -webkit-animation-play-state. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_play_state(697);

  /**
   * generated from use.counter.css.doc.css_webkit_animation_timing_function
   */
  /**
   * Whether a document used the CSS property -webkit-animation-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_timing_function(698);

  /**
   * generated from use.counter.css.doc.css_webkit_appearance
   */
  /**
   * Whether a document used the CSS property -webkit-appearance. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_appearance(699);

  /**
   * generated from use.counter.css.doc.css_webkit_backface_visibility
   */
  /**
   * Whether a document used the CSS property -webkit-backface-visibility. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_backface_visibility(700);

  /**
   * generated from use.counter.css.doc.css_webkit_background_clip
   */
  /**
   * Whether a document used the CSS property -webkit-background-clip. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_clip(701);

  /**
   * generated from use.counter.css.doc.css_webkit_background_origin
   */
  /**
   * Whether a document used the CSS property -webkit-background-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_origin(702);

  /**
   * generated from use.counter.css.doc.css_webkit_background_size
   */
  /**
   * Whether a document used the CSS property -webkit-background-size. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_size(703);

  /**
   * generated from use.counter.css.doc.css_webkit_border_bottom_left_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-bottom-left-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_left_radius(704);

  /**
   * generated from use.counter.css.doc.css_webkit_border_bottom_right_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-bottom-right-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_right_radius(705);

  /**
   * generated from use.counter.css.doc.css_webkit_border_image
   */
  /**
   * Whether a document used the CSS property -webkit-border-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_image(706);

  /**
   * generated from use.counter.css.doc.css_webkit_border_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-radius. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_radius(707);

  /**
   * generated from use.counter.css.doc.css_webkit_border_top_left_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-top-left-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_left_radius(708);

  /**
   * generated from use.counter.css.doc.css_webkit_border_top_right_radius
   */
  /**
   * Whether a document used the CSS property -webkit-border-top-right-radius.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_right_radius(709);

  /**
   * generated from use.counter.css.doc.css_webkit_box_align
   */
  /**
   * Whether a document used the CSS property -webkit-box-align. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_align(710);

  /**
   * generated from use.counter.css.doc.css_webkit_box_direction
   */
  /**
   * Whether a document used the CSS property -webkit-box-direction. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_direction(711);

  /**
   * generated from use.counter.css.doc.css_webkit_box_flex
   */
  /**
   * Whether a document used the CSS property -webkit-box-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_flex(712);

  /**
   * generated from use.counter.css.doc.css_webkit_box_ordinal_group
   */
  /**
   * Whether a document used the CSS property -webkit-box-ordinal-group. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_ordinal_group(713);

  /**
   * generated from use.counter.css.doc.css_webkit_box_orient
   */
  /**
   * Whether a document used the CSS property -webkit-box-orient. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_orient(714);

  /**
   * generated from use.counter.css.doc.css_webkit_box_pack
   */
  /**
   * Whether a document used the CSS property -webkit-box-pack. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_pack(715);

  /**
   * generated from use.counter.css.doc.css_webkit_box_shadow
   */
  /**
   * Whether a document used the CSS property -webkit-box-shadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_shadow(716);

  /**
   * generated from use.counter.css.doc.css_webkit_box_sizing
   */
  /**
   * Whether a document used the CSS property -webkit-box-sizing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_sizing(717);

  /**
   * generated from use.counter.css.doc.css_webkit_clip_path
   */
  /**
   * Whether a document used the CSS property -webkit-clip-path. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_clip_path(718);

  /**
   * generated from use.counter.css.doc.css_webkit_filter
   */
  /**
   * Whether a document used the CSS property -webkit-filter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_filter(719);

  /**
   * generated from use.counter.css.doc.css_webkit_flex
   */
  /**
   * Whether a document used the CSS property -webkit-flex. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex(720);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_basis
   */
  /**
   * Whether a document used the CSS property -webkit-flex-basis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_basis(721);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_direction
   */
  /**
   * Whether a document used the CSS property -webkit-flex-direction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_direction(722);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_flow
   */
  /**
   * Whether a document used the CSS property -webkit-flex-flow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_flow(723);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_grow
   */
  /**
   * Whether a document used the CSS property -webkit-flex-grow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_grow(724);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_shrink
   */
  /**
   * Whether a document used the CSS property -webkit-flex-shrink. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_shrink(725);

  /**
   * generated from use.counter.css.doc.css_webkit_flex_wrap
   */
  /**
   * Whether a document used the CSS property -webkit-flex-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_wrap(726);

  /**
   * generated from use.counter.css.doc.css_webkit_justify_content
   */
  /**
   * Whether a document used the CSS property -webkit-justify-content. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_justify_content(727);

  /**
   * generated from use.counter.css.doc.css_webkit_line_clamp
   */
  /**
   * Whether a document used the CSS property -webkit-line-clamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_line_clamp(728);

  /**
   * generated from use.counter.css.doc.css_webkit_mask
   */
  /**
   * Whether a document used the CSS property -webkit-mask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask(729);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_clip
   */
  /**
   * Whether a document used the CSS property -webkit-mask-clip. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_clip(730);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_composite
   */
  /**
   * Whether a document used the CSS property -webkit-mask-composite. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_composite(731);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_image
   */
  /**
   * Whether a document used the CSS property -webkit-mask-image. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_image(732);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_origin
   */
  /**
   * Whether a document used the CSS property -webkit-mask-origin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_origin(733);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position(734);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position_x
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position-x. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_x(735);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_position_y
   */
  /**
   * Whether a document used the CSS property -webkit-mask-position-y. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_y(736);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_repeat
   */
  /**
   * Whether a document used the CSS property -webkit-mask-repeat. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_repeat(737);

  /**
   * generated from use.counter.css.doc.css_webkit_mask_size
   */
  /**
   * Whether a document used the CSS property -webkit-mask-size. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_size(738);

  /**
   * generated from use.counter.css.doc.css_webkit_order
   */
  /**
   * Whether a document used the CSS property -webkit-order. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_order(739);

  /**
   * generated from use.counter.css.doc.css_webkit_perspective
   */
  /**
   * Whether a document used the CSS property -webkit-perspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective(740);

  /**
   * generated from use.counter.css.doc.css_webkit_perspective_origin
   */
  /**
   * Whether a document used the CSS property -webkit-perspective-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective_origin(741);

  /**
   * generated from use.counter.css.doc.css_webkit_text_fill_color
   */
  /**
   * Whether a document used the CSS property -webkit-text-fill-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_fill_color(742);

  /**
   * generated from use.counter.css.doc.css_webkit_text_security
   */
  /**
   * Whether a document used the CSS property -webkit-text-security. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_security(743);

  /**
   * generated from use.counter.css.doc.css_webkit_text_size_adjust
   */
  /**
   * Whether a document used the CSS property -webkit-text-size-adjust. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_size_adjust(744);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke(745);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke_color
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke-color. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_color(746);

  /**
   * generated from use.counter.css.doc.css_webkit_text_stroke_width
   */
  /**
   * Whether a document used the CSS property -webkit-text-stroke-width. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_width(747);

  /**
   * generated from use.counter.css.doc.css_webkit_transform
   */
  /**
   * Whether a document used the CSS property -webkit-transform. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform(748);

  /**
   * generated from use.counter.css.doc.css_webkit_transform_origin
   */
  /**
   * Whether a document used the CSS property -webkit-transform-origin. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_origin(749);

  /**
   * generated from use.counter.css.doc.css_webkit_transform_style
   */
  /**
   * Whether a document used the CSS property -webkit-transform-style. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_style(750);

  /**
   * generated from use.counter.css.doc.css_webkit_transition
   */
  /**
   * Whether a document used the CSS property -webkit-transition. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition(751);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_delay
   */
  /**
   * Whether a document used the CSS property -webkit-transition-delay. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_delay(752);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_duration
   */
  /**
   * Whether a document used the CSS property -webkit-transition-duration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_duration(753);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_property
   */
  /**
   * Whether a document used the CSS property -webkit-transition-property. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_property(754);

  /**
   * generated from use.counter.css.doc.css_webkit_transition_timing_function
   */
  /**
   * Whether a document used the CSS property -webkit-transition-timing-function.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_timing_function(755);

  /**
   * generated from use.counter.css.doc.css_webkit_user_select
   */
  /**
   * Whether a document used the CSS property -webkit-user-select. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_user_select(756);

  /**
   * generated from use.counter.css.doc.css_white_space
   */
  /**
   * Whether a document used the CSS property white-space. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space(757);

  /**
   * generated from use.counter.css.doc.css_width
   */
  /**
   * Whether a document used the CSS property width. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_width(758);

  /**
   * generated from use.counter.css.doc.css_will_change
   */
  /**
   * Whether a document used the CSS property will-change. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_will_change(759);

  /**
   * generated from use.counter.css.doc.css_word_break
   */
  /**
   * Whether a document used the CSS property word-break. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_break(760);

  /**
   * generated from use.counter.css.doc.css_word_spacing
   */
  /**
   * Whether a document used the CSS property word-spacing. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_spacing(761);

  /**
   * generated from use.counter.css.doc.css_word_wrap
   */
  /**
   * Whether a document used the CSS property word-wrap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_wrap(762);

  /**
   * generated from use.counter.css.doc.css_writing_mode
   */
  /**
   * Whether a document used the CSS property writing-mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_writing_mode(763);

  /**
   * generated from use.counter.css.doc.css_x
   */
  /**
   * Whether a document used the CSS property x. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x(764);

  /**
   * generated from use.counter.css.doc.css_x_lang
   */
  /**
   * Whether a document used the CSS property -x-lang. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_lang(765);

  /**
   * generated from use.counter.css.doc.css_x_span
   */
  /**
   * Whether a document used the CSS property -x-span. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_span(766);

  /**
   * generated from use.counter.css.doc.css_x_text_scale
   */
  /**
   * Whether a document used the CSS property -x-text-scale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_text_scale(767);

  /**
   * generated from use.counter.css.doc.css_y
   */
  /**
   * Whether a document used the CSS property y. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_y(768);

  /**
   * generated from use.counter.css.doc.css_z_index
   */
  /**
   * Whether a document used the CSS property z-index. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_z_index(769);

  /**
   * generated from use.counter.css.doc.css_zoom
   */
  /**
   * Whether a document used the CSS property zoom. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_zoom(770);

  /**
   * generated from use.counter.css.doc.max_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property max-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric max_zoom(771);

  /**
   * generated from use.counter.css.doc.min_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property min-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric min_zoom(772);

  /**
   * generated from use.counter.css.doc.orientation
   */
  /**
   * Whether a document used the (unknown, counted) CSS property orientation.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orientation(773);

  /**
   * generated from use.counter.css.doc.orphans
   */
  /**
   * Whether a document used the (unknown, counted) CSS property orphans. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orphans(774);

  /**
   * generated from use.counter.css.doc.speak
   */
  /**
   * Whether a document used the (unknown, counted) CSS property speak. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric speak(775);

  /**
   * generated from use.counter.css.doc.text_size_adjust
   */
  /**
   * Whether a document used the (unknown, counted) CSS property text-size-adjust.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric text_size_adjust(776);

  /**
   * generated from use.counter.css.doc.user_zoom
   */
  /**
   * Whether a document used the (unknown, counted) CSS property user-zoom. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric user_zoom(777);

  /**
   * generated from use.counter.css.doc.webkit_app_region
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-app-region.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_app_region(778);

  /**
   * generated from use.counter.css.doc.webkit_border_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_after(779);

  /**
   * generated from use.counter.css.doc.webkit_border_after_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_color(780);

  /**
   * generated from use.counter.css.doc.webkit_border_after_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_style(781);

  /**
   * generated from use.counter.css.doc.webkit_border_after_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * after-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_width(782);

  /**
   * generated from use.counter.css.doc.webkit_border_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_before(783);

  /**
   * generated from use.counter.css.doc.webkit_border_before_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_color(784);

  /**
   * generated from use.counter.css.doc.webkit_border_before_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_style(785);

  /**
   * generated from use.counter.css.doc.webkit_border_before_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * before-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_width(786);

  /**
   * generated from use.counter.css.doc.webkit_border_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_border_end(787);

  /**
   * generated from use.counter.css.doc.webkit_border_end_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * color. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_color(788);

  /**
   * generated from use.counter.css.doc.webkit_border_end_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * style. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_style(789);

  /**
   * generated from use.counter.css.doc.webkit_border_end_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-end-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_width(790);

  /**
   * generated from use.counter.css.doc.webkit_border_horizontal_spacing
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * horizontal-spacing. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_horizontal_spacing(791);

  /**
   * generated from use.counter.css.doc.webkit_border_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_border_start(792);

  /**
   * generated from use.counter.css.doc.webkit_border_start_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_color(793);

  /**
   * generated from use.counter.css.doc.webkit_border_start_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_style(794);

  /**
   * generated from use.counter.css.doc.webkit_border_start_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * start-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_width(795);

  /**
   * generated from use.counter.css.doc.webkit_border_vertical_spacing
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-border-
     * vertical-spacing. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_vertical_spacing(796);

  /**
   * generated from use.counter.css.doc.webkit_box_decoration_break
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-box-
     * decoration-break. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_decoration_break(797);

  /**
   * generated from use.counter.css.doc.webkit_box_reflect
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-box-
     * reflect. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_box_reflect(798);

  /**
   * generated from use.counter.css.doc.webkit_column_break_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-after. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_after(799);

  /**
   * generated from use.counter.css.doc.webkit_column_break_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-before. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_before(800);

  /**
   * generated from use.counter.css.doc.webkit_column_break_inside
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * break-inside. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_inside(801);

  /**
   * generated from use.counter.css.doc.webkit_column_count
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * count. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_count(802);

  /**
   * generated from use.counter.css.doc.webkit_column_gap
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-gap.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_column_gap(803);

  /**
   * generated from use.counter.css.doc.webkit_column_rule
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule(804);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_color(805);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_style(806);

  /**
   * generated from use.counter.css.doc.webkit_column_rule_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * rule-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_width(807);

  /**
   * generated from use.counter.css.doc.webkit_column_span
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * span. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_span(808);

  /**
   * generated from use.counter.css.doc.webkit_column_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-column-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_column_width(809);

  /**
   * generated from use.counter.css.doc.webkit_columns
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-columns.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_columns(810);

  /**
   * generated from use.counter.css.doc.webkit_font_feature_settings
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-font-
     * feature-settings. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_feature_settings(811);

  /**
   * generated from use.counter.css.doc.webkit_font_size_delta
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-font-size-
     * delta. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_font_size_delta(812);

  /**
   * generated from use.counter.css.doc.webkit_font_smoothing
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-font-
     * smoothing. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_smoothing(813);

  /**
   * generated from use.counter.css.doc.webkit_highlight
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-highlight.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_highlight(814);

  /**
   * generated from use.counter.css.doc.webkit_hyphenate_character
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-hyphenate-
     * character. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_hyphenate_character(815);

  /**
   * generated from use.counter.css.doc.webkit_line_break
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-line-break.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_line_break(816);

  /**
   * generated from use.counter.css.doc.webkit_locale
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-locale.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_locale(817);

  /**
   * generated from use.counter.css.doc.webkit_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-logical-
     * height. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_logical_height(818);

  /**
   * generated from use.counter.css.doc.webkit_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-logical-
     * width. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_logical_width(819);

  /**
   * generated from use.counter.css.doc.webkit_margin_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after(820);

  /**
   * generated from use.counter.css.doc.webkit_margin_after_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * after-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after_collapse(821);

  /**
   * generated from use.counter.css.doc.webkit_margin_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before(822);

  /**
   * generated from use.counter.css.doc.webkit_margin_before_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * before-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before_collapse(823);

  /**
   * generated from use.counter.css.doc.webkit_margin_bottom_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * bottom-collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_bottom_collapse(824);

  /**
   * generated from use.counter.css.doc.webkit_margin_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_collapse(825);

  /**
   * generated from use.counter.css.doc.webkit_margin_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-end.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_margin_end(826);

  /**
   * generated from use.counter.css.doc.webkit_margin_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_margin_start(827);

  /**
   * generated from use.counter.css.doc.webkit_margin_top_collapse
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-margin-top-
     * collapse. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_top_collapse(828);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image(829);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_outset
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-outset. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_outset(830);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_repeat
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-repeat. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_repeat(831);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_slice
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-slice. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_slice(832);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_source
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-source. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_source(833);

  /**
   * generated from use.counter.css.doc.webkit_mask_box_image_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
     * image-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_width(834);

  /**
   * generated from use.counter.css.doc.webkit_mask_repeat_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-
     * repeat-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_x(835);

  /**
   * generated from use.counter.css.doc.webkit_mask_repeat_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-mask-
     * repeat-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_y(836);

  /**
   * generated from use.counter.css.doc.webkit_max_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-max-
     * logical-height. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_height(837);

  /**
   * generated from use.counter.css.doc.webkit_max_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-max-
     * logical-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_width(838);

  /**
   * generated from use.counter.css.doc.webkit_min_logical_height
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-min-
     * logical-height. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_height(839);

  /**
   * generated from use.counter.css.doc.webkit_min_logical_width
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-min-
     * logical-width. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_width(840);

  /**
   * generated from use.counter.css.doc.webkit_opacity
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-opacity.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_opacity(841);

  /**
   * generated from use.counter.css.doc.webkit_padding_after
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * after. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_after(842);

  /**
   * generated from use.counter.css.doc.webkit_padding_before
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * before. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_before(843);

  /**
   * generated from use.counter.css.doc.webkit_padding_end
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * end. Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_padding_end(844);

  /**
   * generated from use.counter.css.doc.webkit_padding_start
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-padding-
     * start. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_padding_start(845);

  /**
   * generated from use.counter.css.doc.webkit_perspective_origin_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-
     * perspective-origin-x. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_x(846);

  /**
   * generated from use.counter.css.doc.webkit_perspective_origin_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-
     * perspective-origin-y. Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_y(847);

  /**
   * generated from use.counter.css.doc.webkit_print_color_adjust
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-print-
     * color-adjust. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_print_color_adjust(848);

  /**
   * generated from use.counter.css.doc.webkit_rtl_ordering
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-rtl-
     * ordering. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_rtl_ordering(849);

  /**
   * generated from use.counter.css.doc.webkit_ruby_position
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-ruby-
     * position. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_ruby_position(850);

  /**
   * generated from use.counter.css.doc.webkit_shape_image_threshold
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * image-threshold. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_image_threshold(851);

  /**
   * generated from use.counter.css.doc.webkit_shape_margin
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * margin. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_shape_margin(852);

  /**
   * generated from use.counter.css.doc.webkit_shape_outside
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-shape-
     * outside. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_shape_outside(853);

  /**
   * generated from use.counter.css.doc.webkit_tap_highlight_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-tap-
     * highlight-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_tap_highlight_color(854);

  /**
   * generated from use.counter.css.doc.webkit_text_combine
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * combine. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_text_combine(855);

  /**
   * generated from use.counter.css.doc.webkit_text_decorations_in_effect
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * decorations-in-effect. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_decorations_in_effect(856);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis(857);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_color
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-color. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_color(858);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_position
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-position. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_position(859);

  /**
   * generated from use.counter.css.doc.webkit_text_emphasis_style
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * emphasis-style. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_style(860);

  /**
   * generated from use.counter.css.doc.webkit_text_orientation
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-text-
     * orientation. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_orientation(861);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_x
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-x. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_x(862);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_y
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-y. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_y(863);

  /**
   * generated from use.counter.css.doc.webkit_transform_origin_z
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-transform-
     * origin-z. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_z(864);

  /**
   * generated from use.counter.css.doc.webkit_user_drag
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-user-drag.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_user_drag(865);

  /**
   * generated from use.counter.css.doc.webkit_user_modify
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-user-
     * modify. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_user_modify(866);

  /**
   * generated from use.counter.css.doc.webkit_writing_mode
   */
  /**
   * Whether a document used the (unknown, counted) CSS property -webkit-writing-
     * mode. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric webkit_writing_mode(867);

  /**
   * generated from use.counter.css.doc.widows
   */
  /**
   * Whether a document used the (unknown, counted) CSS property widows. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric widows(868);

}
namespace use_counter_css_page {
  /**
   * generated from use.counter.css.page.alignment_baseline
   */
  /**
   * Whether a page used the (unknown, counted) CSS property alignment-baseline.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric alignment_baseline(869);

  /**
   * generated from use.counter.css.page.background_repeat_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property background-repeat-x.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_x(870);

  /**
   * generated from use.counter.css.page.background_repeat_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property background-repeat-y.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric background_repeat_y(871);

  /**
   * generated from use.counter.css.page.baseline_shift
   */
  /**
   * Whether a page used the (unknown, counted) CSS property baseline-shift. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric baseline_shift(872);

  /**
   * generated from use.counter.css.page.buffered_rendering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property buffered-rendering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric buffered_rendering(873);

  /**
   * generated from use.counter.css.page.color_rendering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property color-rendering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric color_rendering(874);

  /**
   * generated from use.counter.css.page.css_accent_color
   */
  /**
   * Whether a page used the CSS property accent-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_accent_color(875);

  /**
   * generated from use.counter.css.page.css_align_content
   */
  /**
   * Whether a page used the CSS property align-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_content(876);

  /**
   * generated from use.counter.css.page.css_align_items
   */
  /**
   * Whether a page used the CSS property align-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_items(877);

  /**
   * generated from use.counter.css.page.css_align_self
   */
  /**
   * Whether a page used the CSS property align-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_self(878);

  /**
   * generated from use.counter.css.page.css_align_tracks
   */
  /**
   * Whether a page used the CSS property align-tracks. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_align_tracks(879);

  /**
   * generated from use.counter.css.page.css_all
   */
  /**
   * Whether a page used the CSS property all. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_all(880);

  /**
   * generated from use.counter.css.page.css_animation
   */
  /**
   * Whether a page used the CSS property animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation(881);

  /**
   * generated from use.counter.css.page.css_animation_composition
   */
  /**
   * Whether a page used the CSS property animation-composition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_composition(882);

  /**
   * generated from use.counter.css.page.css_animation_delay
   */
  /**
   * Whether a page used the CSS property animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_delay(883);

  /**
   * generated from use.counter.css.page.css_animation_direction
   */
  /**
   * Whether a page used the CSS property animation-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_direction(884);

  /**
   * generated from use.counter.css.page.css_animation_duration
   */
  /**
   * Whether a page used the CSS property animation-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_duration(885);

  /**
   * generated from use.counter.css.page.css_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property animation-fill-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_fill_mode(886);

  /**
   * generated from use.counter.css.page.css_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property animation-iteration-count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_iteration_count(887);

  /**
   * generated from use.counter.css.page.css_animation_name
   */
  /**
   * Whether a page used the CSS property animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_name(888);

  /**
   * generated from use.counter.css.page.css_animation_play_state
   */
  /**
   * Whether a page used the CSS property animation-play-state. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_play_state(889);

  /**
   * generated from use.counter.css.page.css_animation_timeline
   */
  /**
   * Whether a page used the CSS property animation-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timeline(890);

  /**
   * generated from use.counter.css.page.css_animation_timing_function
   */
  /**
   * Whether a page used the CSS property animation-timing-function. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_animation_timing_function(891);

  /**
   * generated from use.counter.css.page.css_appearance
   */
  /**
   * Whether a page used the CSS property appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_appearance(892);

  /**
   * generated from use.counter.css.page.css_aspect_ratio
   */
  /**
   * Whether a page used the CSS property aspect-ratio. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_aspect_ratio(893);

  /**
   * generated from use.counter.css.page.css_backdrop_filter
   */
  /**
   * Whether a page used the CSS property backdrop-filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backdrop_filter(894);

  /**
   * generated from use.counter.css.page.css_backface_visibility
   */
  /**
   * Whether a page used the CSS property backface-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_backface_visibility(895);

  /**
   * generated from use.counter.css.page.css_background
   */
  /**
   * Whether a page used the CSS property background. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background(896);

  /**
   * generated from use.counter.css.page.css_background_attachment
   */
  /**
   * Whether a page used the CSS property background-attachment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_attachment(897);

  /**
   * generated from use.counter.css.page.css_background_blend_mode
   */
  /**
   * Whether a page used the CSS property background-blend-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_blend_mode(898);

  /**
   * generated from use.counter.css.page.css_background_clip
   */
  /**
   * Whether a page used the CSS property background-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_clip(899);

  /**
   * generated from use.counter.css.page.css_background_color
   */
  /**
   * Whether a page used the CSS property background-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_color(900);

  /**
   * generated from use.counter.css.page.css_background_image
   */
  /**
   * Whether a page used the CSS property background-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_image(901);

  /**
   * generated from use.counter.css.page.css_background_origin
   */
  /**
   * Whether a page used the CSS property background-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_origin(902);

  /**
   * generated from use.counter.css.page.css_background_position
   */
  /**
   * Whether a page used the CSS property background-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position(903);

  /**
   * generated from use.counter.css.page.css_background_position_x
   */
  /**
   * Whether a page used the CSS property background-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_x(904);

  /**
   * generated from use.counter.css.page.css_background_position_y
   */
  /**
   * Whether a page used the CSS property background-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_position_y(905);

  /**
   * generated from use.counter.css.page.css_background_repeat
   */
  /**
   * Whether a page used the CSS property background-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_repeat(906);

  /**
   * generated from use.counter.css.page.css_background_size
   */
  /**
   * Whether a page used the CSS property background-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_background_size(907);

  /**
   * generated from use.counter.css.page.css_baseline_source
   */
  /**
   * Whether a page used the CSS property baseline-source. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_baseline_source(908);

  /**
   * generated from use.counter.css.page.css_block_size
   */
  /**
   * Whether a page used the CSS property block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_block_size(909);

  /**
   * generated from use.counter.css.page.css_border
   */
  /**
   * Whether a page used the CSS property border. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border(910);

  /**
   * generated from use.counter.css.page.css_border_block
   */
  /**
   * Whether a page used the CSS property border-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block(911);

  /**
   * generated from use.counter.css.page.css_border_block_color
   */
  /**
   * Whether a page used the CSS property border-block-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_color(912);

  /**
   * generated from use.counter.css.page.css_border_block_end
   */
  /**
   * Whether a page used the CSS property border-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end(913);

  /**
   * generated from use.counter.css.page.css_border_block_end_color
   */
  /**
   * Whether a page used the CSS property border-block-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_color(914);

  /**
   * generated from use.counter.css.page.css_border_block_end_style
   */
  /**
   * Whether a page used the CSS property border-block-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_style(915);

  /**
   * generated from use.counter.css.page.css_border_block_end_width
   */
  /**
   * Whether a page used the CSS property border-block-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_end_width(916);

  /**
   * generated from use.counter.css.page.css_border_block_start
   */
  /**
   * Whether a page used the CSS property border-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start(917);

  /**
   * generated from use.counter.css.page.css_border_block_start_color
   */
  /**
   * Whether a page used the CSS property border-block-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_color(918);

  /**
   * generated from use.counter.css.page.css_border_block_start_style
   */
  /**
   * Whether a page used the CSS property border-block-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_style(919);

  /**
   * generated from use.counter.css.page.css_border_block_start_width
   */
  /**
   * Whether a page used the CSS property border-block-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_start_width(920);

  /**
   * generated from use.counter.css.page.css_border_block_style
   */
  /**
   * Whether a page used the CSS property border-block-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_style(921);

  /**
   * generated from use.counter.css.page.css_border_block_width
   */
  /**
   * Whether a page used the CSS property border-block-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_block_width(922);

  /**
   * generated from use.counter.css.page.css_border_bottom
   */
  /**
   * Whether a page used the CSS property border-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom(923);

  /**
   * generated from use.counter.css.page.css_border_bottom_color
   */
  /**
   * Whether a page used the CSS property border-bottom-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_color(924);

  /**
   * generated from use.counter.css.page.css_border_bottom_left_radius
   */
  /**
   * Whether a page used the CSS property border-bottom-left-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_left_radius(925);

  /**
   * generated from use.counter.css.page.css_border_bottom_right_radius
   */
  /**
   * Whether a page used the CSS property border-bottom-right-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_border_bottom_right_radius(926);

  /**
   * generated from use.counter.css.page.css_border_bottom_style
   */
  /**
   * Whether a page used the CSS property border-bottom-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_style(927);

  /**
   * generated from use.counter.css.page.css_border_bottom_width
   */
  /**
   * Whether a page used the CSS property border-bottom-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_bottom_width(928);

  /**
   * generated from use.counter.css.page.css_border_collapse
   */
  /**
   * Whether a page used the CSS property border-collapse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_collapse(929);

  /**
   * generated from use.counter.css.page.css_border_color
   */
  /**
   * Whether a page used the CSS property border-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_color(930);

  /**
   * generated from use.counter.css.page.css_border_end_end_radius
   */
  /**
   * Whether a page used the CSS property border-end-end-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_end_radius(931);

  /**
   * generated from use.counter.css.page.css_border_end_start_radius
   */
  /**
   * Whether a page used the CSS property border-end-start-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_end_start_radius(932);

  /**
   * generated from use.counter.css.page.css_border_image
   */
  /**
   * Whether a page used the CSS property border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image(933);

  /**
   * generated from use.counter.css.page.css_border_image_outset
   */
  /**
   * Whether a page used the CSS property border-image-outset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_outset(934);

  /**
   * generated from use.counter.css.page.css_border_image_repeat
   */
  /**
   * Whether a page used the CSS property border-image-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_repeat(935);

  /**
   * generated from use.counter.css.page.css_border_image_slice
   */
  /**
   * Whether a page used the CSS property border-image-slice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_slice(936);

  /**
   * generated from use.counter.css.page.css_border_image_source
   */
  /**
   * Whether a page used the CSS property border-image-source. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_source(937);

  /**
   * generated from use.counter.css.page.css_border_image_width
   */
  /**
   * Whether a page used the CSS property border-image-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_image_width(938);

  /**
   * generated from use.counter.css.page.css_border_inline
   */
  /**
   * Whether a page used the CSS property border-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline(939);

  /**
   * generated from use.counter.css.page.css_border_inline_color
   */
  /**
   * Whether a page used the CSS property border-inline-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_color(940);

  /**
   * generated from use.counter.css.page.css_border_inline_end
   */
  /**
   * Whether a page used the CSS property border-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end(941);

  /**
   * generated from use.counter.css.page.css_border_inline_end_color
   */
  /**
   * Whether a page used the CSS property border-inline-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_color(942);

  /**
   * generated from use.counter.css.page.css_border_inline_end_style
   */
  /**
   * Whether a page used the CSS property border-inline-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_style(943);

  /**
   * generated from use.counter.css.page.css_border_inline_end_width
   */
  /**
   * Whether a page used the CSS property border-inline-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_end_width(944);

  /**
   * generated from use.counter.css.page.css_border_inline_start
   */
  /**
   * Whether a page used the CSS property border-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start(945);

  /**
   * generated from use.counter.css.page.css_border_inline_start_color
   */
  /**
   * Whether a page used the CSS property border-inline-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_color(946);

  /**
   * generated from use.counter.css.page.css_border_inline_start_style
   */
  /**
   * Whether a page used the CSS property border-inline-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_style(947);

  /**
   * generated from use.counter.css.page.css_border_inline_start_width
   */
  /**
   * Whether a page used the CSS property border-inline-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_start_width(948);

  /**
   * generated from use.counter.css.page.css_border_inline_style
   */
  /**
   * Whether a page used the CSS property border-inline-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_style(949);

  /**
   * generated from use.counter.css.page.css_border_inline_width
   */
  /**
   * Whether a page used the CSS property border-inline-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_inline_width(950);

  /**
   * generated from use.counter.css.page.css_border_left
   */
  /**
   * Whether a page used the CSS property border-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left(951);

  /**
   * generated from use.counter.css.page.css_border_left_color
   */
  /**
   * Whether a page used the CSS property border-left-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_color(952);

  /**
   * generated from use.counter.css.page.css_border_left_style
   */
  /**
   * Whether a page used the CSS property border-left-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_style(953);

  /**
   * generated from use.counter.css.page.css_border_left_width
   */
  /**
   * Whether a page used the CSS property border-left-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_left_width(954);

  /**
   * generated from use.counter.css.page.css_border_radius
   */
  /**
   * Whether a page used the CSS property border-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_radius(955);

  /**
   * generated from use.counter.css.page.css_border_right
   */
  /**
   * Whether a page used the CSS property border-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right(956);

  /**
   * generated from use.counter.css.page.css_border_right_color
   */
  /**
   * Whether a page used the CSS property border-right-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_color(957);

  /**
   * generated from use.counter.css.page.css_border_right_style
   */
  /**
   * Whether a page used the CSS property border-right-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_style(958);

  /**
   * generated from use.counter.css.page.css_border_right_width
   */
  /**
   * Whether a page used the CSS property border-right-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_right_width(959);

  /**
   * generated from use.counter.css.page.css_border_spacing
   */
  /**
   * Whether a page used the CSS property border-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_spacing(960);

  /**
   * generated from use.counter.css.page.css_border_start_end_radius
   */
  /**
   * Whether a page used the CSS property border-start-end-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_end_radius(961);

  /**
   * generated from use.counter.css.page.css_border_start_start_radius
   */
  /**
   * Whether a page used the CSS property border-start-start-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_start_start_radius(962);

  /**
   * generated from use.counter.css.page.css_border_style
   */
  /**
   * Whether a page used the CSS property border-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_style(963);

  /**
   * generated from use.counter.css.page.css_border_top
   */
  /**
   * Whether a page used the CSS property border-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top(964);

  /**
   * generated from use.counter.css.page.css_border_top_color
   */
  /**
   * Whether a page used the CSS property border-top-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_color(965);

  /**
   * generated from use.counter.css.page.css_border_top_left_radius
   */
  /**
   * Whether a page used the CSS property border-top-left-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_left_radius(966);

  /**
   * generated from use.counter.css.page.css_border_top_right_radius
   */
  /**
   * Whether a page used the CSS property border-top-right-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_right_radius(967);

  /**
   * generated from use.counter.css.page.css_border_top_style
   */
  /**
   * Whether a page used the CSS property border-top-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_style(968);

  /**
   * generated from use.counter.css.page.css_border_top_width
   */
  /**
   * Whether a page used the CSS property border-top-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_top_width(969);

  /**
   * generated from use.counter.css.page.css_border_width
   */
  /**
   * Whether a page used the CSS property border-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_border_width(970);

  /**
   * generated from use.counter.css.page.css_bottom
   */
  /**
   * Whether a page used the CSS property bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_bottom(971);

  /**
   * generated from use.counter.css.page.css_box_decoration_break
   */
  /**
   * Whether a page used the CSS property box-decoration-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_decoration_break(972);

  /**
   * generated from use.counter.css.page.css_box_shadow
   */
  /**
   * Whether a page used the CSS property box-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_shadow(973);

  /**
   * generated from use.counter.css.page.css_box_sizing
   */
  /**
   * Whether a page used the CSS property box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_box_sizing(974);

  /**
   * generated from use.counter.css.page.css_break_after
   */
  /**
   * Whether a page used the CSS property break-after. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_after(975);

  /**
   * generated from use.counter.css.page.css_break_before
   */
  /**
   * Whether a page used the CSS property break-before. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_before(976);

  /**
   * generated from use.counter.css.page.css_break_inside
   */
  /**
   * Whether a page used the CSS property break-inside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_break_inside(977);

  /**
   * generated from use.counter.css.page.css_caption_side
   */
  /**
   * Whether a page used the CSS property caption-side. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caption_side(978);

  /**
   * generated from use.counter.css.page.css_caret_color
   */
  /**
   * Whether a page used the CSS property caret-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_caret_color(979);

  /**
   * generated from use.counter.css.page.css_clear
   */
  /**
   * Whether a page used the CSS property clear. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clear(980);

  /**
   * generated from use.counter.css.page.css_clip
   */
  /**
   * Whether a page used the CSS property clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip(981);

  /**
   * generated from use.counter.css.page.css_clip_path
   */
  /**
   * Whether a page used the CSS property clip-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_path(982);

  /**
   * generated from use.counter.css.page.css_clip_rule
   */
  /**
   * Whether a page used the CSS property clip-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_clip_rule(983);

  /**
   * generated from use.counter.css.page.css_color
   */
  /**
   * Whether a page used the CSS property color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color(984);

  /**
   * generated from use.counter.css.page.css_color_adjust
   */
  /**
   * Whether a page used the CSS property color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_adjust(985);

  /**
   * generated from use.counter.css.page.css_color_interpolation
   */
  /**
   * Whether a page used the CSS property color-interpolation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_interpolation(986);

  /**
   * generated from use.counter.css.page.css_color_interpolation_filters
   */
  /**
   * Whether a page used the CSS property color-interpolation-filters. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_color_interpolation_filters(987);

  /**
   * generated from use.counter.css.page.css_color_scheme
   */
  /**
   * Whether a page used the CSS property color-scheme. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_color_scheme(988);

  /**
   * generated from use.counter.css.page.css_column_count
   */
  /**
   * Whether a page used the CSS property column-count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_count(989);

  /**
   * generated from use.counter.css.page.css_column_fill
   */
  /**
   * Whether a page used the CSS property column-fill. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_fill(990);

  /**
   * generated from use.counter.css.page.css_column_gap
   */
  /**
   * Whether a page used the CSS property column-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_gap(991);

  /**
   * generated from use.counter.css.page.css_column_rule
   */
  /**
   * Whether a page used the CSS property column-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule(992);

  /**
   * generated from use.counter.css.page.css_column_rule_color
   */
  /**
   * Whether a page used the CSS property column-rule-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_color(993);

  /**
   * generated from use.counter.css.page.css_column_rule_style
   */
  /**
   * Whether a page used the CSS property column-rule-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_style(994);

  /**
   * generated from use.counter.css.page.css_column_rule_width
   */
  /**
   * Whether a page used the CSS property column-rule-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_rule_width(995);

  /**
   * generated from use.counter.css.page.css_column_span
   */
  /**
   * Whether a page used the CSS property column-span. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_span(996);

  /**
   * generated from use.counter.css.page.css_column_width
   */
  /**
   * Whether a page used the CSS property column-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_column_width(997);

  /**
   * generated from use.counter.css.page.css_columns
   */
  /**
   * Whether a page used the CSS property columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_columns(998);

  /**
   * generated from use.counter.css.page.css_contain
   */
  /**
   * Whether a page used the CSS property contain. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain(999);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_block_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-block-size. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_block_size(1000);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_height
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_height(1001);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_inline_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-inline-size. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_inline_size(1002);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_size
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_size(1003);

  /**
   * generated from use.counter.css.page.css_contain_intrinsic_width
   */
  /**
   * Whether a page used the CSS property contain-intrinsic-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_contain_intrinsic_width(1004);

  /**
   * generated from use.counter.css.page.css_container
   */
  /**
   * Whether a page used the CSS property container. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container(1005);

  /**
   * generated from use.counter.css.page.css_container_name
   */
  /**
   * Whether a page used the CSS property container-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_name(1006);

  /**
   * generated from use.counter.css.page.css_container_type
   */
  /**
   * Whether a page used the CSS property container-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_container_type(1007);

  /**
   * generated from use.counter.css.page.css_content
   */
  /**
   * Whether a page used the CSS property content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content(1008);

  /**
   * generated from use.counter.css.page.css_content_visibility
   */
  /**
   * Whether a page used the CSS property content-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_content_visibility(1009);

  /**
   * generated from use.counter.css.page.css_counter_increment
   */
  /**
   * Whether a page used the CSS property counter-increment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_increment(1010);

  /**
   * generated from use.counter.css.page.css_counter_reset
   */
  /**
   * Whether a page used the CSS property counter-reset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_reset(1011);

  /**
   * generated from use.counter.css.page.css_counter_set
   */
  /**
   * Whether a page used the CSS property counter-set. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_counter_set(1012);

  /**
   * generated from use.counter.css.page.css_cursor
   */
  /**
   * Whether a page used the CSS property cursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cursor(1013);

  /**
   * generated from use.counter.css.page.css_cx
   */
  /**
   * Whether a page used the CSS property cx. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cx(1014);

  /**
   * generated from use.counter.css.page.css_cy
   */
  /**
   * Whether a page used the CSS property cy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_cy(1015);

  /**
   * generated from use.counter.css.page.css_d
   */
  /**
   * Whether a page used the CSS property d. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_d(1016);

  /**
   * generated from use.counter.css.page.css_direction
   */
  /**
   * Whether a page used the CSS property direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_direction(1017);

  /**
   * generated from use.counter.css.page.css_display
   */
  /**
   * Whether a page used the CSS property display. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_display(1018);

  /**
   * generated from use.counter.css.page.css_dominant_baseline
   */
  /**
   * Whether a page used the CSS property dominant-baseline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_dominant_baseline(1019);

  /**
   * generated from use.counter.css.page.css_empty_cells
   */
  /**
   * Whether a page used the CSS property empty-cells. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_empty_cells(1020);

  /**
   * generated from use.counter.css.page.css_fill
   */
  /**
   * Whether a page used the CSS property fill. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill(1021);

  /**
   * generated from use.counter.css.page.css_fill_opacity
   */
  /**
   * Whether a page used the CSS property fill-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_opacity(1022);

  /**
   * generated from use.counter.css.page.css_fill_rule
   */
  /**
   * Whether a page used the CSS property fill-rule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_fill_rule(1023);

  /**
   * generated from use.counter.css.page.css_filter
   */
  /**
   * Whether a page used the CSS property filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_filter(1024);

  /**
   * generated from use.counter.css.page.css_flex
   */
  /**
   * Whether a page used the CSS property flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex(1025);

  /**
   * generated from use.counter.css.page.css_flex_basis
   */
  /**
   * Whether a page used the CSS property flex-basis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_basis(1026);

  /**
   * generated from use.counter.css.page.css_flex_direction
   */
  /**
   * Whether a page used the CSS property flex-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_direction(1027);

  /**
   * generated from use.counter.css.page.css_flex_flow
   */
  /**
   * Whether a page used the CSS property flex-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_flow(1028);

  /**
   * generated from use.counter.css.page.css_flex_grow
   */
  /**
   * Whether a page used the CSS property flex-grow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_grow(1029);

  /**
   * generated from use.counter.css.page.css_flex_shrink
   */
  /**
   * Whether a page used the CSS property flex-shrink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_shrink(1030);

  /**
   * generated from use.counter.css.page.css_flex_wrap
   */
  /**
   * Whether a page used the CSS property flex-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flex_wrap(1031);

  /**
   * generated from use.counter.css.page.css_float
   */
  /**
   * Whether a page used the CSS property float. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_float(1032);

  /**
   * generated from use.counter.css.page.css_flood_color
   */
  /**
   * Whether a page used the CSS property flood-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_color(1033);

  /**
   * generated from use.counter.css.page.css_flood_opacity
   */
  /**
   * Whether a page used the CSS property flood-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_flood_opacity(1034);

  /**
   * generated from use.counter.css.page.css_font
   */
  /**
   * Whether a page used the CSS property font. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font(1035);

  /**
   * generated from use.counter.css.page.css_font_family
   */
  /**
   * Whether a page used the CSS property font-family. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_family(1036);

  /**
   * generated from use.counter.css.page.css_font_feature_settings
   */
  /**
   * Whether a page used the CSS property font-feature-settings. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_feature_settings(1037);

  /**
   * generated from use.counter.css.page.css_font_kerning
   */
  /**
   * Whether a page used the CSS property font-kerning. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_kerning(1038);

  /**
   * generated from use.counter.css.page.css_font_language_override
   */
  /**
   * Whether a page used the CSS property font-language-override. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_language_override(1039);

  /**
   * generated from use.counter.css.page.css_font_optical_sizing
   */
  /**
   * Whether a page used the CSS property font-optical-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_optical_sizing(1040);

  /**
   * generated from use.counter.css.page.css_font_palette
   */
  /**
   * Whether a page used the CSS property font-palette. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_palette(1041);

  /**
   * generated from use.counter.css.page.css_font_size
   */
  /**
   * Whether a page used the CSS property font-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size(1042);

  /**
   * generated from use.counter.css.page.css_font_size_adjust
   */
  /**
   * Whether a page used the CSS property font-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_size_adjust(1043);

  /**
   * generated from use.counter.css.page.css_font_stretch
   */
  /**
   * Whether a page used the CSS property font-stretch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_stretch(1044);

  /**
   * generated from use.counter.css.page.css_font_style
   */
  /**
   * Whether a page used the CSS property font-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_style(1045);

  /**
   * generated from use.counter.css.page.css_font_synthesis
   */
  /**
   * Whether a page used the CSS property font-synthesis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis(1046);

  /**
   * generated from use.counter.css.page.css_font_synthesis_position
   */
  /**
   * Whether a page used the CSS property font-synthesis-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_position(1047);

  /**
   * generated from use.counter.css.page.css_font_synthesis_small_caps
   */
  /**
   * Whether a page used the CSS property font-synthesis-small-caps. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_small_caps(1048);

  /**
   * generated from use.counter.css.page.css_font_synthesis_style
   */
  /**
   * Whether a page used the CSS property font-synthesis-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_style(1049);

  /**
   * generated from use.counter.css.page.css_font_synthesis_weight
   */
  /**
   * Whether a page used the CSS property font-synthesis-weight. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_synthesis_weight(1050);

  /**
   * generated from use.counter.css.page.css_font_variant
   */
  /**
   * Whether a page used the CSS property font-variant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant(1051);

  /**
   * generated from use.counter.css.page.css_font_variant_alternates
   */
  /**
   * Whether a page used the CSS property font-variant-alternates. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_alternates(1052);

  /**
   * generated from use.counter.css.page.css_font_variant_caps
   */
  /**
   * Whether a page used the CSS property font-variant-caps. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_caps(1053);

  /**
   * generated from use.counter.css.page.css_font_variant_east_asian
   */
  /**
   * Whether a page used the CSS property font-variant-east-asian. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_east_asian(1054);

  /**
   * generated from use.counter.css.page.css_font_variant_emoji
   */
  /**
   * Whether a page used the CSS property font-variant-emoji. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_emoji(1055);

  /**
   * generated from use.counter.css.page.css_font_variant_ligatures
   */
  /**
   * Whether a page used the CSS property font-variant-ligatures. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_ligatures(1056);

  /**
   * generated from use.counter.css.page.css_font_variant_numeric
   */
  /**
   * Whether a page used the CSS property font-variant-numeric. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_numeric(1057);

  /**
   * generated from use.counter.css.page.css_font_variant_position
   */
  /**
   * Whether a page used the CSS property font-variant-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variant_position(1058);

  /**
   * generated from use.counter.css.page.css_font_variation_settings
   */
  /**
   * Whether a page used the CSS property font-variation-settings. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_variation_settings(1059);

  /**
   * generated from use.counter.css.page.css_font_weight
   */
  /**
   * Whether a page used the CSS property font-weight. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_font_weight(1060);

  /**
   * generated from use.counter.css.page.css_forced_color_adjust
   */
  /**
   * Whether a page used the CSS property forced-color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_forced_color_adjust(1061);

  /**
   * generated from use.counter.css.page.css_gap
   */
  /**
   * Whether a page used the CSS property gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_gap(1062);

  /**
   * generated from use.counter.css.page.css_grid
   */
  /**
   * Whether a page used the CSS property grid. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid(1063);

  /**
   * generated from use.counter.css.page.css_grid_area
   */
  /**
   * Whether a page used the CSS property grid-area. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_area(1064);

  /**
   * generated from use.counter.css.page.css_grid_auto_columns
   */
  /**
   * Whether a page used the CSS property grid-auto-columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_columns(1065);

  /**
   * generated from use.counter.css.page.css_grid_auto_flow
   */
  /**
   * Whether a page used the CSS property grid-auto-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_flow(1066);

  /**
   * generated from use.counter.css.page.css_grid_auto_rows
   */
  /**
   * Whether a page used the CSS property grid-auto-rows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_auto_rows(1067);

  /**
   * generated from use.counter.css.page.css_grid_column
   */
  /**
   * Whether a page used the CSS property grid-column. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column(1068);

  /**
   * generated from use.counter.css.page.css_grid_column_end
   */
  /**
   * Whether a page used the CSS property grid-column-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_end(1069);

  /**
   * generated from use.counter.css.page.css_grid_column_gap
   */
  /**
   * Whether a page used the CSS property grid-column-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_gap(1070);

  /**
   * generated from use.counter.css.page.css_grid_column_start
   */
  /**
   * Whether a page used the CSS property grid-column-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_column_start(1071);

  /**
   * generated from use.counter.css.page.css_grid_gap
   */
  /**
   * Whether a page used the CSS property grid-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_gap(1072);

  /**
   * generated from use.counter.css.page.css_grid_row
   */
  /**
   * Whether a page used the CSS property grid-row. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row(1073);

  /**
   * generated from use.counter.css.page.css_grid_row_end
   */
  /**
   * Whether a page used the CSS property grid-row-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_end(1074);

  /**
   * generated from use.counter.css.page.css_grid_row_gap
   */
  /**
   * Whether a page used the CSS property grid-row-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_gap(1075);

  /**
   * generated from use.counter.css.page.css_grid_row_start
   */
  /**
   * Whether a page used the CSS property grid-row-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_row_start(1076);

  /**
   * generated from use.counter.css.page.css_grid_template
   */
  /**
   * Whether a page used the CSS property grid-template. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template(1077);

  /**
   * generated from use.counter.css.page.css_grid_template_areas
   */
  /**
   * Whether a page used the CSS property grid-template-areas. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_areas(1078);

  /**
   * generated from use.counter.css.page.css_grid_template_columns
   */
  /**
   * Whether a page used the CSS property grid-template-columns. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_columns(1079);

  /**
   * generated from use.counter.css.page.css_grid_template_rows
   */
  /**
   * Whether a page used the CSS property grid-template-rows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_grid_template_rows(1080);

  /**
   * generated from use.counter.css.page.css_height
   */
  /**
   * Whether a page used the CSS property height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_height(1081);

  /**
   * generated from use.counter.css.page.css_hyphenate_character
   */
  /**
   * Whether a page used the CSS property hyphenate-character. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphenate_character(1082);

  /**
   * generated from use.counter.css.page.css_hyphens
   */
  /**
   * Whether a page used the CSS property hyphens. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_hyphens(1083);

  /**
   * generated from use.counter.css.page.css_image_orientation
   */
  /**
   * Whether a page used the CSS property image-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_orientation(1084);

  /**
   * generated from use.counter.css.page.css_image_rendering
   */
  /**
   * Whether a page used the CSS property image-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_image_rendering(1085);

  /**
   * generated from use.counter.css.page.css_ime_mode
   */
  /**
   * Whether a page used the CSS property ime-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ime_mode(1086);

  /**
   * generated from use.counter.css.page.css_initial_letter
   */
  /**
   * Whether a page used the CSS property initial-letter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_initial_letter(1087);

  /**
   * generated from use.counter.css.page.css_inline_size
   */
  /**
   * Whether a page used the CSS property inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inline_size(1088);

  /**
   * generated from use.counter.css.page.css_inset
   */
  /**
   * Whether a page used the CSS property inset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset(1089);

  /**
   * generated from use.counter.css.page.css_inset_block
   */
  /**
   * Whether a page used the CSS property inset-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block(1090);

  /**
   * generated from use.counter.css.page.css_inset_block_end
   */
  /**
   * Whether a page used the CSS property inset-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_end(1091);

  /**
   * generated from use.counter.css.page.css_inset_block_start
   */
  /**
   * Whether a page used the CSS property inset-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_block_start(1092);

  /**
   * generated from use.counter.css.page.css_inset_inline
   */
  /**
   * Whether a page used the CSS property inset-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline(1093);

  /**
   * generated from use.counter.css.page.css_inset_inline_end
   */
  /**
   * Whether a page used the CSS property inset-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_end(1094);

  /**
   * generated from use.counter.css.page.css_inset_inline_start
   */
  /**
   * Whether a page used the CSS property inset-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_inset_inline_start(1095);

  /**
   * generated from use.counter.css.page.css_isolation
   */
  /**
   * Whether a page used the CSS property isolation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_isolation(1096);

  /**
   * generated from use.counter.css.page.css_justify_content
   */
  /**
   * Whether a page used the CSS property justify-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_content(1097);

  /**
   * generated from use.counter.css.page.css_justify_items
   */
  /**
   * Whether a page used the CSS property justify-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_items(1098);

  /**
   * generated from use.counter.css.page.css_justify_self
   */
  /**
   * Whether a page used the CSS property justify-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_self(1099);

  /**
   * generated from use.counter.css.page.css_justify_tracks
   */
  /**
   * Whether a page used the CSS property justify-tracks. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_justify_tracks(1100);

  /**
   * generated from use.counter.css.page.css_left
   */
  /**
   * Whether a page used the CSS property left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_left(1101);

  /**
   * generated from use.counter.css.page.css_letter_spacing
   */
  /**
   * Whether a page used the CSS property letter-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_letter_spacing(1102);

  /**
   * generated from use.counter.css.page.css_lighting_color
   */
  /**
   * Whether a page used the CSS property lighting-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_lighting_color(1103);

  /**
   * generated from use.counter.css.page.css_line_break
   */
  /**
   * Whether a page used the CSS property line-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_break(1104);

  /**
   * generated from use.counter.css.page.css_line_height
   */
  /**
   * Whether a page used the CSS property line-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_line_height(1105);

  /**
   * generated from use.counter.css.page.css_list_style
   */
  /**
   * Whether a page used the CSS property list-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style(1106);

  /**
   * generated from use.counter.css.page.css_list_style_image
   */
  /**
   * Whether a page used the CSS property list-style-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_image(1107);

  /**
   * generated from use.counter.css.page.css_list_style_position
   */
  /**
   * Whether a page used the CSS property list-style-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_position(1108);

  /**
   * generated from use.counter.css.page.css_list_style_type
   */
  /**
   * Whether a page used the CSS property list-style-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_list_style_type(1109);

  /**
   * generated from use.counter.css.page.css_margin
   */
  /**
   * Whether a page used the CSS property margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin(1110);

  /**
   * generated from use.counter.css.page.css_margin_block
   */
  /**
   * Whether a page used the CSS property margin-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block(1111);

  /**
   * generated from use.counter.css.page.css_margin_block_end
   */
  /**
   * Whether a page used the CSS property margin-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_end(1112);

  /**
   * generated from use.counter.css.page.css_margin_block_start
   */
  /**
   * Whether a page used the CSS property margin-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_block_start(1113);

  /**
   * generated from use.counter.css.page.css_margin_bottom
   */
  /**
   * Whether a page used the CSS property margin-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_bottom(1114);

  /**
   * generated from use.counter.css.page.css_margin_inline
   */
  /**
   * Whether a page used the CSS property margin-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline(1115);

  /**
   * generated from use.counter.css.page.css_margin_inline_end
   */
  /**
   * Whether a page used the CSS property margin-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_end(1116);

  /**
   * generated from use.counter.css.page.css_margin_inline_start
   */
  /**
   * Whether a page used the CSS property margin-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_inline_start(1117);

  /**
   * generated from use.counter.css.page.css_margin_left
   */
  /**
   * Whether a page used the CSS property margin-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_left(1118);

  /**
   * generated from use.counter.css.page.css_margin_right
   */
  /**
   * Whether a page used the CSS property margin-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_right(1119);

  /**
   * generated from use.counter.css.page.css_margin_top
   */
  /**
   * Whether a page used the CSS property margin-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_margin_top(1120);

  /**
   * generated from use.counter.css.page.css_marker
   */
  /**
   * Whether a page used the CSS property marker. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker(1121);

  /**
   * generated from use.counter.css.page.css_marker_end
   */
  /**
   * Whether a page used the CSS property marker-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_end(1122);

  /**
   * generated from use.counter.css.page.css_marker_mid
   */
  /**
   * Whether a page used the CSS property marker-mid. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_mid(1123);

  /**
   * generated from use.counter.css.page.css_marker_start
   */
  /**
   * Whether a page used the CSS property marker-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_marker_start(1124);

  /**
   * generated from use.counter.css.page.css_mask
   */
  /**
   * Whether a page used the CSS property mask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask(1125);

  /**
   * generated from use.counter.css.page.css_mask_clip
   */
  /**
   * Whether a page used the CSS property mask-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_clip(1126);

  /**
   * generated from use.counter.css.page.css_mask_composite
   */
  /**
   * Whether a page used the CSS property mask-composite. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_composite(1127);

  /**
   * generated from use.counter.css.page.css_mask_image
   */
  /**
   * Whether a page used the CSS property mask-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_image(1128);

  /**
   * generated from use.counter.css.page.css_mask_mode
   */
  /**
   * Whether a page used the CSS property mask-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_mode(1129);

  /**
   * generated from use.counter.css.page.css_mask_origin
   */
  /**
   * Whether a page used the CSS property mask-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_origin(1130);

  /**
   * generated from use.counter.css.page.css_mask_position
   */
  /**
   * Whether a page used the CSS property mask-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position(1131);

  /**
   * generated from use.counter.css.page.css_mask_position_x
   */
  /**
   * Whether a page used the CSS property mask-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_x(1132);

  /**
   * generated from use.counter.css.page.css_mask_position_y
   */
  /**
   * Whether a page used the CSS property mask-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_position_y(1133);

  /**
   * generated from use.counter.css.page.css_mask_repeat
   */
  /**
   * Whether a page used the CSS property mask-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_repeat(1134);

  /**
   * generated from use.counter.css.page.css_mask_size
   */
  /**
   * Whether a page used the CSS property mask-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_size(1135);

  /**
   * generated from use.counter.css.page.css_mask_type
   */
  /**
   * Whether a page used the CSS property mask-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mask_type(1136);

  /**
   * generated from use.counter.css.page.css_masonry_auto_flow
   */
  /**
   * Whether a page used the CSS property masonry-auto-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_masonry_auto_flow(1137);

  /**
   * generated from use.counter.css.page.css_math_depth
   */
  /**
   * Whether a page used the CSS property math-depth. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_depth(1138);

  /**
   * generated from use.counter.css.page.css_math_style
   */
  /**
   * Whether a page used the CSS property math-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_math_style(1139);

  /**
   * generated from use.counter.css.page.css_max_block_size
   */
  /**
   * Whether a page used the CSS property max-block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_block_size(1140);

  /**
   * generated from use.counter.css.page.css_max_height
   */
  /**
   * Whether a page used the CSS property max-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_height(1141);

  /**
   * generated from use.counter.css.page.css_max_inline_size
   */
  /**
   * Whether a page used the CSS property max-inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_inline_size(1142);

  /**
   * generated from use.counter.css.page.css_max_width
   */
  /**
   * Whether a page used the CSS property max-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_max_width(1143);

  /**
   * generated from use.counter.css.page.css_min_block_size
   */
  /**
   * Whether a page used the CSS property min-block-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_block_size(1144);

  /**
   * generated from use.counter.css.page.css_min_height
   */
  /**
   * Whether a page used the CSS property min-height. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_height(1145);

  /**
   * generated from use.counter.css.page.css_min_inline_size
   */
  /**
   * Whether a page used the CSS property min-inline-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_inline_size(1146);

  /**
   * generated from use.counter.css.page.css_min_width
   */
  /**
   * Whether a page used the CSS property min-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_min_width(1147);

  /**
   * generated from use.counter.css.page.css_mix_blend_mode
   */
  /**
   * Whether a page used the CSS property mix-blend-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_mix_blend_mode(1148);

  /**
   * generated from use.counter.css.page.css_moz_animation
   */
  /**
   * Whether a page used the CSS property -moz-animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation(1149);

  /**
   * generated from use.counter.css.page.css_moz_animation_delay
   */
  /**
   * Whether a page used the CSS property -moz-animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_delay(1150);

  /**
   * generated from use.counter.css.page.css_moz_animation_direction
   */
  /**
   * Whether a page used the CSS property -moz-animation-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_direction(1151);

  /**
   * generated from use.counter.css.page.css_moz_animation_duration
   */
  /**
   * Whether a page used the CSS property -moz-animation-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_duration(1152);

  /**
   * generated from use.counter.css.page.css_moz_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property -moz-animation-fill-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_fill_mode(1153);

  /**
   * generated from use.counter.css.page.css_moz_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property -moz-animation-iteration-count. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_iteration_count(1154);

  /**
   * generated from use.counter.css.page.css_moz_animation_name
   */
  /**
   * Whether a page used the CSS property -moz-animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_name(1155);

  /**
   * generated from use.counter.css.page.css_moz_animation_play_state
   */
  /**
   * Whether a page used the CSS property -moz-animation-play-state. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_animation_play_state(1156);

  /**
   * generated from use.counter.css.page.css_moz_animation_timing_function
   */
  /**
   * Whether a page used the CSS property -moz-animation-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_animation_timing_function(1157);

  /**
   * generated from use.counter.css.page.css_moz_appearance
   */
  /**
   * Whether a page used the CSS property -moz-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_appearance(1158);

  /**
   * generated from use.counter.css.page.css_moz_backface_visibility
   */
  /**
   * Whether a page used the CSS property -moz-backface-visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_backface_visibility(1159);

  /**
   * generated from use.counter.css.page.css_moz_border_end
   */
  /**
   * Whether a page used the CSS property -moz-border-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end(1160);

  /**
   * generated from use.counter.css.page.css_moz_border_end_color
   */
  /**
   * Whether a page used the CSS property -moz-border-end-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_color(1161);

  /**
   * generated from use.counter.css.page.css_moz_border_end_style
   */
  /**
   * Whether a page used the CSS property -moz-border-end-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_style(1162);

  /**
   * generated from use.counter.css.page.css_moz_border_end_width
   */
  /**
   * Whether a page used the CSS property -moz-border-end-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_end_width(1163);

  /**
   * generated from use.counter.css.page.css_moz_border_image
   */
  /**
   * Whether a page used the CSS property -moz-border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_image(1164);

  /**
   * generated from use.counter.css.page.css_moz_border_start
   */
  /**
   * Whether a page used the CSS property -moz-border-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start(1165);

  /**
   * generated from use.counter.css.page.css_moz_border_start_color
   */
  /**
   * Whether a page used the CSS property -moz-border-start-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_color(1166);

  /**
   * generated from use.counter.css.page.css_moz_border_start_style
   */
  /**
   * Whether a page used the CSS property -moz-border-start-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_style(1167);

  /**
   * generated from use.counter.css.page.css_moz_border_start_width
   */
  /**
   * Whether a page used the CSS property -moz-border-start-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_border_start_width(1168);

  /**
   * generated from use.counter.css.page.css_moz_box_align
   */
  /**
   * Whether a page used the CSS property -moz-box-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_align(1169);

  /**
   * generated from use.counter.css.page.css_moz_box_collapse
   */
  /**
   * Whether a page used the CSS property -moz-box-collapse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_collapse(1170);

  /**
   * generated from use.counter.css.page.css_moz_box_direction
   */
  /**
   * Whether a page used the CSS property -moz-box-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_direction(1171);

  /**
   * generated from use.counter.css.page.css_moz_box_flex
   */
  /**
   * Whether a page used the CSS property -moz-box-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_flex(1172);

  /**
   * generated from use.counter.css.page.css_moz_box_ordinal_group
   */
  /**
   * Whether a page used the CSS property -moz-box-ordinal-group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_ordinal_group(1173);

  /**
   * generated from use.counter.css.page.css_moz_box_orient
   */
  /**
   * Whether a page used the CSS property -moz-box-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_orient(1174);

  /**
   * generated from use.counter.css.page.css_moz_box_pack
   */
  /**
   * Whether a page used the CSS property -moz-box-pack. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_pack(1175);

  /**
   * generated from use.counter.css.page.css_moz_box_sizing
   */
  /**
   * Whether a page used the CSS property -moz-box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_box_sizing(1176);

  /**
   * generated from use.counter.css.page.css_moz_context_properties
   */
  /**
   * Whether a page used the CSS property -moz-context-properties. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_context_properties(1177);

  /**
   * generated from use.counter.css.page.css_moz_control_character_visibility
   */
  /**
   * Whether a page used the CSS property -moz-control-character-visibility. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_control_character_visibility(1178);

  /**
   * generated from use.counter.css.page.css_moz_default_appearance
   */
  /**
   * Whether a page used the CSS property -moz-default-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_default_appearance(1179);

  /**
   * generated from use.counter.css.page.css_moz_float_edge
   */
  /**
   * Whether a page used the CSS property -moz-float-edge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_float_edge(1180);

  /**
   * generated from use.counter.css.page.css_moz_font_feature_settings
   */
  /**
   * Whether a page used the CSS property -moz-font-feature-settings. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_font_feature_settings(1181);

  /**
   * generated from use.counter.css.page.css_moz_font_language_override
   */
  /**
   * Whether a page used the CSS property -moz-font-language-override. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_font_language_override(1182);

  /**
   * generated from use.counter.css.page.css_moz_force_broken_image_icon
   */
  /**
   * Whether a page used the CSS property -moz-force-broken-image-icon. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_force_broken_image_icon(1183);

  /**
   * generated from use.counter.css.page.css_moz_hyphens
   */
  /**
   * Whether a page used the CSS property -moz-hyphens. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_hyphens(1184);

  /**
   * generated from use.counter.css.page.css_moz_inert
   */
  /**
   * Whether a page used the CSS property -moz-inert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_inert(1185);

  /**
   * generated from use.counter.css.page.css_moz_margin_end
   */
  /**
   * Whether a page used the CSS property -moz-margin-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_end(1186);

  /**
   * generated from use.counter.css.page.css_moz_margin_start
   */
  /**
   * Whether a page used the CSS property -moz-margin-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_margin_start(1187);

  /**
   * generated from use.counter.css.page.css_moz_math_variant
   */
  /**
   * Whether a page used the CSS property -moz-math-variant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_math_variant(1188);

  /**
   * generated from use.counter.css.page.css_moz_min_font_size_ratio
   */
  /**
   * Whether a page used the CSS property -moz-min-font-size-ratio. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_min_font_size_ratio(1189);

  /**
   * generated from use.counter.css.page.css_moz_orient
   */
  /**
   * Whether a page used the CSS property -moz-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_orient(1190);

  /**
   * generated from use.counter.css.page.css_moz_osx_font_smoothing
   */
  /**
   * Whether a page used the CSS property -moz-osx-font-smoothing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_osx_font_smoothing(1191);

  /**
   * generated from use.counter.css.page.css_moz_padding_end
   */
  /**
   * Whether a page used the CSS property -moz-padding-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_end(1192);

  /**
   * generated from use.counter.css.page.css_moz_padding_start
   */
  /**
   * Whether a page used the CSS property -moz-padding-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_padding_start(1193);

  /**
   * generated from use.counter.css.page.css_moz_perspective
   */
  /**
   * Whether a page used the CSS property -moz-perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective(1194);

  /**
   * generated from use.counter.css.page.css_moz_perspective_origin
   */
  /**
   * Whether a page used the CSS property -moz-perspective-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_perspective_origin(1195);

  /**
   * generated from use.counter.css.page.css_moz_subtree_hidden_only_visually
   */
  /**
   * Whether a page used the CSS property -moz-subtree-hidden-only-visually. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_subtree_hidden_only_visually(1196);

  /**
   * generated from use.counter.css.page.css_moz_tab_size
   */
  /**
   * Whether a page used the CSS property -moz-tab-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_tab_size(1197);

  /**
   * generated from use.counter.css.page.css_moz_text_size_adjust
   */
  /**
   * Whether a page used the CSS property -moz-text-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_text_size_adjust(1198);

  /**
   * generated from use.counter.css.page.css_moz_theme
   */
  /**
   * Whether a page used the CSS property -moz-theme. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_theme(1199);

  /**
   * generated from use.counter.css.page.css_moz_top_layer
   */
  /**
   * Whether a page used the CSS property -moz-top-layer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_top_layer(1200);

  /**
   * generated from use.counter.css.page.css_moz_transform
   */
  /**
   * Whether a page used the CSS property -moz-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform(1201);

  /**
   * generated from use.counter.css.page.css_moz_transform_origin
   */
  /**
   * Whether a page used the CSS property -moz-transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_origin(1202);

  /**
   * generated from use.counter.css.page.css_moz_transform_style
   */
  /**
   * Whether a page used the CSS property -moz-transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transform_style(1203);

  /**
   * generated from use.counter.css.page.css_moz_transition
   */
  /**
   * Whether a page used the CSS property -moz-transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition(1204);

  /**
   * generated from use.counter.css.page.css_moz_transition_delay
   */
  /**
   * Whether a page used the CSS property -moz-transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_delay(1205);

  /**
   * generated from use.counter.css.page.css_moz_transition_duration
   */
  /**
   * Whether a page used the CSS property -moz-transition-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_duration(1206);

  /**
   * generated from use.counter.css.page.css_moz_transition_property
   */
  /**
   * Whether a page used the CSS property -moz-transition-property. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_transition_property(1207);

  /**
   * generated from use.counter.css.page.css_moz_transition_timing_function
   */
  /**
   * Whether a page used the CSS property -moz-transition-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_transition_timing_function(1208);

  /**
   * generated from use.counter.css.page.css_moz_user_focus
   */
  /**
   * Whether a page used the CSS property -moz-user-focus. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_focus(1209);

  /**
   * generated from use.counter.css.page.css_moz_user_input
   */
  /**
   * Whether a page used the CSS property -moz-user-input. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_input(1210);

  /**
   * generated from use.counter.css.page.css_moz_user_modify
   */
  /**
   * Whether a page used the CSS property -moz-user-modify. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_modify(1211);

  /**
   * generated from use.counter.css.page.css_moz_user_select
   */
  /**
   * Whether a page used the CSS property -moz-user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_user_select(1212);

  /**
   * generated from use.counter.css.page.css_moz_window_dragging
   */
  /**
   * Whether a page used the CSS property -moz-window-dragging. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_dragging(1213);

  /**
   * generated from use.counter.css.page.css_moz_window_input_region_margin
   */
  /**
   * Whether a page used the CSS property -moz-window-input-region-margin. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_window_input_region_margin(1214);

  /**
   * generated from use.counter.css.page.css_moz_window_opacity
   */
  /**
   * Whether a page used the CSS property -moz-window-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_opacity(1215);

  /**
   * generated from use.counter.css.page.css_moz_window_shadow
   */
  /**
   * Whether a page used the CSS property -moz-window-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_shadow(1216);

  /**
   * generated from use.counter.css.page.css_moz_window_transform
   */
  /**
   * Whether a page used the CSS property -moz-window-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform(1217);

  /**
   * generated from use.counter.css.page.css_moz_window_transform_origin
   */
  /**
   * Whether a page used the CSS property -moz-window-transform-origin. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_moz_window_transform_origin(1218);

  /**
   * generated from use.counter.css.page.css_object_fit
   */
  /**
   * Whether a page used the CSS property object-fit. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_fit(1219);

  /**
   * generated from use.counter.css.page.css_object_position
   */
  /**
   * Whether a page used the CSS property object-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_object_position(1220);

  /**
   * generated from use.counter.css.page.css_offset
   */
  /**
   * Whether a page used the CSS property offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset(1221);

  /**
   * generated from use.counter.css.page.css_offset_anchor
   */
  /**
   * Whether a page used the CSS property offset-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_anchor(1222);

  /**
   * generated from use.counter.css.page.css_offset_distance
   */
  /**
   * Whether a page used the CSS property offset-distance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_distance(1223);

  /**
   * generated from use.counter.css.page.css_offset_path
   */
  /**
   * Whether a page used the CSS property offset-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_path(1224);

  /**
   * generated from use.counter.css.page.css_offset_position
   */
  /**
   * Whether a page used the CSS property offset-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_position(1225);

  /**
   * generated from use.counter.css.page.css_offset_rotate
   */
  /**
   * Whether a page used the CSS property offset-rotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_offset_rotate(1226);

  /**
   * generated from use.counter.css.page.css_opacity
   */
  /**
   * Whether a page used the CSS property opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_opacity(1227);

  /**
   * generated from use.counter.css.page.css_order
   */
  /**
   * Whether a page used the CSS property order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_order(1228);

  /**
   * generated from use.counter.css.page.css_outline
   */
  /**
   * Whether a page used the CSS property outline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline(1229);

  /**
   * generated from use.counter.css.page.css_outline_color
   */
  /**
   * Whether a page used the CSS property outline-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_color(1230);

  /**
   * generated from use.counter.css.page.css_outline_offset
   */
  /**
   * Whether a page used the CSS property outline-offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_offset(1231);

  /**
   * generated from use.counter.css.page.css_outline_style
   */
  /**
   * Whether a page used the CSS property outline-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_style(1232);

  /**
   * generated from use.counter.css.page.css_outline_width
   */
  /**
   * Whether a page used the CSS property outline-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_outline_width(1233);

  /**
   * generated from use.counter.css.page.css_overflow
   */
  /**
   * Whether a page used the CSS property overflow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow(1234);

  /**
   * generated from use.counter.css.page.css_overflow_anchor
   */
  /**
   * Whether a page used the CSS property overflow-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_anchor(1235);

  /**
   * generated from use.counter.css.page.css_overflow_block
   */
  /**
   * Whether a page used the CSS property overflow-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_block(1236);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box
   */
  /**
   * Whether a page used the CSS property overflow-clip-box. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box(1237);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box_block
   */
  /**
   * Whether a page used the CSS property overflow-clip-box-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_block(1238);

  /**
   * generated from use.counter.css.page.css_overflow_clip_box_inline
   */
  /**
   * Whether a page used the CSS property overflow-clip-box-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_box_inline(1239);

  /**
   * generated from use.counter.css.page.css_overflow_clip_margin
   */
  /**
   * Whether a page used the CSS property overflow-clip-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_clip_margin(1240);

  /**
   * generated from use.counter.css.page.css_overflow_inline
   */
  /**
   * Whether a page used the CSS property overflow-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_inline(1241);

  /**
   * generated from use.counter.css.page.css_overflow_wrap
   */
  /**
   * Whether a page used the CSS property overflow-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_wrap(1242);

  /**
   * generated from use.counter.css.page.css_overflow_x
   */
  /**
   * Whether a page used the CSS property overflow-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_x(1243);

  /**
   * generated from use.counter.css.page.css_overflow_y
   */
  /**
   * Whether a page used the CSS property overflow-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overflow_y(1244);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior
   */
  /**
   * Whether a page used the CSS property overscroll-behavior. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior(1245);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_block
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_block(1246);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_inline
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-inline. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_inline(1247);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_x
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_x(1248);

  /**
   * generated from use.counter.css.page.css_overscroll_behavior_y
   */
  /**
   * Whether a page used the CSS property overscroll-behavior-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_overscroll_behavior_y(1249);

  /**
   * generated from use.counter.css.page.css_padding
   */
  /**
   * Whether a page used the CSS property padding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding(1250);

  /**
   * generated from use.counter.css.page.css_padding_block
   */
  /**
   * Whether a page used the CSS property padding-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block(1251);

  /**
   * generated from use.counter.css.page.css_padding_block_end
   */
  /**
   * Whether a page used the CSS property padding-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_end(1252);

  /**
   * generated from use.counter.css.page.css_padding_block_start
   */
  /**
   * Whether a page used the CSS property padding-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_block_start(1253);

  /**
   * generated from use.counter.css.page.css_padding_bottom
   */
  /**
   * Whether a page used the CSS property padding-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_bottom(1254);

  /**
   * generated from use.counter.css.page.css_padding_inline
   */
  /**
   * Whether a page used the CSS property padding-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline(1255);

  /**
   * generated from use.counter.css.page.css_padding_inline_end
   */
  /**
   * Whether a page used the CSS property padding-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_end(1256);

  /**
   * generated from use.counter.css.page.css_padding_inline_start
   */
  /**
   * Whether a page used the CSS property padding-inline-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_inline_start(1257);

  /**
   * generated from use.counter.css.page.css_padding_left
   */
  /**
   * Whether a page used the CSS property padding-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_left(1258);

  /**
   * generated from use.counter.css.page.css_padding_right
   */
  /**
   * Whether a page used the CSS property padding-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_right(1259);

  /**
   * generated from use.counter.css.page.css_padding_top
   */
  /**
   * Whether a page used the CSS property padding-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_padding_top(1260);

  /**
   * generated from use.counter.css.page.css_page
   */
  /**
   * Whether a page used the CSS property page. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page(1261);

  /**
   * generated from use.counter.css.page.css_page_break_after
   */
  /**
   * Whether a page used the CSS property page-break-after. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_after(1262);

  /**
   * generated from use.counter.css.page.css_page_break_before
   */
  /**
   * Whether a page used the CSS property page-break-before. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_before(1263);

  /**
   * generated from use.counter.css.page.css_page_break_inside
   */
  /**
   * Whether a page used the CSS property page-break-inside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_break_inside(1264);

  /**
   * generated from use.counter.css.page.css_page_orientation
   */
  /**
   * Whether a page used the CSS property page-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_page_orientation(1265);

  /**
   * generated from use.counter.css.page.css_paint_order
   */
  /**
   * Whether a page used the CSS property paint-order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_paint_order(1266);

  /**
   * generated from use.counter.css.page.css_perspective
   */
  /**
   * Whether a page used the CSS property perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective(1267);

  /**
   * generated from use.counter.css.page.css_perspective_origin
   */
  /**
   * Whether a page used the CSS property perspective-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_perspective_origin(1268);

  /**
   * generated from use.counter.css.page.css_place_content
   */
  /**
   * Whether a page used the CSS property place-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_content(1269);

  /**
   * generated from use.counter.css.page.css_place_items
   */
  /**
   * Whether a page used the CSS property place-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_items(1270);

  /**
   * generated from use.counter.css.page.css_place_self
   */
  /**
   * Whether a page used the CSS property place-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_place_self(1271);

  /**
   * generated from use.counter.css.page.css_pointer_events
   */
  /**
   * Whether a page used the CSS property pointer-events. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_pointer_events(1272);

  /**
   * generated from use.counter.css.page.css_position
   */
  /**
   * Whether a page used the CSS property position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_position(1273);

  /**
   * generated from use.counter.css.page.css_print_color_adjust
   */
  /**
   * Whether a page used the CSS property print-color-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_print_color_adjust(1274);

  /**
   * generated from use.counter.css.page.css_quotes
   */
  /**
   * Whether a page used the CSS property quotes. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_quotes(1275);

  /**
   * generated from use.counter.css.page.css_r
   */
  /**
   * Whether a page used the CSS property r. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_r(1276);

  /**
   * generated from use.counter.css.page.css_resize
   */
  /**
   * Whether a page used the CSS property resize. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_resize(1277);

  /**
   * generated from use.counter.css.page.css_right
   */
  /**
   * Whether a page used the CSS property right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_right(1278);

  /**
   * generated from use.counter.css.page.css_rotate
   */
  /**
   * Whether a page used the CSS property rotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rotate(1279);

  /**
   * generated from use.counter.css.page.css_row_gap
   */
  /**
   * Whether a page used the CSS property row-gap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_row_gap(1280);

  /**
   * generated from use.counter.css.page.css_ruby_align
   */
  /**
   * Whether a page used the CSS property ruby-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_align(1281);

  /**
   * generated from use.counter.css.page.css_ruby_position
   */
  /**
   * Whether a page used the CSS property ruby-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ruby_position(1282);

  /**
   * generated from use.counter.css.page.css_rx
   */
  /**
   * Whether a page used the CSS property rx. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_rx(1283);

  /**
   * generated from use.counter.css.page.css_ry
   */
  /**
   * Whether a page used the CSS property ry. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_ry(1284);

  /**
   * generated from use.counter.css.page.css_scale
   */
  /**
   * Whether a page used the CSS property scale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scale(1285);

  /**
   * generated from use.counter.css.page.css_scroll_behavior
   */
  /**
   * Whether a page used the CSS property scroll-behavior. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_behavior(1286);

  /**
   * generated from use.counter.css.page.css_scroll_margin
   */
  /**
   * Whether a page used the CSS property scroll-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin(1287);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block
   */
  /**
   * Whether a page used the CSS property scroll-margin-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block(1288);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block_end
   */
  /**
   * Whether a page used the CSS property scroll-margin-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_end(1289);

  /**
   * generated from use.counter.css.page.css_scroll_margin_block_start
   */
  /**
   * Whether a page used the CSS property scroll-margin-block-start. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_block_start(1290);

  /**
   * generated from use.counter.css.page.css_scroll_margin_bottom
   */
  /**
   * Whether a page used the CSS property scroll-margin-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_bottom(1291);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline(1292);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline_end
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_end(1293);

  /**
   * generated from use.counter.css.page.css_scroll_margin_inline_start
   */
  /**
   * Whether a page used the CSS property scroll-margin-inline-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_inline_start(1294);

  /**
   * generated from use.counter.css.page.css_scroll_margin_left
   */
  /**
   * Whether a page used the CSS property scroll-margin-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_left(1295);

  /**
   * generated from use.counter.css.page.css_scroll_margin_right
   */
  /**
   * Whether a page used the CSS property scroll-margin-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_right(1296);

  /**
   * generated from use.counter.css.page.css_scroll_margin_top
   */
  /**
   * Whether a page used the CSS property scroll-margin-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_margin_top(1297);

  /**
   * generated from use.counter.css.page.css_scroll_padding
   */
  /**
   * Whether a page used the CSS property scroll-padding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding(1298);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block
   */
  /**
   * Whether a page used the CSS property scroll-padding-block. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block(1299);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block_end
   */
  /**
   * Whether a page used the CSS property scroll-padding-block-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_end(1300);

  /**
   * generated from use.counter.css.page.css_scroll_padding_block_start
   */
  /**
   * Whether a page used the CSS property scroll-padding-block-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_block_start(1301);

  /**
   * generated from use.counter.css.page.css_scroll_padding_bottom
   */
  /**
   * Whether a page used the CSS property scroll-padding-bottom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_bottom(1302);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline(1303);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline_end
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline-end. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_end(1304);

  /**
   * generated from use.counter.css.page.css_scroll_padding_inline_start
   */
  /**
   * Whether a page used the CSS property scroll-padding-inline-start. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_inline_start(1305);

  /**
   * generated from use.counter.css.page.css_scroll_padding_left
   */
  /**
   * Whether a page used the CSS property scroll-padding-left. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_left(1306);

  /**
   * generated from use.counter.css.page.css_scroll_padding_right
   */
  /**
   * Whether a page used the CSS property scroll-padding-right. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_right(1307);

  /**
   * generated from use.counter.css.page.css_scroll_padding_top
   */
  /**
   * Whether a page used the CSS property scroll-padding-top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_padding_top(1308);

  /**
   * generated from use.counter.css.page.css_scroll_snap_align
   */
  /**
   * Whether a page used the CSS property scroll-snap-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_align(1309);

  /**
   * generated from use.counter.css.page.css_scroll_snap_stop
   */
  /**
   * Whether a page used the CSS property scroll-snap-stop. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_stop(1310);

  /**
   * generated from use.counter.css.page.css_scroll_snap_type
   */
  /**
   * Whether a page used the CSS property scroll-snap-type. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_snap_type(1311);

  /**
   * generated from use.counter.css.page.css_scroll_timeline
   */
  /**
   * Whether a page used the CSS property scroll-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline(1312);

  /**
   * generated from use.counter.css.page.css_scroll_timeline_axis
   */
  /**
   * Whether a page used the CSS property scroll-timeline-axis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_axis(1313);

  /**
   * generated from use.counter.css.page.css_scroll_timeline_name
   */
  /**
   * Whether a page used the CSS property scroll-timeline-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scroll_timeline_name(1314);

  /**
   * generated from use.counter.css.page.css_scrollbar_color
   */
  /**
   * Whether a page used the CSS property scrollbar-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_color(1315);

  /**
   * generated from use.counter.css.page.css_scrollbar_gutter
   */
  /**
   * Whether a page used the CSS property scrollbar-gutter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_gutter(1316);

  /**
   * generated from use.counter.css.page.css_scrollbar_width
   */
  /**
   * Whether a page used the CSS property scrollbar-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_scrollbar_width(1317);

  /**
   * generated from use.counter.css.page.css_shape_image_threshold
   */
  /**
   * Whether a page used the CSS property shape-image-threshold. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_image_threshold(1318);

  /**
   * generated from use.counter.css.page.css_shape_margin
   */
  /**
   * Whether a page used the CSS property shape-margin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_margin(1319);

  /**
   * generated from use.counter.css.page.css_shape_outside
   */
  /**
   * Whether a page used the CSS property shape-outside. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_outside(1320);

  /**
   * generated from use.counter.css.page.css_shape_rendering
   */
  /**
   * Whether a page used the CSS property shape-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_shape_rendering(1321);

  /**
   * generated from use.counter.css.page.css_size
   */
  /**
   * Whether a page used the CSS property size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_size(1322);

  /**
   * generated from use.counter.css.page.css_stop_color
   */
  /**
   * Whether a page used the CSS property stop-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_color(1323);

  /**
   * generated from use.counter.css.page.css_stop_opacity
   */
  /**
   * Whether a page used the CSS property stop-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stop_opacity(1324);

  /**
   * generated from use.counter.css.page.css_stroke
   */
  /**
   * Whether a page used the CSS property stroke. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke(1325);

  /**
   * generated from use.counter.css.page.css_stroke_dasharray
   */
  /**
   * Whether a page used the CSS property stroke-dasharray. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dasharray(1326);

  /**
   * generated from use.counter.css.page.css_stroke_dashoffset
   */
  /**
   * Whether a page used the CSS property stroke-dashoffset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_dashoffset(1327);

  /**
   * generated from use.counter.css.page.css_stroke_linecap
   */
  /**
   * Whether a page used the CSS property stroke-linecap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linecap(1328);

  /**
   * generated from use.counter.css.page.css_stroke_linejoin
   */
  /**
   * Whether a page used the CSS property stroke-linejoin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_linejoin(1329);

  /**
   * generated from use.counter.css.page.css_stroke_miterlimit
   */
  /**
   * Whether a page used the CSS property stroke-miterlimit. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_miterlimit(1330);

  /**
   * generated from use.counter.css.page.css_stroke_opacity
   */
  /**
   * Whether a page used the CSS property stroke-opacity. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_opacity(1331);

  /**
   * generated from use.counter.css.page.css_stroke_width
   */
  /**
   * Whether a page used the CSS property stroke-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_stroke_width(1332);

  /**
   * generated from use.counter.css.page.css_tab_size
   */
  /**
   * Whether a page used the CSS property tab-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_tab_size(1333);

  /**
   * generated from use.counter.css.page.css_table_layout
   */
  /**
   * Whether a page used the CSS property table-layout. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_table_layout(1334);

  /**
   * generated from use.counter.css.page.css_text_align
   */
  /**
   * Whether a page used the CSS property text-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align(1335);

  /**
   * generated from use.counter.css.page.css_text_align_last
   */
  /**
   * Whether a page used the CSS property text-align-last. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_align_last(1336);

  /**
   * generated from use.counter.css.page.css_text_anchor
   */
  /**
   * Whether a page used the CSS property text-anchor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_anchor(1337);

  /**
   * generated from use.counter.css.page.css_text_combine_upright
   */
  /**
   * Whether a page used the CSS property text-combine-upright. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_combine_upright(1338);

  /**
   * generated from use.counter.css.page.css_text_decoration
   */
  /**
   * Whether a page used the CSS property text-decoration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration(1339);

  /**
   * generated from use.counter.css.page.css_text_decoration_color
   */
  /**
   * Whether a page used the CSS property text-decoration-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_color(1340);

  /**
   * generated from use.counter.css.page.css_text_decoration_line
   */
  /**
   * Whether a page used the CSS property text-decoration-line. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_line(1341);

  /**
   * generated from use.counter.css.page.css_text_decoration_skip_ink
   */
  /**
   * Whether a page used the CSS property text-decoration-skip-ink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_skip_ink(1342);

  /**
   * generated from use.counter.css.page.css_text_decoration_style
   */
  /**
   * Whether a page used the CSS property text-decoration-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_style(1343);

  /**
   * generated from use.counter.css.page.css_text_decoration_thickness
   */
  /**
   * Whether a page used the CSS property text-decoration-thickness. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_decoration_thickness(1344);

  /**
   * generated from use.counter.css.page.css_text_emphasis
   */
  /**
   * Whether a page used the CSS property text-emphasis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis(1345);

  /**
   * generated from use.counter.css.page.css_text_emphasis_color
   */
  /**
   * Whether a page used the CSS property text-emphasis-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_color(1346);

  /**
   * generated from use.counter.css.page.css_text_emphasis_position
   */
  /**
   * Whether a page used the CSS property text-emphasis-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_position(1347);

  /**
   * generated from use.counter.css.page.css_text_emphasis_style
   */
  /**
   * Whether a page used the CSS property text-emphasis-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_emphasis_style(1348);

  /**
   * generated from use.counter.css.page.css_text_indent
   */
  /**
   * Whether a page used the CSS property text-indent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_indent(1349);

  /**
   * generated from use.counter.css.page.css_text_justify
   */
  /**
   * Whether a page used the CSS property text-justify. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_justify(1350);

  /**
   * generated from use.counter.css.page.css_text_orientation
   */
  /**
   * Whether a page used the CSS property text-orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_orientation(1351);

  /**
   * generated from use.counter.css.page.css_text_overflow
   */
  /**
   * Whether a page used the CSS property text-overflow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_overflow(1352);

  /**
   * generated from use.counter.css.page.css_text_rendering
   */
  /**
   * Whether a page used the CSS property text-rendering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_rendering(1353);

  /**
   * generated from use.counter.css.page.css_text_shadow
   */
  /**
   * Whether a page used the CSS property text-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_shadow(1354);

  /**
   * generated from use.counter.css.page.css_text_transform
   */
  /**
   * Whether a page used the CSS property text-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_transform(1355);

  /**
   * generated from use.counter.css.page.css_text_underline_offset
   */
  /**
   * Whether a page used the CSS property text-underline-offset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_offset(1356);

  /**
   * generated from use.counter.css.page.css_text_underline_position
   */
  /**
   * Whether a page used the CSS property text-underline-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_underline_position(1357);

  /**
   * generated from use.counter.css.page.css_text_wrap
   */
  /**
   * Whether a page used the CSS property text-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_text_wrap(1358);

  /**
   * generated from use.counter.css.page.css_top
   */
  /**
   * Whether a page used the CSS property top. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_top(1359);

  /**
   * generated from use.counter.css.page.css_touch_action
   */
  /**
   * Whether a page used the CSS property touch-action. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_touch_action(1360);

  /**
   * generated from use.counter.css.page.css_transform
   */
  /**
   * Whether a page used the CSS property transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform(1361);

  /**
   * generated from use.counter.css.page.css_transform_box
   */
  /**
   * Whether a page used the CSS property transform-box. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_box(1362);

  /**
   * generated from use.counter.css.page.css_transform_origin
   */
  /**
   * Whether a page used the CSS property transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_origin(1363);

  /**
   * generated from use.counter.css.page.css_transform_style
   */
  /**
   * Whether a page used the CSS property transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transform_style(1364);

  /**
   * generated from use.counter.css.page.css_transition
   */
  /**
   * Whether a page used the CSS property transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition(1365);

  /**
   * generated from use.counter.css.page.css_transition_delay
   */
  /**
   * Whether a page used the CSS property transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_delay(1366);

  /**
   * generated from use.counter.css.page.css_transition_duration
   */
  /**
   * Whether a page used the CSS property transition-duration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_duration(1367);

  /**
   * generated from use.counter.css.page.css_transition_property
   */
  /**
   * Whether a page used the CSS property transition-property. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_transition_property(1368);

  /**
   * generated from use.counter.css.page.css_transition_timing_function
   */
  /**
   * Whether a page used the CSS property transition-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_transition_timing_function(1369);

  /**
   * generated from use.counter.css.page.css_translate
   */
  /**
   * Whether a page used the CSS property translate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_translate(1370);

  /**
   * generated from use.counter.css.page.css_unicode_bidi
   */
  /**
   * Whether a page used the CSS property unicode-bidi. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_unicode_bidi(1371);

  /**
   * generated from use.counter.css.page.css_user_select
   */
  /**
   * Whether a page used the CSS property user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_user_select(1372);

  /**
   * generated from use.counter.css.page.css_vector_effect
   */
  /**
   * Whether a page used the CSS property vector-effect. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vector_effect(1373);

  /**
   * generated from use.counter.css.page.css_vertical_align
   */
  /**
   * Whether a page used the CSS property vertical-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_vertical_align(1374);

  /**
   * generated from use.counter.css.page.css_view_timeline
   */
  /**
   * Whether a page used the CSS property view-timeline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline(1375);

  /**
   * generated from use.counter.css.page.css_view_timeline_axis
   */
  /**
   * Whether a page used the CSS property view-timeline-axis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_axis(1376);

  /**
   * generated from use.counter.css.page.css_view_timeline_inset
   */
  /**
   * Whether a page used the CSS property view-timeline-inset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_inset(1377);

  /**
   * generated from use.counter.css.page.css_view_timeline_name
   */
  /**
   * Whether a page used the CSS property view-timeline-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_view_timeline_name(1378);

  /**
   * generated from use.counter.css.page.css_visibility
   */
  /**
   * Whether a page used the CSS property visibility. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_visibility(1379);

  /**
   * generated from use.counter.css.page.css_webkit_align_content
   */
  /**
   * Whether a page used the CSS property -webkit-align-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_content(1380);

  /**
   * generated from use.counter.css.page.css_webkit_align_items
   */
  /**
   * Whether a page used the CSS property -webkit-align-items. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_items(1381);

  /**
   * generated from use.counter.css.page.css_webkit_align_self
   */
  /**
   * Whether a page used the CSS property -webkit-align-self. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_align_self(1382);

  /**
   * generated from use.counter.css.page.css_webkit_animation
   */
  /**
   * Whether a page used the CSS property -webkit-animation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation(1383);

  /**
   * generated from use.counter.css.page.css_webkit_animation_delay
   */
  /**
   * Whether a page used the CSS property -webkit-animation-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_delay(1384);

  /**
   * generated from use.counter.css.page.css_webkit_animation_direction
   */
  /**
   * Whether a page used the CSS property -webkit-animation-direction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_direction(1385);

  /**
   * generated from use.counter.css.page.css_webkit_animation_duration
   */
  /**
   * Whether a page used the CSS property -webkit-animation-duration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_duration(1386);

  /**
   * generated from use.counter.css.page.css_webkit_animation_fill_mode
   */
  /**
   * Whether a page used the CSS property -webkit-animation-fill-mode. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_fill_mode(1387);

  /**
   * generated from use.counter.css.page.css_webkit_animation_iteration_count
   */
  /**
   * Whether a page used the CSS property -webkit-animation-iteration-count. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_iteration_count(1388);

  /**
   * generated from use.counter.css.page.css_webkit_animation_name
   */
  /**
   * Whether a page used the CSS property -webkit-animation-name. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_name(1389);

  /**
   * generated from use.counter.css.page.css_webkit_animation_play_state
   */
  /**
   * Whether a page used the CSS property -webkit-animation-play-state. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_play_state(1390);

  /**
   * generated from use.counter.css.page.css_webkit_animation_timing_function
   */
  /**
   * Whether a page used the CSS property -webkit-animation-timing-function. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_animation_timing_function(1391);

  /**
   * generated from use.counter.css.page.css_webkit_appearance
   */
  /**
   * Whether a page used the CSS property -webkit-appearance. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_appearance(1392);

  /**
   * generated from use.counter.css.page.css_webkit_backface_visibility
   */
  /**
   * Whether a page used the CSS property -webkit-backface-visibility. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_backface_visibility(1393);

  /**
   * generated from use.counter.css.page.css_webkit_background_clip
   */
  /**
   * Whether a page used the CSS property -webkit-background-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_clip(1394);

  /**
   * generated from use.counter.css.page.css_webkit_background_origin
   */
  /**
   * Whether a page used the CSS property -webkit-background-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_origin(1395);

  /**
   * generated from use.counter.css.page.css_webkit_background_size
   */
  /**
   * Whether a page used the CSS property -webkit-background-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_background_size(1396);

  /**
   * generated from use.counter.css.page.css_webkit_border_bottom_left_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-bottom-left-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_left_radius(1397);

  /**
   * generated from use.counter.css.page.css_webkit_border_bottom_right_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-bottom-right-radius.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_bottom_right_radius(1398);

  /**
   * generated from use.counter.css.page.css_webkit_border_image
   */
  /**
   * Whether a page used the CSS property -webkit-border-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_image(1399);

  /**
   * generated from use.counter.css.page.css_webkit_border_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-radius. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_border_radius(1400);

  /**
   * generated from use.counter.css.page.css_webkit_border_top_left_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-top-left-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_left_radius(1401);

  /**
   * generated from use.counter.css.page.css_webkit_border_top_right_radius
   */
  /**
   * Whether a page used the CSS property -webkit-border-top-right-radius. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_border_top_right_radius(1402);

  /**
   * generated from use.counter.css.page.css_webkit_box_align
   */
  /**
   * Whether a page used the CSS property -webkit-box-align. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_align(1403);

  /**
   * generated from use.counter.css.page.css_webkit_box_direction
   */
  /**
   * Whether a page used the CSS property -webkit-box-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_direction(1404);

  /**
   * generated from use.counter.css.page.css_webkit_box_flex
   */
  /**
   * Whether a page used the CSS property -webkit-box-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_flex(1405);

  /**
   * generated from use.counter.css.page.css_webkit_box_ordinal_group
   */
  /**
   * Whether a page used the CSS property -webkit-box-ordinal-group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_ordinal_group(1406);

  /**
   * generated from use.counter.css.page.css_webkit_box_orient
   */
  /**
   * Whether a page used the CSS property -webkit-box-orient. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_orient(1407);

  /**
   * generated from use.counter.css.page.css_webkit_box_pack
   */
  /**
   * Whether a page used the CSS property -webkit-box-pack. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_pack(1408);

  /**
   * generated from use.counter.css.page.css_webkit_box_shadow
   */
  /**
   * Whether a page used the CSS property -webkit-box-shadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_shadow(1409);

  /**
   * generated from use.counter.css.page.css_webkit_box_sizing
   */
  /**
   * Whether a page used the CSS property -webkit-box-sizing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_box_sizing(1410);

  /**
   * generated from use.counter.css.page.css_webkit_clip_path
   */
  /**
   * Whether a page used the CSS property -webkit-clip-path. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_clip_path(1411);

  /**
   * generated from use.counter.css.page.css_webkit_filter
   */
  /**
   * Whether a page used the CSS property -webkit-filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_filter(1412);

  /**
   * generated from use.counter.css.page.css_webkit_flex
   */
  /**
   * Whether a page used the CSS property -webkit-flex. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex(1413);

  /**
   * generated from use.counter.css.page.css_webkit_flex_basis
   */
  /**
   * Whether a page used the CSS property -webkit-flex-basis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_basis(1414);

  /**
   * generated from use.counter.css.page.css_webkit_flex_direction
   */
  /**
   * Whether a page used the CSS property -webkit-flex-direction. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_direction(1415);

  /**
   * generated from use.counter.css.page.css_webkit_flex_flow
   */
  /**
   * Whether a page used the CSS property -webkit-flex-flow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_flow(1416);

  /**
   * generated from use.counter.css.page.css_webkit_flex_grow
   */
  /**
   * Whether a page used the CSS property -webkit-flex-grow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_grow(1417);

  /**
   * generated from use.counter.css.page.css_webkit_flex_shrink
   */
  /**
   * Whether a page used the CSS property -webkit-flex-shrink. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_shrink(1418);

  /**
   * generated from use.counter.css.page.css_webkit_flex_wrap
   */
  /**
   * Whether a page used the CSS property -webkit-flex-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_flex_wrap(1419);

  /**
   * generated from use.counter.css.page.css_webkit_justify_content
   */
  /**
   * Whether a page used the CSS property -webkit-justify-content. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_justify_content(1420);

  /**
   * generated from use.counter.css.page.css_webkit_line_clamp
   */
  /**
   * Whether a page used the CSS property -webkit-line-clamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_line_clamp(1421);

  /**
   * generated from use.counter.css.page.css_webkit_mask
   */
  /**
   * Whether a page used the CSS property -webkit-mask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask(1422);

  /**
   * generated from use.counter.css.page.css_webkit_mask_clip
   */
  /**
   * Whether a page used the CSS property -webkit-mask-clip. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_clip(1423);

  /**
   * generated from use.counter.css.page.css_webkit_mask_composite
   */
  /**
   * Whether a page used the CSS property -webkit-mask-composite. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_composite(1424);

  /**
   * generated from use.counter.css.page.css_webkit_mask_image
   */
  /**
   * Whether a page used the CSS property -webkit-mask-image. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_image(1425);

  /**
   * generated from use.counter.css.page.css_webkit_mask_origin
   */
  /**
   * Whether a page used the CSS property -webkit-mask-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_origin(1426);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position(1427);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position_x
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position-x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_x(1428);

  /**
   * generated from use.counter.css.page.css_webkit_mask_position_y
   */
  /**
   * Whether a page used the CSS property -webkit-mask-position-y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_position_y(1429);

  /**
   * generated from use.counter.css.page.css_webkit_mask_repeat
   */
  /**
   * Whether a page used the CSS property -webkit-mask-repeat. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_repeat(1430);

  /**
   * generated from use.counter.css.page.css_webkit_mask_size
   */
  /**
   * Whether a page used the CSS property -webkit-mask-size. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_mask_size(1431);

  /**
   * generated from use.counter.css.page.css_webkit_order
   */
  /**
   * Whether a page used the CSS property -webkit-order. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_order(1432);

  /**
   * generated from use.counter.css.page.css_webkit_perspective
   */
  /**
   * Whether a page used the CSS property -webkit-perspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective(1433);

  /**
   * generated from use.counter.css.page.css_webkit_perspective_origin
   */
  /**
   * Whether a page used the CSS property -webkit-perspective-origin. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_perspective_origin(1434);

  /**
   * generated from use.counter.css.page.css_webkit_text_fill_color
   */
  /**
   * Whether a page used the CSS property -webkit-text-fill-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_fill_color(1435);

  /**
   * generated from use.counter.css.page.css_webkit_text_security
   */
  /**
   * Whether a page used the CSS property -webkit-text-security. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_security(1436);

  /**
   * generated from use.counter.css.page.css_webkit_text_size_adjust
   */
  /**
   * Whether a page used the CSS property -webkit-text-size-adjust. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_size_adjust(1437);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke(1438);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke_color
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke-color. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_color(1439);

  /**
   * generated from use.counter.css.page.css_webkit_text_stroke_width
   */
  /**
   * Whether a page used the CSS property -webkit-text-stroke-width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_text_stroke_width(1440);

  /**
   * generated from use.counter.css.page.css_webkit_transform
   */
  /**
   * Whether a page used the CSS property -webkit-transform. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform(1441);

  /**
   * generated from use.counter.css.page.css_webkit_transform_origin
   */
  /**
   * Whether a page used the CSS property -webkit-transform-origin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_origin(1442);

  /**
   * generated from use.counter.css.page.css_webkit_transform_style
   */
  /**
   * Whether a page used the CSS property -webkit-transform-style. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transform_style(1443);

  /**
   * generated from use.counter.css.page.css_webkit_transition
   */
  /**
   * Whether a page used the CSS property -webkit-transition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition(1444);

  /**
   * generated from use.counter.css.page.css_webkit_transition_delay
   */
  /**
   * Whether a page used the CSS property -webkit-transition-delay. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_delay(1445);

  /**
   * generated from use.counter.css.page.css_webkit_transition_duration
   */
  /**
   * Whether a page used the CSS property -webkit-transition-duration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_duration(1446);

  /**
   * generated from use.counter.css.page.css_webkit_transition_property
   */
  /**
   * Whether a page used the CSS property -webkit-transition-property. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_property(1447);

  /**
   * generated from use.counter.css.page.css_webkit_transition_timing_function
   */
  /**
   * Whether a page used the CSS property -webkit-transition-timing-function.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_transition_timing_function(1448);

  /**
   * generated from use.counter.css.page.css_webkit_user_select
   */
  /**
   * Whether a page used the CSS property -webkit-user-select. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_webkit_user_select(1449);

  /**
   * generated from use.counter.css.page.css_white_space
   */
  /**
   * Whether a page used the CSS property white-space. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_white_space(1450);

  /**
   * generated from use.counter.css.page.css_width
   */
  /**
   * Whether a page used the CSS property width. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_width(1451);

  /**
   * generated from use.counter.css.page.css_will_change
   */
  /**
   * Whether a page used the CSS property will-change. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_will_change(1452);

  /**
   * generated from use.counter.css.page.css_word_break
   */
  /**
   * Whether a page used the CSS property word-break. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_break(1453);

  /**
   * generated from use.counter.css.page.css_word_spacing
   */
  /**
   * Whether a page used the CSS property word-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_spacing(1454);

  /**
   * generated from use.counter.css.page.css_word_wrap
   */
  /**
   * Whether a page used the CSS property word-wrap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_word_wrap(1455);

  /**
   * generated from use.counter.css.page.css_writing_mode
   */
  /**
   * Whether a page used the CSS property writing-mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_writing_mode(1456);

  /**
   * generated from use.counter.css.page.css_x
   */
  /**
   * Whether a page used the CSS property x. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x(1457);

  /**
   * generated from use.counter.css.page.css_x_lang
   */
  /**
   * Whether a page used the CSS property -x-lang. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_lang(1458);

  /**
   * generated from use.counter.css.page.css_x_span
   */
  /**
   * Whether a page used the CSS property -x-span. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_span(1459);

  /**
   * generated from use.counter.css.page.css_x_text_scale
   */
  /**
   * Whether a page used the CSS property -x-text-scale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_x_text_scale(1460);

  /**
   * generated from use.counter.css.page.css_y
   */
  /**
   * Whether a page used the CSS property y. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_y(1461);

  /**
   * generated from use.counter.css.page.css_z_index
   */
  /**
   * Whether a page used the CSS property z-index. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_z_index(1462);

  /**
   * generated from use.counter.css.page.css_zoom
   */
  /**
   * Whether a page used the CSS property zoom. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric css_zoom(1463);

  /**
   * generated from use.counter.css.page.max_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property max-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric max_zoom(1464);

  /**
   * generated from use.counter.css.page.min_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property min-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric min_zoom(1465);

  /**
   * generated from use.counter.css.page.orientation
   */
  /**
   * Whether a page used the (unknown, counted) CSS property orientation. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orientation(1466);

  /**
   * generated from use.counter.css.page.orphans
   */
  /**
   * Whether a page used the (unknown, counted) CSS property orphans. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric orphans(1467);

  /**
   * generated from use.counter.css.page.speak
   */
  /**
   * Whether a page used the (unknown, counted) CSS property speak. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric speak(1468);

  /**
   * generated from use.counter.css.page.text_size_adjust
   */
  /**
   * Whether a page used the (unknown, counted) CSS property text-size-adjust.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric text_size_adjust(1469);

  /**
   * generated from use.counter.css.page.user_zoom
   */
  /**
   * Whether a page used the (unknown, counted) CSS property user-zoom. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric user_zoom(1470);

  /**
   * generated from use.counter.css.page.webkit_app_region
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-app-region.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_app_region(1471);

  /**
   * generated from use.counter.css.page.webkit_border_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after(1472);

  /**
   * generated from use.counter.css.page.webkit_border_after_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_color(1473);

  /**
   * generated from use.counter.css.page.webkit_border_after_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_style(1474);

  /**
   * generated from use.counter.css.page.webkit_border_after_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-after-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_after_width(1475);

  /**
   * generated from use.counter.css.page.webkit_border_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before(1476);

  /**
   * generated from use.counter.css.page.webkit_border_before_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_color(1477);

  /**
   * generated from use.counter.css.page.webkit_border_before_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_style(1478);

  /**
   * generated from use.counter.css.page.webkit_border_before_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-before-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_before_width(1479);

  /**
   * generated from use.counter.css.page.webkit_border_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end(1480);

  /**
   * generated from use.counter.css.page.webkit_border_end_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_color(1481);

  /**
   * generated from use.counter.css.page.webkit_border_end_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_style(1482);

  /**
   * generated from use.counter.css.page.webkit_border_end_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-end-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_end_width(1483);

  /**
   * generated from use.counter.css.page.webkit_border_horizontal_spacing
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-
     * horizontal-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_horizontal_spacing(1484);

  /**
   * generated from use.counter.css.page.webkit_border_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start(1485);

  /**
   * generated from use.counter.css.page.webkit_border_start_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_color(1486);

  /**
   * generated from use.counter.css.page.webkit_border_start_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_style(1487);

  /**
   * generated from use.counter.css.page.webkit_border_start_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-start-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_start_width(1488);

  /**
   * generated from use.counter.css.page.webkit_border_vertical_spacing
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-border-
     * vertical-spacing. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_border_vertical_spacing(1489);

  /**
   * generated from use.counter.css.page.webkit_box_decoration_break
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-box-decoration-
     * break. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_decoration_break(1490);

  /**
   * generated from use.counter.css.page.webkit_box_reflect
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-box-reflect.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_box_reflect(1491);

  /**
   * generated from use.counter.css.page.webkit_column_break_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * after. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_after(1492);

  /**
   * generated from use.counter.css.page.webkit_column_break_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * before. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_before(1493);

  /**
   * generated from use.counter.css.page.webkit_column_break_inside
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-break-
     * inside. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_break_inside(1494);

  /**
   * generated from use.counter.css.page.webkit_column_count
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-count.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_count(1495);

  /**
   * generated from use.counter.css.page.webkit_column_gap
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-gap.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_gap(1496);

  /**
   * generated from use.counter.css.page.webkit_column_rule
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule(1497);

  /**
   * generated from use.counter.css.page.webkit_column_rule_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_color(1498);

  /**
   * generated from use.counter.css.page.webkit_column_rule_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_style(1499);

  /**
   * generated from use.counter.css.page.webkit_column_rule_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_rule_width(1500);

  /**
   * generated from use.counter.css.page.webkit_column_span
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-span.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_span(1501);

  /**
   * generated from use.counter.css.page.webkit_column_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-column-width.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_column_width(1502);

  /**
   * generated from use.counter.css.page.webkit_columns
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-columns.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_columns(1503);

  /**
   * generated from use.counter.css.page.webkit_font_feature_settings
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-font-feature-
     * settings. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_feature_settings(1504);

  /**
   * generated from use.counter.css.page.webkit_font_size_delta
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-font-size-
     * delta. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_size_delta(1505);

  /**
   * generated from use.counter.css.page.webkit_font_smoothing
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-font-smoothing.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_font_smoothing(1506);

  /**
   * generated from use.counter.css.page.webkit_highlight
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-highlight.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_highlight(1507);

  /**
   * generated from use.counter.css.page.webkit_hyphenate_character
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-hyphenate-
     * character. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_hyphenate_character(1508);

  /**
   * generated from use.counter.css.page.webkit_line_break
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-line-break.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_line_break(1509);

  /**
   * generated from use.counter.css.page.webkit_locale
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-locale. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric webkit_locale(1510);

  /**
   * generated from use.counter.css.page.webkit_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-logical-height.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_logical_height(1511);

  /**
   * generated from use.counter.css.page.webkit_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-logical-width.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_logical_width(1512);

  /**
   * generated from use.counter.css.page.webkit_margin_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after(1513);

  /**
   * generated from use.counter.css.page.webkit_margin_after_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-after-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_after_collapse(1514);

  /**
   * generated from use.counter.css.page.webkit_margin_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before(1515);

  /**
   * generated from use.counter.css.page.webkit_margin_before_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-before-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_before_collapse(1516);

  /**
   * generated from use.counter.css.page.webkit_margin_bottom_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-bottom-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_bottom_collapse(1517);

  /**
   * generated from use.counter.css.page.webkit_margin_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_collapse(1518);

  /**
   * generated from use.counter.css.page.webkit_margin_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_end(1519);

  /**
   * generated from use.counter.css.page.webkit_margin_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_start(1520);

  /**
   * generated from use.counter.css.page.webkit_margin_top_collapse
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-margin-top-
     * collapse. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_margin_top_collapse(1521);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image(1522);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_outset
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * outset. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_outset(1523);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_repeat
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * repeat. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_repeat(1524);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_slice
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * slice. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_slice(1525);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_source
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * source. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_source(1526);

  /**
   * generated from use.counter.css.page.webkit_mask_box_image_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_box_image_width(1527);

  /**
   * generated from use.counter.css.page.webkit_mask_repeat_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-x.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_x(1528);

  /**
   * generated from use.counter.css.page.webkit_mask_repeat_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-y.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_mask_repeat_y(1529);

  /**
   * generated from use.counter.css.page.webkit_max_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
     * height. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_height(1530);

  /**
   * generated from use.counter.css.page.webkit_max_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_max_logical_width(1531);

  /**
   * generated from use.counter.css.page.webkit_min_logical_height
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
     * height. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_height(1532);

  /**
   * generated from use.counter.css.page.webkit_min_logical_width
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
     * width. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_min_logical_width(1533);

  /**
   * generated from use.counter.css.page.webkit_opacity
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-opacity.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_opacity(1534);

  /**
   * generated from use.counter.css.page.webkit_padding_after
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-after.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_after(1535);

  /**
   * generated from use.counter.css.page.webkit_padding_before
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-before.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_before(1536);

  /**
   * generated from use.counter.css.page.webkit_padding_end
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-end.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_end(1537);

  /**
   * generated from use.counter.css.page.webkit_padding_start
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-padding-start.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_padding_start(1538);

  /**
   * generated from use.counter.css.page.webkit_perspective_origin_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-perspective-
     * origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_x(1539);

  /**
   * generated from use.counter.css.page.webkit_perspective_origin_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-perspective-
     * origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_perspective_origin_y(1540);

  /**
   * generated from use.counter.css.page.webkit_print_color_adjust
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-print-color-
     * adjust. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_print_color_adjust(1541);

  /**
   * generated from use.counter.css.page.webkit_rtl_ordering
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-rtl-ordering.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_rtl_ordering(1542);

  /**
   * generated from use.counter.css.page.webkit_ruby_position
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-ruby-position.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_ruby_position(1543);

  /**
   * generated from use.counter.css.page.webkit_shape_image_threshold
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-image-
     * threshold. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_image_threshold(1544);

  /**
   * generated from use.counter.css.page.webkit_shape_margin
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-margin.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_margin(1545);

  /**
   * generated from use.counter.css.page.webkit_shape_outside
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-shape-outside.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_shape_outside(1546);

  /**
   * generated from use.counter.css.page.webkit_tap_highlight_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-tap-highlight-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_tap_highlight_color(1547);

  /**
   * generated from use.counter.css.page.webkit_text_combine
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-combine.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_combine(1548);

  /**
   * generated from use.counter.css.page.webkit_text_decorations_in_effect
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-
     * decorations-in-effect. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_decorations_in_effect(1549);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis(1550);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_color
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * color. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_color(1551);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_position
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * position. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_position(1552);

  /**
   * generated from use.counter.css.page.webkit_text_emphasis_style
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
     * style. Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_emphasis_style(1553);

  /**
   * generated from use.counter.css.page.webkit_text_orientation
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-text-
     * orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_text_orientation(1554);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_x
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_x(1555);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_y
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_y(1556);

  /**
   * generated from use.counter.css.page.webkit_transform_origin_z
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-transform-
     * origin-z. Compare against `use.counter.top_level_content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric webkit_transform_origin_z(1557);

  /**
   * generated from use.counter.css.page.webkit_user_drag
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-user-drag.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_user_drag(1558);

  /**
   * generated from use.counter.css.page.webkit_user_modify
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-user-modify.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_user_modify(1559);

  /**
   * generated from use.counter.css.page.webkit_writing_mode
   */
  /**
   * Whether a page used the (unknown, counted) CSS property -webkit-writing-mode.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric webkit_writing_mode(1560);

  /**
   * generated from use.counter.css.page.widows
   */
  /**
   * Whether a page used the (unknown, counted) CSS property widows. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric widows(1561);

}
namespace use_counter_deprecated_ops_doc {
  /**
   * generated from use.counter.deprecated_ops.doc.ambient_light_event
   */
  /**
   * Whether a document used AmbientLightEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ambient_light_event(1562);

  /**
   * generated from use.counter.deprecated_ops.doc.app_cache
   */
  /**
   * Whether a document used AppCache. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric app_cache(1563);

  /**
   * generated from use.counter.deprecated_ops.doc.components
   */
  /**
   * Whether a document used Components. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components(1564);

  /**
   * generated from use.counter.deprecated_ops.doc.create_image_bitmap_canvas_rendering_context2_d
   */
  /**
   * Whether a document used CreateImageBitmapCanvasRenderingContext2D. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric create_image_bitmap_canvas_rendering_context2_d(1565);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_attribute
   */
  /**
   * Whether a document used DeprecatedTestingAttribute. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_attribute(1566);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_interface
   */
  /**
   * Whether a document used DeprecatedTestingInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_interface(1567);

  /**
   * generated from use.counter.deprecated_ops.doc.deprecated_testing_method
   */
  /**
   * Whether a document used DeprecatedTestingMethod. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_method(1568);

  /**
   * generated from use.counter.deprecated_ops.doc.document_release_capture
   */
  /**
   * Whether a document used DocumentReleaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_release_capture(1569);

  /**
   * generated from use.counter.deprecated_ops.doc.domquad_bounds_attr
   */
  /**
   * Whether a document used DOMQuadBoundsAttr. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domquad_bounds_attr(1570);

  /**
   * generated from use.counter.deprecated_ops.doc.draw_window_canvas_rendering_context2_d
   */
  /**
   * Whether a document used DrawWindowCanvasRenderingContext2D. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric draw_window_canvas_rendering_context2_d(1571);

  /**
   * generated from use.counter.deprecated_ops.doc.element_release_capture
   */
  /**
   * Whether a document used ElementReleaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_release_capture(1572);

  /**
   * generated from use.counter.deprecated_ops.doc.element_set_capture
   */
  /**
   * Whether a document used ElementSetCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_set_capture(1573);

  /**
   * generated from use.counter.deprecated_ops.doc.external__add_search_provider
   */
  /**
   * Whether a document used External_AddSearchProvider. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric external__add_search_provider(1574);

  /**
   * generated from use.counter.deprecated_ops.doc.form_submission_untrusted_event
   */
  /**
   * Whether a document used FormSubmissionUntrustedEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric form_submission_untrusted_event(1575);

  /**
   * generated from use.counter.deprecated_ops.doc.idbopen_dboptions__storage_type
   */
  /**
   * Whether a document used IDBOpenDBOptions_StorageType. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbopen_dboptions__storage_type(1576);

  /**
   * generated from use.counter.deprecated_ops.doc.image_bitmap_rendering_context__transfer_image_bitmap
   */
  /**
   * Whether a document used ImageBitmapRenderingContext_TransferImageBitmap.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric image_bitmap_rendering_context__transfer_image_bitmap(1577);

  /**
   * generated from use.counter.deprecated_ops.doc.import_xulinto_content
   */
  /**
   * Whether a document used ImportXULIntoContent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric import_xulinto_content(1578);

  /**
   * generated from use.counter.deprecated_ops.doc.init_mouse_event
   */
  /**
   * Whether a document used InitMouseEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_mouse_event(1579);

  /**
   * generated from use.counter.deprecated_ops.doc.init_nsmouse_event
   */
  /**
   * Whether a document used InitNSMouseEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_nsmouse_event(1580);

  /**
   * generated from use.counter.deprecated_ops.doc.install_trigger_deprecated
   */
  /**
   * Whether a document used InstallTriggerDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_deprecated(1581);

  /**
   * generated from use.counter.deprecated_ops.doc.install_trigger_install_deprecated
   */
  /**
   * Whether a document used InstallTriggerInstallDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_install_deprecated(1582);

  /**
   * generated from use.counter.deprecated_ops.doc.is_external_ctap2_security_key_supported
   */
  /**
   * Whether a document used IsExternalCTAP2SecurityKeySupported. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric is_external_ctap2_security_key_supported(1583);

  /**
   * generated from use.counter.deprecated_ops.doc.lenient_setter
   */
  /**
   * Whether a document used LenientSetter. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_setter(1584);

  /**
   * generated from use.counter.deprecated_ops.doc.lenient_this
   */
  /**
   * Whether a document used LenientThis. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_this(1585);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_space_value2
   */
  /**
   * Whether a document used MathML_DeprecatedMathSpaceValue2. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_space_value2(1586);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_variant
   */
  /**
   * Whether a document used MathML_DeprecatedMathVariant. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_variant(1587);

  /**
   * generated from use.counter.deprecated_ops.doc.math_ml__deprecated_stixgeneral_operator_stretching
   */
  /**
   * Whether a document used MathML_DeprecatedStixgeneralOperatorStretching. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_stixgeneral_operator_stretching(1588);

  /**
   * generated from use.counter.deprecated_ops.doc.motion_event
   */
  /**
   * Whether a document used MotionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric motion_event(1589);

  /**
   * generated from use.counter.deprecated_ops.doc.mouse_event__moz_pressure
   */
  /**
   * Whether a document used MouseEvent_MozPressure. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mouse_event__moz_pressure(1590);

  /**
   * generated from use.counter.deprecated_ops.doc.moz_input_source
   */
  /**
   * Whether a document used MozInputSource. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_input_source(1591);

  /**
   * generated from use.counter.deprecated_ops.doc.moz_request_full_screen_deprecated_prefix
   */
  /**
   * Whether a document used MozRequestFullScreenDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_request_full_screen_deprecated_prefix(1592);

  /**
   * generated from use.counter.deprecated_ops.doc.mozfullscreenchange_deprecated_prefix
   */
  /**
   * Whether a document used MozfullscreenchangeDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenchange_deprecated_prefix(1593);

  /**
   * generated from use.counter.deprecated_ops.doc.mozfullscreenerror_deprecated_prefix
   */
  /**
   * Whether a document used MozfullscreenerrorDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenerror_deprecated_prefix(1594);

  /**
   * generated from use.counter.deprecated_ops.doc.mutation_event
   */
  /**
   * Whether a document used MutationEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mutation_event(1595);

  /**
   * generated from use.counter.deprecated_ops.doc.navigator_get_user_media
   */
  /**
   * Whether a document used NavigatorGetUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_get_user_media(1596);

  /**
   * generated from use.counter.deprecated_ops.doc.node_iterator_detach
   */
  /**
   * Whether a document used NodeIteratorDetach. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric node_iterator_detach(1597);

  /**
   * generated from use.counter.deprecated_ops.doc.offscreen_canvas_to_blob
   */
  /**
   * Whether a document used OffscreenCanvasToBlob. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric offscreen_canvas_to_blob(1598);

  /**
   * generated from use.counter.deprecated_ops.doc.orientation_event
   */
  /**
   * Whether a document used OrientationEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orientation_event(1599);

  /**
   * generated from use.counter.deprecated_ops.doc.proximity_event
   */
  /**
   * Whether a document used ProximityEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric proximity_event(1600);

  /**
   * generated from use.counter.deprecated_ops.doc.rtcpeer_connection_get_streams
   */
  /**
   * Whether a document used RTCPeerConnectionGetStreams. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric rtcpeer_connection_get_streams(1601);

  /**
   * generated from use.counter.deprecated_ops.doc.size_to_content
   */
  /**
   * Whether a document used SizeToContent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric size_to_content(1602);

  /**
   * generated from use.counter.deprecated_ops.doc.svgdeselect_all
   */
  /**
   * Whether a document used SVGDeselectAll. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgdeselect_all(1603);

  /**
   * generated from use.counter.deprecated_ops.doc.svgfarthest_viewport_element
   */
  /**
   * Whether a document used SVGFarthestViewportElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgfarthest_viewport_element(1604);

  /**
   * generated from use.counter.deprecated_ops.doc.svgnearest_viewport_element
   */
  /**
   * Whether a document used SVGNearestViewportElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgnearest_viewport_element(1605);

  /**
   * generated from use.counter.deprecated_ops.doc.sync_xmlhttp_request_deprecated
   */
  /**
   * Whether a document used SyncXMLHttpRequestDeprecated. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sync_xmlhttp_request_deprecated(1606);

  /**
   * generated from use.counter.deprecated_ops.doc.use_of_capture_events
   */
  /**
   * Whether a document used UseOfCaptureEvents. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_capture_events(1607);

  /**
   * generated from use.counter.deprecated_ops.doc.use_of_release_events
   */
  /**
   * Whether a document used UseOfReleaseEvents. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_release_events(1608);

  /**
   * generated from use.counter.deprecated_ops.doc.webrtc_deprecated_prefix
   */
  /**
   * Whether a document used WebrtcDeprecatedPrefix. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webrtc_deprecated_prefix(1609);

  /**
   * generated from use.counter.deprecated_ops.doc.window__cc_ontrollers
   */
  /**
   * Whether a document used Window_Cc_ontrollers. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window__cc_ontrollers(1610);

  /**
   * generated from use.counter.deprecated_ops.doc.window_content_untrusted
   */
  /**
   * Whether a document used WindowContentUntrusted. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_content_untrusted(1611);

}
namespace use_counter_deprecated_ops_page {
  /**
   * generated from use.counter.deprecated_ops.page.ambient_light_event
   */
  /**
   * Whether a page used AmbientLightEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ambient_light_event(1612);

  /**
   * generated from use.counter.deprecated_ops.page.app_cache
   */
  /**
   * Whether a page used AppCache. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric app_cache(1613);

  /**
   * generated from use.counter.deprecated_ops.page.components
   */
  /**
   * Whether a page used Components. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric components(1614);

  /**
   * generated from use.counter.deprecated_ops.page.create_image_bitmap_canvas_rendering_context2_d
   */
  /**
   * Whether a page used CreateImageBitmapCanvasRenderingContext2D. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric create_image_bitmap_canvas_rendering_context2_d(1615);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_attribute
   */
  /**
   * Whether a page used DeprecatedTestingAttribute. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_attribute(1616);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_interface
   */
  /**
   * Whether a page used DeprecatedTestingInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_interface(1617);

  /**
   * generated from use.counter.deprecated_ops.page.deprecated_testing_method
   */
  /**
   * Whether a page used DeprecatedTestingMethod. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric deprecated_testing_method(1618);

  /**
   * generated from use.counter.deprecated_ops.page.document_release_capture
   */
  /**
   * Whether a page used DocumentReleaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_release_capture(1619);

  /**
   * generated from use.counter.deprecated_ops.page.domquad_bounds_attr
   */
  /**
   * Whether a page used DOMQuadBoundsAttr. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domquad_bounds_attr(1620);

  /**
   * generated from use.counter.deprecated_ops.page.draw_window_canvas_rendering_context2_d
   */
  /**
   * Whether a page used DrawWindowCanvasRenderingContext2D. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric draw_window_canvas_rendering_context2_d(1621);

  /**
   * generated from use.counter.deprecated_ops.page.element_release_capture
   */
  /**
   * Whether a page used ElementReleaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_release_capture(1622);

  /**
   * generated from use.counter.deprecated_ops.page.element_set_capture
   */
  /**
   * Whether a page used ElementSetCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_set_capture(1623);

  /**
   * generated from use.counter.deprecated_ops.page.external__add_search_provider
   */
  /**
   * Whether a page used External_AddSearchProvider. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric external__add_search_provider(1624);

  /**
   * generated from use.counter.deprecated_ops.page.form_submission_untrusted_event
   */
  /**
   * Whether a page used FormSubmissionUntrustedEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric form_submission_untrusted_event(1625);

  /**
   * generated from use.counter.deprecated_ops.page.idbopen_dboptions__storage_type
   */
  /**
   * Whether a page used IDBOpenDBOptions_StorageType. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric idbopen_dboptions__storage_type(1626);

  /**
   * generated from use.counter.deprecated_ops.page.image_bitmap_rendering_context__transfer_image_bitmap
   */
  /**
   * Whether a page used ImageBitmapRenderingContext_TransferImageBitmap. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric image_bitmap_rendering_context__transfer_image_bitmap(1627);

  /**
   * generated from use.counter.deprecated_ops.page.import_xulinto_content
   */
  /**
   * Whether a page used ImportXULIntoContent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric import_xulinto_content(1628);

  /**
   * generated from use.counter.deprecated_ops.page.init_mouse_event
   */
  /**
   * Whether a page used InitMouseEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_mouse_event(1629);

  /**
   * generated from use.counter.deprecated_ops.page.init_nsmouse_event
   */
  /**
   * Whether a page used InitNSMouseEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric init_nsmouse_event(1630);

  /**
   * generated from use.counter.deprecated_ops.page.install_trigger_deprecated
   */
  /**
   * Whether a page used InstallTriggerDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_deprecated(1631);

  /**
   * generated from use.counter.deprecated_ops.page.install_trigger_install_deprecated
   */
  /**
   * Whether a page used InstallTriggerInstallDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric install_trigger_install_deprecated(1632);

  /**
   * generated from use.counter.deprecated_ops.page.is_external_ctap2_security_key_supported
   */
  /**
   * Whether a page used IsExternalCTAP2SecurityKeySupported. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric is_external_ctap2_security_key_supported(1633);

  /**
   * generated from use.counter.deprecated_ops.page.lenient_setter
   */
  /**
   * Whether a page used LenientSetter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_setter(1634);

  /**
   * generated from use.counter.deprecated_ops.page.lenient_this
   */
  /**
   * Whether a page used LenientThis. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric lenient_this(1635);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_space_value2
   */
  /**
   * Whether a page used MathML_DeprecatedMathSpaceValue2. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_space_value2(1636);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_variant
   */
  /**
   * Whether a page used MathML_DeprecatedMathVariant. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_math_variant(1637);

  /**
   * generated from use.counter.deprecated_ops.page.math_ml__deprecated_stixgeneral_operator_stretching
   */
  /**
   * Whether a page used MathML_DeprecatedStixgeneralOperatorStretching. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric math_ml__deprecated_stixgeneral_operator_stretching(1638);

  /**
   * generated from use.counter.deprecated_ops.page.motion_event
   */
  /**
   * Whether a page used MotionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric motion_event(1639);

  /**
   * generated from use.counter.deprecated_ops.page.mouse_event__moz_pressure
   */
  /**
   * Whether a page used MouseEvent_MozPressure. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mouse_event__moz_pressure(1640);

  /**
   * generated from use.counter.deprecated_ops.page.moz_input_source
   */
  /**
   * Whether a page used MozInputSource. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_input_source(1641);

  /**
   * generated from use.counter.deprecated_ops.page.moz_request_full_screen_deprecated_prefix
   */
  /**
   * Whether a page used MozRequestFullScreenDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric moz_request_full_screen_deprecated_prefix(1642);

  /**
   * generated from use.counter.deprecated_ops.page.mozfullscreenchange_deprecated_prefix
   */
  /**
   * Whether a page used MozfullscreenchangeDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenchange_deprecated_prefix(1643);

  /**
   * generated from use.counter.deprecated_ops.page.mozfullscreenerror_deprecated_prefix
   */
  /**
   * Whether a page used MozfullscreenerrorDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mozfullscreenerror_deprecated_prefix(1644);

  /**
   * generated from use.counter.deprecated_ops.page.mutation_event
   */
  /**
   * Whether a page used MutationEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mutation_event(1645);

  /**
   * generated from use.counter.deprecated_ops.page.navigator_get_user_media
   */
  /**
   * Whether a page used NavigatorGetUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_get_user_media(1646);

  /**
   * generated from use.counter.deprecated_ops.page.node_iterator_detach
   */
  /**
   * Whether a page used NodeIteratorDetach. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric node_iterator_detach(1647);

  /**
   * generated from use.counter.deprecated_ops.page.offscreen_canvas_to_blob
   */
  /**
   * Whether a page used OffscreenCanvasToBlob. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric offscreen_canvas_to_blob(1648);

  /**
   * generated from use.counter.deprecated_ops.page.orientation_event
   */
  /**
   * Whether a page used OrientationEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric orientation_event(1649);

  /**
   * generated from use.counter.deprecated_ops.page.proximity_event
   */
  /**
   * Whether a page used ProximityEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric proximity_event(1650);

  /**
   * generated from use.counter.deprecated_ops.page.rtcpeer_connection_get_streams
   */
  /**
   * Whether a page used RTCPeerConnectionGetStreams. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric rtcpeer_connection_get_streams(1651);

  /**
   * generated from use.counter.deprecated_ops.page.size_to_content
   */
  /**
   * Whether a page used SizeToContent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric size_to_content(1652);

  /**
   * generated from use.counter.deprecated_ops.page.svgdeselect_all
   */
  /**
   * Whether a page used SVGDeselectAll. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgdeselect_all(1653);

  /**
   * generated from use.counter.deprecated_ops.page.svgfarthest_viewport_element
   */
  /**
   * Whether a page used SVGFarthestViewportElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgfarthest_viewport_element(1654);

  /**
   * generated from use.counter.deprecated_ops.page.svgnearest_viewport_element
   */
  /**
   * Whether a page used SVGNearestViewportElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgnearest_viewport_element(1655);

  /**
   * generated from use.counter.deprecated_ops.page.sync_xmlhttp_request_deprecated
   */
  /**
   * Whether a page used SyncXMLHttpRequestDeprecated. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sync_xmlhttp_request_deprecated(1656);

  /**
   * generated from use.counter.deprecated_ops.page.use_of_capture_events
   */
  /**
   * Whether a page used UseOfCaptureEvents. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_capture_events(1657);

  /**
   * generated from use.counter.deprecated_ops.page.use_of_release_events
   */
  /**
   * Whether a page used UseOfReleaseEvents. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric use_of_release_events(1658);

  /**
   * generated from use.counter.deprecated_ops.page.webrtc_deprecated_prefix
   */
  /**
   * Whether a page used WebrtcDeprecatedPrefix. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric webrtc_deprecated_prefix(1659);

  /**
   * generated from use.counter.deprecated_ops.page.window__cc_ontrollers
   */
  /**
   * Whether a page used Window_Cc_ontrollers. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window__cc_ontrollers(1660);

  /**
   * generated from use.counter.deprecated_ops.page.window_content_untrusted
   */
  /**
   * Whether a page used WindowContentUntrusted. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_content_untrusted(1661);

}
namespace use_counter_doc {
  /**
   * generated from use.counter.doc.clipboard_read
   */
  /**
   * Whether a document called called Clipboard.read. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_read(1662);

  /**
   * generated from use.counter.doc.clipboard_readtext
   */
  /**
   * Whether a document called called Clipboard.readText. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_readtext(1663);

  /**
   * generated from use.counter.doc.clipboard_write
   */
  /**
   * Whether a document called called Clipboard.write. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_write(1664);

  /**
   * generated from use.counter.doc.console_assert
   */
  /**
   * Whether a document called called console.assert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(1665);

  /**
   * generated from use.counter.doc.console_clear
   */
  /**
   * Whether a document called called console.clear. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(1666);

  /**
   * generated from use.counter.doc.console_count
   */
  /**
   * Whether a document called called console.count. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(1667);

  /**
   * generated from use.counter.doc.console_countreset
   */
  /**
   * Whether a document called called console.countReset. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(1668);

  /**
   * generated from use.counter.doc.console_debug
   */
  /**
   * Whether a document called called console.debug. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(1669);

  /**
   * generated from use.counter.doc.console_dir
   */
  /**
   * Whether a document called called console.dir. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(1670);

  /**
   * generated from use.counter.doc.console_dirxml
   */
  /**
   * Whether a document called called console.dirxml. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(1671);

  /**
   * generated from use.counter.doc.console_error
   */
  /**
   * Whether a document called called console.error. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(1672);

  /**
   * generated from use.counter.doc.console_exception
   */
  /**
   * Whether a document called called console.exception. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(1673);

  /**
   * generated from use.counter.doc.console_group
   */
  /**
   * Whether a document called called console.group. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(1674);

  /**
   * generated from use.counter.doc.console_groupcollapsed
   */
  /**
   * Whether a document called called console.groupCollapsed. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(1675);

  /**
   * generated from use.counter.doc.console_groupend
   */
  /**
   * Whether a document called called console.groupEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(1676);

  /**
   * generated from use.counter.doc.console_info
   */
  /**
   * Whether a document called called console.info. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(1677);

  /**
   * generated from use.counter.doc.console_log
   */
  /**
   * Whether a document called called console.log. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(1678);

  /**
   * generated from use.counter.doc.console_profile
   */
  /**
   * Whether a document called called console.profile. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(1679);

  /**
   * generated from use.counter.doc.console_profileend
   */
  /**
   * Whether a document called called console.profileEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(1680);

  /**
   * generated from use.counter.doc.console_table
   */
  /**
   * Whether a document called called console.table. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(1681);

  /**
   * generated from use.counter.doc.console_time
   */
  /**
   * Whether a document called called console.time. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(1682);

  /**
   * generated from use.counter.doc.console_timeend
   */
  /**
   * Whether a document called called console.timeEnd. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(1683);

  /**
   * generated from use.counter.doc.console_timelog
   */
  /**
   * Whether a document called called console.timeLog. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(1684);

  /**
   * generated from use.counter.doc.console_timestamp
   */
  /**
   * Whether a document called called console.timeStamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(1685);

  /**
   * generated from use.counter.doc.console_trace
   */
  /**
   * Whether a document called called console.trace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(1686);

  /**
   * generated from use.counter.doc.console_warn
   */
  /**
   * Whether a document called called console.warn. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(1687);

  /**
   * generated from use.counter.doc.customelementregistry_define
   */
  /**
   * Whether a document called called CustomElementRegistry.define. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customelementregistry_define(1688);

  /**
   * generated from use.counter.doc.customized_builtin
   */
  /**
   * Whether a document registers a customized built-in element. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customized_builtin(1689);

  /**
   * generated from use.counter.doc.datatransfer_addelement
   */
  /**
   * Whether a document called called DataTransfer.addElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_addelement(1690);

  /**
   * generated from use.counter.doc.datatransfer_mozcleardataat
   */
  /**
   * Whether a document called called DataTransfer.mozClearDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcleardataat(1691);

  /**
   * generated from use.counter.doc.datatransfer_mozcursor_getter
   */
  /**
   * Whether a document got DataTransfer.mozCursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_getter(1692);

  /**
   * generated from use.counter.doc.datatransfer_mozcursor_setter
   */
  /**
   * Whether a document set DataTransfer.mozCursor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_setter(1693);

  /**
   * generated from use.counter.doc.datatransfer_mozgetdataat
   */
  /**
   * Whether a document called called DataTransfer.mozGetDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozgetdataat(1694);

  /**
   * generated from use.counter.doc.datatransfer_mozitemcount_getter
   */
  /**
   * Whether a document got DataTransfer.mozItemCount. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_getter(1695);

  /**
   * generated from use.counter.doc.datatransfer_mozitemcount_setter
   */
  /**
   * Whether a document set DataTransfer.mozItemCount. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_setter(1696);

  /**
   * generated from use.counter.doc.datatransfer_mozsetdataat
   */
  /**
   * Whether a document called called DataTransfer.mozSetDataAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsetdataat(1697);

  /**
   * generated from use.counter.doc.datatransfer_mozsourcenode_getter
   */
  /**
   * Whether a document got DataTransfer.mozSourceNode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_getter(1698);

  /**
   * generated from use.counter.doc.datatransfer_mozsourcenode_setter
   */
  /**
   * Whether a document set DataTransfer.mozSourceNode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_setter(1699);

  /**
   * generated from use.counter.doc.datatransfer_moztypesat
   */
  /**
   * Whether a document called called DataTransfer.mozTypesAt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_moztypesat(1700);

  /**
   * generated from use.counter.doc.datatransfer_mozusercancelled_getter
   */
  /**
   * Whether a document got DataTransfer.mozUserCancelled. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_getter(1701);

  /**
   * generated from use.counter.doc.datatransfer_mozusercancelled_setter
   */
  /**
   * Whether a document set DataTransfer.mozUserCancelled. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_setter(1702);

  /**
   * generated from use.counter.doc.datatransferitem_webkitgetasentry
   */
  /**
   * Whether a document called called DataTransferItem.webkitGetAsEntry. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransferitem_webkitgetasentry(1703);

  /**
   * generated from use.counter.doc.document_caretrangefrompoint
   */
  /**
   * Whether a document called called Document.caretRangeFromPoint. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_caretrangefrompoint(1704);

  /**
   * generated from use.counter.doc.document_exec_command_content_read_only
   */
  /**
   * Whether a document calls execCommand with contentReadOnly. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exec_command_content_read_only(1705);

  /**
   * generated from use.counter.doc.document_exitpictureinpicture
   */
  /**
   * Whether a document called called Document.exitPictureInPicture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exitpictureinpicture(1706);

  /**
   * generated from use.counter.doc.document_featurepolicy
   */
  /**
   * Whether a document called called Document.featurePolicy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_featurepolicy(1707);

  /**
   * generated from use.counter.doc.document_mozsetimageelement
   */
  /**
   * Whether a document called called Document.mozSetImageElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_mozsetimageelement(1708);

  /**
   * generated from use.counter.doc.document_onbeforecopy
   */
  /**
   * Whether a document called called Document.onbeforecopy. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecopy(1709);

  /**
   * generated from use.counter.doc.document_onbeforecut
   */
  /**
   * Whether a document called called Document.onbeforecut. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecut(1710);

  /**
   * generated from use.counter.doc.document_onbeforepaste
   */
  /**
   * Whether a document called called Document.onbeforepaste. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforepaste(1711);

  /**
   * generated from use.counter.doc.document_oncancel
   */
  /**
   * Whether a document called called Document.oncancel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_oncancel(1712);

  /**
   * generated from use.counter.doc.document_onfreeze
   */
  /**
   * Whether a document called called Document.onfreeze. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onfreeze(1713);

  /**
   * generated from use.counter.doc.document_onmousewheel
   */
  /**
   * Whether a document called called Document.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onmousewheel(1714);

  /**
   * generated from use.counter.doc.document_onresume
   */
  /**
   * Whether a document called called Document.onresume. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onresume(1715);

  /**
   * generated from use.counter.doc.document_onsearch
   */
  /**
   * Whether a document called called Document.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onsearch(1716);

  /**
   * generated from use.counter.doc.document_onwebkitfullscreenchange
   */
  /**
   * Whether a document called called Document.onwebkitfullscreenchange. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenchange(1717);

  /**
   * generated from use.counter.doc.document_onwebkitfullscreenerror
   */
  /**
   * Whether a document called called Document.onwebkitfullscreenerror. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenerror(1718);

  /**
   * generated from use.counter.doc.document_open
   */
  /**
   * Whether a document calls document.open in a way that creates a new Window
     * object. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric document_open(1719);

  /**
   * generated from use.counter.doc.document_pictureinpictureelement
   */
  /**
   * Whether a document called called Document.pictureInPictureElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureelement(1720);

  /**
   * generated from use.counter.doc.document_pictureinpictureenabled
   */
  /**
   * Whether a document called called Document.pictureInPictureEnabled. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureenabled(1721);

  /**
   * generated from use.counter.doc.document_query_command_state_or_value_content_read_only
   */
  /**
   * Whether a document calls queryCommandState or queryCommandValue with
     * contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_content_read_only(1722);

  /**
   * generated from use.counter.doc.document_query_command_state_or_value_insert_br_on_return
   */
  /**
   * Whether a document calls queryCommandState or queryCommandValue with
     * insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_insert_br_on_return(1723);

  /**
   * generated from use.counter.doc.document_query_command_supported_or_enabled_content_read_only
   */
  /**
   * Whether a document calls queryCommandSupported or queryCommandEnabled with
     * contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_content_read_only(1724);

  /**
   * generated from use.counter.doc.document_query_command_supported_or_enabled_insert_br_on_return
   */
  /**
   * Whether a document calls queryCommandSupported or queryCommandEnabled with
     * insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_insert_br_on_return(1725);

  /**
   * generated from use.counter.doc.document_registerelement
   */
  /**
   * Whether a document called called Document.registerElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_registerelement(1726);

  /**
   * generated from use.counter.doc.document_wasdiscarded
   */
  /**
   * Whether a document called called Document.wasDiscarded. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_wasdiscarded(1727);

  /**
   * generated from use.counter.doc.document_webkitcancelfullscreen
   */
  /**
   * Whether a document called called Document.webkitCancelFullScreen. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitcancelfullscreen(1728);

  /**
   * generated from use.counter.doc.document_webkitcurrentfullscreenelement
   */
  /**
   * Whether a document called called Document.webkitCurrentFullScreenElement.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric document_webkitcurrentfullscreenelement(1729);

  /**
   * generated from use.counter.doc.document_webkitexitfullscreen
   */
  /**
   * Whether a document called called Document.webkitExitFullscreen. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitexitfullscreen(1730);

  /**
   * generated from use.counter.doc.document_webkitfullscreenelement
   */
  /**
   * Whether a document called called Document.webkitFullscreenElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenelement(1731);

  /**
   * generated from use.counter.doc.document_webkitfullscreenenabled
   */
  /**
   * Whether a document called called Document.webkitFullscreenEnabled. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenenabled(1732);

  /**
   * generated from use.counter.doc.document_webkithidden
   */
  /**
   * Whether a document called called Document.webkitHidden. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkithidden(1733);

  /**
   * generated from use.counter.doc.document_webkitisfullscreen
   */
  /**
   * Whether a document called called Document.webkitIsFullScreen. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitisfullscreen(1734);

  /**
   * generated from use.counter.doc.document_webkitvisibilitystate
   */
  /**
   * Whether a document called called Document.webkitVisibilityState. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitvisibilitystate(1735);

  /**
   * generated from use.counter.doc.document_xmlencoding
   */
  /**
   * Whether a document called called Document.xmlEncoding. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlencoding(1736);

  /**
   * generated from use.counter.doc.document_xmlstandalone
   */
  /**
   * Whether a document called called Document.xmlStandalone. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlstandalone(1737);

  /**
   * generated from use.counter.doc.document_xmlversion
   */
  /**
   * Whether a document called called Document.xmlVersion. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlversion(1738);

  /**
   * generated from use.counter.doc.domparser_parsefromstring
   */
  /**
   * Whether a document called called DOMParser.parseFromString. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domparser_parsefromstring(1739);

  /**
   * generated from use.counter.doc.element_attachshadow
   */
  /**
   * Whether a document called called Element.attachShadow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_attachshadow(1740);

  /**
   * generated from use.counter.doc.element_computedstylemap
   */
  /**
   * Whether a document called called Element.computedStyleMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_computedstylemap(1741);

  /**
   * generated from use.counter.doc.element_onmousewheel
   */
  /**
   * Whether a document called called Element.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_onmousewheel(1742);

  /**
   * generated from use.counter.doc.element_releasecapture
   */
  /**
   * Whether a document called called Element.releaseCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasecapture(1743);

  /**
   * generated from use.counter.doc.element_releasepointercapture
   */
  /**
   * Whether a document called called Element.releasePointerCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasepointercapture(1744);

  /**
   * generated from use.counter.doc.element_scrollintoviewifneeded
   */
  /**
   * Whether a document called called Element.scrollIntoViewIfNeeded. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_scrollintoviewifneeded(1745);

  /**
   * generated from use.counter.doc.element_setcapture
   */
  /**
   * Whether a document called called Element.setCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setcapture(1746);

  /**
   * generated from use.counter.doc.element_sethtml
   */
  /**
   * Whether a document called called Element.setHTML. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_sethtml(1747);

  /**
   * generated from use.counter.doc.element_setpointercapture
   */
  /**
   * Whether a document called called Element.setPointerCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setpointercapture(1748);

  /**
   * generated from use.counter.doc.enumerate_devices_insec
   */
  /**
   * Whether a document calls MediaDevices.enumerateDevices from an insecure
     * context. Compare against `use.counter.content_documents_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_insec(1749);

  /**
   * generated from use.counter.doc.enumerate_devices_unfocused
   */
  /**
   * Whether a document calls MediaDevices.enumerateDevices from a unfocused
     * document. Compare against `use.counter.content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_unfocused(1750);

  /**
   * generated from use.counter.doc.fe_blend
   */
  /**
   * Whether a document uses the feBlend SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_blend(1751);

  /**
   * generated from use.counter.doc.fe_color_matrix
   */
  /**
   * Whether a document uses the feColorMatrix SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_color_matrix(1752);

  /**
   * generated from use.counter.doc.fe_component_transfer
   */
  /**
   * Whether a document uses the feComponentTransfer SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_component_transfer(1753);

  /**
   * generated from use.counter.doc.fe_composite
   */
  /**
   * Whether a document uses the feComposite SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_composite(1754);

  /**
   * generated from use.counter.doc.fe_convolve_matrix
   */
  /**
   * Whether a document uses the feConvolveMatrix SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_convolve_matrix(1755);

  /**
   * generated from use.counter.doc.fe_diffuse_lighting
   */
  /**
   * Whether a document uses the feDiffuseLighting SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_diffuse_lighting(1756);

  /**
   * generated from use.counter.doc.fe_displacement_map
   */
  /**
   * Whether a document uses the feDisplacementMap SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_displacement_map(1757);

  /**
   * generated from use.counter.doc.fe_flood
   */
  /**
   * Whether a document uses the feFlood SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_flood(1758);

  /**
   * generated from use.counter.doc.fe_gaussian_blur
   */
  /**
   * Whether a document uses the feGaussianBlur SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_gaussian_blur(1759);

  /**
   * generated from use.counter.doc.fe_image
   */
  /**
   * Whether a document uses the feImage SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_image(1760);

  /**
   * generated from use.counter.doc.fe_merge
   */
  /**
   * Whether a document uses the feMerge SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_merge(1761);

  /**
   * generated from use.counter.doc.fe_morphology
   */
  /**
   * Whether a document uses the feMorphology SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_morphology(1762);

  /**
   * generated from use.counter.doc.fe_offset
   */
  /**
   * Whether a document uses the feOffset SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_offset(1763);

  /**
   * generated from use.counter.doc.fe_specular_lighting
   */
  /**
   * Whether a document uses the feSpecularLighting SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_specular_lighting(1764);

  /**
   * generated from use.counter.doc.fe_tile
   */
  /**
   * Whether a document uses the feTile SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_tile(1765);

  /**
   * generated from use.counter.doc.fe_turbulence
   */
  /**
   * Whether a document uses the feTurbulence SVG filter.. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_turbulence(1766);

  /**
   * generated from use.counter.doc.filtered_cross_origin_iframe
   */
  /**
   * Whether a document cross-origin <iframe> within a CSS/SVG filter. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric filtered_cross_origin_iframe(1767);

  /**
   * generated from use.counter.doc.get_user_media_insec
   */
  /**
   * Whether a document calls MediaDevices.getUserMedia from an insecure context.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric get_user_media_insec(1768);

  /**
   * generated from use.counter.doc.get_user_media_unfocused
   */
  /**
   * Whether a document calls MediaDevices.getUserMedia from an unfocused document.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric get_user_media_unfocused(1769);

  /**
   * generated from use.counter.doc.htmlbuttonelement_popovertargetaction
   */
  /**
   * Whether a document called called HTMLButtonElement.popoverTargetAction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetaction(1770);

  /**
   * generated from use.counter.doc.htmlbuttonelement_popovertargetelement
   */
  /**
   * Whether a document called called HTMLButtonElement.popoverTargetElement.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetelement(1771);

  /**
   * generated from use.counter.doc.htmldocument_named_getter_hit
   */
  /**
   * Whether a document calls to the named getter on HTMLDocument that find
     * something via the name lookup. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldocument_named_getter_hit(1772);

  /**
   * generated from use.counter.doc.htmlelement_attributestylemap
   */
  /**
   * Whether a document called called HTMLElement.attributeStyleMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_attributestylemap(1773);

  /**
   * generated from use.counter.doc.htmlelement_hidepopover
   */
  /**
   * Whether a document called called HTMLElement.hidePopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_hidepopover(1774);

  /**
   * generated from use.counter.doc.htmlelement_popover
   */
  /**
   * Whether a document called called HTMLElement.popover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_popover(1775);

  /**
   * generated from use.counter.doc.htmlelement_showpopover
   */
  /**
   * Whether a document called called HTMLElement.showPopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_showpopover(1776);

  /**
   * generated from use.counter.doc.htmlelement_togglepopover
   */
  /**
   * Whether a document called called HTMLElement.togglePopover. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_togglepopover(1777);

  /**
   * generated from use.counter.doc.htmliframeelement_loading
   */
  /**
   * Whether a document called called HTMLIFrameElement.loading. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmliframeelement_loading(1778);

  /**
   * generated from use.counter.doc.htmlinputelement_capture
   */
  /**
   * Whether a document called called HTMLInputElement.capture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_capture(1779);

  /**
   * generated from use.counter.doc.htmlinputelement_incremental
   */
  /**
   * Whether a document called called HTMLInputElement.incremental. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_incremental(1780);

  /**
   * generated from use.counter.doc.htmlinputelement_onsearch
   */
  /**
   * Whether a document called called HTMLInputElement.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_onsearch(1781);

  /**
   * generated from use.counter.doc.htmlinputelement_popovertargetaction
   */
  /**
   * Whether a document called called HTMLInputElement.popoverTargetAction. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetaction(1782);

  /**
   * generated from use.counter.doc.htmlinputelement_popovertargetelement
   */
  /**
   * Whether a document called called HTMLInputElement.popoverTargetElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetelement(1783);

  /**
   * generated from use.counter.doc.htmlinputelement_webkitdirectory
   */
  /**
   * Whether a document called called HTMLInputElement.webkitdirectory. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitdirectory(1784);

  /**
   * generated from use.counter.doc.htmlinputelement_webkitentries
   */
  /**
   * Whether a document called called HTMLInputElement.webkitEntries. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitentries(1785);

  /**
   * generated from use.counter.doc.htmlmediaelement_disableremoteplayback
   */
  /**
   * Whether a document called called HTMLMediaElement.disableRemotePlayback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_disableremoteplayback(1786);

  /**
   * generated from use.counter.doc.htmlmediaelement_remote
   */
  /**
   * Whether a document called called HTMLMediaElement.remote. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_remote(1787);

  /**
   * generated from use.counter.doc.htmlvideoelement_cancelvideoframecallback
   */
  /**
   * Whether a document called called HTMLVideoElement.cancelVideoFrameCallback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_cancelvideoframecallback(1788);

  /**
   * generated from use.counter.doc.htmlvideoelement_disablepictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.disablePictureInPicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_disablepictureinpicture(1789);

  /**
   * generated from use.counter.doc.htmlvideoelement_onenterpictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.onenterpictureinpicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onenterpictureinpicture(1790);

  /**
   * generated from use.counter.doc.htmlvideoelement_onleavepictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.onleavepictureinpicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onleavepictureinpicture(1791);

  /**
   * generated from use.counter.doc.htmlvideoelement_playsinline
   */
  /**
   * Whether a document called called HTMLVideoElement.playsInline. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_playsinline(1792);

  /**
   * generated from use.counter.doc.htmlvideoelement_requestpictureinpicture
   */
  /**
   * Whether a document called called HTMLVideoElement.requestPictureInPicture.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestpictureinpicture(1793);

  /**
   * generated from use.counter.doc.htmlvideoelement_requestvideoframecallback
   */
  /**
   * Whether a document called called HTMLVideoElement.requestVideoFrameCallback.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestvideoframecallback(1794);

  /**
   * generated from use.counter.doc.imagedata_colorspace
   */
  /**
   * Whether a document called called ImageData.colorSpace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric imagedata_colorspace(1795);

  /**
   * generated from use.counter.doc.js_asmjs
   */
  /**
   * Whether a document uses asm.js. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_asmjs(1796);

  /**
   * generated from use.counter.doc.js_late_weekday
   */
  /**
   * Whether a document parses a Date with day of week in an unexpected position.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric js_late_weekday(1797);

  /**
   * generated from use.counter.doc.js_wasm
   */
  /**
   * Whether a document uses WebAssembly. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm(1798);

  /**
   * generated from use.counter.doc.location_ancestororigins
   */
  /**
   * Whether a document called called Location.ancestorOrigins. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric location_ancestororigins(1799);

  /**
   * generated from use.counter.doc.mediadevices_enumeratedevices
   */
  /**
   * Whether a document called called MediaDevices.enumerateDevices. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_enumeratedevices(1800);

  /**
   * generated from use.counter.doc.mediadevices_getdisplaymedia
   */
  /**
   * Whether a document called called MediaDevices.getDisplayMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getdisplaymedia(1801);

  /**
   * generated from use.counter.doc.mediadevices_getusermedia
   */
  /**
   * Whether a document called called MediaDevices.getUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getusermedia(1802);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_audio_failure
   */
  /**
   * Whether a document includes a mixed content audio element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_failure(1803);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_audio_success
   */
  /**
   * Whether a document includes a mixed content audio element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_success(1804);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_image_failure
   */
  /**
   * Whether a document includes a mixed content img element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_failure(1805);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_image_success
   */
  /**
   * Whether a document includes a mixed content img element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_success(1806);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_video_failure
   */
  /**
   * Whether a document includes a mixed content video element that does not laod..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_failure(1807);

  /**
   * generated from use.counter.doc.mixed_content_not_upgraded_video_success
   */
  /**
   * Whether a document includes a mixed content video element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_success(1808);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_audio_failure
   */
  /**
   * Whether a document includes a mixed content audio element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_failure(1809);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_audio_success
   */
  /**
   * Whether a document includes a mixed content audio element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_success(1810);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_image_failure
   */
  /**
   * Whether a document includes a mixed content img element that does not load..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_failure(1811);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_image_success
   */
  /**
   * Whether a document includes a mixed content img element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_success(1812);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_video_failure
   */
  /**
   * Whether a document includes a mixed content video element that does not laod..
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_failure(1813);

  /**
   * generated from use.counter.doc.mixed_content_upgraded_video_success
   */
  /**
   * Whether a document includes a mixed content video element that loads.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_success(1814);

  /**
   * generated from use.counter.doc.moz_get_user_media_insec
   */
  /**
   * Whether a document calls Navigator.mozGetUserMedia from an insecure context.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric moz_get_user_media_insec(1815);

  /**
   * generated from use.counter.doc.navigator_canshare
   */
  /**
   * Whether a document called called Navigator.canShare. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_canshare(1816);

  /**
   * generated from use.counter.doc.navigator_clearappbadge
   */
  /**
   * Whether a document called called Navigator.clearAppBadge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_clearappbadge(1817);

  /**
   * generated from use.counter.doc.navigator_mozgetusermedia
   */
  /**
   * Whether a document called called Navigator.mozGetUserMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_mozgetusermedia(1818);

  /**
   * generated from use.counter.doc.navigator_setappbadge
   */
  /**
   * Whether a document called called Navigator.setAppBadge. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_setappbadge(1819);

  /**
   * generated from use.counter.doc.navigator_share
   */
  /**
   * Whether a document called called Navigator.share. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_share(1820);

  /**
   * generated from use.counter.doc.navigator_useractivation
   */
  /**
   * Whether a document called called Navigator.userActivation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_useractivation(1821);

  /**
   * generated from use.counter.doc.navigator_wakelock
   */
  /**
   * Whether a document called called Navigator.wakeLock. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_wakelock(1822);

  /**
   * generated from use.counter.doc.onbounce
   */
  /**
   * Whether a document sets a <marquee> onbounce event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onbounce(1823);

  /**
   * generated from use.counter.doc.ondommousescroll
   */
  /**
   * Whether a document sets DOMMouseScroll event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ondommousescroll(1824);

  /**
   * generated from use.counter.doc.onfinish
   */
  /**
   * Whether a document sets a <marquee> onfinish event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onfinish(1825);

  /**
   * generated from use.counter.doc.onmozmousepixelscroll
   */
  /**
   * Whether a document sets MozMousePixelScroll event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onmozmousepixelscroll(1826);

  /**
   * generated from use.counter.doc.onoverflow
   */
  /**
   * Whether a document sets an element onoverflow event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onoverflow(1827);

  /**
   * generated from use.counter.doc.onstart
   */
  /**
   * Whether a document sets a <marquee> onstart event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onstart(1828);

  /**
   * generated from use.counter.doc.onunderflow
   */
  /**
   * Whether a document sets an element onunderflow event listener. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onunderflow(1829);

  /**
   * generated from use.counter.doc.percentage_stroke_width_in_svg
   */
  /**
   * Whether a document whether percentage stroke-width is used in SVG elements
     * (excluding <text>). Compare against `use.counter.content_documents_destroyed`
     * to calculate the rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svg(1830);

  /**
   * generated from use.counter.doc.percentage_stroke_width_in_svgtext
   */
  /**
   * Whether a document whether percentage stroke-width is used in SVG <text>.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svgtext(1831);

  /**
   * generated from use.counter.doc.private_browsing_caches_delete
   */
  /**
   * Whether a document calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(1832);

  /**
   * generated from use.counter.doc.private_browsing_caches_has
   */
  /**
   * Whether a document calls caches.has in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(1833);

  /**
   * generated from use.counter.doc.private_browsing_caches_keys
   */
  /**
   * Whether a document calls caches.keys in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(1834);

  /**
   * generated from use.counter.doc.private_browsing_caches_match
   */
  /**
   * Whether a document calls caches.match in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(1835);

  /**
   * generated from use.counter.doc.private_browsing_caches_open
   */
  /**
   * Whether a document calls caches.open in Private Browsing Mode. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(1836);

  /**
   * generated from use.counter.doc.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a document calls indexedDB.deleteDatabase in Private Browsing Mode.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(1837);

  /**
   * generated from use.counter.doc.private_browsing_idbfactory_open
   */
  /**
   * Whether a document calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(1838);

  /**
   * generated from use.counter.doc.private_browsing_navigator_service_worker
   */
  /**
   * Whether a document accesses navigator.serviceWorker in Private Browsing Mode.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_navigator_service_worker(1839);

  /**
   * generated from use.counter.doc.pushmanager_subscribe
   */
  /**
   * Whether a document called called PushManager.subscribe. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(1840);

  /**
   * generated from use.counter.doc.pushsubscription_unsubscribe
   */
  /**
   * Whether a document called called PushSubscription.unsubscribe. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(1841);

  /**
   * generated from use.counter.doc.range_createcontextualfragment
   */
  /**
   * Whether a document called called Range.createContextualFragment. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric range_createcontextualfragment(1842);

  /**
   * generated from use.counter.doc.sanitizer_constructor
   */
  /**
   * Whether a document called called Sanitizer.constructor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_constructor(1843);

  /**
   * generated from use.counter.doc.sanitizer_sanitize
   */
  /**
   * Whether a document called called Sanitizer.sanitize. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_sanitize(1844);

  /**
   * generated from use.counter.doc.scheduler_posttask
   */
  /**
   * Whether a document called called Scheduler.postTask. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(1845);

  /**
   * generated from use.counter.doc.shadowroot_pictureinpictureelement
   */
  /**
   * Whether a document called called ShadowRoot.pictureInPictureElement. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric shadowroot_pictureinpictureelement(1846);

  /**
   * generated from use.counter.doc.svgsvgelement_currentscale_getter
   */
  /**
   * Whether a document got SVGSVGElement.currentScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_getter(1847);

  /**
   * generated from use.counter.doc.svgsvgelement_currentscale_setter
   */
  /**
   * Whether a document set SVGSVGElement.currentScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_setter(1848);

  /**
   * generated from use.counter.doc.svgsvgelement_getelementbyid
   */
  /**
   * Whether a document called called SVGSVGElement.getElementById. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_getelementbyid(1849);

  /**
   * generated from use.counter.doc.window_absoluteorientationsensor
   */
  /**
   * Whether a document called called Window.AbsoluteOrientationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_absoluteorientationsensor(1850);

  /**
   * generated from use.counter.doc.window_accelerometer
   */
  /**
   * Whether a document called called Window.Accelerometer. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_accelerometer(1851);

  /**
   * generated from use.counter.doc.window_backgroundfetchmanager
   */
  /**
   * Whether a document called called Window.BackgroundFetchManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchmanager(1852);

  /**
   * generated from use.counter.doc.window_backgroundfetchrecord
   */
  /**
   * Whether a document called called Window.BackgroundFetchRecord. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchrecord(1853);

  /**
   * generated from use.counter.doc.window_backgroundfetchregistration
   */
  /**
   * Whether a document called called Window.BackgroundFetchRegistration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchregistration(1854);

  /**
   * generated from use.counter.doc.window_beforeinstallpromptevent
   */
  /**
   * Whether a document called called Window.BeforeInstallPromptEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_beforeinstallpromptevent(1855);

  /**
   * generated from use.counter.doc.window_bluetooth
   */
  /**
   * Whether a document called called Window.Bluetooth. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetooth(1856);

  /**
   * generated from use.counter.doc.window_bluetoothcharacteristicproperties
   */
  /**
   * Whether a document called called Window.BluetoothCharacteristicProperties.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothcharacteristicproperties(1857);

  /**
   * generated from use.counter.doc.window_bluetoothdevice
   */
  /**
   * Whether a document called called Window.BluetoothDevice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothdevice(1858);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattcharacteristic
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTCharacteristic.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattcharacteristic(1859);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattdescriptor
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTDescriptor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattdescriptor(1860);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattserver
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTServer. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattserver(1861);

  /**
   * generated from use.counter.doc.window_bluetoothremotegattservice
   */
  /**
   * Whether a document called called Window.BluetoothRemoteGATTService. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattservice(1862);

  /**
   * generated from use.counter.doc.window_bluetoothuuid
   */
  /**
   * Whether a document called called Window.BluetoothUUID. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothuuid(1863);

  /**
   * generated from use.counter.doc.window_canvascapturemediastreamtrack
   */
  /**
   * Whether a document called called Window.CanvasCaptureMediaStreamTrack. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_canvascapturemediastreamtrack(1864);

  /**
   * generated from use.counter.doc.window_chrome
   */
  /**
   * Whether a document called called Window.chrome. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_chrome(1865);

  /**
   * generated from use.counter.doc.window_clipboarditem
   */
  /**
   * Whether a document called called Window.ClipboardItem. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_clipboarditem(1866);

  /**
   * generated from use.counter.doc.window_cssimagevalue
   */
  /**
   * Whether a document called called Window.CSSImageValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssimagevalue(1867);

  /**
   * generated from use.counter.doc.window_csskeywordvalue
   */
  /**
   * Whether a document called called Window.CSSKeywordValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csskeywordvalue(1868);

  /**
   * generated from use.counter.doc.window_cssmathclamp
   */
  /**
   * Whether a document called called Window.CSSMathClamp. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathclamp(1869);

  /**
   * generated from use.counter.doc.window_cssmathinvert
   */
  /**
   * Whether a document called called Window.CSSMathInvert. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathinvert(1870);

  /**
   * generated from use.counter.doc.window_cssmathmax
   */
  /**
   * Whether a document called called Window.CSSMathMax. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmax(1871);

  /**
   * generated from use.counter.doc.window_cssmathmin
   */
  /**
   * Whether a document called called Window.CSSMathMin. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmin(1872);

  /**
   * generated from use.counter.doc.window_cssmathnegate
   */
  /**
   * Whether a document called called Window.CSSMathNegate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathnegate(1873);

  /**
   * generated from use.counter.doc.window_cssmathproduct
   */
  /**
   * Whether a document called called Window.CSSMathProduct. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathproduct(1874);

  /**
   * generated from use.counter.doc.window_cssmathsum
   */
  /**
   * Whether a document called called Window.CSSMathSum. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathsum(1875);

  /**
   * generated from use.counter.doc.window_cssmathvalue
   */
  /**
   * Whether a document called called Window.CSSMathValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathvalue(1876);

  /**
   * generated from use.counter.doc.window_cssmatrixcomponent
   */
  /**
   * Whether a document called called Window.CSSMatrixComponent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmatrixcomponent(1877);

  /**
   * generated from use.counter.doc.window_cssnumericarray
   */
  /**
   * Whether a document called called Window.CSSNumericArray. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericarray(1878);

  /**
   * generated from use.counter.doc.window_cssnumericvalue
   */
  /**
   * Whether a document called called Window.CSSNumericValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericvalue(1879);

  /**
   * generated from use.counter.doc.window_cssperspective
   */
  /**
   * Whether a document called called Window.CSSPerspective. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssperspective(1880);

  /**
   * generated from use.counter.doc.window_csspositionvalue
   */
  /**
   * Whether a document called called Window.CSSPositionValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspositionvalue(1881);

  /**
   * generated from use.counter.doc.window_csspropertyrule
   */
  /**
   * Whether a document called called Window.CSSPropertyRule. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspropertyrule(1882);

  /**
   * generated from use.counter.doc.window_cssrotate
   */
  /**
   * Whether a document called called Window.CSSRotate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssrotate(1883);

  /**
   * generated from use.counter.doc.window_cssscale
   */
  /**
   * Whether a document called called Window.CSSScale. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssscale(1884);

  /**
   * generated from use.counter.doc.window_cssskew
   */
  /**
   * Whether a document called called Window.CSSSkew. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskew(1885);

  /**
   * generated from use.counter.doc.window_cssskewx
   */
  /**
   * Whether a document called called Window.CSSSkewX. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewx(1886);

  /**
   * generated from use.counter.doc.window_cssskewy
   */
  /**
   * Whether a document called called Window.CSSSkewY. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewy(1887);

  /**
   * generated from use.counter.doc.window_cssstylevalue
   */
  /**
   * Whether a document called called Window.CSSStyleValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssstylevalue(1888);

  /**
   * generated from use.counter.doc.window_csstransformcomponent
   */
  /**
   * Whether a document called called Window.CSSTransformComponent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformcomponent(1889);

  /**
   * generated from use.counter.doc.window_csstransformvalue
   */
  /**
   * Whether a document called called Window.CSSTransformValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformvalue(1890);

  /**
   * generated from use.counter.doc.window_csstranslate
   */
  /**
   * Whether a document called called Window.CSSTranslate. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstranslate(1891);

  /**
   * generated from use.counter.doc.window_cssunitvalue
   */
  /**
   * Whether a document called called Window.CSSUnitValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunitvalue(1892);

  /**
   * generated from use.counter.doc.window_cssunparsedvalue
   */
  /**
   * Whether a document called called Window.CSSUnparsedValue. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunparsedvalue(1893);

  /**
   * generated from use.counter.doc.window_cssvariablereferencevalue
   */
  /**
   * Whether a document called called Window.CSSVariableReferenceValue. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssvariablereferencevalue(1894);

  /**
   * generated from use.counter.doc.window_defaultstatus
   */
  /**
   * Whether a document called called Window.defaultStatus. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_defaultstatus(1895);

  /**
   * generated from use.counter.doc.window_devicemotioneventacceleration
   */
  /**
   * Whether a document called called Window.DeviceMotionEventAcceleration. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventacceleration(1896);

  /**
   * generated from use.counter.doc.window_devicemotioneventrotationrate
   */
  /**
   * Whether a document called called Window.DeviceMotionEventRotationRate. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventrotationrate(1897);

  /**
   * generated from use.counter.doc.window_domerror
   */
  /**
   * Whether a document called called Window.DOMError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_domerror(1898);

  /**
   * generated from use.counter.doc.window_encodedvideochunk
   */
  /**
   * Whether a document called called Window.EncodedVideoChunk. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_encodedvideochunk(1899);

  /**
   * generated from use.counter.doc.window_enterpictureinpictureevent
   */
  /**
   * Whether a document called called Window.EnterPictureInPictureEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_enterpictureinpictureevent(1900);

  /**
   * generated from use.counter.doc.window_external
   */
  /**
   * Whether a document called called Window.External. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_external(1901);

  /**
   * generated from use.counter.doc.window_federatedcredential
   */
  /**
   * Whether a document called called Window.FederatedCredential. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_federatedcredential(1902);

  /**
   * generated from use.counter.doc.window_gyroscope
   */
  /**
   * Whether a document called called Window.Gyroscope. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_gyroscope(1903);

  /**
   * generated from use.counter.doc.window_htmlcontentelement
   */
  /**
   * Whether a document called called Window.HTMLContentElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlcontentelement(1904);

  /**
   * generated from use.counter.doc.window_htmlshadowelement
   */
  /**
   * Whether a document called called Window.HTMLShadowElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlshadowelement(1905);

  /**
   * generated from use.counter.doc.window_imagecapture
   */
  /**
   * Whether a document called called Window.ImageCapture. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_imagecapture(1906);

  /**
   * generated from use.counter.doc.window_inputdevicecapabilities
   */
  /**
   * Whether a document called called Window.InputDeviceCapabilities. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdevicecapabilities(1907);

  /**
   * generated from use.counter.doc.window_inputdeviceinfo
   */
  /**
   * Whether a document called called Window.InputDeviceInfo. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdeviceinfo(1908);

  /**
   * generated from use.counter.doc.window_keyboard
   */
  /**
   * Whether a document called called Window.Keyboard. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboard(1909);

  /**
   * generated from use.counter.doc.window_keyboardlayoutmap
   */
  /**
   * Whether a document called called Window.KeyboardLayoutMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboardlayoutmap(1910);

  /**
   * generated from use.counter.doc.window_linearaccelerationsensor
   */
  /**
   * Whether a document called called Window.LinearAccelerationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_linearaccelerationsensor(1911);

  /**
   * generated from use.counter.doc.window_mediasettingsrange
   */
  /**
   * Whether a document called called Window.MediaSettingsRange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_mediasettingsrange(1912);

  /**
   * generated from use.counter.doc.window_midiaccess
   */
  /**
   * Whether a document called called Window.MIDIAccess. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiaccess(1913);

  /**
   * generated from use.counter.doc.window_midiconnectionevent
   */
  /**
   * Whether a document called called Window.MIDIConnectionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiconnectionevent(1914);

  /**
   * generated from use.counter.doc.window_midiinput
   */
  /**
   * Whether a document called called Window.MIDIInput. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinput(1915);

  /**
   * generated from use.counter.doc.window_midiinputmap
   */
  /**
   * Whether a document called called Window.MIDIInputMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinputmap(1916);

  /**
   * generated from use.counter.doc.window_midimessageevent
   */
  /**
   * Whether a document called called Window.MIDIMessageEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midimessageevent(1917);

  /**
   * generated from use.counter.doc.window_midioutput
   */
  /**
   * Whether a document called called Window.MIDIOutput. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutput(1918);

  /**
   * generated from use.counter.doc.window_midioutputmap
   */
  /**
   * Whether a document called called Window.MIDIOutputMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutputmap(1919);

  /**
   * generated from use.counter.doc.window_midiport
   */
  /**
   * Whether a document called called Window.MIDIPort. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiport(1920);

  /**
   * generated from use.counter.doc.window_networkinformation
   */
  /**
   * Whether a document called called Window.NetworkInformation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_networkinformation(1921);

  /**
   * generated from use.counter.doc.window_offscreenbuffering
   */
  /**
   * Whether a document called called Window.offscreenBuffering. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_offscreenbuffering(1922);

  /**
   * generated from use.counter.doc.window_onbeforeinstallprompt
   */
  /**
   * Whether a document called called Window.onbeforeinstallprompt. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onbeforeinstallprompt(1923);

  /**
   * generated from use.counter.doc.window_oncancel
   */
  /**
   * Whether a document called called Window.oncancel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_oncancel(1924);

  /**
   * generated from use.counter.doc.window_onmousewheel
   */
  /**
   * Whether a document called called Window.onmousewheel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onmousewheel(1925);

  /**
   * generated from use.counter.doc.window_onorientationchange
   */
  /**
   * Whether a document called called Window.onorientationchange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onorientationchange(1926);

  /**
   * generated from use.counter.doc.window_onsearch
   */
  /**
   * Whether a document called called Window.onsearch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onsearch(1927);

  /**
   * generated from use.counter.doc.window_onselectionchange
   */
  /**
   * Whether a document called called Window.onselectionchange. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onselectionchange(1928);

  /**
   * generated from use.counter.doc.window_open_empty_url
   */
  /**
   * Whether a document calls window.open with an empty url argument. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_open_empty_url(1929);

  /**
   * generated from use.counter.doc.window_opendatabase
   */
  /**
   * Whether a document called called Window.openDatabase. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_opendatabase(1930);

  /**
   * generated from use.counter.doc.window_orientation
   */
  /**
   * Whether a document called called Window.orientation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientation(1931);

  /**
   * generated from use.counter.doc.window_orientationsensor
   */
  /**
   * Whether a document called called Window.OrientationSensor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientationsensor(1932);

  /**
   * generated from use.counter.doc.window_overconstrainederror
   */
  /**
   * Whether a document called called Window.OverconstrainedError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_overconstrainederror(1933);

  /**
   * generated from use.counter.doc.window_passwordcredential
   */
  /**
   * Whether a document called called Window.PasswordCredential. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_passwordcredential(1934);

  /**
   * generated from use.counter.doc.window_paymentaddress
   */
  /**
   * Whether a document called called Window.PaymentAddress. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentaddress(1935);

  /**
   * generated from use.counter.doc.window_paymentinstruments
   */
  /**
   * Whether a document called called Window.PaymentInstruments. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentinstruments(1936);

  /**
   * generated from use.counter.doc.window_paymentmanager
   */
  /**
   * Whether a document called called Window.PaymentManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmanager(1937);

  /**
   * generated from use.counter.doc.window_paymentmethodchangeevent
   */
  /**
   * Whether a document called called Window.PaymentMethodChangeEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmethodchangeevent(1938);

  /**
   * generated from use.counter.doc.window_paymentrequest
   */
  /**
   * Whether a document called called Window.PaymentRequest. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequest(1939);

  /**
   * generated from use.counter.doc.window_paymentrequestupdateevent
   */
  /**
   * Whether a document called called Window.PaymentRequestUpdateEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequestupdateevent(1940);

  /**
   * generated from use.counter.doc.window_paymentresponse
   */
  /**
   * Whether a document called called Window.PaymentResponse. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentresponse(1941);

  /**
   * generated from use.counter.doc.window_performancelongtasktiming
   */
  /**
   * Whether a document called called Window.PerformanceLongTaskTiming. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_performancelongtasktiming(1942);

  /**
   * generated from use.counter.doc.window_photocapabilities
   */
  /**
   * Whether a document called called Window.PhotoCapabilities. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_photocapabilities(1943);

  /**
   * generated from use.counter.doc.window_pictureinpictureevent
   */
  /**
   * Whether a document called called Window.PictureInPictureEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpictureevent(1944);

  /**
   * generated from use.counter.doc.window_pictureinpicturewindow
   */
  /**
   * Whether a document called called Window.PictureInPictureWindow. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpicturewindow(1945);

  /**
   * generated from use.counter.doc.window_presentation
   */
  /**
   * Whether a document called called Window.Presentation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentation(1946);

  /**
   * generated from use.counter.doc.window_presentationavailability
   */
  /**
   * Whether a document called called Window.PresentationAvailability. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationavailability(1947);

  /**
   * generated from use.counter.doc.window_presentationconnection
   */
  /**
   * Whether a document called called Window.PresentationConnection. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnection(1948);

  /**
   * generated from use.counter.doc.window_presentationconnectionavailableevent
   */
  /**
   * Whether a document called called Window.PresentationConnectionAvailableEvent.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionavailableevent(1949);

  /**
   * generated from use.counter.doc.window_presentationconnectioncloseevent
   */
  /**
   * Whether a document called called Window.PresentationConnectionCloseEvent.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectioncloseevent(1950);

  /**
   * generated from use.counter.doc.window_presentationconnectionlist
   */
  /**
   * Whether a document called called Window.PresentationConnectionList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionlist(1951);

  /**
   * generated from use.counter.doc.window_presentationreceiver
   */
  /**
   * Whether a document called called Window.PresentationReceiver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationreceiver(1952);

  /**
   * generated from use.counter.doc.window_presentationrequest
   */
  /**
   * Whether a document called called Window.PresentationRequest. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationrequest(1953);

  /**
   * generated from use.counter.doc.window_relativeorientationsensor
   */
  /**
   * Whether a document called called Window.RelativeOrientationSensor. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_relativeorientationsensor(1954);

  /**
   * generated from use.counter.doc.window_remoteplayback
   */
  /**
   * Whether a document called called Window.RemotePlayback. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_remoteplayback(1955);

  /**
   * generated from use.counter.doc.window_report
   */
  /**
   * Whether a document called called Window.Report. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_report(1956);

  /**
   * generated from use.counter.doc.window_reportbody
   */
  /**
   * Whether a document called called Window.ReportBody. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportbody(1957);

  /**
   * generated from use.counter.doc.window_reportingobserver
   */
  /**
   * Whether a document called called Window.ReportingObserver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportingobserver(1958);

  /**
   * generated from use.counter.doc.window_rtcerror
   */
  /**
   * Whether a document called called Window.RTCError. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerror(1959);

  /**
   * generated from use.counter.doc.window_rtcerrorevent
   */
  /**
   * Whether a document called called Window.RTCErrorEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerrorevent(1960);

  /**
   * generated from use.counter.doc.window_rtcicetransport
   */
  /**
   * Whether a document called called Window.RTCIceTransport. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcicetransport(1961);

  /**
   * generated from use.counter.doc.window_rtcpeerconnectioniceerrorevent
   */
  /**
   * Whether a document called called Window.RTCPeerConnectionIceErrorEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcpeerconnectioniceerrorevent(1962);

  /**
   * generated from use.counter.doc.window_sensor
   */
  /**
   * Whether a document called called Window.Sensor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensor(1963);

  /**
   * generated from use.counter.doc.window_sensorerrorevent
   */
  /**
   * Whether a document called called Window.SensorErrorEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensorerrorevent(1964);

  /**
   * generated from use.counter.doc.window_sidebar_getter
   */
  /**
   * Whether a document got Window.sidebar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_getter(1965);

  /**
   * generated from use.counter.doc.window_sidebar_setter
   */
  /**
   * Whether a document set Window.sidebar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_setter(1966);

  /**
   * generated from use.counter.doc.window_speechrecognitionalternative
   */
  /**
   * Whether a document called called Window.SpeechRecognitionAlternative. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionalternative(1967);

  /**
   * generated from use.counter.doc.window_speechrecognitionresult
   */
  /**
   * Whether a document called called Window.SpeechRecognitionResult. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresult(1968);

  /**
   * generated from use.counter.doc.window_speechrecognitionresultlist
   */
  /**
   * Whether a document called called Window.SpeechRecognitionResultList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresultlist(1969);

  /**
   * generated from use.counter.doc.window_stylemedia
   */
  /**
   * Whether a document called called Window.styleMedia. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylemedia(1970);

  /**
   * generated from use.counter.doc.window_stylepropertymap
   */
  /**
   * Whether a document called called Window.StylePropertyMap. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymap(1971);

  /**
   * generated from use.counter.doc.window_stylepropertymapreadonly
   */
  /**
   * Whether a document called called Window.StylePropertyMapReadOnly. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymapreadonly(1972);

  /**
   * generated from use.counter.doc.window_svgdiscardelement
   */
  /**
   * Whether a document called called Window.SVGDiscardElement. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_svgdiscardelement(1973);

  /**
   * generated from use.counter.doc.window_syncmanager
   */
  /**
   * Whether a document called called Window.SyncManager. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_syncmanager(1974);

  /**
   * generated from use.counter.doc.window_taskattributiontiming
   */
  /**
   * Whether a document called called Window.TaskAttributionTiming. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_taskattributiontiming(1975);

  /**
   * generated from use.counter.doc.window_textevent
   */
  /**
   * Whether a document called called Window.TextEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_textevent(1976);

  /**
   * generated from use.counter.doc.window_touch
   */
  /**
   * Whether a document called called Window.Touch. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touch(1977);

  /**
   * generated from use.counter.doc.window_touchevent
   */
  /**
   * Whether a document called called Window.TouchEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchevent(1978);

  /**
   * generated from use.counter.doc.window_touchlist
   */
  /**
   * Whether a document called called Window.TouchList. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchlist(1979);

  /**
   * generated from use.counter.doc.window_usb
   */
  /**
   * Whether a document called called Window.USB. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usb(1980);

  /**
   * generated from use.counter.doc.window_usbalternateinterface
   */
  /**
   * Whether a document called called Window.USBAlternateInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbalternateinterface(1981);

  /**
   * generated from use.counter.doc.window_usbconfiguration
   */
  /**
   * Whether a document called called Window.USBConfiguration. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconfiguration(1982);

  /**
   * generated from use.counter.doc.window_usbconnectionevent
   */
  /**
   * Whether a document called called Window.USBConnectionEvent. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconnectionevent(1983);

  /**
   * generated from use.counter.doc.window_usbdevice
   */
  /**
   * Whether a document called called Window.USBDevice. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbdevice(1984);

  /**
   * generated from use.counter.doc.window_usbendpoint
   */
  /**
   * Whether a document called called Window.USBEndpoint. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbendpoint(1985);

  /**
   * generated from use.counter.doc.window_usbinterface
   */
  /**
   * Whether a document called called Window.USBInterface. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbinterface(1986);

  /**
   * generated from use.counter.doc.window_usbintransferresult
   */
  /**
   * Whether a document called called Window.USBInTransferResult. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbintransferresult(1987);

  /**
   * generated from use.counter.doc.window_usbisochronousintransferpacket
   */
  /**
   * Whether a document called called Window.USBIsochronousInTransferPacket. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferpacket(1988);

  /**
   * generated from use.counter.doc.window_usbisochronousintransferresult
   */
  /**
   * Whether a document called called Window.USBIsochronousInTransferResult. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferresult(1989);

  /**
   * generated from use.counter.doc.window_usbisochronousouttransferpacket
   */
  /**
   * Whether a document called called Window.USBIsochronousOutTransferPacket.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferpacket(1990);

  /**
   * generated from use.counter.doc.window_usbisochronousouttransferresult
   */
  /**
   * Whether a document called called Window.USBIsochronousOutTransferResult.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferresult(1991);

  /**
   * generated from use.counter.doc.window_usbouttransferresult
   */
  /**
   * Whether a document called called Window.USBOutTransferResult. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbouttransferresult(1992);

  /**
   * generated from use.counter.doc.window_useractivation
   */
  /**
   * Whether a document called called Window.UserActivation. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_useractivation(1993);

  /**
   * generated from use.counter.doc.window_videocolorspace
   */
  /**
   * Whether a document called called Window.VideoColorSpace. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videocolorspace(1994);

  /**
   * generated from use.counter.doc.window_videodecoder
   */
  /**
   * Whether a document called called Window.VideoDecoder. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videodecoder(1995);

  /**
   * generated from use.counter.doc.window_videoencoder
   */
  /**
   * Whether a document called called Window.VideoEncoder. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoencoder(1996);

  /**
   * generated from use.counter.doc.window_videoframe
   */
  /**
   * Whether a document called called Window.VideoFrame. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoframe(1997);

  /**
   * generated from use.counter.doc.window_wakelock
   */
  /**
   * Whether a document called called Window.WakeLock. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelock(1998);

  /**
   * generated from use.counter.doc.window_wakelocksentinel
   */
  /**
   * Whether a document called called Window.WakeLockSentinel. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelocksentinel(1999);

  /**
   * generated from use.counter.doc.window_webkitcancelanimationframe
   */
  /**
   * Whether a document called called Window.webkitCancelAnimationFrame. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitcancelanimationframe(2000);

  /**
   * generated from use.counter.doc.window_webkitmediastream
   */
  /**
   * Whether a document called called Window.webkitMediaStream. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmediastream(2001);

  /**
   * generated from use.counter.doc.window_webkitmutationobserver
   */
  /**
   * Whether a document called called Window.WebKitMutationObserver. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmutationobserver(2002);

  /**
   * generated from use.counter.doc.window_webkitrequestanimationframe
   */
  /**
   * Whether a document called called Window.webkitRequestAnimationFrame. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestanimationframe(2003);

  /**
   * generated from use.counter.doc.window_webkitrequestfilesystem
   */
  /**
   * Whether a document called called Window.webkitRequestFileSystem. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestfilesystem(2004);

  /**
   * generated from use.counter.doc.window_webkitresolvelocalfilesystemurl
   */
  /**
   * Whether a document called called Window.webkitResolveLocalFileSystemURL.
     * Compare against `use.counter.content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitresolvelocalfilesystemurl(2005);

  /**
   * generated from use.counter.doc.window_webkitrtcpeerconnection
   */
  /**
   * Whether a document called called Window.webkitRTCPeerConnection. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrtcpeerconnection(2006);

  /**
   * generated from use.counter.doc.window_webkitspeechgrammar
   */
  /**
   * Whether a document called called Window.webkitSpeechGrammar. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammar(2007);

  /**
   * generated from use.counter.doc.window_webkitspeechgrammarlist
   */
  /**
   * Whether a document called called Window.webkitSpeechGrammarList. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammarlist(2008);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognition
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognition. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognition(2009);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognitionerror
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognitionError. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionerror(2010);

  /**
   * generated from use.counter.doc.window_webkitspeechrecognitionevent
   */
  /**
   * Whether a document called called Window.webkitSpeechRecognitionEvent. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionevent(2011);

  /**
   * generated from use.counter.doc.window_webkitstorageinfo
   */
  /**
   * Whether a document called called Window.webkitStorageInfo. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitstorageinfo(2012);

  /**
   * generated from use.counter.doc.workernavigator_permissions
   */
  /**
   * Whether a document called called WorkerNavigator.permissions. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric workernavigator_permissions(2013);

  /**
   * generated from use.counter.doc.wr_filter_fallback
   */
  /**
   * Whether a document triggers the blob fallback for an SVG filter.. Compare
     * against `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric wr_filter_fallback(2014);

  /**
   * generated from use.counter.doc.xslstylesheet
   */
  /**
   * Whether a document uses an XSL Stylesheet. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xslstylesheet(2015);

  /**
   * generated from use.counter.doc.xsltprocessor_constructor
   */
  /**
   * Whether a document called called XSLTProcessor.constructor. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xsltprocessor_constructor(2016);

  /**
   * generated from use.counter.doc.you_tube_flash_embed
   */
  /**
   * Whether a document in <object> or <embed>. Compare against
     * `use.counter.content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric you_tube_flash_embed(2017);

}
namespace use_counter_error {
  /**
   * generated from use.counter.error.unknown_counter
   */
  enum class UnknownCounterLabel: uint16_t {
      ePage = 0,
      eDoc = 1,
      eDedicated = 2,
      eShared = 3,
      eService = 4,
      e__Other__,
    };
  /**
   * How many times did we try to increment a use counter we couldn't find? Labeled
     * by what kind of use counter it is.
   */
  constexpr impl::Labeled<impl::CounterMetric, UnknownCounterLabel> unknown_counter(2018);

}
namespace use_counter_page {
  /**
   * generated from use.counter.page.clipboard_read
   */
  /**
   * Whether a page called called Clipboard.read. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_read(2019);

  /**
   * generated from use.counter.page.clipboard_readtext
   */
  /**
   * Whether a page called called Clipboard.readText. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_readtext(2020);

  /**
   * generated from use.counter.page.clipboard_write
   */
  /**
   * Whether a page called called Clipboard.write. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric clipboard_write(2021);

  /**
   * generated from use.counter.page.console_assert
   */
  /**
   * Whether a page called called console.assert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2022);

  /**
   * generated from use.counter.page.console_clear
   */
  /**
   * Whether a page called called console.clear. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2023);

  /**
   * generated from use.counter.page.console_count
   */
  /**
   * Whether a page called called console.count. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2024);

  /**
   * generated from use.counter.page.console_countreset
   */
  /**
   * Whether a page called called console.countReset. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2025);

  /**
   * generated from use.counter.page.console_debug
   */
  /**
   * Whether a page called called console.debug. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2026);

  /**
   * generated from use.counter.page.console_dir
   */
  /**
   * Whether a page called called console.dir. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2027);

  /**
   * generated from use.counter.page.console_dirxml
   */
  /**
   * Whether a page called called console.dirxml. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2028);

  /**
   * generated from use.counter.page.console_error
   */
  /**
   * Whether a page called called console.error. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2029);

  /**
   * generated from use.counter.page.console_exception
   */
  /**
   * Whether a page called called console.exception. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2030);

  /**
   * generated from use.counter.page.console_group
   */
  /**
   * Whether a page called called console.group. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2031);

  /**
   * generated from use.counter.page.console_groupcollapsed
   */
  /**
   * Whether a page called called console.groupCollapsed. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2032);

  /**
   * generated from use.counter.page.console_groupend
   */
  /**
   * Whether a page called called console.groupEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2033);

  /**
   * generated from use.counter.page.console_info
   */
  /**
   * Whether a page called called console.info. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2034);

  /**
   * generated from use.counter.page.console_log
   */
  /**
   * Whether a page called called console.log. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2035);

  /**
   * generated from use.counter.page.console_profile
   */
  /**
   * Whether a page called called console.profile. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2036);

  /**
   * generated from use.counter.page.console_profileend
   */
  /**
   * Whether a page called called console.profileEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2037);

  /**
   * generated from use.counter.page.console_table
   */
  /**
   * Whether a page called called console.table. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2038);

  /**
   * generated from use.counter.page.console_time
   */
  /**
   * Whether a page called called console.time. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2039);

  /**
   * generated from use.counter.page.console_timeend
   */
  /**
   * Whether a page called called console.timeEnd. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2040);

  /**
   * generated from use.counter.page.console_timelog
   */
  /**
   * Whether a page called called console.timeLog. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2041);

  /**
   * generated from use.counter.page.console_timestamp
   */
  /**
   * Whether a page called called console.timeStamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2042);

  /**
   * generated from use.counter.page.console_trace
   */
  /**
   * Whether a page called called console.trace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2043);

  /**
   * generated from use.counter.page.console_warn
   */
  /**
   * Whether a page called called console.warn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2044);

  /**
   * generated from use.counter.page.customelementregistry_define
   */
  /**
   * Whether a page called called CustomElementRegistry.define. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customelementregistry_define(2045);

  /**
   * generated from use.counter.page.customized_builtin
   */
  /**
   * Whether a page registers a customized built-in element. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric customized_builtin(2046);

  /**
   * generated from use.counter.page.datatransfer_addelement
   */
  /**
   * Whether a page called called DataTransfer.addElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_addelement(2047);

  /**
   * generated from use.counter.page.datatransfer_mozcleardataat
   */
  /**
   * Whether a page called called DataTransfer.mozClearDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcleardataat(2048);

  /**
   * generated from use.counter.page.datatransfer_mozcursor_getter
   */
  /**
   * Whether a page got DataTransfer.mozCursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_getter(2049);

  /**
   * generated from use.counter.page.datatransfer_mozcursor_setter
   */
  /**
   * Whether a page set DataTransfer.mozCursor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozcursor_setter(2050);

  /**
   * generated from use.counter.page.datatransfer_mozgetdataat
   */
  /**
   * Whether a page called called DataTransfer.mozGetDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozgetdataat(2051);

  /**
   * generated from use.counter.page.datatransfer_mozitemcount_getter
   */
  /**
   * Whether a page got DataTransfer.mozItemCount. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_getter(2052);

  /**
   * generated from use.counter.page.datatransfer_mozitemcount_setter
   */
  /**
   * Whether a page set DataTransfer.mozItemCount. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozitemcount_setter(2053);

  /**
   * generated from use.counter.page.datatransfer_mozsetdataat
   */
  /**
   * Whether a page called called DataTransfer.mozSetDataAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsetdataat(2054);

  /**
   * generated from use.counter.page.datatransfer_mozsourcenode_getter
   */
  /**
   * Whether a page got DataTransfer.mozSourceNode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_getter(2055);

  /**
   * generated from use.counter.page.datatransfer_mozsourcenode_setter
   */
  /**
   * Whether a page set DataTransfer.mozSourceNode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozsourcenode_setter(2056);

  /**
   * generated from use.counter.page.datatransfer_moztypesat
   */
  /**
   * Whether a page called called DataTransfer.mozTypesAt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_moztypesat(2057);

  /**
   * generated from use.counter.page.datatransfer_mozusercancelled_getter
   */
  /**
   * Whether a page got DataTransfer.mozUserCancelled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_getter(2058);

  /**
   * generated from use.counter.page.datatransfer_mozusercancelled_setter
   */
  /**
   * Whether a page set DataTransfer.mozUserCancelled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransfer_mozusercancelled_setter(2059);

  /**
   * generated from use.counter.page.datatransferitem_webkitgetasentry
   */
  /**
   * Whether a page called called DataTransferItem.webkitGetAsEntry. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric datatransferitem_webkitgetasentry(2060);

  /**
   * generated from use.counter.page.document_caretrangefrompoint
   */
  /**
   * Whether a page called called Document.caretRangeFromPoint. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_caretrangefrompoint(2061);

  /**
   * generated from use.counter.page.document_exec_command_content_read_only
   */
  /**
   * Whether a page calls execCommand with contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exec_command_content_read_only(2062);

  /**
   * generated from use.counter.page.document_exitpictureinpicture
   */
  /**
   * Whether a page called called Document.exitPictureInPicture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_exitpictureinpicture(2063);

  /**
   * generated from use.counter.page.document_featurepolicy
   */
  /**
   * Whether a page called called Document.featurePolicy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_featurepolicy(2064);

  /**
   * generated from use.counter.page.document_mozsetimageelement
   */
  /**
   * Whether a page called called Document.mozSetImageElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_mozsetimageelement(2065);

  /**
   * generated from use.counter.page.document_onbeforecopy
   */
  /**
   * Whether a page called called Document.onbeforecopy. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecopy(2066);

  /**
   * generated from use.counter.page.document_onbeforecut
   */
  /**
   * Whether a page called called Document.onbeforecut. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforecut(2067);

  /**
   * generated from use.counter.page.document_onbeforepaste
   */
  /**
   * Whether a page called called Document.onbeforepaste. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onbeforepaste(2068);

  /**
   * generated from use.counter.page.document_oncancel
   */
  /**
   * Whether a page called called Document.oncancel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_oncancel(2069);

  /**
   * generated from use.counter.page.document_onfreeze
   */
  /**
   * Whether a page called called Document.onfreeze. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onfreeze(2070);

  /**
   * generated from use.counter.page.document_onmousewheel
   */
  /**
   * Whether a page called called Document.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onmousewheel(2071);

  /**
   * generated from use.counter.page.document_onresume
   */
  /**
   * Whether a page called called Document.onresume. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onresume(2072);

  /**
   * generated from use.counter.page.document_onsearch
   */
  /**
   * Whether a page called called Document.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onsearch(2073);

  /**
   * generated from use.counter.page.document_onwebkitfullscreenchange
   */
  /**
   * Whether a page called called Document.onwebkitfullscreenchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenchange(2074);

  /**
   * generated from use.counter.page.document_onwebkitfullscreenerror
   */
  /**
   * Whether a page called called Document.onwebkitfullscreenerror. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_onwebkitfullscreenerror(2075);

  /**
   * generated from use.counter.page.document_open
   */
  /**
   * Whether a page calls document.open in a way that creates a new Window object.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric document_open(2076);

  /**
   * generated from use.counter.page.document_pictureinpictureelement
   */
  /**
   * Whether a page called called Document.pictureInPictureElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureelement(2077);

  /**
   * generated from use.counter.page.document_pictureinpictureenabled
   */
  /**
   * Whether a page called called Document.pictureInPictureEnabled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_pictureinpictureenabled(2078);

  /**
   * generated from use.counter.page.document_query_command_state_or_value_content_read_only
   */
  /**
   * Whether a page calls queryCommandState or queryCommandValue with
     * contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_content_read_only(2079);

  /**
   * generated from use.counter.page.document_query_command_state_or_value_insert_br_on_return
   */
  /**
   * Whether a page calls queryCommandState or queryCommandValue with
     * insertBrOnReturn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_state_or_value_insert_br_on_return(2080);

  /**
   * generated from use.counter.page.document_query_command_supported_or_enabled_content_read_only
   */
  /**
   * Whether a page calls queryCommandSupported or queryCommandEnabled with
     * contentReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_content_read_only(2081);

  /**
   * generated from use.counter.page.document_query_command_supported_or_enabled_insert_br_on_return
   */
  /**
   * Whether a page calls queryCommandSupported or queryCommandEnabled with
     * insertBrOnReturn. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_query_command_supported_or_enabled_insert_br_on_return(2082);

  /**
   * generated from use.counter.page.document_registerelement
   */
  /**
   * Whether a page called called Document.registerElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_registerelement(2083);

  /**
   * generated from use.counter.page.document_wasdiscarded
   */
  /**
   * Whether a page called called Document.wasDiscarded. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_wasdiscarded(2084);

  /**
   * generated from use.counter.page.document_webkitcancelfullscreen
   */
  /**
   * Whether a page called called Document.webkitCancelFullScreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitcancelfullscreen(2085);

  /**
   * generated from use.counter.page.document_webkitcurrentfullscreenelement
   */
  /**
   * Whether a page called called Document.webkitCurrentFullScreenElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric document_webkitcurrentfullscreenelement(2086);

  /**
   * generated from use.counter.page.document_webkitexitfullscreen
   */
  /**
   * Whether a page called called Document.webkitExitFullscreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitexitfullscreen(2087);

  /**
   * generated from use.counter.page.document_webkitfullscreenelement
   */
  /**
   * Whether a page called called Document.webkitFullscreenElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenelement(2088);

  /**
   * generated from use.counter.page.document_webkitfullscreenenabled
   */
  /**
   * Whether a page called called Document.webkitFullscreenEnabled. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitfullscreenenabled(2089);

  /**
   * generated from use.counter.page.document_webkithidden
   */
  /**
   * Whether a page called called Document.webkitHidden. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkithidden(2090);

  /**
   * generated from use.counter.page.document_webkitisfullscreen
   */
  /**
   * Whether a page called called Document.webkitIsFullScreen. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitisfullscreen(2091);

  /**
   * generated from use.counter.page.document_webkitvisibilitystate
   */
  /**
   * Whether a page called called Document.webkitVisibilityState. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_webkitvisibilitystate(2092);

  /**
   * generated from use.counter.page.document_xmlencoding
   */
  /**
   * Whether a page called called Document.xmlEncoding. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlencoding(2093);

  /**
   * generated from use.counter.page.document_xmlstandalone
   */
  /**
   * Whether a page called called Document.xmlStandalone. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlstandalone(2094);

  /**
   * generated from use.counter.page.document_xmlversion
   */
  /**
   * Whether a page called called Document.xmlVersion. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric document_xmlversion(2095);

  /**
   * generated from use.counter.page.domparser_parsefromstring
   */
  /**
   * Whether a page called called DOMParser.parseFromString. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric domparser_parsefromstring(2096);

  /**
   * generated from use.counter.page.element_attachshadow
   */
  /**
   * Whether a page called called Element.attachShadow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_attachshadow(2097);

  /**
   * generated from use.counter.page.element_computedstylemap
   */
  /**
   * Whether a page called called Element.computedStyleMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_computedstylemap(2098);

  /**
   * generated from use.counter.page.element_onmousewheel
   */
  /**
   * Whether a page called called Element.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_onmousewheel(2099);

  /**
   * generated from use.counter.page.element_releasecapture
   */
  /**
   * Whether a page called called Element.releaseCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasecapture(2100);

  /**
   * generated from use.counter.page.element_releasepointercapture
   */
  /**
   * Whether a page called called Element.releasePointerCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_releasepointercapture(2101);

  /**
   * generated from use.counter.page.element_scrollintoviewifneeded
   */
  /**
   * Whether a page called called Element.scrollIntoViewIfNeeded. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_scrollintoviewifneeded(2102);

  /**
   * generated from use.counter.page.element_setcapture
   */
  /**
   * Whether a page called called Element.setCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setcapture(2103);

  /**
   * generated from use.counter.page.element_sethtml
   */
  /**
   * Whether a page called called Element.setHTML. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_sethtml(2104);

  /**
   * generated from use.counter.page.element_setpointercapture
   */
  /**
   * Whether a page called called Element.setPointerCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric element_setpointercapture(2105);

  /**
   * generated from use.counter.page.enumerate_devices_insec
   */
  /**
   * Whether a page calls MediaDevices.enumerateDevices from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_insec(2106);

  /**
   * generated from use.counter.page.enumerate_devices_unfocused
   */
  /**
   * Whether a page calls MediaDevices.enumerateDevices from a unfocused document.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric enumerate_devices_unfocused(2107);

  /**
   * generated from use.counter.page.fe_blend
   */
  /**
   * Whether a page uses the feBlend SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_blend(2108);

  /**
   * generated from use.counter.page.fe_color_matrix
   */
  /**
   * Whether a page uses the feColorMatrix SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_color_matrix(2109);

  /**
   * generated from use.counter.page.fe_component_transfer
   */
  /**
   * Whether a page uses the feComponentTransfer SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_component_transfer(2110);

  /**
   * generated from use.counter.page.fe_composite
   */
  /**
   * Whether a page uses the feComposite SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_composite(2111);

  /**
   * generated from use.counter.page.fe_convolve_matrix
   */
  /**
   * Whether a page uses the feConvolveMatrix SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_convolve_matrix(2112);

  /**
   * generated from use.counter.page.fe_diffuse_lighting
   */
  /**
   * Whether a page uses the feDiffuseLighting SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_diffuse_lighting(2113);

  /**
   * generated from use.counter.page.fe_displacement_map
   */
  /**
   * Whether a page uses the feDisplacementMap SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_displacement_map(2114);

  /**
   * generated from use.counter.page.fe_flood
   */
  /**
   * Whether a page uses the feFlood SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_flood(2115);

  /**
   * generated from use.counter.page.fe_gaussian_blur
   */
  /**
   * Whether a page uses the feGaussianBlur SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_gaussian_blur(2116);

  /**
   * generated from use.counter.page.fe_image
   */
  /**
   * Whether a page uses the feImage SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_image(2117);

  /**
   * generated from use.counter.page.fe_merge
   */
  /**
   * Whether a page uses the feMerge SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_merge(2118);

  /**
   * generated from use.counter.page.fe_morphology
   */
  /**
   * Whether a page uses the feMorphology SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_morphology(2119);

  /**
   * generated from use.counter.page.fe_offset
   */
  /**
   * Whether a page uses the feOffset SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_offset(2120);

  /**
   * generated from use.counter.page.fe_specular_lighting
   */
  /**
   * Whether a page uses the feSpecularLighting SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_specular_lighting(2121);

  /**
   * generated from use.counter.page.fe_tile
   */
  /**
   * Whether a page uses the feTile SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_tile(2122);

  /**
   * generated from use.counter.page.fe_turbulence
   */
  /**
   * Whether a page uses the feTurbulence SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric fe_turbulence(2123);

  /**
   * generated from use.counter.page.filtered_cross_origin_iframe
   */
  /**
   * Whether a page cross-origin <iframe> within a CSS/SVG filter. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric filtered_cross_origin_iframe(2124);

  /**
   * generated from use.counter.page.get_user_media_insec
   */
  /**
   * Whether a page calls MediaDevices.getUserMedia from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric get_user_media_insec(2125);

  /**
   * generated from use.counter.page.get_user_media_unfocused
   */
  /**
   * Whether a page calls MediaDevices.getUserMedia from an unfocused document.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric get_user_media_unfocused(2126);

  /**
   * generated from use.counter.page.htmlbuttonelement_popovertargetaction
   */
  /**
   * Whether a page called called HTMLButtonElement.popoverTargetAction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetaction(2127);

  /**
   * generated from use.counter.page.htmlbuttonelement_popovertargetelement
   */
  /**
   * Whether a page called called HTMLButtonElement.popoverTargetElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlbuttonelement_popovertargetelement(2128);

  /**
   * generated from use.counter.page.htmldocument_named_getter_hit
   */
  /**
   * Whether a page calls to the named getter on HTMLDocument that find something
     * via the name lookup. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmldocument_named_getter_hit(2129);

  /**
   * generated from use.counter.page.htmlelement_attributestylemap
   */
  /**
   * Whether a page called called HTMLElement.attributeStyleMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_attributestylemap(2130);

  /**
   * generated from use.counter.page.htmlelement_hidepopover
   */
  /**
   * Whether a page called called HTMLElement.hidePopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_hidepopover(2131);

  /**
   * generated from use.counter.page.htmlelement_popover
   */
  /**
   * Whether a page called called HTMLElement.popover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_popover(2132);

  /**
   * generated from use.counter.page.htmlelement_showpopover
   */
  /**
   * Whether a page called called HTMLElement.showPopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_showpopover(2133);

  /**
   * generated from use.counter.page.htmlelement_togglepopover
   */
  /**
   * Whether a page called called HTMLElement.togglePopover. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlelement_togglepopover(2134);

  /**
   * generated from use.counter.page.htmliframeelement_loading
   */
  /**
   * Whether a page called called HTMLIFrameElement.loading. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmliframeelement_loading(2135);

  /**
   * generated from use.counter.page.htmlinputelement_capture
   */
  /**
   * Whether a page called called HTMLInputElement.capture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_capture(2136);

  /**
   * generated from use.counter.page.htmlinputelement_incremental
   */
  /**
   * Whether a page called called HTMLInputElement.incremental. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_incremental(2137);

  /**
   * generated from use.counter.page.htmlinputelement_onsearch
   */
  /**
   * Whether a page called called HTMLInputElement.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_onsearch(2138);

  /**
   * generated from use.counter.page.htmlinputelement_popovertargetaction
   */
  /**
   * Whether a page called called HTMLInputElement.popoverTargetAction. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetaction(2139);

  /**
   * generated from use.counter.page.htmlinputelement_popovertargetelement
   */
  /**
   * Whether a page called called HTMLInputElement.popoverTargetElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlinputelement_popovertargetelement(2140);

  /**
   * generated from use.counter.page.htmlinputelement_webkitdirectory
   */
  /**
   * Whether a page called called HTMLInputElement.webkitdirectory. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitdirectory(2141);

  /**
   * generated from use.counter.page.htmlinputelement_webkitentries
   */
  /**
   * Whether a page called called HTMLInputElement.webkitEntries. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlinputelement_webkitentries(2142);

  /**
   * generated from use.counter.page.htmlmediaelement_disableremoteplayback
   */
  /**
   * Whether a page called called HTMLMediaElement.disableRemotePlayback. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_disableremoteplayback(2143);

  /**
   * generated from use.counter.page.htmlmediaelement_remote
   */
  /**
   * Whether a page called called HTMLMediaElement.remote. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlmediaelement_remote(2144);

  /**
   * generated from use.counter.page.htmlvideoelement_cancelvideoframecallback
   */
  /**
   * Whether a page called called HTMLVideoElement.cancelVideoFrameCallback. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_cancelvideoframecallback(2145);

  /**
   * generated from use.counter.page.htmlvideoelement_disablepictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.disablePictureInPicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_disablepictureinpicture(2146);

  /**
   * generated from use.counter.page.htmlvideoelement_onenterpictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.onenterpictureinpicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onenterpictureinpicture(2147);

  /**
   * generated from use.counter.page.htmlvideoelement_onleavepictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.onleavepictureinpicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_onleavepictureinpicture(2148);

  /**
   * generated from use.counter.page.htmlvideoelement_playsinline
   */
  /**
   * Whether a page called called HTMLVideoElement.playsInline. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_playsinline(2149);

  /**
   * generated from use.counter.page.htmlvideoelement_requestpictureinpicture
   */
  /**
   * Whether a page called called HTMLVideoElement.requestPictureInPicture. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestpictureinpicture(2150);

  /**
   * generated from use.counter.page.htmlvideoelement_requestvideoframecallback
   */
  /**
   * Whether a page called called HTMLVideoElement.requestVideoFrameCallback.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric htmlvideoelement_requestvideoframecallback(2151);

  /**
   * generated from use.counter.page.imagedata_colorspace
   */
  /**
   * Whether a page called called ImageData.colorSpace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric imagedata_colorspace(2152);

  /**
   * generated from use.counter.page.js_asmjs
   */
  /**
   * Whether a page uses asm.js. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_asmjs(2153);

  /**
   * generated from use.counter.page.js_late_weekday
   */
  /**
   * Whether a page parses a Date with day of week in an unexpected position.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric js_late_weekday(2154);

  /**
   * generated from use.counter.page.js_wasm
   */
  /**
   * Whether a page uses WebAssembly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric js_wasm(2155);

  /**
   * generated from use.counter.page.location_ancestororigins
   */
  /**
   * Whether a page called called Location.ancestorOrigins. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric location_ancestororigins(2156);

  /**
   * generated from use.counter.page.mediadevices_enumeratedevices
   */
  /**
   * Whether a page called called MediaDevices.enumerateDevices. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_enumeratedevices(2157);

  /**
   * generated from use.counter.page.mediadevices_getdisplaymedia
   */
  /**
   * Whether a page called called MediaDevices.getDisplayMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getdisplaymedia(2158);

  /**
   * generated from use.counter.page.mediadevices_getusermedia
   */
  /**
   * Whether a page called called MediaDevices.getUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric mediadevices_getusermedia(2159);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_audio_failure
   */
  /**
   * Whether a page includes a mixed content audio element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_failure(2160);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_audio_success
   */
  /**
   * Whether a page includes a mixed content audio element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_audio_success(2161);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_image_failure
   */
  /**
   * Whether a page includes a mixed content img element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_failure(2162);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_image_success
   */
  /**
   * Whether a page includes a mixed content img element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_image_success(2163);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_video_failure
   */
  /**
   * Whether a page includes a mixed content video element that does not laod..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_failure(2164);

  /**
   * generated from use.counter.page.mixed_content_not_upgraded_video_success
   */
  /**
   * Whether a page includes a mixed content video element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_not_upgraded_video_success(2165);

  /**
   * generated from use.counter.page.mixed_content_upgraded_audio_failure
   */
  /**
   * Whether a page includes a mixed content audio element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_failure(2166);

  /**
   * generated from use.counter.page.mixed_content_upgraded_audio_success
   */
  /**
   * Whether a page includes a mixed content audio element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_audio_success(2167);

  /**
   * generated from use.counter.page.mixed_content_upgraded_image_failure
   */
  /**
   * Whether a page includes a mixed content img element that does not load..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_failure(2168);

  /**
   * generated from use.counter.page.mixed_content_upgraded_image_success
   */
  /**
   * Whether a page includes a mixed content img element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_image_success(2169);

  /**
   * generated from use.counter.page.mixed_content_upgraded_video_failure
   */
  /**
   * Whether a page includes a mixed content video element that does not laod..
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_failure(2170);

  /**
   * generated from use.counter.page.mixed_content_upgraded_video_success
   */
  /**
   * Whether a page includes a mixed content video element that loads.. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric mixed_content_upgraded_video_success(2171);

  /**
   * generated from use.counter.page.moz_get_user_media_insec
   */
  /**
   * Whether a page calls Navigator.mozGetUserMedia from an insecure context.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric moz_get_user_media_insec(2172);

  /**
   * generated from use.counter.page.navigator_canshare
   */
  /**
   * Whether a page called called Navigator.canShare. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_canshare(2173);

  /**
   * generated from use.counter.page.navigator_clearappbadge
   */
  /**
   * Whether a page called called Navigator.clearAppBadge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_clearappbadge(2174);

  /**
   * generated from use.counter.page.navigator_mozgetusermedia
   */
  /**
   * Whether a page called called Navigator.mozGetUserMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_mozgetusermedia(2175);

  /**
   * generated from use.counter.page.navigator_setappbadge
   */
  /**
   * Whether a page called called Navigator.setAppBadge. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_setappbadge(2176);

  /**
   * generated from use.counter.page.navigator_share
   */
  /**
   * Whether a page called called Navigator.share. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_share(2177);

  /**
   * generated from use.counter.page.navigator_useractivation
   */
  /**
   * Whether a page called called Navigator.userActivation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_useractivation(2178);

  /**
   * generated from use.counter.page.navigator_wakelock
   */
  /**
   * Whether a page called called Navigator.wakeLock. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric navigator_wakelock(2179);

  /**
   * generated from use.counter.page.onbounce
   */
  /**
   * Whether a page sets a <marquee> onbounce event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onbounce(2180);

  /**
   * generated from use.counter.page.ondommousescroll
   */
  /**
   * Whether a page sets DOMMouseScroll event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric ondommousescroll(2181);

  /**
   * generated from use.counter.page.onfinish
   */
  /**
   * Whether a page sets a <marquee> onfinish event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onfinish(2182);

  /**
   * generated from use.counter.page.onmozmousepixelscroll
   */
  /**
   * Whether a page sets MozMousePixelScroll event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onmozmousepixelscroll(2183);

  /**
   * generated from use.counter.page.onoverflow
   */
  /**
   * Whether a page sets an element onoverflow event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onoverflow(2184);

  /**
   * generated from use.counter.page.onstart
   */
  /**
   * Whether a page sets a <marquee> onstart event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onstart(2185);

  /**
   * generated from use.counter.page.onunderflow
   */
  /**
   * Whether a page sets an element onunderflow event listener. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric onunderflow(2186);

  /**
   * generated from use.counter.page.percentage_stroke_width_in_svg
   */
  /**
   * Whether a page whether percentage stroke-width is used in SVG elements
     * (excluding <text>). Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svg(2187);

  /**
   * generated from use.counter.page.percentage_stroke_width_in_svgtext
   */
  /**
   * Whether a page whether percentage stroke-width is used in SVG <text>. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric percentage_stroke_width_in_svgtext(2188);

  /**
   * generated from use.counter.page.private_browsing_caches_delete
   */
  /**
   * Whether a page calls caches.delete in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(2189);

  /**
   * generated from use.counter.page.private_browsing_caches_has
   */
  /**
   * Whether a page calls caches.has in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(2190);

  /**
   * generated from use.counter.page.private_browsing_caches_keys
   */
  /**
   * Whether a page calls caches.keys in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(2191);

  /**
   * generated from use.counter.page.private_browsing_caches_match
   */
  /**
   * Whether a page calls caches.match in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(2192);

  /**
   * generated from use.counter.page.private_browsing_caches_open
   */
  /**
   * Whether a page calls caches.open in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(2193);

  /**
   * generated from use.counter.page.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a page calls indexedDB.deleteDatabase in Private Browsing Mode. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(2194);

  /**
   * generated from use.counter.page.private_browsing_idbfactory_open
   */
  /**
   * Whether a page calls indexedDB.open in Private Browsing Mode. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(2195);

  /**
   * generated from use.counter.page.private_browsing_navigator_service_worker
   */
  /**
   * Whether a page accesses navigator.serviceWorker in Private Browsing Mode.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_navigator_service_worker(2196);

  /**
   * generated from use.counter.page.pushmanager_subscribe
   */
  /**
   * Whether a page called called PushManager.subscribe. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(2197);

  /**
   * generated from use.counter.page.pushsubscription_unsubscribe
   */
  /**
   * Whether a page called called PushSubscription.unsubscribe. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(2198);

  /**
   * generated from use.counter.page.range_createcontextualfragment
   */
  /**
   * Whether a page called called Range.createContextualFragment. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric range_createcontextualfragment(2199);

  /**
   * generated from use.counter.page.sanitizer_constructor
   */
  /**
   * Whether a page called called Sanitizer.constructor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_constructor(2200);

  /**
   * generated from use.counter.page.sanitizer_sanitize
   */
  /**
   * Whether a page called called Sanitizer.sanitize. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric sanitizer_sanitize(2201);

  /**
   * generated from use.counter.page.scheduler_posttask
   */
  /**
   * Whether a page called called Scheduler.postTask. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(2202);

  /**
   * generated from use.counter.page.shadowroot_pictureinpictureelement
   */
  /**
   * Whether a page called called ShadowRoot.pictureInPictureElement. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric shadowroot_pictureinpictureelement(2203);

  /**
   * generated from use.counter.page.svgsvgelement_currentscale_getter
   */
  /**
   * Whether a page got SVGSVGElement.currentScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_getter(2204);

  /**
   * generated from use.counter.page.svgsvgelement_currentscale_setter
   */
  /**
   * Whether a page set SVGSVGElement.currentScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_currentscale_setter(2205);

  /**
   * generated from use.counter.page.svgsvgelement_getelementbyid
   */
  /**
   * Whether a page called called SVGSVGElement.getElementById. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric svgsvgelement_getelementbyid(2206);

  /**
   * generated from use.counter.page.window_absoluteorientationsensor
   */
  /**
   * Whether a page called called Window.AbsoluteOrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_absoluteorientationsensor(2207);

  /**
   * generated from use.counter.page.window_accelerometer
   */
  /**
   * Whether a page called called Window.Accelerometer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_accelerometer(2208);

  /**
   * generated from use.counter.page.window_backgroundfetchmanager
   */
  /**
   * Whether a page called called Window.BackgroundFetchManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchmanager(2209);

  /**
   * generated from use.counter.page.window_backgroundfetchrecord
   */
  /**
   * Whether a page called called Window.BackgroundFetchRecord. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchrecord(2210);

  /**
   * generated from use.counter.page.window_backgroundfetchregistration
   */
  /**
   * Whether a page called called Window.BackgroundFetchRegistration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_backgroundfetchregistration(2211);

  /**
   * generated from use.counter.page.window_beforeinstallpromptevent
   */
  /**
   * Whether a page called called Window.BeforeInstallPromptEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_beforeinstallpromptevent(2212);

  /**
   * generated from use.counter.page.window_bluetooth
   */
  /**
   * Whether a page called called Window.Bluetooth. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetooth(2213);

  /**
   * generated from use.counter.page.window_bluetoothcharacteristicproperties
   */
  /**
   * Whether a page called called Window.BluetoothCharacteristicProperties. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothcharacteristicproperties(2214);

  /**
   * generated from use.counter.page.window_bluetoothdevice
   */
  /**
   * Whether a page called called Window.BluetoothDevice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothdevice(2215);

  /**
   * generated from use.counter.page.window_bluetoothremotegattcharacteristic
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTCharacteristic. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattcharacteristic(2216);

  /**
   * generated from use.counter.page.window_bluetoothremotegattdescriptor
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTDescriptor. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattdescriptor(2217);

  /**
   * generated from use.counter.page.window_bluetoothremotegattserver
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTServer. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattserver(2218);

  /**
   * generated from use.counter.page.window_bluetoothremotegattservice
   */
  /**
   * Whether a page called called Window.BluetoothRemoteGATTService. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothremotegattservice(2219);

  /**
   * generated from use.counter.page.window_bluetoothuuid
   */
  /**
   * Whether a page called called Window.BluetoothUUID. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_bluetoothuuid(2220);

  /**
   * generated from use.counter.page.window_canvascapturemediastreamtrack
   */
  /**
   * Whether a page called called Window.CanvasCaptureMediaStreamTrack. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_canvascapturemediastreamtrack(2221);

  /**
   * generated from use.counter.page.window_chrome
   */
  /**
   * Whether a page called called Window.chrome. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_chrome(2222);

  /**
   * generated from use.counter.page.window_clipboarditem
   */
  /**
   * Whether a page called called Window.ClipboardItem. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_clipboarditem(2223);

  /**
   * generated from use.counter.page.window_cssimagevalue
   */
  /**
   * Whether a page called called Window.CSSImageValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssimagevalue(2224);

  /**
   * generated from use.counter.page.window_csskeywordvalue
   */
  /**
   * Whether a page called called Window.CSSKeywordValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csskeywordvalue(2225);

  /**
   * generated from use.counter.page.window_cssmathclamp
   */
  /**
   * Whether a page called called Window.CSSMathClamp. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathclamp(2226);

  /**
   * generated from use.counter.page.window_cssmathinvert
   */
  /**
   * Whether a page called called Window.CSSMathInvert. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathinvert(2227);

  /**
   * generated from use.counter.page.window_cssmathmax
   */
  /**
   * Whether a page called called Window.CSSMathMax. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmax(2228);

  /**
   * generated from use.counter.page.window_cssmathmin
   */
  /**
   * Whether a page called called Window.CSSMathMin. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathmin(2229);

  /**
   * generated from use.counter.page.window_cssmathnegate
   */
  /**
   * Whether a page called called Window.CSSMathNegate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathnegate(2230);

  /**
   * generated from use.counter.page.window_cssmathproduct
   */
  /**
   * Whether a page called called Window.CSSMathProduct. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathproduct(2231);

  /**
   * generated from use.counter.page.window_cssmathsum
   */
  /**
   * Whether a page called called Window.CSSMathSum. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathsum(2232);

  /**
   * generated from use.counter.page.window_cssmathvalue
   */
  /**
   * Whether a page called called Window.CSSMathValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmathvalue(2233);

  /**
   * generated from use.counter.page.window_cssmatrixcomponent
   */
  /**
   * Whether a page called called Window.CSSMatrixComponent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssmatrixcomponent(2234);

  /**
   * generated from use.counter.page.window_cssnumericarray
   */
  /**
   * Whether a page called called Window.CSSNumericArray. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericarray(2235);

  /**
   * generated from use.counter.page.window_cssnumericvalue
   */
  /**
   * Whether a page called called Window.CSSNumericValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssnumericvalue(2236);

  /**
   * generated from use.counter.page.window_cssperspective
   */
  /**
   * Whether a page called called Window.CSSPerspective. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssperspective(2237);

  /**
   * generated from use.counter.page.window_csspositionvalue
   */
  /**
   * Whether a page called called Window.CSSPositionValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspositionvalue(2238);

  /**
   * generated from use.counter.page.window_csspropertyrule
   */
  /**
   * Whether a page called called Window.CSSPropertyRule. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csspropertyrule(2239);

  /**
   * generated from use.counter.page.window_cssrotate
   */
  /**
   * Whether a page called called Window.CSSRotate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssrotate(2240);

  /**
   * generated from use.counter.page.window_cssscale
   */
  /**
   * Whether a page called called Window.CSSScale. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssscale(2241);

  /**
   * generated from use.counter.page.window_cssskew
   */
  /**
   * Whether a page called called Window.CSSSkew. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskew(2242);

  /**
   * generated from use.counter.page.window_cssskewx
   */
  /**
   * Whether a page called called Window.CSSSkewX. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewx(2243);

  /**
   * generated from use.counter.page.window_cssskewy
   */
  /**
   * Whether a page called called Window.CSSSkewY. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssskewy(2244);

  /**
   * generated from use.counter.page.window_cssstylevalue
   */
  /**
   * Whether a page called called Window.CSSStyleValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssstylevalue(2245);

  /**
   * generated from use.counter.page.window_csstransformcomponent
   */
  /**
   * Whether a page called called Window.CSSTransformComponent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformcomponent(2246);

  /**
   * generated from use.counter.page.window_csstransformvalue
   */
  /**
   * Whether a page called called Window.CSSTransformValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstransformvalue(2247);

  /**
   * generated from use.counter.page.window_csstranslate
   */
  /**
   * Whether a page called called Window.CSSTranslate. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_csstranslate(2248);

  /**
   * generated from use.counter.page.window_cssunitvalue
   */
  /**
   * Whether a page called called Window.CSSUnitValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunitvalue(2249);

  /**
   * generated from use.counter.page.window_cssunparsedvalue
   */
  /**
   * Whether a page called called Window.CSSUnparsedValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssunparsedvalue(2250);

  /**
   * generated from use.counter.page.window_cssvariablereferencevalue
   */
  /**
   * Whether a page called called Window.CSSVariableReferenceValue. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_cssvariablereferencevalue(2251);

  /**
   * generated from use.counter.page.window_defaultstatus
   */
  /**
   * Whether a page called called Window.defaultStatus. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_defaultstatus(2252);

  /**
   * generated from use.counter.page.window_devicemotioneventacceleration
   */
  /**
   * Whether a page called called Window.DeviceMotionEventAcceleration. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventacceleration(2253);

  /**
   * generated from use.counter.page.window_devicemotioneventrotationrate
   */
  /**
   * Whether a page called called Window.DeviceMotionEventRotationRate. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_devicemotioneventrotationrate(2254);

  /**
   * generated from use.counter.page.window_domerror
   */
  /**
   * Whether a page called called Window.DOMError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_domerror(2255);

  /**
   * generated from use.counter.page.window_encodedvideochunk
   */
  /**
   * Whether a page called called Window.EncodedVideoChunk. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_encodedvideochunk(2256);

  /**
   * generated from use.counter.page.window_enterpictureinpictureevent
   */
  /**
   * Whether a page called called Window.EnterPictureInPictureEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_enterpictureinpictureevent(2257);

  /**
   * generated from use.counter.page.window_external
   */
  /**
   * Whether a page called called Window.External. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_external(2258);

  /**
   * generated from use.counter.page.window_federatedcredential
   */
  /**
   * Whether a page called called Window.FederatedCredential. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_federatedcredential(2259);

  /**
   * generated from use.counter.page.window_gyroscope
   */
  /**
   * Whether a page called called Window.Gyroscope. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_gyroscope(2260);

  /**
   * generated from use.counter.page.window_htmlcontentelement
   */
  /**
   * Whether a page called called Window.HTMLContentElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlcontentelement(2261);

  /**
   * generated from use.counter.page.window_htmlshadowelement
   */
  /**
   * Whether a page called called Window.HTMLShadowElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_htmlshadowelement(2262);

  /**
   * generated from use.counter.page.window_imagecapture
   */
  /**
   * Whether a page called called Window.ImageCapture. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_imagecapture(2263);

  /**
   * generated from use.counter.page.window_inputdevicecapabilities
   */
  /**
   * Whether a page called called Window.InputDeviceCapabilities. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdevicecapabilities(2264);

  /**
   * generated from use.counter.page.window_inputdeviceinfo
   */
  /**
   * Whether a page called called Window.InputDeviceInfo. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_inputdeviceinfo(2265);

  /**
   * generated from use.counter.page.window_keyboard
   */
  /**
   * Whether a page called called Window.Keyboard. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboard(2266);

  /**
   * generated from use.counter.page.window_keyboardlayoutmap
   */
  /**
   * Whether a page called called Window.KeyboardLayoutMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_keyboardlayoutmap(2267);

  /**
   * generated from use.counter.page.window_linearaccelerationsensor
   */
  /**
   * Whether a page called called Window.LinearAccelerationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_linearaccelerationsensor(2268);

  /**
   * generated from use.counter.page.window_mediasettingsrange
   */
  /**
   * Whether a page called called Window.MediaSettingsRange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_mediasettingsrange(2269);

  /**
   * generated from use.counter.page.window_midiaccess
   */
  /**
   * Whether a page called called Window.MIDIAccess. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiaccess(2270);

  /**
   * generated from use.counter.page.window_midiconnectionevent
   */
  /**
   * Whether a page called called Window.MIDIConnectionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiconnectionevent(2271);

  /**
   * generated from use.counter.page.window_midiinput
   */
  /**
   * Whether a page called called Window.MIDIInput. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinput(2272);

  /**
   * generated from use.counter.page.window_midiinputmap
   */
  /**
   * Whether a page called called Window.MIDIInputMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiinputmap(2273);

  /**
   * generated from use.counter.page.window_midimessageevent
   */
  /**
   * Whether a page called called Window.MIDIMessageEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midimessageevent(2274);

  /**
   * generated from use.counter.page.window_midioutput
   */
  /**
   * Whether a page called called Window.MIDIOutput. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutput(2275);

  /**
   * generated from use.counter.page.window_midioutputmap
   */
  /**
   * Whether a page called called Window.MIDIOutputMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midioutputmap(2276);

  /**
   * generated from use.counter.page.window_midiport
   */
  /**
   * Whether a page called called Window.MIDIPort. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_midiport(2277);

  /**
   * generated from use.counter.page.window_networkinformation
   */
  /**
   * Whether a page called called Window.NetworkInformation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_networkinformation(2278);

  /**
   * generated from use.counter.page.window_offscreenbuffering
   */
  /**
   * Whether a page called called Window.offscreenBuffering. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_offscreenbuffering(2279);

  /**
   * generated from use.counter.page.window_onbeforeinstallprompt
   */
  /**
   * Whether a page called called Window.onbeforeinstallprompt. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onbeforeinstallprompt(2280);

  /**
   * generated from use.counter.page.window_oncancel
   */
  /**
   * Whether a page called called Window.oncancel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_oncancel(2281);

  /**
   * generated from use.counter.page.window_onmousewheel
   */
  /**
   * Whether a page called called Window.onmousewheel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onmousewheel(2282);

  /**
   * generated from use.counter.page.window_onorientationchange
   */
  /**
   * Whether a page called called Window.onorientationchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onorientationchange(2283);

  /**
   * generated from use.counter.page.window_onsearch
   */
  /**
   * Whether a page called called Window.onsearch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onsearch(2284);

  /**
   * generated from use.counter.page.window_onselectionchange
   */
  /**
   * Whether a page called called Window.onselectionchange. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_onselectionchange(2285);

  /**
   * generated from use.counter.page.window_open_empty_url
   */
  /**
   * Whether a page calls window.open with an empty url argument. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_open_empty_url(2286);

  /**
   * generated from use.counter.page.window_opendatabase
   */
  /**
   * Whether a page called called Window.openDatabase. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_opendatabase(2287);

  /**
   * generated from use.counter.page.window_orientation
   */
  /**
   * Whether a page called called Window.orientation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientation(2288);

  /**
   * generated from use.counter.page.window_orientationsensor
   */
  /**
   * Whether a page called called Window.OrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_orientationsensor(2289);

  /**
   * generated from use.counter.page.window_overconstrainederror
   */
  /**
   * Whether a page called called Window.OverconstrainedError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_overconstrainederror(2290);

  /**
   * generated from use.counter.page.window_passwordcredential
   */
  /**
   * Whether a page called called Window.PasswordCredential. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_passwordcredential(2291);

  /**
   * generated from use.counter.page.window_paymentaddress
   */
  /**
   * Whether a page called called Window.PaymentAddress. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentaddress(2292);

  /**
   * generated from use.counter.page.window_paymentinstruments
   */
  /**
   * Whether a page called called Window.PaymentInstruments. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentinstruments(2293);

  /**
   * generated from use.counter.page.window_paymentmanager
   */
  /**
   * Whether a page called called Window.PaymentManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmanager(2294);

  /**
   * generated from use.counter.page.window_paymentmethodchangeevent
   */
  /**
   * Whether a page called called Window.PaymentMethodChangeEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentmethodchangeevent(2295);

  /**
   * generated from use.counter.page.window_paymentrequest
   */
  /**
   * Whether a page called called Window.PaymentRequest. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequest(2296);

  /**
   * generated from use.counter.page.window_paymentrequestupdateevent
   */
  /**
   * Whether a page called called Window.PaymentRequestUpdateEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentrequestupdateevent(2297);

  /**
   * generated from use.counter.page.window_paymentresponse
   */
  /**
   * Whether a page called called Window.PaymentResponse. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_paymentresponse(2298);

  /**
   * generated from use.counter.page.window_performancelongtasktiming
   */
  /**
   * Whether a page called called Window.PerformanceLongTaskTiming. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_performancelongtasktiming(2299);

  /**
   * generated from use.counter.page.window_photocapabilities
   */
  /**
   * Whether a page called called Window.PhotoCapabilities. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_photocapabilities(2300);

  /**
   * generated from use.counter.page.window_pictureinpictureevent
   */
  /**
   * Whether a page called called Window.PictureInPictureEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpictureevent(2301);

  /**
   * generated from use.counter.page.window_pictureinpicturewindow
   */
  /**
   * Whether a page called called Window.PictureInPictureWindow. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_pictureinpicturewindow(2302);

  /**
   * generated from use.counter.page.window_presentation
   */
  /**
   * Whether a page called called Window.Presentation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentation(2303);

  /**
   * generated from use.counter.page.window_presentationavailability
   */
  /**
   * Whether a page called called Window.PresentationAvailability. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationavailability(2304);

  /**
   * generated from use.counter.page.window_presentationconnection
   */
  /**
   * Whether a page called called Window.PresentationConnection. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnection(2305);

  /**
   * generated from use.counter.page.window_presentationconnectionavailableevent
   */
  /**
   * Whether a page called called Window.PresentationConnectionAvailableEvent.
     * Compare against `use.counter.top_level_content_documents_destroyed` to
     * calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionavailableevent(2306);

  /**
   * generated from use.counter.page.window_presentationconnectioncloseevent
   */
  /**
   * Whether a page called called Window.PresentationConnectionCloseEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_presentationconnectioncloseevent(2307);

  /**
   * generated from use.counter.page.window_presentationconnectionlist
   */
  /**
   * Whether a page called called Window.PresentationConnectionList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationconnectionlist(2308);

  /**
   * generated from use.counter.page.window_presentationreceiver
   */
  /**
   * Whether a page called called Window.PresentationReceiver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationreceiver(2309);

  /**
   * generated from use.counter.page.window_presentationrequest
   */
  /**
   * Whether a page called called Window.PresentationRequest. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_presentationrequest(2310);

  /**
   * generated from use.counter.page.window_relativeorientationsensor
   */
  /**
   * Whether a page called called Window.RelativeOrientationSensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_relativeorientationsensor(2311);

  /**
   * generated from use.counter.page.window_remoteplayback
   */
  /**
   * Whether a page called called Window.RemotePlayback. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_remoteplayback(2312);

  /**
   * generated from use.counter.page.window_report
   */
  /**
   * Whether a page called called Window.Report. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_report(2313);

  /**
   * generated from use.counter.page.window_reportbody
   */
  /**
   * Whether a page called called Window.ReportBody. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportbody(2314);

  /**
   * generated from use.counter.page.window_reportingobserver
   */
  /**
   * Whether a page called called Window.ReportingObserver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_reportingobserver(2315);

  /**
   * generated from use.counter.page.window_rtcerror
   */
  /**
   * Whether a page called called Window.RTCError. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerror(2316);

  /**
   * generated from use.counter.page.window_rtcerrorevent
   */
  /**
   * Whether a page called called Window.RTCErrorEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcerrorevent(2317);

  /**
   * generated from use.counter.page.window_rtcicetransport
   */
  /**
   * Whether a page called called Window.RTCIceTransport. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_rtcicetransport(2318);

  /**
   * generated from use.counter.page.window_rtcpeerconnectioniceerrorevent
   */
  /**
   * Whether a page called called Window.RTCPeerConnectionIceErrorEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_rtcpeerconnectioniceerrorevent(2319);

  /**
   * generated from use.counter.page.window_sensor
   */
  /**
   * Whether a page called called Window.Sensor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensor(2320);

  /**
   * generated from use.counter.page.window_sensorerrorevent
   */
  /**
   * Whether a page called called Window.SensorErrorEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sensorerrorevent(2321);

  /**
   * generated from use.counter.page.window_sidebar_getter
   */
  /**
   * Whether a page got Window.sidebar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_getter(2322);

  /**
   * generated from use.counter.page.window_sidebar_setter
   */
  /**
   * Whether a page set Window.sidebar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_sidebar_setter(2323);

  /**
   * generated from use.counter.page.window_speechrecognitionalternative
   */
  /**
   * Whether a page called called Window.SpeechRecognitionAlternative. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionalternative(2324);

  /**
   * generated from use.counter.page.window_speechrecognitionresult
   */
  /**
   * Whether a page called called Window.SpeechRecognitionResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresult(2325);

  /**
   * generated from use.counter.page.window_speechrecognitionresultlist
   */
  /**
   * Whether a page called called Window.SpeechRecognitionResultList. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_speechrecognitionresultlist(2326);

  /**
   * generated from use.counter.page.window_stylemedia
   */
  /**
   * Whether a page called called Window.styleMedia. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylemedia(2327);

  /**
   * generated from use.counter.page.window_stylepropertymap
   */
  /**
   * Whether a page called called Window.StylePropertyMap. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymap(2328);

  /**
   * generated from use.counter.page.window_stylepropertymapreadonly
   */
  /**
   * Whether a page called called Window.StylePropertyMapReadOnly. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_stylepropertymapreadonly(2329);

  /**
   * generated from use.counter.page.window_svgdiscardelement
   */
  /**
   * Whether a page called called Window.SVGDiscardElement. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_svgdiscardelement(2330);

  /**
   * generated from use.counter.page.window_syncmanager
   */
  /**
   * Whether a page called called Window.SyncManager. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_syncmanager(2331);

  /**
   * generated from use.counter.page.window_taskattributiontiming
   */
  /**
   * Whether a page called called Window.TaskAttributionTiming. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_taskattributiontiming(2332);

  /**
   * generated from use.counter.page.window_textevent
   */
  /**
   * Whether a page called called Window.TextEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_textevent(2333);

  /**
   * generated from use.counter.page.window_touch
   */
  /**
   * Whether a page called called Window.Touch. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touch(2334);

  /**
   * generated from use.counter.page.window_touchevent
   */
  /**
   * Whether a page called called Window.TouchEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchevent(2335);

  /**
   * generated from use.counter.page.window_touchlist
   */
  /**
   * Whether a page called called Window.TouchList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_touchlist(2336);

  /**
   * generated from use.counter.page.window_usb
   */
  /**
   * Whether a page called called Window.USB. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usb(2337);

  /**
   * generated from use.counter.page.window_usbalternateinterface
   */
  /**
   * Whether a page called called Window.USBAlternateInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbalternateinterface(2338);

  /**
   * generated from use.counter.page.window_usbconfiguration
   */
  /**
   * Whether a page called called Window.USBConfiguration. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconfiguration(2339);

  /**
   * generated from use.counter.page.window_usbconnectionevent
   */
  /**
   * Whether a page called called Window.USBConnectionEvent. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbconnectionevent(2340);

  /**
   * generated from use.counter.page.window_usbdevice
   */
  /**
   * Whether a page called called Window.USBDevice. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbdevice(2341);

  /**
   * generated from use.counter.page.window_usbendpoint
   */
  /**
   * Whether a page called called Window.USBEndpoint. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbendpoint(2342);

  /**
   * generated from use.counter.page.window_usbinterface
   */
  /**
   * Whether a page called called Window.USBInterface. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbinterface(2343);

  /**
   * generated from use.counter.page.window_usbintransferresult
   */
  /**
   * Whether a page called called Window.USBInTransferResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbintransferresult(2344);

  /**
   * generated from use.counter.page.window_usbisochronousintransferpacket
   */
  /**
   * Whether a page called called Window.USBIsochronousInTransferPacket. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferpacket(2345);

  /**
   * generated from use.counter.page.window_usbisochronousintransferresult
   */
  /**
   * Whether a page called called Window.USBIsochronousInTransferResult. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousintransferresult(2346);

  /**
   * generated from use.counter.page.window_usbisochronousouttransferpacket
   */
  /**
   * Whether a page called called Window.USBIsochronousOutTransferPacket. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferpacket(2347);

  /**
   * generated from use.counter.page.window_usbisochronousouttransferresult
   */
  /**
   * Whether a page called called Window.USBIsochronousOutTransferResult. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_usbisochronousouttransferresult(2348);

  /**
   * generated from use.counter.page.window_usbouttransferresult
   */
  /**
   * Whether a page called called Window.USBOutTransferResult. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_usbouttransferresult(2349);

  /**
   * generated from use.counter.page.window_useractivation
   */
  /**
   * Whether a page called called Window.UserActivation. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_useractivation(2350);

  /**
   * generated from use.counter.page.window_videocolorspace
   */
  /**
   * Whether a page called called Window.VideoColorSpace. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videocolorspace(2351);

  /**
   * generated from use.counter.page.window_videodecoder
   */
  /**
   * Whether a page called called Window.VideoDecoder. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videodecoder(2352);

  /**
   * generated from use.counter.page.window_videoencoder
   */
  /**
   * Whether a page called called Window.VideoEncoder. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoencoder(2353);

  /**
   * generated from use.counter.page.window_videoframe
   */
  /**
   * Whether a page called called Window.VideoFrame. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_videoframe(2354);

  /**
   * generated from use.counter.page.window_wakelock
   */
  /**
   * Whether a page called called Window.WakeLock. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelock(2355);

  /**
   * generated from use.counter.page.window_wakelocksentinel
   */
  /**
   * Whether a page called called Window.WakeLockSentinel. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_wakelocksentinel(2356);

  /**
   * generated from use.counter.page.window_webkitcancelanimationframe
   */
  /**
   * Whether a page called called Window.webkitCancelAnimationFrame. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitcancelanimationframe(2357);

  /**
   * generated from use.counter.page.window_webkitmediastream
   */
  /**
   * Whether a page called called Window.webkitMediaStream. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmediastream(2358);

  /**
   * generated from use.counter.page.window_webkitmutationobserver
   */
  /**
   * Whether a page called called Window.WebKitMutationObserver. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitmutationobserver(2359);

  /**
   * generated from use.counter.page.window_webkitrequestanimationframe
   */
  /**
   * Whether a page called called Window.webkitRequestAnimationFrame. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitrequestanimationframe(2360);

  /**
   * generated from use.counter.page.window_webkitrequestfilesystem
   */
  /**
   * Whether a page called called Window.webkitRequestFileSystem. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrequestfilesystem(2361);

  /**
   * generated from use.counter.page.window_webkitresolvelocalfilesystemurl
   */
  /**
   * Whether a page called called Window.webkitResolveLocalFileSystemURL. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitresolvelocalfilesystemurl(2362);

  /**
   * generated from use.counter.page.window_webkitrtcpeerconnection
   */
  /**
   * Whether a page called called Window.webkitRTCPeerConnection. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitrtcpeerconnection(2363);

  /**
   * generated from use.counter.page.window_webkitspeechgrammar
   */
  /**
   * Whether a page called called Window.webkitSpeechGrammar. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammar(2364);

  /**
   * generated from use.counter.page.window_webkitspeechgrammarlist
   */
  /**
   * Whether a page called called Window.webkitSpeechGrammarList. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechgrammarlist(2365);

  /**
   * generated from use.counter.page.window_webkitspeechrecognition
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognition. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognition(2366);

  /**
   * generated from use.counter.page.window_webkitspeechrecognitionerror
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognitionError. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionerror(2367);

  /**
   * generated from use.counter.page.window_webkitspeechrecognitionevent
   */
  /**
   * Whether a page called called Window.webkitSpeechRecognitionEvent. Compare
     * against `use.counter.top_level_content_documents_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric window_webkitspeechrecognitionevent(2368);

  /**
   * generated from use.counter.page.window_webkitstorageinfo
   */
  /**
   * Whether a page called called Window.webkitStorageInfo. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric window_webkitstorageinfo(2369);

  /**
   * generated from use.counter.page.workernavigator_permissions
   */
  /**
   * Whether a page called called WorkerNavigator.permissions. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric workernavigator_permissions(2370);

  /**
   * generated from use.counter.page.wr_filter_fallback
   */
  /**
   * Whether a page triggers the blob fallback for an SVG filter.. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric wr_filter_fallback(2371);

  /**
   * generated from use.counter.page.xslstylesheet
   */
  /**
   * Whether a page uses an XSL Stylesheet. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xslstylesheet(2372);

  /**
   * generated from use.counter.page.xsltprocessor_constructor
   */
  /**
   * Whether a page called called XSLTProcessor.constructor. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric xsltprocessor_constructor(2373);

  /**
   * generated from use.counter.page.you_tube_flash_embed
   */
  /**
   * Whether a page in <object> or <embed>. Compare against
     * `use.counter.top_level_content_documents_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric you_tube_flash_embed(2374);

}
namespace use_counter_worker_dedicated {
  /**
   * generated from use.counter.worker.dedicated.console_assert
   */
  /**
   * Whether a dedicated worker called called console.assert. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2375);

  /**
   * generated from use.counter.worker.dedicated.console_clear
   */
  /**
   * Whether a dedicated worker called called console.clear. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2376);

  /**
   * generated from use.counter.worker.dedicated.console_count
   */
  /**
   * Whether a dedicated worker called called console.count. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2377);

  /**
   * generated from use.counter.worker.dedicated.console_countreset
   */
  /**
   * Whether a dedicated worker called called console.countReset. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2378);

  /**
   * generated from use.counter.worker.dedicated.console_debug
   */
  /**
   * Whether a dedicated worker called called console.debug. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2379);

  /**
   * generated from use.counter.worker.dedicated.console_dir
   */
  /**
   * Whether a dedicated worker called called console.dir. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2380);

  /**
   * generated from use.counter.worker.dedicated.console_dirxml
   */
  /**
   * Whether a dedicated worker called called console.dirxml. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2381);

  /**
   * generated from use.counter.worker.dedicated.console_error
   */
  /**
   * Whether a dedicated worker called called console.error. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2382);

  /**
   * generated from use.counter.worker.dedicated.console_exception
   */
  /**
   * Whether a dedicated worker called called console.exception. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2383);

  /**
   * generated from use.counter.worker.dedicated.console_group
   */
  /**
   * Whether a dedicated worker called called console.group. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2384);

  /**
   * generated from use.counter.worker.dedicated.console_groupcollapsed
   */
  /**
   * Whether a dedicated worker called called console.groupCollapsed. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2385);

  /**
   * generated from use.counter.worker.dedicated.console_groupend
   */
  /**
   * Whether a dedicated worker called called console.groupEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2386);

  /**
   * generated from use.counter.worker.dedicated.console_info
   */
  /**
   * Whether a dedicated worker called called console.info. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2387);

  /**
   * generated from use.counter.worker.dedicated.console_log
   */
  /**
   * Whether a dedicated worker called called console.log. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2388);

  /**
   * generated from use.counter.worker.dedicated.console_profile
   */
  /**
   * Whether a dedicated worker called called console.profile. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2389);

  /**
   * generated from use.counter.worker.dedicated.console_profileend
   */
  /**
   * Whether a dedicated worker called called console.profileEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2390);

  /**
   * generated from use.counter.worker.dedicated.console_table
   */
  /**
   * Whether a dedicated worker called called console.table. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2391);

  /**
   * generated from use.counter.worker.dedicated.console_time
   */
  /**
   * Whether a dedicated worker called called console.time. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2392);

  /**
   * generated from use.counter.worker.dedicated.console_timeend
   */
  /**
   * Whether a dedicated worker called called console.timeEnd. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2393);

  /**
   * generated from use.counter.worker.dedicated.console_timelog
   */
  /**
   * Whether a dedicated worker called called console.timeLog. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2394);

  /**
   * generated from use.counter.worker.dedicated.console_timestamp
   */
  /**
   * Whether a dedicated worker called called console.timeStamp. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2395);

  /**
   * generated from use.counter.worker.dedicated.console_trace
   */
  /**
   * Whether a dedicated worker called called console.trace. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2396);

  /**
   * generated from use.counter.worker.dedicated.console_warn
   */
  /**
   * Whether a dedicated worker called called console.warn. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2397);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_delete
   */
  /**
   * Whether a dedicated worker calls caches.delete in Private Browsing Mode.
     * Compare against `use.counter.dedicated_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(2398);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_has
   */
  /**
   * Whether a dedicated worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(2399);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_keys
   */
  /**
   * Whether a dedicated worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(2400);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_match
   */
  /**
   * Whether a dedicated worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(2401);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_caches_open
   */
  /**
   * Whether a dedicated worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(2402);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a dedicated worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate
     * the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(2403);

  /**
   * generated from use.counter.worker.dedicated.private_browsing_idbfactory_open
   */
  /**
   * Whether a dedicated worker calls indexedDB.open in Private Browsing Mode.
     * Compare against `use.counter.dedicated_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(2404);

  /**
   * generated from use.counter.worker.dedicated.pushmanager_subscribe
   */
  /**
   * Whether a dedicated worker called called PushManager.subscribe. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(2405);

  /**
   * generated from use.counter.worker.dedicated.pushsubscription_unsubscribe
   */
  /**
   * Whether a dedicated worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(2406);

  /**
   * generated from use.counter.worker.dedicated.scheduler_posttask
   */
  /**
   * Whether a dedicated worker called called Scheduler.postTask. Compare against
     * `use.counter.dedicated_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(2407);

}
namespace use_counter_worker_service {
  /**
   * generated from use.counter.worker.service.console_assert
   */
  /**
   * Whether a service worker called called console.assert. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2408);

  /**
   * generated from use.counter.worker.service.console_clear
   */
  /**
   * Whether a service worker called called console.clear. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2409);

  /**
   * generated from use.counter.worker.service.console_count
   */
  /**
   * Whether a service worker called called console.count. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2410);

  /**
   * generated from use.counter.worker.service.console_countreset
   */
  /**
   * Whether a service worker called called console.countReset. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2411);

  /**
   * generated from use.counter.worker.service.console_debug
   */
  /**
   * Whether a service worker called called console.debug. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2412);

  /**
   * generated from use.counter.worker.service.console_dir
   */
  /**
   * Whether a service worker called called console.dir. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2413);

  /**
   * generated from use.counter.worker.service.console_dirxml
   */
  /**
   * Whether a service worker called called console.dirxml. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2414);

  /**
   * generated from use.counter.worker.service.console_error
   */
  /**
   * Whether a service worker called called console.error. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2415);

  /**
   * generated from use.counter.worker.service.console_exception
   */
  /**
   * Whether a service worker called called console.exception. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2416);

  /**
   * generated from use.counter.worker.service.console_group
   */
  /**
   * Whether a service worker called called console.group. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2417);

  /**
   * generated from use.counter.worker.service.console_groupcollapsed
   */
  /**
   * Whether a service worker called called console.groupCollapsed. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2418);

  /**
   * generated from use.counter.worker.service.console_groupend
   */
  /**
   * Whether a service worker called called console.groupEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2419);

  /**
   * generated from use.counter.worker.service.console_info
   */
  /**
   * Whether a service worker called called console.info. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2420);

  /**
   * generated from use.counter.worker.service.console_log
   */
  /**
   * Whether a service worker called called console.log. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2421);

  /**
   * generated from use.counter.worker.service.console_profile
   */
  /**
   * Whether a service worker called called console.profile. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2422);

  /**
   * generated from use.counter.worker.service.console_profileend
   */
  /**
   * Whether a service worker called called console.profileEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2423);

  /**
   * generated from use.counter.worker.service.console_table
   */
  /**
   * Whether a service worker called called console.table. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2424);

  /**
   * generated from use.counter.worker.service.console_time
   */
  /**
   * Whether a service worker called called console.time. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2425);

  /**
   * generated from use.counter.worker.service.console_timeend
   */
  /**
   * Whether a service worker called called console.timeEnd. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2426);

  /**
   * generated from use.counter.worker.service.console_timelog
   */
  /**
   * Whether a service worker called called console.timeLog. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2427);

  /**
   * generated from use.counter.worker.service.console_timestamp
   */
  /**
   * Whether a service worker called called console.timeStamp. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2428);

  /**
   * generated from use.counter.worker.service.console_trace
   */
  /**
   * Whether a service worker called called console.trace. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2429);

  /**
   * generated from use.counter.worker.service.console_warn
   */
  /**
   * Whether a service worker called called console.warn. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2430);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_delete
   */
  /**
   * Whether a service worker calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(2431);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_has
   */
  /**
   * Whether a service worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(2432);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_keys
   */
  /**
   * Whether a service worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(2433);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_match
   */
  /**
   * Whether a service worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(2434);

  /**
   * generated from use.counter.worker.service.private_browsing_caches_open
   */
  /**
   * Whether a service worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(2435);

  /**
   * generated from use.counter.worker.service.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a service worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.service_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(2436);

  /**
   * generated from use.counter.worker.service.private_browsing_idbfactory_open
   */
  /**
   * Whether a service worker calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(2437);

  /**
   * generated from use.counter.worker.service.pushmanager_subscribe
   */
  /**
   * Whether a service worker called called PushManager.subscribe. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(2438);

  /**
   * generated from use.counter.worker.service.pushsubscription_unsubscribe
   */
  /**
   * Whether a service worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(2439);

  /**
   * generated from use.counter.worker.service.scheduler_posttask
   */
  /**
   * Whether a service worker called called Scheduler.postTask. Compare against
     * `use.counter.service_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(2440);

}
namespace use_counter_worker_shared {
  /**
   * generated from use.counter.worker.shared.console_assert
   */
  /**
   * Whether a shared worker called called console.assert. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_assert(2441);

  /**
   * generated from use.counter.worker.shared.console_clear
   */
  /**
   * Whether a shared worker called called console.clear. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_clear(2442);

  /**
   * generated from use.counter.worker.shared.console_count
   */
  /**
   * Whether a shared worker called called console.count. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_count(2443);

  /**
   * generated from use.counter.worker.shared.console_countreset
   */
  /**
   * Whether a shared worker called called console.countReset. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_countreset(2444);

  /**
   * generated from use.counter.worker.shared.console_debug
   */
  /**
   * Whether a shared worker called called console.debug. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_debug(2445);

  /**
   * generated from use.counter.worker.shared.console_dir
   */
  /**
   * Whether a shared worker called called console.dir. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dir(2446);

  /**
   * generated from use.counter.worker.shared.console_dirxml
   */
  /**
   * Whether a shared worker called called console.dirxml. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_dirxml(2447);

  /**
   * generated from use.counter.worker.shared.console_error
   */
  /**
   * Whether a shared worker called called console.error. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_error(2448);

  /**
   * generated from use.counter.worker.shared.console_exception
   */
  /**
   * Whether a shared worker called called console.exception. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_exception(2449);

  /**
   * generated from use.counter.worker.shared.console_group
   */
  /**
   * Whether a shared worker called called console.group. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_group(2450);

  /**
   * generated from use.counter.worker.shared.console_groupcollapsed
   */
  /**
   * Whether a shared worker called called console.groupCollapsed. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupcollapsed(2451);

  /**
   * generated from use.counter.worker.shared.console_groupend
   */
  /**
   * Whether a shared worker called called console.groupEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_groupend(2452);

  /**
   * generated from use.counter.worker.shared.console_info
   */
  /**
   * Whether a shared worker called called console.info. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_info(2453);

  /**
   * generated from use.counter.worker.shared.console_log
   */
  /**
   * Whether a shared worker called called console.log. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_log(2454);

  /**
   * generated from use.counter.worker.shared.console_profile
   */
  /**
   * Whether a shared worker called called console.profile. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profile(2455);

  /**
   * generated from use.counter.worker.shared.console_profileend
   */
  /**
   * Whether a shared worker called called console.profileEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_profileend(2456);

  /**
   * generated from use.counter.worker.shared.console_table
   */
  /**
   * Whether a shared worker called called console.table. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_table(2457);

  /**
   * generated from use.counter.worker.shared.console_time
   */
  /**
   * Whether a shared worker called called console.time. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_time(2458);

  /**
   * generated from use.counter.worker.shared.console_timeend
   */
  /**
   * Whether a shared worker called called console.timeEnd. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timeend(2459);

  /**
   * generated from use.counter.worker.shared.console_timelog
   */
  /**
   * Whether a shared worker called called console.timeLog. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timelog(2460);

  /**
   * generated from use.counter.worker.shared.console_timestamp
   */
  /**
   * Whether a shared worker called called console.timeStamp. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_timestamp(2461);

  /**
   * generated from use.counter.worker.shared.console_trace
   */
  /**
   * Whether a shared worker called called console.trace. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_trace(2462);

  /**
   * generated from use.counter.worker.shared.console_warn
   */
  /**
   * Whether a shared worker called called console.warn. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric console_warn(2463);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_delete
   */
  /**
   * Whether a shared worker calls caches.delete in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_delete(2464);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_has
   */
  /**
   * Whether a shared worker calls caches.has in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_has(2465);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_keys
   */
  /**
   * Whether a shared worker calls caches.keys in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_keys(2466);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_match
   */
  /**
   * Whether a shared worker calls caches.match in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_match(2467);

  /**
   * generated from use.counter.worker.shared.private_browsing_caches_open
   */
  /**
   * Whether a shared worker calls caches.open in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_caches_open(2468);

  /**
   * generated from use.counter.worker.shared.private_browsing_idbfactory_delete_database
   */
  /**
   * Whether a shared worker calls indexedDB.deleteDatabase in Private Browsing
     * Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the
     * rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_delete_database(2469);

  /**
   * generated from use.counter.worker.shared.private_browsing_idbfactory_open
   */
  /**
   * Whether a shared worker calls indexedDB.open in Private Browsing Mode. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric private_browsing_idbfactory_open(2470);

  /**
   * generated from use.counter.worker.shared.pushmanager_subscribe
   */
  /**
   * Whether a shared worker called called PushManager.subscribe. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushmanager_subscribe(2471);

  /**
   * generated from use.counter.worker.shared.pushsubscription_unsubscribe
   */
  /**
   * Whether a shared worker called called PushSubscription.unsubscribe. Compare
     * against `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric pushsubscription_unsubscribe(2472);

  /**
   * generated from use.counter.worker.shared.scheduler_posttask
   */
  /**
   * Whether a shared worker called called Scheduler.postTask. Compare against
     * `use.counter.shared_workers_destroyed` to calculate the rate.
   */
  constexpr impl::CounterMetric scheduler_posttask(2473);

}
namespace gmp {
  /**
   * generated from gmp.update_xml_fetch_result
   */
  enum class UpdateXmlFetchResultLabel: uint16_t {
      eCertPinSuccess = 0,
      eCertPinNetRequestError = 1,
      eCertPinNetTimeout = 2,
      eCertPinAbort = 3,
      eCertPinMissingData = 4,
      eCertPinFailed = 5,
      eCertPinInvalid = 6,
      eCertPinXmlParseError = 7,
      eCertPinUnknownError = 8,
      eContentSigSuccess = 9,
      eContentSigNetRequestError = 10,
      eContentSigNetTimeout = 11,
      eContentSigAbort = 12,
      eContentSigMissingData = 13,
      eContentSigFailed = 14,
      eContentSigInvalid = 15,
      eContentSigXmlParseError = 16,
      eContentSigUnknownError = 17,
      e__Other__,
    };
  /**
   * The result of Gecko fetching an update.xml from Balrog. This captures 3
     * different data points: success or failure of the request, if cert pinning or
     * content signatures were used to verify the result, and the reason for failure,
     * if the request failed.
   */
  constexpr impl::Labeled<impl::CounterMetric, UpdateXmlFetchResultLabel> update_xml_fetch_result(2474);

}
namespace codec_stats {
  /**
   * generated from codec.stats.audio_preferred_codec
   */
  /**
   * Counts the preferred audio codec being signaled to us to identify preferred
     * audio codec.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> audio_preferred_codec(2475);

  /**
   * generated from codec.stats.other_fec_signaled
   */
  /**
   * Count how many other fec options are being offered.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> other_fec_signaled(2476);

  /**
   * generated from codec.stats.ulpfec_negotiated
   */
  enum class UlpfecNegotiatedLabel: uint16_t {
      eNegotiated = 0,
      eNotNegotiated = 1,
      e__Other__,
    };
  /**
   * Counts the number of times that ulpfec is negotiated or not negotiated on the
     * first negotiation for each video transceiver.
   */
  constexpr impl::Labeled<impl::CounterMetric, UlpfecNegotiatedLabel> ulpfec_negotiated(2477);

  /**
   * generated from codec.stats.video_preferred_codec
   */
  /**
   * Counts the preferred video codec being signaled to us to identify preferred
     * video codec.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> video_preferred_codec(2478);

}
namespace rtcrtpsender {
  /**
   * generated from rtcrtpsender.count
   */
  /**
   * The number of RTCRtpSenders created.
   */
  constexpr impl::DenominatorMetric count(2479);

  /**
   * generated from rtcrtpsender.count_setparameters_compat
   */
  /**
   * The number of RTCRtpSenders created that use the compatibility mode for
     * setParameters.
   */
  constexpr impl::DenominatorMetric count_setparameters_compat(2480);

  /**
   * generated from rtcrtpsender.used_sendencodings
   */
  /**
   * The proportion of RTCRtpSenders that were created by an addTransceivers call
     * that was passed a sendEncodings.
   */
  constexpr impl::NumeratorMetric used_sendencodings(2481);

}
namespace rtcrtpsender_setparameters {
  /**
   * generated from rtcrtpsender.setparameters.blame_length_changed
   */
  /**
   * The number of RTCRtpSenders that have warned at least once about a
     * `setParameters` call that attempted to change the number of encodings, broken
     * down by the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> blame_length_changed(2482);

  /**
   * generated from rtcrtpsender.setparameters.blame_no_getparameters
   */
  /**
   * The number of RTCRtpSenders that have warned at least once about a
     * `setParameters` call because `[[LastReturnedParameters]]` was not set, broken
     * down by the eTLD+1 of the site. (ie; there was not a recent enough call to
     * `getParameters`) Collected only on EARLY_BETA_OR_EARLIER.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> blame_no_getparameters(2483);

  /**
   * generated from rtcrtpsender.setparameters.blame_no_transactionid
   */
  /**
   * The number of RTCRtpSenders that have warned at least once about a
     * `setParameters` call that did not set the transactionId field, broken down by
     * the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> blame_no_transactionid(2484);

  /**
   * generated from rtcrtpsender.setparameters.fail_length_changed
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the number of encodings.
   */
  constexpr impl::NumeratorMetric fail_length_changed(2485);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_encodings
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have thrown an error at least once about a setParameters call that had no
     * encodings (we do not measure this against the general population of
     * RTCRtpSenders, since without the compat mode this failure is never observed,
     * because it fails the length change check).
   */
  constexpr impl::NumeratorMetric fail_no_encodings(2486);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_getparameters
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call because [[LastReturnedParameters]] was not set. (ie; there
     * was not a recent enough call to getParameters)
   */
  constexpr impl::NumeratorMetric fail_no_getparameters(2487);

  /**
   * generated from rtcrtpsender.setparameters.fail_no_transactionid
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that did not set the transactionId field.
   */
  constexpr impl::NumeratorMetric fail_no_transactionid(2488);

  /**
   * generated from rtcrtpsender.setparameters.fail_other
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that had no encodings.
   */
  constexpr impl::NumeratorMetric fail_other(2489);

  /**
   * generated from rtcrtpsender.setparameters.fail_rid_changed
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the rid on an encoding (note that
     * we only check this if the encoding count did not change, see
     * fail_length_changed).
   */
  constexpr impl::NumeratorMetric fail_rid_changed(2490);

  /**
   * generated from rtcrtpsender.setparameters.fail_stale_transactionid
   */
  /**
   * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that used a stale transaction id.
   */
  constexpr impl::NumeratorMetric fail_stale_transactionid(2491);

  /**
   * generated from rtcrtpsender.setparameters.warn_length_changed
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that attempted to
     * change the number of encodings.
   */
  constexpr impl::NumeratorMetric warn_length_changed(2492);

  /**
   * generated from rtcrtpsender.setparameters.warn_no_getparameters
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call because
     * [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
     * call to getParameters)
   */
  constexpr impl::NumeratorMetric warn_no_getparameters(2493);

  /**
   * generated from rtcrtpsender.setparameters.warn_no_transactionid
   */
  /**
   * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that did not set the
     * transactionId field.
   */
  constexpr impl::NumeratorMetric warn_no_transactionid(2494);

}
namespace bloburl {
  /**
   * generated from bloburl.resolve_stopped
   */
  /**
   * Counts how many times we do not resolve a blob URL because of different
     * partition keys
   */
  constexpr impl::CounterMetric resolve_stopped(2495);

}
namespace perf {
  /**
   * generated from perf.largest_contentful_paint
   */
  /**
   * Time from navigation start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint(2496);

  /**
   * generated from perf.largest_contentful_paint_from_response_start
   */
  /**
   * Time from response start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint_from_response_start(2497);

  /**
   * generated from perf.page_load
   */
    struct PageLoadExtra {
      mozilla::Maybe<uint32_t> dnsLookupTime;
      mozilla::Maybe<uint32_t> fcpTime;
      mozilla::Maybe<uint32_t> httpVer;
      mozilla::Maybe<uint32_t> jsExecTime;
      mozilla::Maybe<uint32_t> lcpTime;
      mozilla::Maybe<uint32_t> loadTime;
      mozilla::Maybe<nsCString> loadType;
      mozilla::Maybe<uint32_t> redirectCount;
      mozilla::Maybe<uint32_t> redirectTime;
      mozilla::Maybe<uint32_t> responseTime;
      mozilla::Maybe<bool> sameOriginNav;
      mozilla::Maybe<nsCString> trrDomain;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (dnsLookupTime) {
          extraKeys.AppendElement()->AssignASCII("dns_lookup_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", dnsLookupTime.value()));
        }
        if (fcpTime) {
          extraKeys.AppendElement()->AssignASCII("fcp_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", fcpTime.value()));
        }
        if (httpVer) {
          extraKeys.AppendElement()->AssignASCII("http_ver");
          extraValues.EmplaceBack(nsPrintfCString("%d", httpVer.value()));
        }
        if (jsExecTime) {
          extraKeys.AppendElement()->AssignASCII("js_exec_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", jsExecTime.value()));
        }
        if (lcpTime) {
          extraKeys.AppendElement()->AssignASCII("lcp_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", lcpTime.value()));
        }
        if (loadTime) {
          extraKeys.AppendElement()->AssignASCII("load_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", loadTime.value()));
        }
        if (loadType) {
          extraKeys.AppendElement()->AssignASCII("load_type");
          extraValues.EmplaceBack(loadType.value());
        }
        if (redirectCount) {
          extraKeys.AppendElement()->AssignASCII("redirect_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectCount.value()));
        }
        if (redirectTime) {
          extraKeys.AppendElement()->AssignASCII("redirect_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectTime.value()));
        }
        if (responseTime) {
          extraKeys.AppendElement()->AssignASCII("response_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", responseTime.value()));
        }
        if (sameOriginNav) {
          extraKeys.AppendElement()->AssignASCII("same_origin_nav");
          extraValues.AppendElement()->AssignASCII(sameOriginNav.value() ? "true" : "false");
        }
        if (trrDomain) {
          extraKeys.AppendElement()->AssignASCII("trr_domain");
          extraValues.EmplaceBack(trrDomain.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a top level content document has been loaded.
   */
  constexpr impl::EventMetric<PageLoadExtra> page_load(2498);

}
namespace paint {
  /**
   * generated from paint.build_displaylist_time
   */
  /**
   * The time to build a Gecko display list.
   */
  constexpr impl::TimingDistributionMetric build_displaylist_time(2499);

}
namespace wr {
  /**
   * generated from wr.framebuild_time
   */
  /**
   * The time to rasterize glyphs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric framebuild_time(2500);

  /**
   * generated from wr.gpu_wait_time
   */
  /**
   * The time spent waiting for the GPU to complete previously issued drawing
     * commands.
   */
  constexpr impl::TimingDistributionMetric gpu_wait_time(2501);

  /**
   * generated from wr.rasterize_blobs_time
   */
  /**
   * The time to rasterize blobs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric rasterize_blobs_time(2502);

  /**
   * generated from wr.rasterize_glyphs_time
   */
  /**
   * The time to rasterize glyphs for consumption by WebRender.
   */
  constexpr impl::TimingDistributionMetric rasterize_glyphs_time(2503);

  /**
   * generated from wr.renderer_time
   */
  /**
   * WebRender renderer time.
   */
  constexpr impl::TimingDistributionMetric renderer_time(2504);

  /**
   * generated from wr.renderer_time_no_sc
   */
  /**
   * WebRender renderer time excluding frames in which shader compilation took
     * place.
   */
  constexpr impl::TimingDistributionMetric renderer_time_no_sc(2505);

  /**
   * generated from wr.scenebuild_time
   */
  /**
   * WebRender scene build time.
   */
  constexpr impl::TimingDistributionMetric scenebuild_time(2506);

  /**
   * generated from wr.sceneswap_time
   */
  /**
   * WebRender scene swap time.
   */
  constexpr impl::TimingDistributionMetric sceneswap_time(2507);

  /**
   * generated from wr.texture_cache_update_time
   */
  /**
   * Time taken by WebRender to update the texture cache.
   */
  constexpr impl::TimingDistributionMetric texture_cache_update_time(2508);

  /**
   * generated from wr.time_to_frame_build
   */
  /**
   * Time elapsed between the construction of a transaction and the associated frame
     * build beginning.
   */
  constexpr impl::TimingDistributionMetric time_to_frame_build(2509);

  /**
   * generated from wr.time_to_render_start
   */
  /**
   * Time elapsed between the construction of a frame and the start of rendering.
   */
  constexpr impl::TimingDistributionMetric time_to_render_start(2510);

}
namespace dotprint {
  /**
   * generated from dotprint.android_dialog_requested
   */
  /**
   * Opening the Android print dialog was requested via window.print.
   */
  constexpr impl::CounterMetric android_dialog_requested(2511);

  /**
   * generated from dotprint.failure
   */
  enum class FailureLabel: uint16_t {
      eNoSettingsService = 0,
      eNoSettings = 1,
      eNoCanonicalContext = 2,
      eNoActivityContextDelegate = 3,
      eNoActivityContext = 4,
      eIoError = 5,
      eUnknown = 6,
      e__Other__,
    };
  /**
   * An error occured while setting up for printing. Default label is 'unknown'.
   */
  constexpr impl::Labeled<impl::CounterMetric, FailureLabel> failure(2512);

  /**
   * generated from dotprint.requested
   */
  /**
   * How many times window.print was requested.
   */
  constexpr impl::CounterMetric requested(2513);

}
namespace networking {
  /**
   * generated from networking.cookie_access_fixup_diff
   */
  /**
   * If we fix up a cookie lastAccessed timestamp that is in the future this metric
     * records the number of seconds that timestamp was off from NOW.
   */
  constexpr impl::CustomDistributionMetric cookie_access_fixup_diff(2514);

  /**
   * generated from networking.cookie_count_part_by_key
   */
  /**
   * A distribution of the partitioned cookies in storage belonging to a particular
     * cookie key (host + origin attributes)
   */
  constexpr impl::CustomDistributionMetric cookie_count_part_by_key(2515);

  /**
   * generated from networking.cookie_count_partitioned
   */
  /**
   * Reports the number of partitioned cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_partitioned(2516);

  /**
   * generated from networking.cookie_count_total
   */
  /**
   * Reports the total number of cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_total(2517);

  /**
   * generated from networking.cookie_count_unpart_by_key
   */
  /**
   * A distribution of the unpartitioned cookies in storage belonging to a
     * particular cookie key (host + origin attributes)
   */
  constexpr impl::CustomDistributionMetric cookie_count_unpart_by_key(2518);

  /**
   * generated from networking.cookie_count_unpartitioned
   */
  /**
   * Reports the number of unpartitioned cookies in storage
   */
  constexpr impl::CustomDistributionMetric cookie_count_unpartitioned(2519);

  /**
   * generated from networking.cookie_creation_fixup_diff
   */
  /**
   * If we fix up a cookie creation timestamp that is in the future this metric
     * records the number of seconds that timestamp was off from NOW.
   */
  constexpr impl::CustomDistributionMetric cookie_creation_fixup_diff(2520);

  /**
   * generated from networking.cookie_purge_entry_max
   */
  /**
   * A distribution of the number of cookies purged for a single host + OA entry as
     * a result of exceeding the maximum threshold for the given host + OA (single
     * purge)
   */
  constexpr impl::CustomDistributionMetric cookie_purge_entry_max(2521);

  /**
   * generated from networking.cookie_purge_max
   */
  /**
   * A distribution of the number of cookies purged across all host + OAs as a
     * result of exceeding the cookie maximum threshold (single purge)
   */
  constexpr impl::CustomDistributionMetric cookie_purge_max(2522);

  /**
   * generated from networking.cookie_timestamp_fixed_count
   */
  enum class CookieTimestampFixedCountLabel: uint16_t {
      eCreationtime = 0,
      eLastaccessed = 1,
      e__Other__,
    };
  /**
   * Counts the number of times a cookie's invalid timestamp was fixed when reading
     * it from the DB.
   */
  constexpr impl::Labeled<impl::CounterMetric, CookieTimestampFixedCountLabel> cookie_timestamp_fixed_count(2523);

  /**
   * generated from networking.dns_failed_lookup_time
   */
  /**
   * Time for an unsuccessful DNS OS resolution (msec) | Migrated from Firefox
     * Telemetry's `DNS_FAILED_LOOKUP_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_failed_lookup_time(2524);

  /**
   * generated from networking.dns_lookup_time
   */
  /**
   * Time for a successful DNS resolution (msec) | Migrated from Firefox Telemetry's
     * `DNS_LOOKUP_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_lookup_time(2525);

  /**
   * generated from networking.dns_renewal_time
   */
  /**
   * Time for a renewed DNS OS resolution (msec) | Migrated from Firefox Telemetry's
     * `DNS_RENEWAL_TIME`.
   */
  constexpr impl::TimingDistributionMetric dns_renewal_time(2526);

  /**
   * generated from networking.dns_renewal_time_for_ttl
   */
  /**
   * Time for a DNS OS resolution (msec) used to get TTL | Migrated from Firefox
     * Telemetry's `DNS_RENEWAL_TIME_FOR_TTL`.
   */
  constexpr impl::TimingDistributionMetric dns_renewal_time_for_ttl(2527);

  /**
   * generated from networking.http_1_download_throughput
   */
  /**
   * The download throughput for  http/1.0, http/1.1 requests larger than 10MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_download_throughput(2528);

  /**
   * generated from networking.http_1_upload_throughput
   */
  /**
   * The upload throughput for http/1.0, http/1.1 requests larger than 10MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput(2529);

  /**
   * generated from networking.http_1_upload_throughput_100
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size larger than 100MB.
     * Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_100(2530);

  /**
   * generated from networking.http_1_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size between 10MB and
     * 50MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_10_50(2531);

  /**
   * generated from networking.http_1_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/1.0, http/1.1 request size between 50MB and
     * 100MB. Measured in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_1_upload_throughput_50_100(2532);

  /**
   * generated from networking.http_2_download_throughput
   */
  /**
   * The download throughput for http/2 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_download_throughput(2533);

  /**
   * generated from networking.http_2_upload_throughput
   */
  /**
   * The upload throughput for http/2 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput(2534);

  /**
   * generated from networking.http_2_upload_throughput_100
   */
  /**
   * The upload throughput for http/2 request size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_100(2535);

  /**
   * generated from networking.http_2_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/2 request size between 10MB and 50MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_10_50(2536);

  /**
   * generated from networking.http_2_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/2 request size between 50MB and 100MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_2_upload_throughput_50_100(2537);

  /**
   * generated from networking.http_3_download_throughput
   */
  /**
   * The download throughput for http/3 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_download_throughput(2538);

  /**
   * generated from networking.http_3_upload_throughput
   */
  /**
   * The upload throughput for http/3 requests larger than 10MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput(2539);

  /**
   * generated from networking.http_3_upload_throughput_100
   */
  /**
   * The upload throughput for http/3 request size larger than 100MB. Measured in
     * megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_100(2540);

  /**
   * generated from networking.http_3_upload_throughput_10_50
   */
  /**
   * The upload throughput for http/3 request size between 10MB and 50MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_10_50(2541);

  /**
   * generated from networking.http_3_upload_throughput_50_100
   */
  /**
   * The upload throughput for http/3 request size between 50MB and 100MB. Measured
     * in megabits per second, Mbps.
   */
  constexpr impl::CustomDistributionMetric http_3_upload_throughput_50_100(2542);

  /**
   * generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay
   */
  /**
   * The time between processing OnDataFinished and processing OnStopRequest (if
     * OnDataFinished comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_html5parser_ondatafinished_to_onstop_delay(2543);

  /**
   * generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay_negative
   */
  /**
   * The time between processing OnStopRequest and processing OnDataFinished (if
     * OnStopRequest comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_html5parser_ondatafinished_to_onstop_delay_negative(2544);

  /**
   * generated from networking.http_content_ondatafinished_delay
   */
  /**
   * The time between dispatching OnDataFinished from the socket thread and
     * processing it.
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_delay(2545);

  /**
   * generated from networking.http_content_ondatafinished_to_onstop_delay
   */
  /**
   * The time between processing OnDataFinished and processing OnStopRequest (if
     * OnDataFinished comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_to_onstop_delay(2546);

  /**
   * generated from networking.http_content_ondatafinished_to_onstop_delay_negative
   */
  /**
   * The time between processing OnStopRequest and processing OnDataFinished (if
     * OnStopRequest comes first)
   */
  constexpr impl::TimingDistributionMetric http_content_ondatafinished_to_onstop_delay_negative(2547);

  /**
   * generated from networking.http_content_onstart_delay
   */
  /**
   * The time between dispatching OnStartRequest from the socket thread and
     * processing it on the main thread (content process).
   */
  constexpr impl::TimingDistributionMetric http_content_onstart_delay(2548);

  /**
   * generated from networking.http_content_onstop_delay
   */
  /**
   * The time between dispatching OnStopRequest from the socket thread and
     * processing it on the main thread (content process).
   */
  constexpr impl::TimingDistributionMetric http_content_onstop_delay(2549);

  /**
   * generated from networking.residual_cache_folder_count
   */
  /**
   * Counts how often we find a cache folder that wasn't purged at shutdown by a
     * background task process.
   */
  constexpr impl::CounterMetric residual_cache_folder_count(2550);

  /**
   * generated from networking.residual_cache_folder_removal
   */
  enum class ResidualCacheFolderRemovalLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      e__Other__,
    };
  /**
   * Counts how often succeed/fail in removing cache folder that wasn't purged at
     * shutdown
   */
  constexpr impl::Labeled<impl::CounterMetric, ResidualCacheFolderRemovalLabel> residual_cache_folder_removal(2551);

  /**
   * generated from networking.set_cookie
   */
  /**
   * This counts the number of times we set a cookie. Introduced as a denomenator
     * for measuring CHIPS adoption.
   */
  constexpr impl::DenominatorMetric set_cookie(2552);

  /**
   * generated from networking.set_cookie_foreign
   */
  /**
   * This counts the number of times we set a cookie from a foreign (not same-site)
     * context. Introduced as a denomenator for measuring CHIPS adoption.
   */
  constexpr impl::NumeratorMetric set_cookie_foreign(2553);

  /**
   * generated from networking.set_cookie_foreign_partitioned
   */
  /**
   * This counts the number of times we set a cookie that has the Partitioned
     * attribute in a foreign (not same-site) context. This tracks the adoption of
     * CHIPS.
   */
  constexpr impl::NumeratorMetric set_cookie_foreign_partitioned(2554);

  /**
   * generated from networking.set_cookie_partitioned
   */
  /**
   * This counts the number of times we set a cookie that has the Partitioned
     * attribute. This tracks the adoption of CHIPS.
   */
  constexpr impl::NumeratorMetric set_cookie_partitioned(2555);

  /**
   * generated from networking.speculative_connect_outcome
   */
  enum class SpeculativeConnectOutcomeLabel: uint16_t {
      eSuccessful = 0,
      eAbortedSocketLimit = 1,
      eAbortedSocketFail = 2,
      eAbortedHttpsNotEnabled = 3,
      e__Other__,
    };
  /**
   * Counts the occurrence of each outcome of a speculative connection
   */
  constexpr impl::Labeled<impl::CounterMetric, SpeculativeConnectOutcomeLabel> speculative_connect_outcome(2556);

  /**
   * generated from networking.trr_request_count
   */
  enum class TrrRequestCountLabel: uint16_t {
      eRegular = 0,
      ePrivate = 1,
      e__Other__,
    };
  /**
   * The count of successful TRR requests keyed by regular/private browsing
   */
  constexpr impl::Labeled<impl::CounterMetric, TrrRequestCountLabel> trr_request_count(2557);

}
namespace netwerk {
  /**
   * generated from netwerk.early_hints
   */
  enum class EarlyHintsLabel: uint16_t {
      eStylesheet = 0,
      eFonts = 1,
      eScripts = 2,
      eFetch = 3,
      eImage = 4,
      eOther = 5,
      e__Other__,
    };
  /**
   * Counts the different type of resources that are sent for early hints.
   */
  constexpr impl::Labeled<impl::CounterMetric, EarlyHintsLabel> early_hints(2558);

  /**
   * generated from netwerk.eh_link_type
   */
  enum class EhLinkTypeLabel: uint16_t {
      eDnsPrefetch = 0,
      eIcon = 1,
      eModulepreload = 2,
      ePreconnect = 3,
      ePrefetch = 4,
      ePreload = 5,
      ePrerender = 6,
      eStylesheet = 7,
      eOther = 8,
      e__Other__,
    };
  /**
   * Counts different type of link headers that are sent in early hint
   */
  constexpr impl::Labeled<impl::CounterMetric, EhLinkTypeLabel> eh_link_type(2559);

}
namespace network {
  /**
   * generated from network.cors_authorization_header
   */
  enum class CorsAuthorizationHeaderLabel: uint16_t {
      eAllowed = 0,
      eDisallowed = 1,
      eCoveredByWildcard = 2,
      e__Other__,
    };
  /**
   * Count how many times we see `Authorization` header in `Access-Control-Request-
     * Headers` header and the possible outcomes.
   */
  constexpr impl::Labeled<impl::CounterMetric, CorsAuthorizationHeaderLabel> cors_authorization_header(2560);

  /**
   * generated from network.data_size_pb_per_type
   */
  enum class DataSizePbPerTypeLabel: uint16_t {
      eTextHtml = 0,
      eTextCss = 1,
      eTextJson = 2,
      eTextPlain = 3,
      eTextJavascript = 4,
      eTextOther = 5,
      eAudio = 6,
      eVideo = 7,
      eMultipart = 8,
      eIcon = 9,
      eImage = 10,
      eOcsp = 11,
      eXpinstall = 12,
      eWasm = 13,
      ePdf = 14,
      eOctetStream = 15,
      eProxy = 16,
      eCompressed = 17,
      eX509 = 18,
      eApplicationOther = 19,
      e__Other__,
    };
  /**
   * Number of KB we transferred keyed by "contentType"
   */
  constexpr impl::Labeled<impl::CounterMetric, DataSizePbPerTypeLabel> data_size_pb_per_type(2561);

  /**
   * generated from network.data_size_per_type
   */
  enum class DataSizePerTypeLabel: uint16_t {
      eTextHtml = 0,
      eTextCss = 1,
      eTextJson = 2,
      eTextPlain = 3,
      eTextJavascript = 4,
      eTextOther = 5,
      eAudio = 6,
      eVideo = 7,
      eMultipart = 8,
      eIcon = 9,
      eImage = 10,
      eOcsp = 11,
      eXpinstall = 12,
      eWasm = 13,
      ePdf = 14,
      eOctetStream = 15,
      eProxy = 16,
      eCompressed = 17,
      eX509 = 18,
      eApplicationOther = 19,
      e__Other__,
    };
  /**
   * Number of KB we transferred keyed by "contentType"
   */
  constexpr impl::Labeled<impl::CounterMetric, DataSizePerTypeLabel> data_size_per_type(2562);

}
namespace data_storage {
  /**
   * generated from data_storage.entries
   */
  enum class EntriesLabel: uint16_t {
      eAlternateservices = 0,
      eClientauthrememberlist = 1,
      eSitesecurityservicestate = 2,
      e__Other__,
    };
  /**
   * Counts the number of entries stored in each nsIDataStorage.
   */
  constexpr impl::Labeled<impl::CounterMetric, EntriesLabel> entries(2563);

  /**
   * generated from data_storage.migration
   */
  enum class MigrationLabel: uint16_t {
      eAlternateservices = 0,
      eClientauthrememberlist = 1,
      eSitesecurityservicestate = 2,
      e__Other__,
    };
  /**
   * Indicates whether or not migration was successful for each nsIDataStorage.
   */
  constexpr impl::Labeled<impl::BooleanMetric, MigrationLabel> migration(2564);

}
namespace oskeystore {
  /**
   * generated from oskeystore.self_test
   */
  enum class SelfTestLabel: uint16_t {
      eGenerate = 0,
      eAvailable = 1,
      eEncrypt = 2,
      eDecrypt = 3,
      e__Other__,
    };
  /**
   * Whether or not each step of the OSKeyStore self test succeeded.
   */
  constexpr impl::Labeled<impl::BooleanMetric, SelfTestLabel> self_test(2565);

}
namespace background_tasks_rmdir_base {
  /**
   * generated from background_tasks.rmdir.base.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(2566);

  /**
   * generated from background_tasks.rmdir.base.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(2567);

  /**
   * generated from background_tasks.rmdir.base.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(2568);

  /**
   * generated from background_tasks.rmdir.base.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(2569);

  /**
   * generated from background_tasks.rmdir.base.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(2570);

  /**
   * generated from background_tasks.rmdir.base.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(2571);

  /**
   * generated from background_tasks.rmdir.base.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(2572);

  /**
   * generated from background_tasks.rmdir.base.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(2573);

}
namespace background_tasks_rmdir_http_cache {
  /**
   * generated from background_tasks.rmdir.http_cache.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(2574);

  /**
   * generated from background_tasks.rmdir.http_cache.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(2575);

  /**
   * generated from background_tasks.rmdir.http_cache.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(2576);

  /**
   * generated from background_tasks.rmdir.http_cache.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(2577);

  /**
   * generated from background_tasks.rmdir.http_cache.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(2578);

  /**
   * generated from background_tasks.rmdir.http_cache.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(2579);

  /**
   * generated from background_tasks.rmdir.http_cache.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(2580);

  /**
   * generated from background_tasks.rmdir.http_cache.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(2581);

}
namespace background_tasks_rmdir_quota {
  /**
   * generated from background_tasks.rmdir.quota.elapsed_ms
   */
  /**
   * The amount of time the task took for removing the directories.
   */
  constexpr impl::QuantityMetric elapsed_ms(2582);

  /**
   * generated from background_tasks.rmdir.quota.metric_base
   */
  /**
   * The base metric template for removeDirectory.
   */
  constexpr impl::EventMetric<NoExtraKeys> metric_base(2583);

  /**
   * generated from background_tasks.rmdir.quota.removal_count
   */
  /**
   * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
   */
  constexpr impl::QuantityMetric removal_count(2584);

  /**
   * generated from background_tasks.rmdir.quota.retry_count
   */
  /**
   * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
   */
  constexpr impl::QuantityMetric retry_count(2585);

  /**
   * generated from background_tasks.rmdir.quota.succeeded
   */
  /**
   * Whether the target directory removal succeeded.
   */
  constexpr impl::BooleanMetric succeeded(2586);

  /**
   * generated from background_tasks.rmdir.quota.suffix_ever_failed
   */
  /**
   * Whether removing the suffixed directories ever failed.
   */
  constexpr impl::BooleanMetric suffix_ever_failed(2587);

  /**
   * generated from background_tasks.rmdir.quota.suffix_removal_count
   */
  /**
   * The number of the removed entries of the suffixed directories.
   */
  constexpr impl::QuantityMetric suffix_removal_count(2588);

  /**
   * generated from background_tasks.rmdir.quota.was_first
   */
  /**
   * Whether this task is the first one removing the directory.
   */
  constexpr impl::BooleanMetric was_first(2589);

}
namespace cookie_banners {
  /**
   * generated from cookie.banners.cookie_injection_fail
   */
  /**
   * Counts how often the cookie banner is still shown even if we have injected
     * cookies.
   */
  constexpr impl::CounterMetric cookie_injection_fail(2590);

  /**
   * generated from cookie.banners.normal_window_service_mode
   */
  enum class NormalWindowServiceModeLabel: uint16_t {
      eDisabled = 0,
      eReject = 1,
      eRejectOrAccept = 2,
      eInvalid = 3,
      e__Other__,
    };
  /**
   * The pref value of the cookie banner service mode for normal windows.
   */
  constexpr impl::Labeled<impl::BooleanMetric, NormalWindowServiceModeLabel> normal_window_service_mode(2591);

  /**
   * generated from cookie.banners.private_window_service_mode
   */
  enum class PrivateWindowServiceModeLabel: uint16_t {
      eDisabled = 0,
      eReject = 1,
      eRejectOrAccept = 2,
      eInvalid = 3,
      e__Other__,
    };
  /**
   * The pref value of the cookie banner service mode for private windows.
   */
  constexpr impl::Labeled<impl::BooleanMetric, PrivateWindowServiceModeLabel> private_window_service_mode(2592);

  /**
   * generated from cookie.banners.reload
   */
    struct ReloadExtra {
      mozilla::Maybe<bool> hasClickRule;
      mozilla::Maybe<bool> hasCookieRule;
      mozilla::Maybe<bool> noRule;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasClickRule) {
          extraKeys.AppendElement()->AssignASCII("has_click_rule");
          extraValues.AppendElement()->AssignASCII(hasClickRule.value() ? "true" : "false");
        }
        if (hasCookieRule) {
          extraKeys.AppendElement()->AssignASCII("has_cookie_rule");
          extraValues.AppendElement()->AssignASCII(hasCookieRule.value() ? "true" : "false");
        }
        if (noRule) {
          extraKeys.AppendElement()->AssignASCII("no_rule");
          extraValues.AppendElement()->AssignASCII(noRule.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the top-level page is reloaded. We use this event metric to know
     * whether or not the reloading domain has cookie banner rule.
   */
  constexpr impl::EventMetric<ReloadExtra> reload(2593);

  /**
   * generated from cookie.banners.rule_lookup_by_domain
   */
  enum class RuleLookupByDomainLabel: uint16_t {
      eTopHit = 0,
      eTopHitOptIn = 1,
      eTopHitOptOut = 2,
      eTopMiss = 3,
      eIframeHit = 4,
      eIframeHitOptIn = 5,
      eIframeHitOptOut = 6,
      eIframeMiss = 7,
      eTopCookieHit = 8,
      eTopCookieHitOptIn = 9,
      eTopCookieHitOptOut = 10,
      eTopCookieMiss = 11,
      eIframeCookieHit = 12,
      eIframeCookieHitOptIn = 13,
      eIframeCookieHitOptOut = 14,
      eIframeCookieMiss = 15,
      eTopClickHit = 16,
      eTopClickHitOptIn = 17,
      eTopClickHitOptOut = 18,
      eTopClickMiss = 19,
      eIframeClickHit = 20,
      eIframeClickHitOptIn = 21,
      eIframeClickHitOptOut = 22,
      eIframeClickMiss = 23,
      e__Other__,
    };
  /**
   * Counts the number of hit/miss of cookie banner rule lookups for domain. We
     * collect three types of counters, including counters for overall rule lookup,
     * counters for cookie rule lookup and counters for click rule lookup. We also
     * divide the counter by top-level loads and iframe loads. For each domain, we
     * will only collect once.
   */
  constexpr impl::Labeled<impl::CounterMetric, RuleLookupByDomainLabel> rule_lookup_by_domain(2594);

  /**
   * generated from cookie.banners.rule_lookup_by_load
   */
  enum class RuleLookupByLoadLabel: uint16_t {
      eTopHit = 0,
      eTopHitOptIn = 1,
      eTopHitOptOut = 2,
      eTopMiss = 3,
      eIframeHit = 4,
      eIframeHitOptIn = 5,
      eIframeHitOptOut = 6,
      eIframeMiss = 7,
      eTopCookieHit = 8,
      eTopCookieHitOptIn = 9,
      eTopCookieHitOptOut = 10,
      eTopCookieMiss = 11,
      eIframeCookieHit = 12,
      eIframeCookieHitOptIn = 13,
      eIframeCookieHitOptOut = 14,
      eIframeCookieMiss = 15,
      eTopClickHit = 16,
      eTopClickHitOptIn = 17,
      eTopClickHitOptOut = 18,
      eTopClickMiss = 19,
      eIframeClickHit = 20,
      eIframeClickHitOptIn = 21,
      eIframeClickHitOptOut = 22,
      eIframeClickMiss = 23,
      e__Other__,
    };
  /**
   * Counts the number of hit/miss of cookie banner rule lookups for every load. We
     * collect three types of counters, including counters for overall rule lookup,
     * counters for cookie rule lookup and counters for click rule lookup. We also
     * divide the counter by top-level loads and iframe loads.
   */
  constexpr impl::Labeled<impl::CounterMetric, RuleLookupByLoadLabel> rule_lookup_by_load(2595);

  /**
   * generated from cookie.banners.service_detect_only
   */
  /**
   * Tracks the value of the cookiebanners.service.detectOnly pref.
   */
  constexpr impl::BooleanMetric service_detect_only(2596);

}
namespace cookie_banners_click {
  /**
   * generated from cookie.banners.click.handle_duration
   */
  /**
   * Counts how long it takes to handle cookie banners successfully from
     * DOMContentLoaded until click.
   */
  constexpr impl::TimingDistributionMetric handle_duration(2597);

  /**
   * generated from cookie.banners.click.query_selector_run_count_per_window_frame
   */
  /**
   * How often a query selector is run during the lifetime of a sub-frame content
     * window.
   */
  constexpr impl::CustomDistributionMetric query_selector_run_count_per_window_frame(2598);

  /**
   * generated from cookie.banners.click.query_selector_run_count_per_window_top_level
   */
  /**
   * How often a query selector is run during the lifetime of a top-level content
     * window.
   */
  constexpr impl::CustomDistributionMetric query_selector_run_count_per_window_top_level(2599);

  /**
   * generated from cookie.banners.click.query_selector_run_duration_per_window_frame
   */
  /**
   * Total time spent (in microseconds) on running querySelector for the lifetime of
     * a sub-frame content window.
   */
  constexpr impl::CustomDistributionMetric query_selector_run_duration_per_window_frame(2600);

  /**
   * generated from cookie.banners.click.query_selector_run_duration_per_window_top_level
   */
  /**
   * Total time spent (in microseconds) on running querySelector for the lifetime of
     * a top-level content window.
   */
  constexpr impl::CustomDistributionMetric query_selector_run_duration_per_window_top_level(2601);

  /**
   * generated from cookie.banners.click.result
   */
  enum class ResultLabel: uint16_t {
      eSuccess = 0,
      eSuccessCookieInjected = 1,
      eSuccessDomContentLoaded = 2,
      eSuccessMutationPreLoad = 3,
      eSuccessMutationPostLoad = 4,
      eFail = 5,
      eFailBannerNotFound = 6,
      eFailBannerNotVisible = 7,
      eFailButtonNotFound = 8,
      eFailNoRuleForMode = 9,
      eFailActorDestroyed = 10,
      e__Other__,
    };
  /**
   * Given a matching cookie banner rule, how often do we handle or fail to handle
     * cookie banners, labelled by reason. The 'success' and 'fail' counters count the
     * total numbers independently of the reason counters. Counters are incremented
     * after the content window has been destroyed. This metric additionally reports
     * cookie injections after which we didn't see a banner as
     * "success_cookie_injected".
   */
  constexpr impl::Labeled<impl::CounterMetric, ResultLabel> result(2602);

}
namespace cookie_banners_cmp {
  /**
   * generated from cookie.banners.cmp.detected_cmp
   */
  /**
   * Counts how often a specific cmp has been detected by our cookie banner
     * handling.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> detected_cmp(2603);

  /**
   * generated from cookie.banners.cmp.handle_duration
   */
  /**
   * Counts how long it takes to handle cookie banners successfully using CMP rules
     * from DOMContentLoaded until click. This metric is a variant of the
     * cookieBanners.click.handle_duration.
   */
  constexpr impl::TimingDistributionMetric handle_duration(2604);

  /**
   * generated from cookie.banners.cmp.ratio_handled_by_cmp_rule
   */
  /**
   * The proportion of cookie banners handled by CMP rules within the total number
     * of cases handled, including those handled by site-specific rules.
   */
  constexpr impl::RateMetric ratio_handled_by_cmp_rule(2605);

  /**
   * generated from cookie.banners.cmp.result
   */
  enum class ResultLabel: uint16_t {
      eSuccess = 0,
      eSuccessDomContentLoaded = 1,
      eSuccessMutationPreLoad = 2,
      eSuccessMutationPostLoad = 3,
      eFail = 4,
      eFailBannerNotFound = 5,
      eFailBannerNotVisible = 6,
      eFailButtonNotFound = 7,
      eFailNoRuleForMode = 8,
      eFailActorDestroyed = 9,
      e__Other__,
    };
  /**
   * Given a matching CMP rule, how often do we handle or fail to handle cookie
     * banners, labelled by reason. The 'success' and 'fail' counters count the total
     * numbers independently of the reason counters. Counters are incremented after
     * the content window has been destroyed.
   */
  constexpr impl::Labeled<impl::CounterMetric, ResultLabel> result(2606);

}
namespace crash {
  /**
   * generated from crash.process_type
   */
  /**
   * The type of process that experienced a crash. See the full list of options
     * [here](https://firefox-source-
     * docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
     * types).
   */
  constexpr impl::StringMetric process_type(2607);

  /**
   * generated from crash.startup
   */
  /**
   * If true, the crash occurred during process startup.
   */
  constexpr impl::BooleanMetric startup(2608);

  /**
   * generated from crash.time
   */
  /**
   * The time at which the crash occurred.
   */
  constexpr impl::DatetimeMetric time(2609);

  /**
   * generated from crash.uptime
   */
  /**
   * The application uptime. This is equivalent to the legacy crash ping's
     * `UptimeTS` field.
   */
  constexpr impl::TimespanMetric uptime(2610);

}
namespace extensions {
  /**
   * generated from extensions.process_event
   */
  enum class ProcessEventLabel: uint16_t {
      eCrashedBg = 0,
      eCrashedFg = 1,
      eCreatedBg = 2,
      eCreatedFg = 3,
      eCrashedOverThresholdBg = 4,
      eCrashedOverThresholdFg = 5,
      e__Other__,
    };
  /**
   * Counters for how many times the extension process has crashed or been created.
     * The labels with "_fg" / "_bg" suffixes are only recorded in Android builds,
     * while the "created" and "crashed" labels are recorded on both Desktop and
     * Android
     * builds.
   */
  constexpr impl::Labeled<impl::CounterMetric, ProcessEventLabel> process_event(2611);

  /**
   * generated from extensions.startup_cache_load_time
   */
  /**
   * Time to load and deserialize the extensions startupCache data.
   */
  constexpr impl::TimespanMetric startup_cache_load_time(2612);

  /**
   * generated from extensions.startup_cache_read_errors
   */
  /**
   * The number of times an unexpected error has been raised while reading
     * the extensions StartupCache file.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> startup_cache_read_errors(2613);

  /**
   * generated from extensions.startup_cache_write_bytelength
   */
  /**
   * The amount of bytes written to the extensions StartupCache file.
   */
  constexpr impl::QuantityMetric startup_cache_write_bytelength(2614);

  /**
   * generated from extensions.use_remote_policy
   */
  /**
   * Corresponds to the value of `WebExtensionPolicy.useRemoteWebExtensions`.
   */
  constexpr impl::BooleanMetric use_remote_policy(2615);

  /**
   * generated from extensions.use_remote_pref
   */
  /**
   * Corresponds to the value of `extensions.webextensions.remote` pref.
   */
  constexpr impl::BooleanMetric use_remote_pref(2616);

}
namespace extensions_apis_dnr {
  /**
   * generated from extensions.apis.dnr.evaluate_rules_count_max
   */
  /**
   * Max amount of DNR rules being evaluated.
   */
  constexpr impl::QuantityMetric evaluate_rules_count_max(2617);

  /**
   * generated from extensions.apis.dnr.evaluate_rules_time
   */
  /**
   * Amount of time it takes to evaluate DNR rules for one network request.
   */
  constexpr impl::TimingDistributionMetric evaluate_rules_time(2618);

  /**
   * generated from extensions.apis.dnr.startup_cache_entries
   */
  enum class StartupCacheEntriesLabel: uint16_t {
      eHit = 0,
      eMiss = 1,
      e__Other__,
    };
  /**
   * Counters for startup cache data hits or misses on initializating
     * DNR rules for extensions loaded on application startup.
   */
  constexpr impl::Labeled<impl::CounterMetric, StartupCacheEntriesLabel> startup_cache_entries(2619);

  /**
   * generated from extensions.apis.dnr.startup_cache_read_size
   */
  /**
   * Amount of data read from the DNR startup cache file.
   */
  constexpr impl::MemoryDistributionMetric startup_cache_read_size(2620);

  /**
   * generated from extensions.apis.dnr.startup_cache_read_time
   */
  /**
   * Amount of time it takes to read data into the DNR startup cache file.
   */
  constexpr impl::TimingDistributionMetric startup_cache_read_time(2621);

  /**
   * generated from extensions.apis.dnr.startup_cache_write_size
   */
  /**
   * Amount of data written to the DNR startup cache file.
   */
  constexpr impl::MemoryDistributionMetric startup_cache_write_size(2622);

  /**
   * generated from extensions.apis.dnr.startup_cache_write_time
   */
  /**
   * Amount of time it takes to write data into the DNR startup cache file.
   */
  constexpr impl::TimingDistributionMetric startup_cache_write_time(2623);

  /**
   * generated from extensions.apis.dnr.validate_rules_time
   */
  /**
   * Amount of time it takes to validate DNR rules of individual ruleset
     * when dynamic or static rulesets have been loaded from disk.
   */
  constexpr impl::TimingDistributionMetric validate_rules_time(2624);

}
namespace extensions_counters {
  /**
   * generated from extensions.counters.browser_action_preload_result
   */
  enum class BrowserActionPreloadResultLabel: uint16_t {
      ePopupshown = 0,
      eClearafterhover = 1,
      eClearaftermousedown = 2,
      e__Other__,
    };
  /**
   * Number of times an event page hit the idle timeout and results in one of the
     * labels.
   */
  constexpr impl::Labeled<impl::CounterMetric, BrowserActionPreloadResultLabel> browser_action_preload_result(2625);

  /**
   * generated from extensions.counters.event_page_idle_result
   */
  enum class EventPageIdleResultLabel: uint16_t {
      eSuspend = 0,
      eResetOther = 1,
      eResetEvent = 2,
      eResetListeners = 3,
      eResetNativeapp = 4,
      eResetStreamfilter = 5,
      eResetParentapicall = 6,
      e__Other__,
    };
  /**
   * Number of times an event page hit the idle timeout and results in one of the
     * labels.
   */
  constexpr impl::Labeled<impl::CounterMetric, EventPageIdleResultLabel> event_page_idle_result(2626);

}
namespace extensions_data {
  /**
   * generated from extensions.data.migrate_result
   */
    struct MigrateResultExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> backend;
      mozilla::Maybe<nsCString> dataMigrated;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> hasJsonfile;
      mozilla::Maybe<nsCString> hasOlddata;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (backend) {
          extraKeys.AppendElement()->AssignASCII("backend");
          extraValues.EmplaceBack(backend.value());
        }
        if (dataMigrated) {
          extraKeys.AppendElement()->AssignASCII("data_migrated");
          extraValues.EmplaceBack(dataMigrated.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (hasJsonfile) {
          extraKeys.AppendElement()->AssignASCII("has_jsonfile");
          extraValues.EmplaceBack(hasJsonfile.value());
        }
        if (hasOlddata) {
          extraKeys.AppendElement()->AssignASCII("has_olddata");
          extraValues.EmplaceBack(hasOlddata.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are sent when an extension is migrating its data to the new
     * IndexedDB backend.
   */
  constexpr impl::EventMetric<MigrateResultExtra> migrate_result(2627);

  /**
   * generated from extensions.data.storage_local_error
   */
    struct StorageLocalErrorExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> errorName;
      mozilla::Maybe<nsCString> method;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (errorName) {
          extraKeys.AppendElement()->AssignASCII("error_name");
          extraValues.EmplaceBack(errorName.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are collected when an extension triggers an unexpected error
     * while running a storage.local API call (e.g. because of some underlying
     * QuotaManager and/or IndexedDB error).
   */
  constexpr impl::EventMetric<StorageLocalErrorExtra> storage_local_error(2628);

}
namespace extensions_quarantined_domains {
  /**
   * generated from extensions.quarantined_domains.listhash
   */
  /**
   * SHA1 cryptographic hash of the quarantined domains string pref.
   */
  constexpr impl::StringMetric listhash(2629);

  /**
   * generated from extensions.quarantined_domains.listsize
   */
  /**
   * Number of domains listed in the quarantined domains list pref for the client
     * during this session.
   */
  constexpr impl::QuantityMetric listsize(2630);

  /**
   * generated from extensions.quarantined_domains.remotehash
   */
  /**
   * SHA1 cryptographic hash of the quarantined domains string pref as it was set
     * based on the value got synced from the RemoteSettings collection.
     * AMRemoteSettings will be re-processing the entries on the next application
     * startup and so this metric lifetime can be set to application and expect it to
     * be always set to the value got from the RemoteSettings collection.
   */
  constexpr impl::StringMetric remotehash(2631);

}
namespace extensions_timing {
  /**
   * generated from extensions.timing.background_page_load
   */
  /**
   * Amount of time it takes to load a WebExtensions background page, from when the
     * build function is called to when the page has finished processing the onload
     * event.
   */
  constexpr impl::TimingDistributionMetric background_page_load(2632);

  /**
   * generated from extensions.timing.browser_action_popup_open
   */
  /**
   * Amount of time it takes for a BrowserAction popup to open.
   */
  constexpr impl::TimingDistributionMetric browser_action_popup_open(2633);

  /**
   * generated from extensions.timing.content_script_injection
   */
  /**
   * Amount of time it takes for content scripts from a WebExtension to be injected
     * into a window.
   */
  constexpr impl::TimingDistributionMetric content_script_injection(2634);

  /**
   * generated from extensions.timing.event_page_running_time
   */
  /**
   * Amount of time (keyed by addon id) that an event page has been running before
     * being suspended,
     * or the entire addon shutdown.
   */
  constexpr impl::CustomDistributionMetric event_page_running_time(2635);

  /**
   * generated from extensions.timing.extension_startup
   */
  /**
   * Amount of time it takes for a WebExtension to start up, from when the
     * startup function is called to when the startup promise resolves.
   */
  constexpr impl::TimingDistributionMetric extension_startup(2636);

  /**
   * generated from extensions.timing.page_action_popup_open
   */
  /**
   * Amount of time it takes for a PageAction popup to open.
   */
  constexpr impl::TimingDistributionMetric page_action_popup_open(2637);

  /**
   * generated from extensions.timing.storage_local_get_idb
   */
  /**
   * Amount of time it takes to perform a get via storage.local using the IndexedDB
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_get_idb(2638);

  /**
   * generated from extensions.timing.storage_local_get_json
   */
  /**
   * Amount of time it takes to perform a get via storage.local using the JSONFile
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_get_json(2639);

  /**
   * generated from extensions.timing.storage_local_set_idb
   */
  /**
   * Amount of time it takes to perform a set via storage.local using the Indexed
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_set_idb(2640);

  /**
   * generated from extensions.timing.storage_local_set_json
   */
  /**
   * Amount of time it takes to perform a set via storage.local using the JSONFile
     * backend.
   */
  constexpr impl::TimingDistributionMetric storage_local_set_json(2641);

}
namespace formautofill_creditcards {
  /**
   * generated from formautofill.creditcards.autofill_profiles_count
   */
  /**
   * Count at store time how many credit card autofill profiles the user has.
   */
  constexpr impl::QuantityMetric autofill_profiles_count(2642);

  /**
   * generated from formautofill.creditcards.form_cleared
   */
    struct FormClearedExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is cleared . The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * field_name is used to record the field that triggers this event
   */
  constexpr impl::EventMetric<FormClearedExtra> form_cleared(2643);

  /**
   * generated from formautofill.creditcards.form_detected
   */
    struct FormDetectedExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<uint32_t> ccNumberMultiParts;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccNumberMultiParts) {
          extraKeys.AppendElement()->AssignASCII("cc_number_multi_parts");
          extraValues.EmplaceBack(nsPrintfCString("%d", ccNumberMultiParts.value()));
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a form is recognized as a credit card form. The possible value of
     * cc_* are "autocomplete", "undetected", "regexp" or an integer between 0-100:
     *   - When the value is "autocomplete", the field is identified via autocomplete
     * attribute
     *   - When the value is "undetected", the field is not detected in the form
     *   - When the value is "regexp", then the field is identified by regexp-based
     * heuristic
     *   - When the value is an integer greater than 0, the value indicates the
     * confidence value from fathom (normalized to 0-100)
     * The flow id points to an interaction session with a credit card form and is
     * shared across cc_form events .
   */
  constexpr impl::EventMetric<FormDetectedExtra> form_detected(2644);

  /**
   * generated from formautofill.creditcards.form_filled
   */
    struct FormFilledExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is autofilled. The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * possible value of cc_* are `filled`, `not_filled`, `user_filled` or
     * `unavailable`
   */
  constexpr impl::EventMetric<FormFilledExtra> form_filled(2645);

  /**
   * generated from formautofill.creditcards.form_filled_modified
   */
    struct FormFilledModifiedExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a field in a credit card form is autofilled and then modified by
     * the user. The flow id indicates an interaction session with the a form and is
     * shared across cc_form events. The field_name is used to record the field that
     * triggers this event.
   */
  constexpr impl::EventMetric<FormFilledModifiedExtra> form_filled_modified(2646);

  /**
   * generated from formautofill.creditcards.form_popup_shown
   */
    struct FormPopupShownExtra {
      mozilla::Maybe<nsCString> fieldName;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fieldName) {
          extraKeys.AppendElement()->AssignASCII("field_name");
          extraValues.EmplaceBack(fieldName.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when autofill popup is shown for a credit card form. The flow id
     * indicates an interaction session with the a form and is shared across cc_form
     * events. The field_name is used to record the field that triggers this event.
   */
  constexpr impl::EventMetric<FormPopupShownExtra> form_popup_shown(2647);

  /**
   * generated from formautofill.creditcards.form_submitted
   */
    struct FormSubmittedExtra {
      mozilla::Maybe<nsCString> ccExp;
      mozilla::Maybe<nsCString> ccExpMonth;
      mozilla::Maybe<nsCString> ccExpYear;
      mozilla::Maybe<nsCString> ccName;
      mozilla::Maybe<nsCString> ccNumber;
      mozilla::Maybe<nsCString> ccType;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (ccExp) {
          extraKeys.AppendElement()->AssignASCII("cc_exp");
          extraValues.EmplaceBack(ccExp.value());
        }
        if (ccExpMonth) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_month");
          extraValues.EmplaceBack(ccExpMonth.value());
        }
        if (ccExpYear) {
          extraKeys.AppendElement()->AssignASCII("cc_exp_year");
          extraValues.EmplaceBack(ccExpYear.value());
        }
        if (ccName) {
          extraKeys.AppendElement()->AssignASCII("cc_name");
          extraValues.EmplaceBack(ccName.value());
        }
        if (ccNumber) {
          extraKeys.AppendElement()->AssignASCII("cc_number");
          extraValues.EmplaceBack(ccNumber.value());
        }
        if (ccType) {
          extraKeys.AppendElement()->AssignASCII("cc_type");
          extraValues.EmplaceBack(ccType.value());
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a credit card form is submitted. The flow id indicates an
     * interaction session with the a form and is shared across cc_form events. The
     * possible value of cc_* are `autofilled`, `user_filled` or `unavailable`
   */
  constexpr impl::EventMetric<FormSubmittedExtra> form_submitted(2648);

}
namespace fog {
  /**
   * generated from fog.failed_idle_registration
   */
  /**
   * True if we failed to register with the idle service. Absent otherwise.
     * Means IPC probably isn't working well.
     * Child-process data will likely be absent, or incomplete.
   */
  constexpr impl::BooleanMetric failed_idle_registration(2649);

  /**
   * generated from fog.initialization
   */
  /**
   * Time the FOG initialization takes.
   */
  constexpr impl::TimespanMetric initialization(2650);

  /**
   * generated from fog.inits_during_shutdown
   */
  /**
   * Counts the number of times init had to be called during shutdown.
     * Should never have a value for any session long enough to grow idle.
   */
  constexpr impl::CounterMetric inits_during_shutdown(2651);

  /**
   * generated from fog.max_pings_per_minute
   */
  /**
   * Value of the configurable rate limit, in pings per minute, for Glean pings as
     * set at init.
   */
  constexpr impl::QuantityMetric max_pings_per_minute(2652);

}
namespace fog_ipc {
  /**
   * generated from fog.ipc.buffer_sizes
   */
  /**
   * The number and size of the IPC buffers being received over FOG IPC.
   */
  constexpr impl::MemoryDistributionMetric buffer_sizes(2653);

  /**
   * generated from fog.ipc.flush_durations
   */
  /**
   * The length of time between asking the child processes for their
     * IPC buffers and all of them being received by the parent.
   */
  constexpr impl::TimingDistributionMetric flush_durations(2654);

  /**
   * generated from fog.ipc.flush_failures
   */
  /**
   * The number of times we failed to flush all non-parent-process data,
     * throwing even partial results into the trash.
     * If this number is high, we might consider writing custom `MozPromise`-
     * handling code instead of using `MozPromise::All`.
   */
  constexpr impl::CounterMetric flush_failures(2655);

  /**
   * generated from fog.ipc.replay_failures
   */
  /**
   * The number of times the ipc buffer failed to be replayed in the
     * parent process.
   */
  constexpr impl::CounterMetric replay_failures(2656);

  /**
   * generated from fog.ipc.shutdown_registration_failures
   */
  /**
   * The number of times we tried to register shutdown flush routines for
     * content child processes, and failed (probably because there was no main
     * thread).
     * As a result there may be data loss from content child processes.
     * Large or rising number of clients experiencing this indicates we should
     * perhaps refactor content child shutdown in FOG to try harder to register
     * flush operations.
     * Will likely be obsoleted by bug 1641989.
   */
  constexpr impl::CounterMetric shutdown_registration_failures(2657);

}
namespace fog_validation {
  /**
   * generated from fog.validation.validate_early_event
   */
  /**
   * An event sent very early to validate that FOG is able to process it.
   */
  constexpr impl::EventMetric<NoExtraKeys> validate_early_event(2658);

}
namespace test_only {
  /**
   * generated from test_only.bad_code
   */
  /**
   * Number of times we encountered bad code.
     * This is a test-only metric.
   */
  constexpr impl::CounterMetric bad_code(2659);

  /**
   * generated from test_only.can_we_flag_it
   */
  /**
   * Test metric for a boolean.
     * This is a test-only metric.
   */
  constexpr impl::BooleanMetric can_we_flag_it(2660);

  /**
   * generated from test_only.can_we_time_it
   */
  /**
   * Test metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric can_we_time_it(2661);

  /**
   * generated from test_only.cheesy_string
   */
  /**
   * Only the cheesiest of strings.
     * This is a test-only metric.
   */
  constexpr impl::StringMetric cheesy_string(2662);

  /**
   * generated from test_only.cheesy_string_list
   */
  /**
   * Only the cheesiest of strings. In list form!
     * This is a test-only metric.
   */
  constexpr impl::StringListMetric cheesy_string_list(2663);

  /**
   * generated from test_only.do_you_remember
   */
  /**
   * They say it's the second thing to go.
     * This is a test-only metric.
   */
  constexpr impl::MemoryDistributionMetric do_you_remember(2664);

  /**
   * generated from test_only.mabels_balloon_labels
   */
  enum class MabelsBalloonLabelsLabel: uint16_t {
      eCelebratory = 0,
      eCelebratoryAndSnarky = 1,
      e__Other__,
    };
  /**
   * How does Mabel label her balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, MabelsBalloonLabelsLabel> mabels_balloon_labels(2665);

  /**
   * generated from test_only.mabels_balloon_strings
   */
  /**
   * What do the labeled Mabel's liked balloons' strings say?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> mabels_balloon_strings(2666);

  /**
   * generated from test_only.mabels_bathroom_counters
   */
  /**
   * Counts Mabels labeled by their bathroom counters.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> mabels_bathroom_counters(2667);

  /**
   * generated from test_only.mabels_kitchen_counters
   */
  /**
   * Counts Mabels labeled by their kitchen counters.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> mabels_kitchen_counters(2668);

  /**
   * generated from test_only.mabels_label_maker
   */
  /**
   * Mabel just got a label maker and wants to party like it's
     * 1999.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::StringMetric, DynamicLabel> mabels_label_maker(2669);

  /**
   * generated from test_only.mabels_labeled_counters
   */
  enum class MabelsLabeledCountersLabel: uint16_t {
      eNextToTheFridge = 0,
      eClean = 1,
      e__Other__,
    };
  /**
   * Counts Mabels labeled by their kitchen counters.
     * Now with static labels.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::CounterMetric, MabelsLabeledCountersLabel> mabels_labeled_counters(2670);

  /**
   * generated from test_only.mabels_like_balloons
   */
  /**
   * Does the labeled Mabel like balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> mabels_like_balloons(2671);

  /**
   * generated from test_only.mabels_like_labeled_balloons
   */
  enum class MabelsLikeLabeledBalloonsLabel: uint16_t {
      eWater = 0,
      eBirthdayParty = 1,
      e__Other__,
    };
  /**
   * Does the labeled Mabel like balloons?
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, MabelsLikeLabeledBalloonsLabel> mabels_like_labeled_balloons(2672);

  /**
   * generated from test_only.meaning_of_life
   */
  /**
   * Measures the one true answer to the Ultimate Question of Life,
     * the Universe, and Everything.
     * Approximately.
     * This is a test-only metric.
   */
  constexpr impl::QuantityMetric meaning_of_life(2673);

  /**
   * generated from test_only.mirror_time
   */
  /**
   * Mirrored metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric mirror_time(2674);

  /**
   * generated from test_only.mirror_time_nanos
   */
  /**
   * Mirrored metric for a timespan.
     * This is a test-only metric.
   */
  constexpr impl::TimespanMetric mirror_time_nanos(2675);

  /**
   * generated from test_only.mirrors_for_labeled_bools
   */
  /**
   * Mirrored metric.
     * This is a test-only metric.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> mirrors_for_labeled_bools(2676);

  /**
   * generated from test_only.one_ping_one_bool
   */
  /**
   * One bool for one ping only.
     * This is a test-only metric.
   */
  constexpr impl::BooleanMetric one_ping_one_bool(2677);

  /**
   * generated from test_only.what_a_date
   */
  /**
   * ...To be writing FOG code. This is a test-only metric.
   */
  constexpr impl::DatetimeMetric what_a_date(2678);

  /**
   * generated from test_only.what_id_it
   */
  /**
   * Just a UUID.
     * This is a test-only metric.
   */
  constexpr impl::UuidMetric what_id_it(2679);

  /**
   * generated from test_only.what_time_is_it
   */
  /**
   * Adheres to at least two of the top ten fallacies programmers believe
     * about time.
     * This is a test-only metric.
   */
  constexpr impl::TimingDistributionMetric what_time_is_it(2680);

}
namespace test_only_ipc {
  /**
   * generated from test_only.ipc.a_bool
   */
  /**
   * This is a test-only metric.
     * Just flagging things.
   */
  constexpr impl::BooleanMetric a_bool(2681);

  /**
   * generated from test_only.ipc.a_counter
   */
  /**
   * This is a test-only metric.
     * Just counting things.
   */
  constexpr impl::CounterMetric a_counter(2682);

  /**
   * generated from test_only.ipc.a_custom_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring samples.
   */
  constexpr impl::CustomDistributionMetric a_custom_dist(2683);

  /**
   * generated from test_only.ipc.a_date
   */
  /**
   * This is a test-only metric.
     * Just putting things on the calendar.
   */
  constexpr impl::DatetimeMetric a_date(2684);

  /**
   * generated from test_only.ipc.a_labeled_counter
   */
  /**
   * This is a test-only metric.
     * Just counting labeled things.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> a_labeled_counter(2685);

  /**
   * generated from test_only.ipc.a_memory_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring memory.
   */
  constexpr impl::MemoryDistributionMetric a_memory_dist(2686);

  /**
   * generated from test_only.ipc.a_quantity
   */
  /**
   * This is a test-only metric.
     * Just quantifying things.
   */
  constexpr impl::QuantityMetric a_quantity(2687);

  /**
   * generated from test_only.ipc.a_string
   */
  /**
   * This is a test-only metric.
     * Just setting some strings.
   */
  constexpr impl::StringMetric a_string(2688);

  /**
   * generated from test_only.ipc.a_string_list
   */
  /**
   * This is a test-only metric.
     * Just appending some strings.
   */
  constexpr impl::StringListMetric a_string_list(2689);

  /**
   * generated from test_only.ipc.a_text
   */
  /**
   * This is a test-only metric.
     * For holding Text data.
   */
  constexpr impl::TextMetric a_text(2690);

  /**
   * generated from test_only.ipc.a_timing_dist
   */
  /**
   * This is a test-only metric.
     * Just measuring time.
   */
  constexpr impl::TimingDistributionMetric a_timing_dist(2691);

  /**
   * generated from test_only.ipc.a_url
   */
  /**
   * This is a test-only metric.
     * Just setting some Urls.
   */
  constexpr impl::UrlMetric a_url(2692);

  /**
   * generated from test_only.ipc.a_uuid
   */
  /**
   * This is a test-only metric.
     * Just recording some unique identifiers.
   */
  constexpr impl::UuidMetric a_uuid(2693);

  /**
   * generated from test_only.ipc.an_event
   */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
   */
  constexpr impl::EventMetric<AnEventExtra> an_event(2694);

  /**
   * generated from test_only.ipc.an_external_denominator
   */
  /**
   * This is a test-only metric.
     * A denominator not from around here.
   */
  constexpr impl::DenominatorMetric an_external_denominator(2695);

  /**
   * generated from test_only.ipc.another_labeled_counter
   */
  /**
   * This is a test-only metric.
     * Just another metric counting labeled things.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> another_labeled_counter(2696);

  /**
   * generated from test_only.ipc.event_with_extra
   */
    struct EventWithExtraExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<uint32_t> extra2;
      mozilla::Maybe<bool> extra3LongerName;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(nsPrintfCString("%d", extra2.value()));
        }
        if (extra3LongerName) {
          extraKeys.AppendElement()->AssignASCII("extra3_longer_name");
          extraValues.AppendElement()->AssignASCII(extra3LongerName.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
   */
  constexpr impl::EventMetric<EventWithExtraExtra> event_with_extra(2697);

  /**
   * generated from test_only.ipc.irate
   */
  /**
   * This is a test-only metric.
     * A rate that isn't happy about it.
   */
  constexpr impl::RateMetric irate(2698);

  /**
   * generated from test_only.ipc.no_extra_event
   */
  /**
   * This is a test-only metric.
     * Just recording some events without the extra fuss.
   */
  constexpr impl::EventMetric<NoExtraKeys> no_extra_event(2699);

  /**
   * generated from test_only.ipc.rate_with_external_denominator
   */
  /**
   * This is a test-only metric.
     * A rate with a denominator that is Out There.
   */
  constexpr impl::NumeratorMetric rate_with_external_denominator(2700);

}
namespace test_only_jog {
  /**
   * generated from test_only.jog.a_counter
   */
  /**
   * This is a test-only metric.
     * Just counting things.
     * Tied closely to test_jog_name_collision.
   */
  constexpr impl::CounterMetric a_counter(2701);

  /**
   * generated from test_only.jog.an_event
   */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This is a test-only metric.
     * Just recording some events.
     * Tied closely to test_jog_name_collision.
   */
  constexpr impl::EventMetric<AnEventExtra> an_event(2702);

}
namespace nimbus_events {
  /**
   * generated from nimbus_events.enroll_failed
   */
    struct EnrollFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an enrollment fails, including the reason for the failure.
   */
  constexpr impl::EventMetric<EnrollFailedExtra> enroll_failed(2703);

  /**
   * generated from nimbus_events.enrollment
   */
    struct EnrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> experimentType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (experimentType) {
          extraKeys.AppendElement()->AssignASCII("experiment_type");
          extraValues.EmplaceBack(experimentType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user has met the conditions and is first bucketed into an
     * experiment (i.e. targeting matched and they were randomized into a bucket and
     * branch of the experiment). Expected a maximum of once per experiment per user.
   */
  constexpr impl::EventMetric<EnrollmentExtra> enrollment(2704);

  /**
   * generated from nimbus_events.exposure
   */
    struct ExposureExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> featureId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (featureId) {
          extraKeys.AppendElement()->AssignASCII("feature_id");
          extraValues.EmplaceBack(featureId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when a user actually observes an experimental treatment, or would have
     * observed an experimental treatment if they had been in a branch that would have
     * shown one.
   */
  constexpr impl::EventMetric<ExposureExtra> exposure(2705);

  /**
   * generated from nimbus_events.unenroll_failed
   */
    struct UnenrollFailedExtra {
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when an unenrollment fails, including the reason for the failure.
   */
  constexpr impl::EventMetric<UnenrollFailedExtra> unenroll_failed(2706);

  /**
   * generated from nimbus_events.unenrollment
   */
    struct UnenrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> changedPref;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (changedPref) {
          extraKeys.AppendElement()->AssignASCII("changed_pref");
          extraValues.EmplaceBack(changedPref.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when either telemetry is disabled, or the experiment has run for its
     * designed duration (i.e. it is no longer present in the Nimbus Remote Settings
     * collection)
   */
  constexpr impl::EventMetric<UnenrollmentExtra> unenrollment(2707);

  /**
   * generated from nimbus_events.validation_failed
   */
    struct ValidationFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> feature;
      mozilla::Maybe<nsCString> l10nIds;
      mozilla::Maybe<nsCString> locale;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (feature) {
          extraKeys.AppendElement()->AssignASCII("feature");
          extraValues.EmplaceBack(feature.value());
        }
        if (l10nIds) {
          extraKeys.AppendElement()->AssignASCII("l10n_ids");
          extraValues.EmplaceBack(l10nIds.value());
        }
        if (locale) {
          extraKeys.AppendElement()->AssignASCII("locale");
          extraValues.EmplaceBack(locale.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This records when validation of a recipe fails.
   */
  constexpr impl::EventMetric<ValidationFailedExtra> validation_failed(2708);

}
namespace pwmgr {
  /**
   * generated from pwmgr.form_autofill_result
   */
  enum class FormAutofillResultLabel: uint16_t {
      eFilled = 0,
      eNoPasswordField = 1,
      ePasswordDisabledReadonly = 2,
      eNoLoginsFit = 3,
      eNoSavedLogins = 4,
      eExistingPassword = 5,
      eExistingUsername = 6,
      eMultipleLogins = 7,
      eNoAutofillForms = 8,
      eAutocompleteOff = 9,
      eInsecure = 10,
      ePasswordAutocompleteNewPassword = 11,
      eTypeNoLongerPassword = 12,
      eFormInCrossoriginSubframe = 13,
      eFilledUsernameOnlyForm = 14,
      e__Other__,
    };
  /**
   * The result of auto-filling a login form.
   */
  constexpr impl::Labeled<impl::CounterMetric, FormAutofillResultLabel> form_autofill_result(2709);

}
namespace pdfjs {
  /**
   * generated from pdfjs.buttons
   */
  enum class ButtonsLabel: uint16_t {
      ePresentationMode = 0,
      ePresentationModeKeyboard = 1,
      eViewBookmark = 2,
      eFirstPage = 3,
      eLastPage = 4,
      ePageRotateCw = 5,
      ePageRotateCcw = 6,
      eCursorSelectTool = 7,
      eCursorHandTool = 8,
      eScrollPage = 9,
      eScrollVertical = 10,
      eScrollHorizontal = 11,
      eScrollWrapped = 12,
      eSpreadNone = 13,
      eSpreadOdd = 14,
      eSpreadEven = 15,
      eDocumentProperties = 16,
      e__Other__,
    };
  /**
   * Counts the number of times some actions are executed in the PDF viewer.
   */
  constexpr impl::Labeled<impl::CounterMetric, ButtonsLabel> buttons(2710);

  /**
   * generated from pdfjs.editing
   */
  enum class EditingLabel: uint16_t {
      eInk = 0,
      eFreetext = 1,
      eStamp = 2,
      eSave = 3,
      ePrint = 4,
      e__Other__,
    };
  /**
   * Counts the number of times some PDF editing features are used.
   */
  constexpr impl::Labeled<impl::CounterMetric, EditingLabel> editing(2711);

  /**
   * generated from pdfjs.geckoview
   */
  enum class GeckoviewLabel: uint16_t {
      eDownloadTapped = 0,
      eOpenInAppTapped = 1,
      eOpenInAppJustOnce = 2,
      eOpenInAppAlways = 3,
      eDownloadFailed = 4,
      eDownloadSucceeded = 5,
      eSaveAsPdfTapped = 6,
      e__Other__,
    };
  /**
   * Counts the number of times some actions are executed in the PDF viewer.
   */
  constexpr impl::Labeled<impl::CounterMetric, GeckoviewLabel> geckoview(2712);

  /**
   * generated from pdfjs.stamp
   */
  enum class StampLabel: uint16_t {
      eInsertedImage = 0,
      eAltTextSave = 1,
      eAltTextCancel = 2,
      eAltTextTooltip = 3,
      eAltTextEdit = 4,
      eAltTextDescription = 5,
      eAltTextDecorative = 6,
      eAltTextKeyboard = 7,
      e__Other__,
    };
  /**
   * Counts the number of times some PDF editing features are used.
   */
  constexpr impl::Labeled<impl::CounterMetric, StampLabel> stamp(2713);

  /**
   * generated from pdfjs.time_to_view
   */
  /**
   * Time spent to display first page in PDF Viewer (ms).
   */
  constexpr impl::CustomDistributionMetric time_to_view(2714);

  /**
   * generated from pdfjs.used
   */
  /**
   * How many times PDF Viewer was used.
   */
  constexpr impl::CounterMetric used(2715);

}
namespace power {
  /**
   * generated from power.cpu_time_bogus_values
   */
  /**
   * Impossibly large CPU time values that were discarded.
   */
  constexpr impl::CounterMetric cpu_time_bogus_values(2716);

  /**
   * generated from power.cpu_time_per_process_type_ms
   */
  enum class CpuTimePerProcessTypeMsLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * CPU time used by each process type in ms.
   */
  constexpr impl::Labeled<impl::CounterMetric, CpuTimePerProcessTypeMsLabel> cpu_time_per_process_type_ms(2717);

  /**
   * generated from power.cpu_time_per_tracker_type_ms
   */
  enum class CpuTimePerTrackerTypeMsLabel: uint16_t {
      eAd = 0,
      eAnalytics = 1,
      eCryptomining = 2,
      eFingerprinting = 3,
      eSocial = 4,
      eUnknown = 5,
      e__Other__,
    };
  /**
   * CPU time used by content processes used only for tracking resources, labeled by
     * the category of the tracker.
   */
  constexpr impl::Labeled<impl::CounterMetric, CpuTimePerTrackerTypeMsLabel> cpu_time_per_tracker_type_ms(2718);

  /**
   * generated from power.gpu_time_bogus_values
   */
  /**
   * Impossibly large GPU time values that were discarded.
   */
  constexpr impl::CounterMetric gpu_time_bogus_values(2719);

  /**
   * generated from power.gpu_time_per_process_type_ms
   */
  enum class GpuTimePerProcessTypeMsLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * GPU time used by each process type in ms.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuTimePerProcessTypeMsLabel> gpu_time_per_process_type_ms(2720);

  /**
   * generated from power.total_cpu_time_ms
   */
  /**
   * Total CPU time used by all processes in ms.
   */
  constexpr impl::CounterMetric total_cpu_time_ms(2721);

  /**
   * generated from power.total_gpu_time_ms
   */
  /**
   * Total GPU time used by all processes in ms.
   */
  constexpr impl::CounterMetric total_gpu_time_ms(2722);

  /**
   * generated from power.total_thread_wakeups
   */
  /**
   * How many times threads woke up and could have woken up a CPU core.
   */
  constexpr impl::CounterMetric total_thread_wakeups(2723);

  /**
   * generated from power.wakeups_per_process_type
   */
  enum class WakeupsPerProcessTypeLabel: uint16_t {
      eParentActive = 0,
      eParentActivePlayingAudio = 1,
      eParentActivePlayingVideo = 2,
      eParentInactive = 3,
      eParentInactivePlayingAudio = 4,
      eParentInactivePlayingVideo = 5,
      ePrealloc = 6,
      ePrivilegedabout = 7,
      eRdd = 8,
      eSocket = 9,
      eWebBackground = 10,
      eWebBackgroundPerceivable = 11,
      eWebForeground = 12,
      eExtension = 13,
      eGpu = 14,
      eGmplugin = 15,
      eUtility = 16,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, WakeupsPerProcessTypeLabel> wakeups_per_process_type(2724);

}
namespace power_battery {
  /**
   * generated from power.battery.percentage_when_user_active
   */
  /**
   * Records how many percent of battery was available for each period of user
     * activity.
   */
  constexpr impl::CustomDistributionMetric percentage_when_user_active(2725);

}
namespace power_cpu_ms_per_thread {
  /**
   * generated from power.cpu_ms_per_thread.content_background
   */
  enum class ContentBackgroundLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentBackgroundLabel> content_background(2726);

  /**
   * generated from power.cpu_ms_per_thread.content_foreground
   */
  enum class ContentForegroundLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentForegroundLabel> content_foreground(2727);

  /**
   * generated from power.cpu_ms_per_thread.gpu_process
   */
  enum class GpuProcessLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuProcessLabel> gpu_process(2728);

  /**
   * generated from power.cpu_ms_per_thread.parent_active
   */
  enum class ParentActiveLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentActiveLabel> parent_active(2729);

  /**
   * generated from power.cpu_ms_per_thread.parent_inactive
   */
  enum class ParentInactiveLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentInactiveLabel> parent_inactive(2730);

}
namespace power_wakeups_per_thread {
  /**
   * generated from power.wakeups_per_thread.content_background
   */
  enum class ContentBackgroundLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentBackgroundLabel> content_background(2731);

  /**
   * generated from power.wakeups_per_thread.content_foreground
   */
  enum class ContentForegroundLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ContentForegroundLabel> content_foreground(2732);

  /**
   * generated from power.wakeups_per_thread.gpu_process
   */
  enum class GpuProcessLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, GpuProcessLabel> gpu_process(2733);

  /**
   * generated from power.wakeups_per_thread.parent_active
   */
  enum class ParentActiveLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentActiveLabel> parent_active(2734);

  /**
   * generated from power.wakeups_per_thread.parent_inactive
   */
  enum class ParentInactiveLabel: uint16_t {
      eAsynclogger = 0,
      eAudioipc = 1,
      eAudioipcCallbackRpc = 2,
      eAudioipcClientCallback = 3,
      eAudioipcClientRpc = 4,
      eAudioipcDevicecollectionRpc = 5,
      eAudioipcServerCallback = 6,
      eAudioipcServerRpc = 7,
      eBackgroundthreadpool = 8,
      eBgiothreadpool = 9,
      eBgreadurls = 10,
      eBhmgrMonitor = 11,
      eBhmgrProcessor = 12,
      eCamerasIpc = 13,
      eCapturethread = 14,
      eClassifierUpdate = 15,
      eComMta = 16,
      eCompositor = 17,
      eCookie = 18,
      eCubeboperation = 19,
      eDatachannelIo = 20,
      eDnsResolver = 21,
      eDomWorker = 22,
      eDomcachethread = 23,
      eExtensionprotocolhandler = 24,
      eFontLoader = 25,
      eFontenumthread = 26,
      eFsBroker = 27,
      eGeckomain = 28,
      eGmpthread = 29,
      eGraphrunner = 30,
      eHtml5Parser = 31,
      eImagebridgechld = 32,
      eImageio = 33,
      eIndexeddb = 34,
      eInitfontlist = 35,
      eInotifyeventthread = 36,
      eIpcIOChild = 37,
      eIpcIOParent = 38,
      eIpcLaunch = 39,
      eIpdlBackground = 40,
      eJsWatchdog = 41,
      eJumpList = 42,
      eLibwebrtcmodulethread = 43,
      eLinkMonitor = 44,
      eLsThread = 45,
      eMediacache = 46,
      eMediadecoderstatemachine = 47,
      eMediapdecoder = 48,
      eMediasupervisor = 49,
      eMediatimer = 50,
      eMediatrackgrph = 51,
      eMemorypoller = 52,
      eMozstorage = 53,
      eMtransport = 54,
      eNetlinkMonitor = 55,
      ePacerthread = 56,
      ePermission = 57,
      ePlayeventsound = 58,
      eProcesshangmon = 59,
      eProfilerchild = 60,
      eProxyresolution = 61,
      eQuotamanagerIo = 62,
      eRegisterfonts = 63,
      eRemotebackbuffer = 64,
      eRemotelzystream = 65,
      eRemvidchild = 66,
      eRenderer = 67,
      eSandboxreporter = 68,
      eSavescripts = 69,
      eSocketThread = 70,
      eSoftwarevsyncthread = 71,
      eSslCert = 72,
      eStartupcache = 73,
      eStreamtrans = 74,
      eStylethread = 75,
      eSwcomposite = 76,
      eTaskcontroller = 77,
      eTimer = 78,
      eToastbgthread = 79,
      eTrrBackground = 80,
      eUntrustedModules = 81,
      eUrlClassifier = 82,
      eVideocapture = 83,
      eVsynciothread = 84,
      eWebrtccallthread = 85,
      eWebrtcworker = 86,
      eWincompositor = 87,
      eWindowsvsyncthread = 88,
      eWinwindowocclusioncalc = 89,
      eWorkerLauncher = 90,
      eWrrenderbackend = 91,
      eWrscenebuilder = 92,
      eWrscenebuilderlp = 93,
      eWrworker = 94,
      eWrworkerlp = 95,
      e__Other__,
    };
  /**
   * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
   */
  constexpr impl::Labeled<impl::CounterMetric, ParentInactiveLabel> parent_inactive(2735);

}
namespace broken_site_report {
  /**
   * generated from broken_site_report.breakage_category
   */
  /**
   * An optional select-box choice (options may eventually change)
   */
  constexpr impl::StringMetric breakage_category(2736);

  /**
   * generated from broken_site_report.description
   */
  /**
   * An optional description of the site issue the user is experiencing. May contain
     * PII.
   */
  constexpr impl::TextMetric description(2737);

  /**
   * generated from broken_site_report.url
   */
  /**
   * The URL of the site being reported. May contain PII.
   */
  constexpr impl::UrlMetric url(2738);

}
namespace broken_site_report_browser_info_app {
  /**
   * generated from broken_site_report.browser_info.app.default_locales
   */
  /**
   * Locale strings, ie `["en-US", "en"]`
   */
  constexpr impl::StringListMetric default_locales(2739);

  /**
   * generated from broken_site_report.browser_info.app.default_useragent_string
   */
  /**
   * The default user-agent string of the browser
   */
  constexpr impl::TextMetric default_useragent_string(2740);

  /**
   * generated from broken_site_report.browser_info.app.fission_enabled
   */
  /**
   * Whether Fission is enabled
   */
  constexpr impl::BooleanMetric fission_enabled(2741);

}
namespace broken_site_report_browser_info_graphics {
  /**
   * generated from broken_site_report.browser_info.graphics.device_pixel_ratio
   */
  /**
   * A decimal number
   */
  constexpr impl::StringMetric device_pixel_ratio(2742);

  /**
   * generated from broken_site_report.browser_info.graphics.devices_json
   */
  /**
   * JSON array of objects with `vendorID` and `deviceID`. For instance,
     * `[{"vendorID":"0x000", "deviceID":"0x001"}]`
   */
  constexpr impl::TextMetric devices_json(2743);

  /**
   * generated from broken_site_report.browser_info.graphics.drivers_json
   */
  /**
   * JSON array of objects with `renderer` and `version`. For instance,
     * `[{"renderer":"demo", "version":"0.2"}]`
   */
  constexpr impl::TextMetric drivers_json(2744);

  /**
   * generated from broken_site_report.browser_info.graphics.features_json
   */
  /**
   * JSON object. For instance,
     * `{"WEBRENDER":"available","WEBRENDER_PARTIAL":"disabled (User disabled via
     * pref)"}`
   */
  constexpr impl::TextMetric features_json(2745);

  /**
   * generated from broken_site_report.browser_info.graphics.has_touch_screen
   */
  /**
   * Whether a touch screen was detected
   */
  constexpr impl::BooleanMetric has_touch_screen(2746);

  /**
   * generated from broken_site_report.browser_info.graphics.monitors_json
   */
  /**
   * JSON array of objects with `screenWidth`, 'screenHeight`, and `scale`. For
     * instance, `[{"screenWidth":3584,"screenHeight":2240,"scale":2}]`
   */
  constexpr impl::TextMetric monitors_json(2747);

}
namespace broken_site_report_browser_info_prefs {
  /**
   * generated from broken_site_report.browser_info.prefs.cookie_behavior
   */
  /**
   * Value of `network.cookie.cookieBehavior`
   */
  constexpr impl::QuantityMetric cookie_behavior(2748);

  /**
   * generated from broken_site_report.browser_info.prefs.forced_accelerated_layers
   */
  /**
   * Value of `layers.acceleration_force.enabled`
   */
  constexpr impl::BooleanMetric forced_accelerated_layers(2749);

  /**
   * generated from broken_site_report.browser_info.prefs.global_privacy_control_enabled
   */
  /**
   * Value of `privacy.globalprivacycontrol.enabled`
   */
  constexpr impl::BooleanMetric global_privacy_control_enabled(2750);

  /**
   * generated from broken_site_report.browser_info.prefs.installtrigger_enabled
   */
  /**
   * Value of `extensions.InstallTrigger.enabled`
   */
  constexpr impl::BooleanMetric installtrigger_enabled(2751);

  /**
   * generated from broken_site_report.browser_info.prefs.opaque_response_blocking
   */
  /**
   * Value of `browser.opaqueResponseBlocking`
   */
  constexpr impl::BooleanMetric opaque_response_blocking(2752);

  /**
   * generated from broken_site_report.browser_info.prefs.resist_fingerprinting_enabled
   */
  /**
   * Value of `privacy.resistFingerprinting`
   */
  constexpr impl::BooleanMetric resist_fingerprinting_enabled(2753);

  /**
   * generated from broken_site_report.browser_info.prefs.software_webrender
   */
  /**
   * Value of `gfx.webrender.software`
   */
  constexpr impl::BooleanMetric software_webrender(2754);

}
namespace broken_site_report_browser_info_security {
  /**
   * generated from broken_site_report.browser_info.security.antispyware
   */
  /**
   * Which antispyware software was reported on this system.
   */
  constexpr impl::StringListMetric antispyware(2755);

  /**
   * generated from broken_site_report.browser_info.security.antivirus
   */
  /**
   * Which antivirus software was reported on this system.
   */
  constexpr impl::StringListMetric antivirus(2756);

  /**
   * generated from broken_site_report.browser_info.security.firewall
   */
  /**
   * Which firewall software was reported on this system.
   */
  constexpr impl::StringListMetric firewall(2757);

}
namespace broken_site_report_browser_info_system {
  /**
   * generated from broken_site_report.browser_info.system.is_tablet
   */
  /**
   * Whether the device is a tablet
   */
  constexpr impl::BooleanMetric is_tablet(2758);

  /**
   * generated from broken_site_report.browser_info.system.memory
   */
  /**
   * How many mb of RAM is reported for the system
   */
  constexpr impl::QuantityMetric memory(2759);

}
namespace broken_site_report_tab_info {
  /**
   * generated from broken_site_report.tab_info.languages
   */
  /**
   * The languages the site actually sees (may be overridden)
   */
  constexpr impl::StringListMetric languages(2760);

  /**
   * generated from broken_site_report.tab_info.useragent_string
   */
  /**
   * The userAgent the site actually sees (may be overridden)
   */
  constexpr impl::TextMetric useragent_string(2761);

}
namespace broken_site_report_tab_info_antitracking {
  /**
   * generated from broken_site_report.tab_info.antitracking.block_list
   */
  /**
   * Currently either `basic` or `strict`, may change in the future.
   */
  constexpr impl::StringMetric block_list(2762);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_mixed_active_content_blocked
   */
  /**
   * Whether the reported tab has any blocked mixed active content
   */
  constexpr impl::BooleanMetric has_mixed_active_content_blocked(2763);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_mixed_display_content_blocked
   */
  /**
   * Whether the reported tab has any blocked mixed display content
   */
  constexpr impl::BooleanMetric has_mixed_display_content_blocked(2764);

  /**
   * generated from broken_site_report.tab_info.antitracking.has_tracking_content_blocked
   */
  /**
   * Whether the reported tab has any blocked tracking content
   */
  constexpr impl::BooleanMetric has_tracking_content_blocked(2765);

  /**
   * generated from broken_site_report.tab_info.antitracking.is_private_browsing
   */
  /**
   * Whether the tab the user was on when reporting is in private browsing mode
   */
  constexpr impl::BooleanMetric is_private_browsing(2766);

}
namespace broken_site_report_tab_info_frameworks {
  /**
   * generated from broken_site_report.tab_info.frameworks.fastclick
   */
  /**
   * Whether the FastClick web library was detected on the original tab.
   */
  constexpr impl::BooleanMetric fastclick(2767);

  /**
   * generated from broken_site_report.tab_info.frameworks.marfeel
   */
  /**
   * Whether the Marfeel web framework was detected on the original tab.
   */
  constexpr impl::BooleanMetric marfeel(2768);

  /**
   * generated from broken_site_report.tab_info.frameworks.mobify
   */
  /**
   * Whether the Mobify web framework was detected on the original tab.
   */
  constexpr impl::BooleanMetric mobify(2769);

}
namespace webcompatreporting {
  /**
   * generated from webcompatreporting.opened
   */
    struct OpenedExtra {
      mozilla::Maybe<nsCString> source;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Records the method for opening the webcompat reporting window.
   */
  constexpr impl::EventMetric<OpenedExtra> opened(2770);

  /**
   * generated from webcompatreporting.reason_dropdown
   */
    struct ReasonDropdownExtra {
      mozilla::Maybe<nsCString> setting;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (setting) {
          extraKeys.AppendElement()->AssignASCII("setting");
          extraValues.EmplaceBack(setting.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Record whether the user has a dropdown enabled + whether the dropdown menu is
     * optional or mandatory.
   */
  constexpr impl::EventMetric<ReasonDropdownExtra> reason_dropdown(2771);

  /**
   * generated from webcompatreporting.send
   */
  /**
   * Recorded when a user selects the Send button to submit webcompat report data.
   */
  constexpr impl::EventMetric<NoExtraKeys> send(2772);

  /**
   * generated from webcompatreporting.send_more_info
   */
  /**
   * Recorded when a user clicks on the Send More Info link in the reporting UI The
     * user will be redirected to webcompat.com to submit a more comprehensive report.
     * (This is only enabled on beta/nightly/pre-release channels).
   */
  constexpr impl::EventMetric<NoExtraKeys> send_more_info(2773);

}
namespace fingerprinting_protection {
  /**
   * generated from fingerprinting.protection.canvas_noise_calculate_time
   */
  /**
   * Counts how long to generate canvas random noises.
   */
  constexpr impl::TimingDistributionMetric canvas_noise_calculate_time(2774);

}
namespace search_engine_default {
  /**
   * generated from search.engine.default.changed
   */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the default search engine is changed.
   */
  constexpr impl::EventMetric<ChangedExtra> changed(2775);

  /**
   * generated from search.engine.default.display_name
   */
  /**
   * The display name of the user's default engine.
   */
  constexpr impl::StringMetric display_name(2776);

  /**
   * generated from search.engine.default.engine_id
   */
  /**
   * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
   */
  constexpr impl::StringMetric engine_id(2777);

  /**
   * generated from search.engine.default.load_path
   */
  /**
   * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
   */
  constexpr impl::StringMetric load_path(2778);

  /**
   * generated from search.engine.default.submission_url
   */
  /**
   * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
   */
  constexpr impl::UrlMetric submission_url(2779);

  /**
   * generated from search.engine.default.verified
   */
  /**
   * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
   */
  constexpr impl::StringMetric verified(2780);

}
namespace search_engine_private {
  /**
   * generated from search.engine.private.changed
   */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Recorded when the default search engine is changed
   */
  constexpr impl::EventMetric<ChangedExtra> changed(2781);

  /**
   * generated from search.engine.private.display_name
   */
  /**
   * The display name of the user's default engine.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric display_name(2782);

  /**
   * generated from search.engine.private.engine_id
   */
  /**
   * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric engine_id(2783);

  /**
   * generated from search.engine.private.load_path
   */
  /**
   * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric load_path(2784);

  /**
   * generated from search.engine.private.submission_url
   */
  /**
   * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::UrlMetric submission_url(2785);

  /**
   * generated from search.engine.private.verified
   */
  /**
   * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
   */
  constexpr impl::StringMetric verified(2786);

}
namespace search_service {
  /**
   * generated from search.service.initialization_status
   */
  enum class InitializationStatusLabel: uint16_t {
      eFailedsettings = 0,
      eFailedfetchengines = 1,
      eFailedloadengines = 2,
      eSuccess = 3,
      e__Other__,
    };
  /**
   * Counts the type of initialization statuses on start up.
     * failedSettings - failed loading and migrating the search settings file.
     * failedFetchEngines - failed to load or parse the configuration from remote
     *                      settings.
     * failedLoadEngines - failed to create all the search engines from the
     *                     configuration or user installed engines.
     * success - search service successfully initialized.
   */
  constexpr impl::Labeled<impl::CounterMetric, InitializationStatusLabel> initialization_status(2787);

  /**
   * generated from search.service.startup_time
   */
  /**
   * The time duration it takes for the search service to start up.
   */
  constexpr impl::TimingDistributionMetric startup_time(2788);

}
namespace dap {
  /**
   * generated from dap.report_generation_status
   */
  enum class ReportGenerationStatusLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      eAbort = 2,
      eHpkeLeaderFail = 3,
      eHpkeHelperFail = 4,
      e__Other__,
    };
  /**
   * The result of trying to generate a DAP report.
   */
  constexpr impl::Labeled<impl::CounterMetric, ReportGenerationStatusLabel> report_generation_status(2789);

  /**
   * generated from dap.upload_status
   */
  enum class UploadStatusLabel: uint16_t {
      eSuccess = 0,
      eFailure = 1,
      eHttpError = 2,
      eHttp502 = 3,
      eAbort = 4,
      eAbortTimed = 5,
      eAbortShutdown = 6,
      e__Other__,
    };
  /**
   * The result of trying to upload a report to the DAP server.
   */
  constexpr impl::Labeled<impl::CounterMetric, UploadStatusLabel> upload_status(2790);

}
namespace legacy_telemetry {
  /**
   * generated from legacy.telemetry.client_id
   */
  /**
   * The client_id according to Telemetry.
     * Might not always have a value due to being too early for it to have
     * loaded.
     * Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
     * in pings near when the data upload pref is disabled (if Telemetry gets
     * to go first), or between when a client_id has been removed and when it
     * has been regenerated.
     * Does not need to be sent in the Glean "deletion-request" ping.
   */
  constexpr impl::UuidMetric client_id(2791);

}
namespace translations {
  /**
   * generated from translations.error
   */
    struct ErrorExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> reason;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * The specific translations error that caused a full-page translation failure.
   */
  constexpr impl::EventMetric<ErrorExtra> error(2792);

  /**
   * generated from translations.error_rate
   */
  /**
   * The rate of failed translations requests.
   */
  constexpr impl::NumeratorMetric error_rate(2793);

  /**
   * generated from translations.requests_count
   */
  /**
   * The count of translation requests.
   */
  constexpr impl::DenominatorMetric requests_count(2794);

  /**
   * generated from translations.restore_page
   */
    struct RestorePageExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the a restore-page event is triggered.
   */
  constexpr impl::EventMetric<RestorePageExtra> restore_page(2795);

  /**
   * generated from translations.translation_request
   */
    struct TranslationRequestExtra {
      mozilla::Maybe<bool> autoTranslate;
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> fromLanguage;
      mozilla::Maybe<nsCString> toLanguage;
      mozilla::Maybe<nsCString> topPreferredLanguage;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoTranslate) {
          extraKeys.AppendElement()->AssignASCII("auto_translate");
          extraValues.AppendElement()->AssignASCII(autoTranslate.value() ? "true" : "false");
        }
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (fromLanguage) {
          extraKeys.AppendElement()->AssignASCII("from_language");
          extraValues.EmplaceBack(fromLanguage.value());
        }
        if (toLanguage) {
          extraKeys.AppendElement()->AssignASCII("to_language");
          extraValues.EmplaceBack(toLanguage.value());
        }
        if (topPreferredLanguage) {
          extraKeys.AppendElement()->AssignASCII("top_preferred_language");
          extraValues.EmplaceBack(topPreferredLanguage.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when a full-page translation request is sent.
   */
  constexpr impl::EventMetric<TranslationRequestExtra> translation_request(2796);

}
namespace translations_panel {
  /**
   * generated from translations.panel.about_translations
   */
    struct AboutTranslationsExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the about-translations menuitem is invoked in the translations
     * panel settings.
   */
  constexpr impl::EventMetric<AboutTranslationsExtra> about_translations(2797);

  /**
   * generated from translations.panel.always_offer_translations
   */
    struct AlwaysOfferTranslationsExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the always-offer-translations menuitem is invoked in the
     * translations panel seeings.
   */
  constexpr impl::EventMetric<AlwaysOfferTranslationsExtra> always_offer_translations(2798);

  /**
   * generated from translations.panel.always_translate_language
   */
    struct AlwaysTranslateLanguageExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the always-translate-language menuitem is invoked in the
     * translations panel settings.
   */
  constexpr impl::EventMetric<AlwaysTranslateLanguageExtra> always_translate_language(2799);

  /**
   * generated from translations.panel.cancel_button
   */
    struct CancelButtonExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the cancel button is invoked in the translations panel.
   */
  constexpr impl::EventMetric<CancelButtonExtra> cancel_button(2800);

  /**
   * generated from translations.panel.change_from_language
   */
    struct ChangeFromLanguageExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeFromLanguageExtra> change_from_language(2801);

  /**
   * generated from translations.panel.change_source_language_button
   */
    struct ChangeSourceLanguageButtonExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the change-source-language button is invoked in the translations
     * panel.
   */
  constexpr impl::EventMetric<ChangeSourceLanguageButtonExtra> change_source_language_button(2802);

  /**
   * generated from translations.panel.change_to_language
   */
    struct ChangeToLanguageExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the to-language selected value is changed.
   */
  constexpr impl::EventMetric<ChangeToLanguageExtra> change_to_language(2803);

  /**
   * generated from translations.panel.close
   */
    struct CloseExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when translations panel is closed.
   */
  constexpr impl::EventMetric<CloseExtra> close(2804);

  /**
   * generated from translations.panel.close_from_language_menu
   */
    struct CloseFromLanguageMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is closed in the translations panel.
   */
  constexpr impl::EventMetric<CloseFromLanguageMenuExtra> close_from_language_menu(2805);

  /**
   * generated from translations.panel.close_settings_menu
   */
    struct CloseSettingsMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the settings menu is closed in the translations panel.
   */
  constexpr impl::EventMetric<CloseSettingsMenuExtra> close_settings_menu(2806);

  /**
   * generated from translations.panel.close_to_language_menu
   */
    struct CloseToLanguageMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is closed in the translations panel.
   */
  constexpr impl::EventMetric<CloseToLanguageMenuExtra> close_to_language_menu(2807);

  /**
   * generated from translations.panel.dismiss_error_button
   */
    struct DismissErrorButtonExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the dismiss-error button is invoked in the translations panel.
   */
  constexpr impl::EventMetric<DismissErrorButtonExtra> dismiss_error_button(2808);

  /**
   * generated from translations.panel.learn_more
   */
    struct LearnMoreExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the learn-more link is invoked in the translations panel first
     * interaction.
   */
  constexpr impl::EventMetric<LearnMoreExtra> learn_more(2809);

  /**
   * generated from translations.panel.manage_languages
   */
    struct ManageLanguagesExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the manage-languages menuitem is invoked in the translations
     * panel settings.
   */
  constexpr impl::EventMetric<ManageLanguagesExtra> manage_languages(2810);

  /**
   * generated from translations.panel.never_translate_language
   */
    struct NeverTranslateLanguageExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> language;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (language) {
          extraKeys.AppendElement()->AssignASCII("language");
          extraValues.EmplaceBack(language.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the never-translate-language menuitem is invoked in the
     * translations panel settings.
   */
  constexpr impl::EventMetric<NeverTranslateLanguageExtra> never_translate_language(2811);

  /**
   * generated from translations.panel.never_translate_site
   */
    struct NeverTranslateSiteExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<bool> toggledOn;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (toggledOn) {
          extraKeys.AppendElement()->AssignASCII("toggled_on");
          extraValues.AppendElement()->AssignASCII(toggledOn.value() ? "true" : "false");
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the never-translate-site menuitem is invoked in the translations
     * panel settings.
   */
  constexpr impl::EventMetric<NeverTranslateSiteExtra> never_translate_site(2812);

  /**
   * generated from translations.panel.open
   */
    struct OpenExtra {
      mozilla::Maybe<bool> autoShow;
      mozilla::Maybe<nsCString> documentLanguage;
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;
      mozilla::Maybe<nsCString> openedFrom;
      mozilla::Maybe<nsCString> viewName;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (autoShow) {
          extraKeys.AppendElement()->AssignASCII("auto_show");
          extraValues.AppendElement()->AssignASCII(autoShow.value() ? "true" : "false");
        }
        if (documentLanguage) {
          extraKeys.AppendElement()->AssignASCII("document_language");
          extraValues.EmplaceBack(documentLanguage.value());
        }
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        if (openedFrom) {
          extraKeys.AppendElement()->AssignASCII("opened_from");
          extraValues.EmplaceBack(openedFrom.value());
        }
        if (viewName) {
          extraKeys.AppendElement()->AssignASCII("view_name");
          extraValues.EmplaceBack(viewName.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translations panel is opened.
   */
  constexpr impl::EventMetric<OpenExtra> open(2813);

  /**
   * generated from translations.panel.open_from_language_menu
   */
    struct OpenFromLanguageMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is opened in the translations panel.
   */
  constexpr impl::EventMetric<OpenFromLanguageMenuExtra> open_from_language_menu(2814);

  /**
   * generated from translations.panel.open_settings_menu
   */
    struct OpenSettingsMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the settings menu is opened in the translations panel.
   */
  constexpr impl::EventMetric<OpenSettingsMenuExtra> open_settings_menu(2815);

  /**
   * generated from translations.panel.open_to_language_menu
   */
    struct OpenToLanguageMenuExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the from-language dropdown is opened in the translations panel.
   */
  constexpr impl::EventMetric<OpenToLanguageMenuExtra> open_to_language_menu(2816);

  /**
   * generated from translations.panel.restore_page_button
   */
    struct RestorePageButtonExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the restore-page button is invoked in the translations panel.
   */
  constexpr impl::EventMetric<RestorePageButtonExtra> restore_page_button(2817);

  /**
   * generated from translations.panel.translate_button
   */
    struct TranslateButtonExtra {
      mozilla::Maybe<bool> firstInteraction;
      mozilla::Maybe<nsCString> flowId;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (firstInteraction) {
          extraKeys.AppendElement()->AssignASCII("first_interaction");
          extraValues.AppendElement()->AssignASCII(firstInteraction.value() ? "true" : "false");
        }
        if (flowId) {
          extraKeys.AppendElement()->AssignASCII("flow_id");
          extraValues.EmplaceBack(flowId.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Triggers when the translate button is invoked in the translations panel.
   */
  constexpr impl::EventMetric<TranslateButtonExtra> translate_button(2818);

}
namespace first_startup {
  /**
   * generated from first_startup.delete_tasks_time
   */
  /**
   * Number of milliseconds until TaskScheduler.deleteAllTasks resolved in
     * FirstStartup.
   */
  constexpr impl::QuantityMetric delete_tasks_time(2819);

  /**
   * generated from first_startup.elapsed
   */
  /**
   * Number of milliseconds the FirstStartup service took to run.
   */
  constexpr impl::QuantityMetric elapsed(2820);

  /**
   * generated from first_startup.normandy_init_time
   */
  /**
   * Number of milliseconds until Normandy.init resolved in FirstStartup.
   */
  constexpr impl::QuantityMetric normandy_init_time(2821);

  /**
   * generated from first_startup.status_code
   */
  /**
   * Status of the FirstStartup service, which runs
     * post-install/early-startup in Firefox.
   */
  constexpr impl::QuantityMetric status_code(2822);

}
namespace notification {
  /**
   * generated from notification.action
   */
  /**
   * The action that the user took in response to the notification. Possible values
     * currently include the following: * “dismissed-by-timeout” * “dismissed-to-
     * action-center” * “dismissed-by-button” * “dismissed-by-application-hidden” *
     * “make-firefox-default-button” * “toast-clicked”
     * Many of the values correspond to buttons on the notification and should be
     * pretty self explanatory, but a few are less so. * “dismissed-to-action-center”
     * will be used if the user clicks the arrow in
     *   the top right corner of the notification to dismiss it to the
     *   action center.
     * * “dismissed-by-application-hidden” is provided because that is a method of
     *   dismissal that the notification API could give but, in practice, should
     *   never be seen.
     * * “dismissed-by-timeout” indicates that the user did not interact with the
     *   notification and it timed out.
   */
  constexpr impl::StringMetric action(2823);

  /**
   * generated from notification.show_success
   */
  /**
   * Whether a notification was shown or not. Possible value include "shown" and
     * "error".
   */
  constexpr impl::BooleanMetric show_success(2824);

}
namespace system {
  /**
   * generated from system.os_version
   */
  /**
   * The current Windows OS version, usually as a dotted quad ("x.y.z.w") with
     * Windows Update Build Revision (UBR), but potentially as a dotted triple
     * ("x.y.z") without UBR.
   */
  constexpr impl::StringMetric os_version(2825);

  /**
   * generated from system.previous_os_version
   */
  /**
   * The Windows OS version before it was changed to the current setting. The
     * possible values are the same as for `system.os_version`.
     * The OS does not keep track of the previous OS version, so the agent records
     * this information itself. That means that it will be inaccurate until the first
     * time the default is changed after the agent task begins running. Before then,
     * the value of `previous_os_version` will be the same as `os_version`.
     * This value is updated every time the Default Agent runs, so when the default
     * browser is first changed the values for `os_version` and `previous_os_version`
     * will be different. But on subsequent executions of the Default Agent, the two
     * values will be the same.
   */
  constexpr impl::StringMetric previous_os_version(2826);

}
namespace system_default {
  /**
   * generated from system_default.browser
   */
  /**
   * Which browser is currently set as the system default web browser. This is
     * simply a string with the name of the browser binned to a fixed set of known
     * browsers.
     * Possible values currently include the following (from
     * [DefaultBrowser.cpp](https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/defaultagent/DefaultBrowser.cpp)): * "error" *
     * "" (unknown) * "firefox" * "chrome" * "edge" * "edge-chrome" * "ie" * "opera" *
     * "brave" * "yandex" * "qq-browser" * "360-browser" * "sogou" * "duckduckgo"
   */
  constexpr impl::StringMetric browser(2827);

  /**
   * generated from system_default.pdf_handler
   */
  /**
   * Which pdf handler is currently set as the system default handler. This is
     * simply a string with the name of the handler binned to a fixed set of known
     * handlers.
     * Possible values currently include the following (from
     * [DefaultPDF.cpp](https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/defaultagent/DefaultPDF.cpp)): * "Error" * ""
     * (unknown) * "Firefox" * "Microsoft Edge" * "Google Chrome" * "Adobe Acrobat" *
     * "WPS" * "Nitro" * "Foxit" * "PDF-XChange" * "Avast" * "Sumatra"
   */
  constexpr impl::StringMetric pdf_handler(2828);

  /**
   * generated from system_default.previous_browser
   */
  /**
   * Which browser was set as the system default before it was changed to the
     * current setting. The possible values are the same as for
     * `system_default.browser`.
     * The OS does not keep track of previous default settings, so the agent records
     * this information itself. That means that it will be inaccurate until the first
     * time the default is changed after the agent task begins running. Before then,
     * the value of `previous_browser` will be the same as `browser`.
     * This value is updated every time the Default Agent runs, so when the default
     * browser is first changed the values for `browser` and `previous_browser` will
     * be different. But on subsequent executions of the Default Agent, the two values
     * will be the same.
   */
  constexpr impl::StringMetric previous_browser(2829);

}
namespace addons_manager {
  /**
   * generated from addons_manager.install
   */
    struct InstallExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<uint32_t> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installId;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", downloadTime.value()));
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installId) {
          extraKeys.AppendElement()->AssignASCII("install_id");
          extraValues.EmplaceBack(installId.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for
     * extensions and themes.
   */
  constexpr impl::EventMetric<InstallExtra> install(2830);

  /**
   * generated from addons_manager.install_stats
   */
    struct InstallStatsExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<nsCString> taarBased;
      mozilla::Maybe<nsCString> utmCampaign;
      mozilla::Maybe<nsCString> utmContent;
      mozilla::Maybe<nsCString> utmMedium;
      mozilla::Maybe<nsCString> utmSource;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (taarBased) {
          extraKeys.AppendElement()->AssignASCII("taar_based");
          extraValues.EmplaceBack(taarBased.value());
        }
        if (utmCampaign) {
          extraKeys.AppendElement()->AssignASCII("utm_campaign");
          extraValues.EmplaceBack(utmCampaign.value());
        }
        if (utmContent) {
          extraKeys.AppendElement()->AssignASCII("utm_content");
          extraValues.EmplaceBack(utmContent.value());
        }
        if (utmMedium) {
          extraKeys.AppendElement()->AssignASCII("utm_medium");
          extraValues.EmplaceBack(utmMedium.value());
        }
        if (utmSource) {
          extraKeys.AppendElement()->AssignASCII("utm_source");
          extraValues.EmplaceBack(utmSource.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded at the end of the install flow, but only
     * when the source that originally triggered the add-on installation
     * is "amo", "rtamo" or "disco".
   */
  constexpr impl::EventMetric<InstallStatsExtra> install_stats(2831);

  /**
   * generated from addons_manager.manage
   */
    struct ManageExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<nsCString> method;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (method) {
          extraKeys.AppendElement()->AssignASCII("method");
          extraValues.EmplaceBack(method.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * This events are recorded when an installed add-ons is being
     * disable/enabled/uninstalled.
   */
  constexpr impl::EventMetric<ManageExtra> manage(2832);

  /**
   * generated from addons_manager.report
   */
    struct ReportExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<nsCString> entryPoint;
      mozilla::Maybe<nsCString> errorType;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (entryPoint) {
          extraKeys.AppendElement()->AssignASCII("entry_point");
          extraValues.EmplaceBack(entryPoint.value());
        }
        if (errorType) {
          extraKeys.AppendElement()->AssignASCII("error_type");
          extraValues.EmplaceBack(errorType.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An abuse report submitted by a user for a given extension.
   */
  constexpr impl::EventMetric<ReportExtra> report(2833);

  /**
   * generated from addons_manager.report_suspicious_site
   */
    struct ReportSuspiciousSiteExtra {
      mozilla::Maybe<nsCString> suspiciousSite;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (suspiciousSite) {
          extraKeys.AppendElement()->AssignASCII("suspicious_site");
          extraValues.EmplaceBack(suspiciousSite.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * Sent when a user clicks "Report Suspicious Site" on the dropdown
     * menu of the third-party xpinstall doorhanger.
   */
  constexpr impl::EventMetric<ReportSuspiciousSiteExtra> report_suspicious_site(2834);

  /**
   * generated from addons_manager.update
   */
    struct UpdateExtra {
      mozilla::Maybe<nsCString> addonId;
      mozilla::Maybe<nsCString> addonType;
      mozilla::Maybe<uint32_t> downloadTime;
      mozilla::Maybe<nsCString> error;
      mozilla::Maybe<nsCString> installId;
      mozilla::Maybe<nsCString> installOrigins;
      mozilla::Maybe<uint32_t> numStrings;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<nsCString> sourceMethod;
      mozilla::Maybe<nsCString> step;
      mozilla::Maybe<nsCString> updatedFrom;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonId) {
          extraKeys.AppendElement()->AssignASCII("addon_id");
          extraValues.EmplaceBack(addonId.value());
        }
        if (addonType) {
          extraKeys.AppendElement()->AssignASCII("addon_type");
          extraValues.EmplaceBack(addonType.value());
        }
        if (downloadTime) {
          extraKeys.AppendElement()->AssignASCII("download_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", downloadTime.value()));
        }
        if (error) {
          extraKeys.AppendElement()->AssignASCII("error");
          extraValues.EmplaceBack(error.value());
        }
        if (installId) {
          extraKeys.AppendElement()->AssignASCII("install_id");
          extraValues.EmplaceBack(installId.value());
        }
        if (installOrigins) {
          extraKeys.AppendElement()->AssignASCII("install_origins");
          extraValues.EmplaceBack(installOrigins.value());
        }
        if (numStrings) {
          extraKeys.AppendElement()->AssignASCII("num_strings");
          extraValues.EmplaceBack(nsPrintfCString("%d", numStrings.value()));
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (sourceMethod) {
          extraKeys.AppendElement()->AssignASCII("source_method");
          extraValues.EmplaceBack(sourceMethod.value());
        }
        if (step) {
          extraKeys.AppendElement()->AssignASCII("step");
          extraValues.EmplaceBack(step.value());
        }
        if (updatedFrom) {
          extraKeys.AppendElement()->AssignASCII("updated_from");
          extraValues.EmplaceBack(updatedFrom.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * These events are recorded during the install and update flow for
     * extensions and themes.
   */
  constexpr impl::EventMetric<UpdateExtra> update(2835);

}
namespace blocklist {
  /**
   * generated from blocklist.addon_block_change
   */
    struct AddonBlockChangeExtra {
      mozilla::Maybe<nsCString> addonVersion;
      mozilla::Maybe<nsCString> blocklistState;
      mozilla::Maybe<nsCString> hoursSince;
      mozilla::Maybe<nsCString> mlbfGeneration;
      mozilla::Maybe<nsCString> mlbfLastTime;
      mozilla::Maybe<nsCString> mlbfSource;
      mozilla::Maybe<nsCString> object;
      mozilla::Maybe<nsCString> signedDate;
      mozilla::Maybe<nsCString> value;

      std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (addonVersion) {
          extraKeys.AppendElement()->AssignASCII("addon_version");
          extraValues.EmplaceBack(addonVersion.value());
        }
        if (blocklistState) {
          extraKeys.AppendElement()->AssignASCII("blocklist_state");
          extraValues.EmplaceBack(blocklistState.value());
        }
        if (hoursSince) {
          extraKeys.AppendElement()->AssignASCII("hours_since");
          extraValues.EmplaceBack(hoursSince.value());
        }
        if (mlbfGeneration) {
          extraKeys.AppendElement()->AssignASCII("mlbf_generation");
          extraValues.EmplaceBack(mlbfGeneration.value());
        }
        if (mlbfLastTime) {
          extraKeys.AppendElement()->AssignASCII("mlbf_last_time");
          extraValues.EmplaceBack(mlbfLastTime.value());
        }
        if (mlbfSource) {
          extraKeys.AppendElement()->AssignASCII("mlbf_source");
          extraValues.EmplaceBack(mlbfSource.value());
        }
        if (object) {
          extraKeys.AppendElement()->AssignASCII("object");
          extraValues.EmplaceBack(object.value());
        }
        if (signedDate) {
          extraKeys.AppendElement()->AssignASCII("signed_date");
          extraValues.EmplaceBack(signedDate.value());
        }
        if (value) {
          extraKeys.AppendElement()->AssignASCII("value");
          extraValues.EmplaceBack(value.value());
        }
        return std::make_tuple(std::move(extraKeys), std::move(extraValues));
      }
    };
  /**
   * An add-on is blocked, or an installed add-on is unblocked. When an add-on
     * install/update is blocked, its installation is aborted and the add-on is no
     * longer listed in the activeAddons field of TelemetryEnvironment.
   */
  constexpr impl::EventMetric<AddonBlockChangeExtra> addon_block_change(2836);

  /**
   * generated from blocklist.last_modified_rs_addons_mblf
   */
  /**
   * Keep track of the last time the "addons-bloomfilters" remotesetting blocklist
     * has been successfully updated.
   */
  constexpr impl::DatetimeMetric last_modified_rs_addons_mblf(2837);

  /**
   * generated from blocklist.mlbf_generation_time
   */
  /**
   * Keep track of the generation time of the addon blocklist's bloom filter. This
     * marks the point in time until which signed add-ons are recognized by the
     * selected bloom filter from the addons-bloomfilters collection.
   */
  constexpr impl::DatetimeMetric mlbf_generation_time(2838);

  /**
   * generated from blocklist.mlbf_source
   */
  /**
   * The source of the RemoteSettings attachment that holds the bloom filter.
     * Possible values are "dump_match", "cache_match",
     * "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
     * "cache_match" and "remote_match" are expected known-good values, and means that
     * the loaded bloomfilter matches the blocklist record in the RemoteSettings
     * collection. The prefix denotes the immediate source of the loaded data: "dump"
     * means packaged with the application, "remote" means a freshly downloaded
     * bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
     * and "cache_fallback" means that the last known bloomfilter was used, despite it
     * not matching the latest record in the RemoteSettings collection. In this case
     * the outdated bloomfilter is used as a fallback (e.g. because the latest version
     * cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
     * at all. This can happen if the blocklist is disabled via preferences or
     * enterprise policies.
   */
  constexpr impl::StringMetric mlbf_source(2839);

  /**
   * generated from blocklist.mlbf_stash_time_newest
   */
  /**
   * Keep track of the timestamp of the most recent stash of the addons blocklist.
   */
  constexpr impl::DatetimeMetric mlbf_stash_time_newest(2840);

  /**
   * generated from blocklist.mlbf_stash_time_oldest
   */
  /**
   * Keep track of the timestamp of the oldest stash of the addons blocklist.
   */
  constexpr impl::DatetimeMetric mlbf_stash_time_oldest(2841);

}
namespace update {
  /**
   * generated from update.auto_download
   */
  /**
   * Per-installation preference "app.update.auto": whether to fetch and install
     * updates without user intervention.
   */
  constexpr impl::BooleanMetric auto_download(2842);

  /**
   * generated from update.background_update
   */
  /**
   * Per-installation preference "app.update.background.enabled": whether to fetch
     * and install updates in the background when Firefox is not running.
   */
  constexpr impl::BooleanMetric background_update(2843);

  /**
   * generated from update.can_usually_apply_updates
   */
  /**
   * Whether or not the Update Service can usually download and install updates. See
     * `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_apply_updates(2844);

  /**
   * generated from update.can_usually_check_for_updates
   */
  /**
   * Whether or not the Update Service can usually check for updates. See
     * `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_check_for_updates(2845);

  /**
   * generated from update.can_usually_stage_updates
   */
  /**
   * Whether the Update Service is usually able to stage updates. See
     * `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_stage_updates(2846);

  /**
   * generated from update.can_usually_use_bits
   */
  /**
   * On Windows, whether the Update Service can usually use BITS. See
     * `canUsuallyUseBits` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
   */
  constexpr impl::BooleanMetric can_usually_use_bits(2847);

  /**
   * generated from update.channel
   */
  /**
   * The update channel.
   */
  constexpr impl::StringMetric channel(2848);

  /**
   * generated from update.enabled
   */
  /**
   * True when policies are disabled or when the "DisableAppUpdate" is not in
     * effect.
   */
  constexpr impl::BooleanMetric enabled(2849);

  /**
   * generated from update.service_enabled
   */
  /**
   * Preference "app.update.service.enabled": whether the Mozilla Maintenance
     * Service is enabled.
   */
  constexpr impl::BooleanMetric service_enabled(2850);

}
namespace timer_thread {
  /**
   * generated from timer_thread.timers_fired_per_wakeup
   */
  /**
   * How many timers were processed in a single wake-up of the Timer Thread.
   */
  constexpr impl::CustomDistributionMetric timers_fired_per_wakeup(2851);

}

} // namespace mozilla::glean

#endif // mozilla_Metrics_h
